Package: fSeries
Version: 240.10068
Date: 1996 - 2006
Title: Rmetrics - The Dynamical Process Behind Markets
Author: Diethelm Wuertz and many others, see the SOURCE file
Depends: R (>= 1.9.0), methods, mgcv, nnet, fCalendar, fBasics
Maintainer: Diethelm Wuertz and Rmetrics Core Team <wuertz@itp.phys.ethz.ch>
Description: Environment for teaching "Financial Engineering and Computational Finance"
License: GPL Version 2 or later
URL: http://www.rmetrics.org 
Packaged: Sun Oct 22 13:09:12 2006; myself

#
# Examples from the forthcoming Monograph:
#   Rmetrics - Financial Engineering and Computational Finance
#   A Practitioner's Guide for R and SPlus Programmers
#   written by Diethelm Wuertz
#   ISBN to be published
#
# Details:
#   Examples from Chapter 3.4
#   Modelling Volatility by Heteroskedastic Processes
#
# List of Examples, Exercises and Code Snippets:
#
#   BOLLERSLEV GARCH(1,1) DEM2GBP BENCHMARK:
#   3.4.1 Example:   GARCH(1,1) - Write Main Fit Function
#   3.4.2 Example:   Garch(1,1) - Time Series Initialization
#   3.4.3 Example:   GARCH(1,1) - Parameter Initialization
#   3.4.4 Example:   GARCH(1,1) - Parameter Optimization
#   3.4.5 Example:   GARCH(1,1) - logLikelihood Function
#   3.4.6 Example:   Stylized Facts of 'dem2gbp' Data Set
#   3.4.7 Example:   GARCH(1,1) Modelling of 'dem2gbp' Data Set
#   
#   CONDITIONAL DISTRIBUTIONS:
#   3.4.8  Snippet:  *ged Functions
#   3.4.9  Exercise: Implementation Tests for the Symmetric GED
#   3.4.10 Example:  Generate Figure 3.4.3 Symmetric GED 
#   3.4.11 Snippet:  *std Functions
#   3.4.12 Exercise: Implementation Tests for the Symmetric Student-t
#   3.4.13 Exercise: Generate Figure 3.4.4 Symmetric Student-t
#   3.4.14 Exercise: Skewed Distributions
#   
#   HETEROSKEDASTIC MODELLING:
#   3.4.15 Example:  GARCH/APARCH Modelling Functions
#   3.4.16 Snippet:  garchSpec Class Representation
#   3.4.17 Example:  GARCH Specification - Argument List
# 
#   DGE SP500 MA-APARCH MODELLING:
#       * Example:   DGE Bollerslev GARCH Model - Formula (15)
#       * Example:   DGE Taylor Schwert MA-TSGARCH Model - Formula (17)
#       * Example:   DGE MA-APARCH Model - Formula (19)
#
#   OX INTERFACE:
#       * Example: Ox - G@RCH Ox Interface 
#       * Example: Ox - ARMA/GARCH Models with Gaussian Distribution
#       * Example: Ox - Other than Gaussian Distributions
#       * Example: Ox - Extended GARCH Models: 
#
# Author:
#   (C) 1997-2005, Diethelm Wuertz, GPL
#     www.rmetrics.org
#     www.itp.phys.ethz.ch
#     www.finance.ch
#


################################################################################
# GARCH(1,1) Parameter Estimation:


### 3.4.1 Exercise: GARCH(1,1) - Write Main Fit Function

    # Write the Main garch11Fit() Function:
    garch11Fit = function(x)
    {
        # Initialize:
        .series <<- .garch11InitSeries(x)
        .params <<- .garch11InitParameters(x)
        .LLH <<- 1e99
        
        # Optimize LLH:
        fit = .garch11OptimizeLLH()
        
        # Final Coefficients and Standard Errors:
        coef = fit$par
        se.coef = sqrt(diag(solve(fit$hessian)))
        tval = coef/se.coef
        matcoef = cbind(coef, se.coef, tval, 2*(1-pnorm(abs(tval))))
        dimnames(matcoef) = list(names(tval), c(" Estimate",
            " Std. Error", " t value", "Pr(>|t|)"))
        cat("\nCoefficient(s):\n")
        printCoefmat(matcoef, digits = 6, signif.stars = TRUE)
        cat("\n")
        
        # Return Value:
        ans = list(fit = fit, residuals = x - fit$par["mu"],
            fitted.values = fit$par["mu"], variances = .series$h)
        invisible(ans)
    }
    ###
    
    
# ------------------------------------------------------------------------------


### 3.4.2 Exercise: Garch(1,1) - Time Series Initialization

    # Initialize the Time Series
    .garch11InitSeries = function(x)
    {   
        # Add Startup Values:
        h = rep( mean((x-mean(x))^2), times = 1 + length(x) )
        x = c(sqrt(h[1]), x)
        
        # Trace:
        cat("\nInitialize Series:\n")
        print(cbind.data.frame(t = 0, h1 = h[1], x1 = x[1]))
        cat("\n")
              
        # Return Value:
        list(h = h, x = x, N = length(h))
    }
    ###
       
    
# ------------------------------------------------------------------------------
    
    
### 3.4.3 Exercise: GARCH(1,1) - Parameter Initialization

    # Initialize Model Parameters and Bounds:
    .garch11InitParameters = function(x)
    {
        # Set Bounds:
        U = c(mu = -10*abs(mean(x)), omega = 1e-12, alpha = 1e-6,
            beta = 1e-6)
        V = c(mu =  10*abs(mean(x)), omega = 100*var(x),
            alpha = 1-1e-6, beta = 1-1e-6)
            
        # Initialize Parameters:
        params = c(mu = mean(x), omega = 0.10*var(x),
            alpha = 0.1, beta = 0.8)
            
        # Trace:
        cat("\nInitial Parameters:\n")
        print(params)
        cat("\nBounds:\n")
        print(rbind(U, V))
        cat("\n")
        
        # Return Value:
        list(params = params, U = U, V = V)
    }
    ###


# ------------------------------------------------------------------------------


### 3.4.4 Exercise: GARCH(1,1) - Parameter Optimization

    # Estimate Parameters and Compute Hessian:
    .garch11OptimizeLLH = function()
    {
        # Estimate Parameters:
        cat("\nIteration Path:\n")
        fit = nlminb(start = .params$params, objective = .garch11LLH,
            lower = .params$U, upper = .params$V)
        
        # Compute Hessian Matrix Numerically:
        eps = 0.0001 * fit$par
        n = length(fit$par)
        H = matrix(0, ncol = n, nrow = n)
        f = .garch11LLH
        for (i in 1:n) {
            for (j in 1:n) {
                x1 = x2 = x3 = x4 = fit$par
                x1[i] = x1[i] + eps[i]
                x1[j] = x1[j] + eps[j]
                x2[i] = x2[i] + eps[i]
                x2[j] = x2[j] - eps[j]
                x3[i] = x3[i] - eps[i]
                x3[j] = x3[j] + eps[j]
                x4[i] = x4[i] - eps[i]
                x4[j] = x4[j] - eps[j]
                H[i, j] = (f(x1)-f(x2)-f(x3)+f(x4))/(4*eps[i]*eps[j])
            }
        }
        colnames(H) = rownames(H) = names(.params$params)
        fit$hessian = H
        
        # Print Hessian Matrix:
        cat("\nHessian Matrix:\n")
        print(fit$hessian)
        
        # Return Value:
        fit
    }
    ###
    
    
# ------------------------------------------------------------------------------


### 3.4.5 Exercise: GARCH(1,1) - logLikelihood Function

    # Compute Value of Log-Likelihood Function:
    .garch11LLH = function(parm)
    {
        # Conditional Distribution Function:
        .garchDist = function(z, hh) {
            dnorm(x = z/hh, mean = 0, sd = 1) / hh 
        }
            
        # Extract Parameters:
        mu = parm[1]
        omega = parm[2]
        alpha = parm[3]
        beta = parm[4]      
        
        # Iterate and Save Conditional Variances:
        N = .series$N
        h = .series$h
        z = .series$x - mu
        h[1] = mean( (.series$x[-1] - mu)^2 )
        z[1] = sqrt(h[1])
        for ( i in 2:N )
        h[i] = omega + alpha*z[i-1]^2 + beta*h[i-1]
        .series$h <<- h
        
        # Calculate log-Likelihood:
        llh = -sum(log(.garchDist(z = z[-1], hh = sqrt(abs(h[-1])))))
            
        # Trace:
        if (llh < .LLH) {
            .LLH <<- llh
            cat("\n LLH: ", llh, "\n")
            print(parm)
        }
        
        # Return Value:
        llh
    }
    ###
    
    
# ------------------------------------------------------------------------------


### 3.4.6 Example: Stylized Facts of  'dem2gbp' Data Set

    # Settings:
    par (mfrow = c(3, 2), cex = 0.7)
    ###
    
    # Load Data Set:
    data(dem2gbp)
    dem2gbp = dem2gbp[, 1]/100
    ###
    
    # Plot Log-Return Series:
    ts.plot(dem2gbp, xlab = "index", ylab = "log Return", col = "steelblue3",
        main = "DEMGBP FX Rate")
    grid()
    abline (h = 0, col = "grey")
    ###

    # Histogram Plot:
    hist(dem2gbp, col = "steelblue", probability = TRUE, 
        breaks = "FD", border = "white", xlim = c(-0.02, 0.02))
    abline (h = 0)
    x = seq(-0.02, 0.02, length = 201)
    lines(x, dnorm(x = x, mean = mean(dem2gbp), sd = sqrt(var(dem2gbp))))
    ###
    
    # Quantile - Quantile Plot:
    qqnorm(dem2gbp, xlab = "Normal Quantiles", ylab = "Empirical Quantiles",
        col = "steelblue3", main = "Normal QQ-Plot", cex = 0.5) 
    qqline(dem2gbp)
    grid()
    ###
    
    # Partial Autocorrelation Plot:  
    pacf(dem2gbp)
    ###
    
    # ACF Volatilities Plot:
    acf(abs(dem2gbp))
    ###
    

# ------------------------------------------------------------------------------


### 3.4.7 Example: GARCH(1,1) Modelling of 'dem2gbp' Data Set

    # Estimate the Parameters:
    data(dem2gbp)
    dem2gbp = dem2gbp[, 1]
    ###
    
    # Fit:
    garch11Fit(x = dem2gbp)
    ###
    
    # Result:
    #     Coefficient(s):
    #          Estimate   Std. Error  t value   Pr(>|t|)    
    # mu    -0.00619041  0.00846260 -0.73150 0.46447258    
    # omega  0.01076140  0.00285270  3.77236 0.00016171 ***
    # alpha  0.15313407  0.02652271  5.77370 7.7552e-09 ***
    # beta   0.80597366  0.03355251 24.02126 < 2.22e-16 ***

    # Benchmark:
    # mu: -0.006190, omega = 0.01076, alpha = 0.1531, beta = 0.8060
    ###
   

################################################################################
# CONDITIONAL DISTRIBUTIONS:

    
### 3.4.8 Code Snippet: *ged Functions

    # Symmetric Generalized Error Distribution:
    #   Write functions to compute density, probability and quantile
    #   functions for the generalized error distribution and to generate
    #   random numbers.
    ###
    
    # Density Function:
    .dged = function(x, mean = 0, sd = 1, nu = 2)
    {
        # x - Vector of quantiles
        x = (x - mean ) / sd
        lambda = sqrt ( 2^(-2/nu) * gamma(1/nu) / gamma(3/nu) )
        g = nu / ( lambda * (2^(1+1/nu)) * gamma(1/nu) )
        Density = g * exp (-0.5*(abs(x/lambda))^nu) / sd
        return(Density)
    }
    ###

    # Distribution Function:
    .pged = function(q, mean = 0, sd = 1, nu = 2)
    {
        # q - Vector of quantiles
        q = (q - mean ) / sd
        lambda = sqrt ( 2^(-2/nu) * gamma(1/nu) / gamma(3/nu) )
        g = nu / ( lambda * (2^(1+1/nu)) * gamma(1/nu) )
        h = 2^(1/nu) * lambda * g * gamma(1/nu) / nu
        s = 0.5 * ( abs(q) / lambda )^nu
        Distribution = 0.5 + sign(q) * h * pgamma(s, 1/nu)
        return(Distribution)
    }
    ###

    # Quantile Function:
    .pged = function(p, mean = 0, sd = 1, nu = 2)
    {
        # p - Vector of probabilities
        lambda = sqrt ( 2^(-2/nu) * gamma(1/nu) / gamma(3/nu) )
        g  = nu / ( lambda * (2^(1+1/nu)) * gamma(1/nu) )
        h = 2^(1/nu) * lambda * g * gamma(1/nu) / nu
        s = 0.5 * ( abs(p) / lambda )^nu
        Quantiles = qgamma(s, 1/nu)
        return(Quantiles)
    }
    ###

    # Random Variates:
    .rged = function(n, mean = 0, sd = 1, nu = 2)
    {
        # n - Number of random deviates to be generated
        r = rgamma(n, shape = 1/nu, scale = nu)
        Deviates = r^(1/nu) * sign(runif(n)-0.5)
        return(Deviates)
    }
    ###

    # Try -
    hist(.rged(1000), probability = TRUE)
    x = seq(-4, 4, length = 251)
    lines(x, .dged(x))
    ###
    
    
# ------------------------------------------------------------------------------


### 3.4.9 Exercise: Implementation Tests for the Symmetric GED

    # Test if the Symmetric GED has the desired properties:
    # 1. Fullfills the density the relation f(x) = f(-x)?
    # 2. Is the density normalized?
    # 3. Is the first moment equal to "mean"?
    # 4. Is the sqrt(variance) equal to "sd"?
    # 5. Is the computed distribution the same as the integrated?
    # 6. Is the quantile function the inverse of the distribution function?
    # 7. Have the random deviates proper mean and variance?
    # 8. Fits the true density to the histogram of the rvs?

    # Test GED Settings:
    par(mfrow = c(1, 1))
    mean = 0.5; sd = 1/2; nu = 2.5
    x = -4:4; q = x; n = 100000
    ### 
    
    # Test GED density function:
    # 1. Fullfills the density the relation f(x) = f(-x)?
    Density1 = dged( x, mean = 0, sd = 1, nu = nu)
    Density2 = dged(-x, mean = 0, sd = 1, nu = nu)
    c(mean = mean, sd = sd, nu = nu)
    cbind(x, Density1, Density2)
    # 2. Is the density normalized?
    f = function(x, mean, sd, nu) { 
      dged(x, mean = mean, sd = sd, nu = nu) }
    Norm = integrate(f, -Inf, Inf, mean = mean, sd = sd, nu = nu)$value
    c(mean = mean, sd = sd, nu = nu)
    c(norm = 1, Norm = Norm)
    # 3. Is the first moment equal to "mean"?
    f = function(x, mean, sd, nu) { 
      x * dged(x, mean = mean, sd = sd, nu = nu) }
    mu = integrate(f, -Inf, Inf, mean = mean, sd = sd, nu = nu)$value
    c(mean = mean, sd = sd, nu = nu)
    c(mean = mean, mu = mu)
    # 4. Is the variance equal to "sd"?
    f = function(x, mean, sd, nu) { 
      (x-mean)^2 * dged(x, mean = mean, sd = sd, nu = nu) }
    sigma = sqrt(integrate(f, -Inf, Inf, mean = mean, sd = sd, nu = nu)$value)
    c(mean = mean, sd = sd, nu = nu)
    c(sd = sd, sigma = sigma)
    ###
        
    # Test GED distribution function:
    # 5. Is the computed distribution the same as the integrated?   
    Probability1 = pged(q = q, mean = mean, sd = sd, nu = nu)
    Probability2 = NULL
    for (i in 1:length(q)) Probability2 = c(Probability2, integrate(dged, 
      -Inf, q[i], mean = mean, sd = sd, nu = nu)$value)
    c(mean = mean, sd = sd, nu = nu)
    cbind(q, Probability1, Probability2)
    ###
    
    # Test GED quantile function:   
    # 6. Is the quantile function the inverse of the distribution function?
    Probability = pged(q = q, mean = mean, sd = sd, nu = nu)
    Quantile = qged(p = Probability, mean = mean, sd = sd, nu = nu)
    c(mean = mean, sd = sd, nu = nu)
    cbind(q, Probability, Quantile)
    ### 
    
    # Test GED random variates:
    # 7. Have the random deviates proper mean and variance?
    r = rged(n = n, mean = mean, sd = sd, nu = nu)
    c(mean = mean, sd = sd, nu = nu)
    c(mu = mean(r), sigma =  sqrt(var(r)))
    # 8. Fits the true density to the histogram?
    x1 = 3 * x[1] * sd + mean
    x2 = 3 * x[length(x)] * sd + mean
    hist(r, n = 100, probability = TRUE, xlim = c(x1, x2))
    z = seq(x1, x2, length = 801)
    lines(z, dged(z, mean = mean, sd = sd, nu = nu), col = "red")
    ###


# ------------------------------------------------------------------------------


### 3.4.10 Example: Generate Figure 3.4.
    
    # Symmetric GED Function - Limiting Cases:
    #   nu = 1   : Laplace Distribution
    #   nu = 2   : Gaussian Distribution
    #   nu = Inf : Uniform Distribution
    ###
    
    # Settings:
    par(mfrow = c(2, 2), cex = 0.7)
    mean = 0; sd = 1; dx = 0.001
    x = seq(-5+mean, 5+mean, by = dx)
    ###

    # Figure - GED Density Function:
    d1 = dged(x, mean = mean, sd = sd, nu = 1)
    d2 = dged(x, mean = mean, sd = sd, nu = 2)
    d3 = dged(x, mean = mean, sd = sd, nu = 10)
    plot(x, d1, type = "n", xlim = c(-5, 5), ylim = c(0, 0.7), 
        xlab = "z", ylab = "f(z)", main = "GED: Density")
    lines(x, d1, col = "blue")
    lines(x, d2, col = "red")
    lines(x, d3, col = "green")
    text(3.6, 0.15, "nu=10", col = "green")
    text(2.4, 0.40, "nu=2",  col = "red")
    text(1.7, 0.64, "nu=1",  col = "blue")
    ###

    # Figure 2 - GED Distribution Function:
    p1 = pged(x, mean = mean, sd = sd, nu = 1)
    p2 = pged(x, mean = mean, sd = sd, nu = 2)
    p3 = pged(x, mean = mean, sd = sd, nu = 10)
    plot(x, p1, type = "n", xlim = c(-5, 5),
        xlab = "z", ylab = "F(z)", main = "GED: Distribution")
    lines(x, p1, col = "blue")
    lines(x, p2, col = "red")
    lines(x, p3, col = "green")
    text(2.0, 0.20, "nu=1", col = "blue")
    text(2.7, 0.50, "nu=2", col = "red")
    text(3.8, 0.80, "nu=10", col = "green")
    ###
    
    # Figure 3 - GED Absolute Moment Ratios
    plot(c(0, 11), c(0, 15), type = "n", 
        xlab = "n", ylab = "M(n)/M(n-1)", main = "absMoment Ratio")
    for (nu in c(3/4, 1, 2)) {
        # True Values:
        m1 = absMoments(n = 1:10, density = "dged", nu = nu)
        m2 = absMoments(n = 2:11, density = "dged", nu = nu)
        cat("\n nu: ", nu, "\n")
        print(diff(m2/m1))
        points(1:10, m2/m1)
        lines (1:10, m2/m1) 
        text(10,  2.4, "nu=2")
        text(10,  6.6, "nu=1")
        text(10, 11.6, "nu=3/4") 
    }
    ###

    # Figure 4: The Kurtosis M4/M2^2 - 3
    nu = seq(0.1, 10, length = 100)
    M4 = absMoments(n = 4, density = "dged", nu = nu)
    # Plot:
    plot(nu, log(M4), type = "l", ylim = c(0,10), 
        xlab = "nu", ylab = "ln M(4)", main = "GED: 4th Moment")
    abline(v = 0, lty = 3)
    abline(h = log(3), lty = 3)
    points(2, log(3))
    points(1, log(6))
    text(3.1, log(4.8), "Normal")
    text(2.1, log(9.3), "Laplace")
    text(9.1, log(1.2), "Uniform")
    ###
    
    
# ------------------------------------------------------------------------------


### 3.4.11 Code Snippet: *std Functions

    # Standardized Symmetric Student-t Distribution:
    #   Write functions to compute density, probability and quantile
    #   functions for the standardized Student-t distribution and to 
    #   generate random numbers.
    ###

    # Density Function:
    .dstd = function(x, mean = 0, sd = 1, nu = 5)
    {
        # x - Vector of quantiles
        s = sqrt(nu/(nu-2))
        z = (x-mean) / sd
        Density = dt(x = z * s, df = nu) * s/sd
        return(Density)
    }
    ###

    # Distribution Function:
    .pstd = function (q, mean = 0, sd = 1, nu = 5)
    {
        # q - Vector of quantiles
        s = sqrt(nu/(nu-2))
        z = (q-mean) / sd
        Distribution = pt(q = z*s, df = nu)
        return(Distribution)
    }
    ###

    # Quantile Function:
    .qstd = function (p, mean = 0, sd = 1, nu = 5)
    {
        # p - vector of probabilities
        s = sqrt(nu/(nu-2))
        Quantiles = qt(p = p, df = nu) * sd / s + mean
        return(Quantiles)
    }
    ###

    # Random Deviates:
    .rstd = function(n, mean = 0, sd = 1, nu = 5)
    {
        # n - Number of random deviates to be generated
        s = sqrt(nu/(nu-2))
        Deviates = rt(n = n, df = nu) * sd / s + mean
        return(Deviates)
    }
    ###

    # Try -
    set.seed(4711)
    hist(.rstd(1000), breaks = "FD", probability = TRUE, ylim = c(0, 0.6))
    x = seq(-4, 4, length = 251)
    lines(x, .dstd(x))
    ###

 
# ------------------------------------------------------------------------------


### 3.4.12 Exercise: Implementation Tests for the Symmetric Student-t

    # Test if the Symmetric Student-t has the desired properties:
    # 1. Fullfills the density the relation f(x) = f(-x)?
    # 2. Is the density normalized?
    # 3. Is the first moment equal to "mean"?
    # 4. Is the sqrt(variance) equal to "sd"?
    # 5. Is the computed distribution the same as the integrated?
    # 6. Is the quantile function the inverse of the distribution function?
    # 7. Have the random deviates proper mean and variance?
    # 8. Fits the true density to the histogram?
    ###
    
    # Test STD Settings:
    par(mfrow = c(1, 1))
    mean = 0.5; sd = 1.5; nu = 2.5
    x = -4:4; q = x; n = 100000
    ###
            
    # Test STD density function:
    # 1. Fullfills the density the relation f(x) = f(-x)?
    Density1 = dstd( x, mean = 0, sd = 1, nu = nu)
    Density2 = dstd(-x, mean = 0, sd = 1, nu = nu)
    c(mean = mean, sd = sd, nu = nu)
    cbind(x, Density1, Density2)
    # 2. Is the density normalized?
    f = function(x, mean, sd, nu) { 
      dstd(x, mean = mean, sd = sd, nu = nu) }
    Norm = integrate(f, -Inf, Inf, mean = mean, sd = sd, nu = nu)$value
    c(mean = mean, sd = sd, nu = nu)
    c(norm = 1, Norm = Norm)
    # 3. Is the first moment equal to "mean"?
    f = function(x, mean, sd, nu) { 
      x * dstd(x, mean = mean, sd = sd, nu = nu) }
    mu = integrate(f, -Inf, Inf, mean = mean, sd = sd, nu = nu)$value
    c(mean = mean, sd = sd, nu = nu)
    c(mean = mean, mu = mu)
    # 4. Is the variance equal to "sd"?
    f = function(x, mean, sd, nu) { 
      (x-mean)^2 * dstd(x, mean = mean, sd = sd, nu = nu) }
    sigma = sqrt(integrate(f, -Inf, Inf, mean = mean, sd = sd, nu = nu)$value)
    c(mean = mean, sd = sd, nu = nu)
    c(sd = sd, sigma = sigma)
    ###
    
    # Test STD distribution function:
    # 5. Is the computed distribution the same as the integrated?   
    Probability1 = pstd(q = q, mean = mean, sd = sd, nu = nu)
    Probability2 = NULL
    for (i in 1:length(q)) Probability2 = c(Probability2, integrate(dstd, 
      -Inf, q[i], mean = mean, sd = sd, nu = nu)$value)
    c(mean = mean, sd = sd, nu = nu)
    cbind(q, Probability1, Probability2)
    ### 
    
    # Test STD quantile function:   
    # 6. Is the quantile function the inverse of the distribution function?
    Probability = pstd(q = q, mean = mean, sd = sd, nu = nu)
    Quantile = qstd(p = Probability, mean = mean, sd = sd, nu = nu)
    c(mean = mean, sd = sd, nu = nu)
    cbind(q, Probability, Quantile)
    ###
        
    # Test STD random variates:
    # 7. Have the random deviates proper mean and variance?
    r = rstd(n = n, mean = mean, sd = sd, nu = nu)
    c(mean = mean, sd = sd, nu = nu)
    c(mu = mean(r), sigma =  sqrt(var(r)))  
    # 8. Fits the true density to the histogram?
    x1 = x[1]*sd + mean
    x2 = x[length(x)]*sd + mean
    hist(r, n = 500, probability = TRUE, xlim = c(x1, x2))
    z = seq(x1, x2, length = 801)
    lines(z, dstd(z, mean = mean, sd = sd, nu = nu), col = "red")
    ###
    

# ------------------------------------------------------------------------------


### 3.4.13 Exercise: Generate Figure 3.4 Symmetric Student-t
    
    # Standardized Symmetric Student-t Distribution:
    #   nu =  2.5 Fat tailed Distribution
    #   nu =  5.0 Less fat tailed
    #   nu = 10.0 Almost Gaussian Distribution
    ###
    
    # Settings:
    mean = 0; sd = 1; dx = 0.001
    x = seq(-10+mean, 10+mean, by = dx)
    ###
    
    # 1st Graph - Density Function:
    par(mfrow = c(2, 2), cex = 0.7)
    d1 = dstd(x, mean = mean, sd = sd, nu = 2.5)
    d2 = dstd(x, mean = mean, sd = sd, nu = 5)
    d3 = dstd(x, mean = mean, sd = sd, nu = 10)
    plot(x, d1, type = "n", xlim = c(-5, 5), ylim = c(0, 0.85), 
        xlab = "z", ylab = "f(z)", main = "Student-t: Density")
    grid()
    lines(x, d1, col = "blue")
    lines(x, d2, col = "red")
    lines(x, d3, col = "green")
    text(3.6, 0.15, "nu=10", col = "green")
    text(2.4, 0.40, "nu=2",  col = "red")
    text(1.7, 0.64, "nu=1",  col = "blue")
    ###
    
    # 2nd Graph - Distribution Function:
    p1 = pstd(x, mean = mean, sd = sd, nu = 2.5)
    p2 = pstd(x, mean = mean, sd = sd, nu = 5)
    p3 = pstd(x, mean = mean, sd = sd, nu = 10)
    plot(x, p1, type = "n", xlim = c(-5, 5),
        xlab = "z", ylab = "F(z)", main = "Student-t Distribution")
    grid()
    lines(x, p1, col = "blue")
    lines(x, p2, col = "red")
    lines(x, p3, col = "green")
    text(1.2, 0.20, "nu=1",  col = "blue")
    text(1.7, 0.50, "nu=2",  col = "red")
    text(2.6, 0.80, "nu=10", col = "green")
    ###
    
    # 3rd Graph - Histogram Plot:
    set.seed(0.4711)
    r = rstd(n = 10000, mean = 1, sd = 2, nu = 2.5)
    mean(r)
    sqrt(var(r))
    hist(r, n = 500, probability = TRUE, xlim = c(-5, 7), 
        main = "10000 Random Deviates")
    x = seq(-5, 7, length = 201)
    lines(x, dstd (x, mean = 1, sd = 2, nu = 2.5), col = "red")
    lines(x, dnorm(x, mean = 1, sd = 1.90), col = "blue")

    # 4th Graph - Kurtosis:
    nu = seq(8.1, 16, by = 0.1)
    M4 = M2 = rep(NA, times = length(nu))
    for (i in 1:length(nu)) {
        M4[i] = absMoments(n = 4, density = "dstd", nu[i])
        M2[i] = absMoments(n = 2, density = "dstd", nu[i]) }
    kurtosis = M4/M2 - 3
    plot(nu, kurtosis)
    ###

        
# ------------------------------------------------------------------------------


### 3.4.14 Exercise: Skewed Distributions

    # Skewed Student-t Density Function:
    .dsstd = function(x, nu, xi)
    {
        # Standardize:
        m1 = 2 * sqrt(nu-2) / (nu-1) / beta(1/2, nu/2)
        mu = m1*(xi-1/xi)
        sigma =  sqrt((1-m1^2)*(xi^2+1/xi^2) + 2*m1^2 - 1)
        z = x*sigma + mu
        # Compute:
        Xi = xi^sign(z)
        g = 2 / (xi + 1/xi)
        Density = g * dstd(x = z/Xi, nu = nu) * sigma
        return(Density)
    }
    ###

    # Skewed Student-t Distribution Function:
    .psstd = function(q, nu, xi)
    {
        # Standardize:
        m1 = 2 * sqrt(nu-2) / (nu-1) / beta(1/2, nu/2)
        mu = m1*(xi-1/xi)
        sigma =  sqrt((1-m1^2)*(xi^2+1/xi^2) + 2*m1^2 - 1)
        z = q*sigma + mu
        # Compute:
        Xi = xi^sign(z); g = 2 / (xi + 1/xi)
        Distribution = H(z) -
            sign(z) * g * Xi * pstd(q = -abs(z)/Xi, nu = nu)
        return(Distribution)
    }
    ###

    # Skewed Student-t Quantile Function:
    .qsstd = function(p, nu, xi)
    {
        # Standardize:
        m1 = 2 * sqrt(nu-2) / (nu-1) / beta(1/2, nu/2)
        mu = m1*(xi-1/xi)
        sigma =  sqrt((1-m1^2)*(xi^2+1/xi^2) + 2*m1^2 - 1)
        # Compute:
        g = 2  / (xi + 1/xi); sig = sign(p-1/2)
        Xi = xi^sig; p = (H(p-1/2)-sig*p) / (g*Xi)
        Quantiles = (-sig*qstd(p=p, sd=Xi, nu=nu) - mu ) / sigma
        return(Quantiles)
    }
    ###

    # Skewed Student-t Random Deviates:
    .rsstd = function(n, nu, xi)
    {
        # Generate Random Deviates:
        weight = xi / (xi + 1/xi)
        z = runif(n, -weight, 1-weight)
        Xi = xi^sign(z)
        Random = -abs(rstd(n, nu=nu))/Xi * sign(z)
        # Scale:
        m1 = 2 * sqrt(nu-2) / (nu-1) / beta(1/2, nu/2)
        mu = m1*(xi-1/xi)
        sigma =  sqrt((1-m1^2)*(xi^2+1/xi^2) + 2*m1^2 - 1)
        Deviates = (Random - mu ) / sigma
        return(Deviates)
    }
    ###

    # For skewed distributions only change the function names
    # and exchange the expression for the 1st abs moment "m1".
    # For skewed distributions with arbitrary mean and standard
    # deviation, we have only to add a shift and scale parameter:
    .dsstd = function (x, mean = 0, sd = 1, nu = 5, xi = 1.5)
    {
        .dsstd(x = (x - mean)/sd, nu = nu, xi = xi)/sd
    }
    ###

    # For details of the implementation inspect the functions:
    # .[dpqr]snorm(x, mean, sd, xi)
    # .[dpqr]sged(x, mean, sd, nu, xi)
    # .[dpqr]sstd(x, mean, sd, nu, xi)
    ###

    # TRY -
    #   Write Implementation Tests for the Skewed Distributions
    #   1. Skew Normal Distribution
    #   2. Skew Generalized Error Distribution
    #   3. Skew Standardized Student-t Distribution
    ###

    # Exercise: 1. Skew Normal Distribution Tests
    # Test if the Normal Distribution has the desired properties:
    # 1. Fullfills the density the relation f(x|xi) = f(-x|1/xi)?
    # 2. Is the density normalized?
    # 3. Is the first moment equal to "mean"?
    # 4. Is the sqrt(variance) equal to "sd"?
    # 5. Is the computed distribution the same as the integrated?
    # 6. Is the quantile function the inverse of the distribution function?
    # 7. Have the random deviates proper mean and variance?
    # 8. Fits the true density to the histogram?
    ###
        
    # Test snorm Settings:
    par(mfrow = c(1, 1))
    mean = 0.5; sd = 1.5; xi = 1.5
    x = -4:4; q = x; n = 100000
    ###
            
    # Test snorm Density Function:
    # 1. Fullfills the density the relation f(x|xi) = f(-x|1/xi)?
    Density1 = dsnorm( x, mean = 0, sd = 1, xi = xi)
    Density2 = dsnorm(-x, mean = 0, sd = 1, xi = 1/xi)
    c(mean = mean, sd = sd, xi = xi)
    cbind(x, Density1, Density2)
    # 2. Is the density normalized?
    f = function(x, mean, sd, nu, xi) { 
      dsnorm(x, mean = mean, sd = sd, xi = xi) }
    Norm = integrate(f, -Inf, Inf, mean = mean, sd = sd, xi = xi)$value
    c(mean = mean, sd = sd, xi = xi)
    c(norm = 1, Norm = Norm)    
    # 3. Is the first moment equal to "mean"?
    f = function(x, mean, sd, nu, xi) { 
      x * dsnorm(x, mean = mean, sd = sd, xi = xi) }
    mu = integrate(f, -Inf, Inf, mean = mean, sd = sd, xi = xi)$value
    c(mean = mean, sd = sd, xi = xi)
    c(mean = mean, mu = mu) 
    # 4. Is the variance equal to "sd"?
    f = function(x, mean, sd, nu, xi) { 
        (x-mean)^2 * dsnorm(x, mean = mean, sd = sd, xi = xi) }
    sigma = sqrt(integrate(f, -Inf, Inf, mean = mean, sd = sd, xi = xi)$value)
    c(mean = mean, sd = sd, xi = xi)
    c(sd = sd, sigma = sigma)
    ###
        
    # Test snorm Distribution Function:
    # 5. Is the computed distribution the same as the integrated?   
    Probability1 = psnorm(q = q, mean = mean, sd = sd, xi = xi)
    Probability2 = NULL
    for (i in 1:length(q)) Probability2 = c(Probability2, integrate(dsnorm, 
        -Inf, q[i], mean = mean, sd = sd, xi = xi)$value)
    c(mean = mean, sd = sd, xi = xi)
    cbind(q, Probability1, Probability2)
    ###
        
    # Test snorm Quantile Function: 
    # 6. Is the quantile function the inverse of the distribution function?
    Probability = psnorm(q = q, mean = mean, sd = sd, xi = xi)
    Quantile = qsnorm(p = Probability, mean = mean, sd = sd, xi = xi)
    c(mean = mean, sd = sd, xi = xi)
    cbind(q, Probability, Quantile)
    ###
        
    # Test snorm Random Variates:
    # 7. Have the random deviates proper mean and variance?
    r = rsnorm(n = n, mean = mean, sd = sd, xi = xi)
    c(mean = mean, sd = sd, xi = xi)
    c(mu = mean(r), sigma =  sqrt(var(r)))  
    # 8. Fits the true density to the histogram?
    x1 = x[1] * sd + mean
    x2 = x[length(x)] * sd + mean
    hist(r, n = 100, probability = TRUE, xlim = c(x1, x2))
    z = seq(x1, x2, length = 801)
    lines(z, dsnorm(z, mean = mean, sd = sd, xi = xi), col = "red")
    ###

    
    # Example: 2. Skew Student-t Distribution Specification Tests:
    # Test if the Skew Student-t has the desired properties:
    # 1. Fullfills the density the relation f(x|xi) = f(-x|1/xi)?
    # 2. Is the density normalized?
    # 3. Is the first moment equal to "mean"?
    # 4. Is the sqrt(variance) equal to "sd"?
    # 5. Is the computed distribution the same as the integrated?
    # 6. Is the quantile function the inverse of the distribution function?
    # 7. Have the random deviates proper mean and variance?
    # 8. Fits the true density to the histogram?
    ###
    
    # Test SSTD Settings:
    par(mfrow = c(1, 1))
    mean = 0.5; sd = 1.5; nu = 2.5; xi = 1.5
    x = -4:4; q = x; n = 100000
    ###
        
    # Test SSTD density function:
    # 1. Fullfills the density the relation f(x|xi) = f(-x|1/xi)?
    Density1 = dsstd( x, mean = 0, sd = 1, nu = nu, xi = xi)
    Density2 = dsstd(-x, mean = 0, sd = 1, nu = nu, xi = 1/xi)
    c(mean = mean, sd = sd, nu = nu, xi = xi)
    cbind(x, Density1, Density2)        
    # 2. Is the density normalized?
    f = function(x, mean, sd, nu, xi) { 
        dsstd(x, mean = mean, sd = sd, nu = nu, xi = xi) }
    Norm = integrate(f, -Inf, Inf, mean = mean, sd = sd, nu = nu, 
        xi = xi)$value
    c(mean = mean, sd = sd, nu = nu, xi = xi)
    c(norm = 1, Norm = Norm)        
    # 3. Is the first moment equal to "mean"?
    f = function(x, mean, sd, nu, xi) { 
        x * dsstd(x, mean = mean, sd = sd, nu = nu, xi = xi) }
    mu = integrate(f, -Inf, Inf, mean = mean, sd = sd, nu = nu, 
        xi = xi)$value
    c(mean = mean, sd = sd, nu = nu, xi = xi)
    c(mean = mean, mu = mu) 
    # 4. Is the variance equal to "sd"?
    f = function(x, mean, sd, nu, xi) { 
        (x-mean)^2 * dsstd(x, mean = mean, sd = sd, nu = nu, xi = xi) }
    sigma = sqrt(integrate(f, -Inf, Inf, mean = mean, sd = sd, 
        nu = nu, xi = xi)$value)
    c(sd = sd, sigma = sigma)
    ###
        
    # Test SSTD distribution function:
    # 5. Is the computed distribution the same as the integrated?   
    Probability1 = psstd(q = q, mean = mean, sd = sd, nu = nu, xi = xi)
    Probability2 = NULL
    for (i in 1:length(q)) Probability2 = c(Probability2, integrate(dsstd, 
        -Inf, q[i], mean = mean, sd = sd, nu = nu, xi = xi)$value)
    c(mean = mean, sd = sd, nu = nu, xi = xi)
    cbind(q, Probability1, Probability2)
    ### 

    # Test SSTD quantile function:  
    # 6. Is the quantile function the inverse of the distribution function?
    Probability = psstd(q = q, mean = mean, sd = sd, nu = nu, xi = xi)
    Quantile = qsstd(p = Probability, mean = mean, sd = sd, nu = nu, xi = xi)
    c(mean = mean, sd = sd, nu = nu, xi = xi)
    cbind(q, Probability, Quantile)
    ###
    
    # Test SSTD random variates:
    # 7. Have the random deviates proper mean and variance?
    r = rsstd(n = n, mean = mean, sd = sd, nu = nu, xi = xi)
    c(mean = mean, sd = sd, nu = nu, xi = xi)
    c(mu = mean(r), sigma =  sqrt(var(r)))  
    # 8. Fits the true density to the histogram?
    x1 = x[1] * sd + mean
    x2 = x[length(x)] * sd + mean
    hist(r, n = 500, probability = TRUE, xlim = c(x1, x2))
    z = seq(x1, x2, length = 801)
    lines(z, dsstd(z, mean = mean, sd = sd, nu = nu, xi = xi), col = "red")
    ###

    
    # Example: 3. Skew GED Specification Tests:
    # Test if the Skew GED has the desired properties:
    # 1. Fullfills the density the relation f(x|xi) = f(-x|1/xi)?
    # 2. Is the density normalized?
    # 3. Is the first moment equal to "mean"?
    # 4. Is the sqrt(variance) equal to "sd"?
    # 5. Is the computed distribution the same as the integrated?
    # 6. Is the quantile function the inverse of the distribution function?
    # 7. Have the random deviates proper mean and variance?
    # 8. Fits the true density to the histogram?
    ###
    
    # Test SGED Settings
    par(mfrow = c(1, 1))
    mean = 0.5; sd = 1/2; nu = 2.5; xi = 1.5
    x = -4:4; q = x; n = 100000
    ###
            
    # Test SGED density function:
    # 1. Fullfills the density the relation f(x|xi) = f(-x|1/xi)?
    Density1 = dsged( x, mean = 0, sd = 1, nu = nu, xi = xi)
    Density2 = dsged(-x, mean = 0, sd = 1, nu = nu, xi = 1/xi)
    c(mean = mean, sd = sd, nu = nu, xi = xi)
    cbind(x, Density1, Density2)
    # 2. Is the density normalized?
    f = function(x, mean, sd, nu, xi) { 
      dsged(x, mean = mean, sd = sd, nu = nu, xi = xi) }
    Norm = integrate(f, -Inf, Inf, mean = mean, sd = sd, nu = nu, 
      xi = xi)$value
    c(mean = mean, sd = sd, nu = nu, xi = xi)
    c(norm = 1, Norm = Norm)
    ###
        
    # 3. Is the first moment equal to "mean"?
    f = function(x, mean, sd, nu, xi) { 
      x * dsged(x, mean = mean, sd = sd, nu = nu, xi = xi) }
    mu = integrate(f, -Inf, Inf, mean = mean, sd = sd, nu = nu, xi = xi)$value
    c(mean = mean, sd = sd, nu = nu, xi = xi)
    c(mean = mean, mu = mu) 
    # 4. Is the sqrt(variance) equal to "sd"?
    f = function(x, mean, sd, nu, xi) { 
      (x-mean)^2 * dsged(x, mean = mean, sd = sd, nu = nu, xi = xi) }
    sigma = sqrt(integrate(f, -Inf, Inf, mean = mean, sd = sd, 
      nu = nu, xi = xi)$value)
    c(mean = mean, sd = sd, nu = nu, xi = xi)
    c(sd = sd, sigma = sigma)
    ###
        
    # Test SGED distribution function:
    # 5. Is the computed distribution the same as the integrated?   
    Probability1 = psged(q = q, mean = mean, sd = sd, nu = nu, xi = xi)
    Probability2 = NULL
    for (i in 1:length(q)) Probability2 = c(Probability2, integrate(dsged, 
      -Inf, q[i], mean = mean, sd = sd, nu = nu, xi = xi)$value)
    c(mean = mean, sd = sd, nu = nu, xi = xi)
    cbind(q, Probability1, Probability2)
    ### 

    # Test SGED quantile function:  
    # 6. Is the quantile function the inverse of the distribution function?
    Probability = psged(q = q, mean = mean, sd = sd, nu = nu, xi = xi)
    Quantile = qsged(p = Probability, mean = mean, sd = sd, nu = nu, xi = xi)
    c(mean = mean, sd = sd, nu = nu, xi = xi)
    cbind(q, Probability, Quantile)
    ###
        
    # Test SGED random variates:
    # 7. Have the random deviates proper mean and variance?
    r = rsged(n = n, mean = mean, sd = sd, nu = nu, xi = xi)
    c(mean = mean, sd = sd, nu = nu, xi = xi)
    c(mu = mean(r), sigma =  sqrt(var(r)))  
    # 8. Fits the true density to the histogram?
    x1 = 3 * x[1] * sd + mean
    x2 = 3 * x[length(x)] * sd + mean
    hist(r, n = 100, probability = TRUE, xlim = c(x1, x2))
    z = seq(x1, x2, length = 801)
    lines(z, dsged(z, mean = mean, sd = sd, nu = nu, xi = xi), col = "red")
    ###
        
    
################################################################################
# HETEROSKEDASTIC MODELLING
    
    
### 3.4.15 Example: GARCH/APARCH Modelling Functions

    # List Arguments:
    args(garchSpec)
    args(garchSim)
    args(garchFit)
    args(predict.fGARCH)
    ###
    
    
# ------------------------------------------------------------------------------

  
### 3.4.16 Code Snippet: garchSpec Class Representation

    # Class Representation:
    setClass("garchSpec",
      representation(
        call = "call",
        formula = "formula",
        model = "list",
        presample = "matrix",
        distribution = "character")
      )
    )
    
    
# ------------------------------------------------------------------------------


### 3.4.17 Example: GARCH Specification - Argument List

    # List Arguments:
    > args(garchSpec)
    # function (model = list(omega = 1e-06, alpha = 0.1, beta = 0.8),
    #    presample = NULL, cond.dist = c("rnorm", "rged", "rstd",
    #    "rsnorm", "rsged", "rsstd"))
    ###
    
    
# ------------------------------------------------------------------------------


### 3.4.18 Example: Specify ARMA-GARCH/APARCH Models

    # Create the default GARCH(1,1) specifiaction:
    garchSpec()
    ###
    
    # Try the following specifications:
    ###
    
    # ARCH(1)
    garchSpec(model = list())
    garchSpec(model = list(alpha = 0.1))
    garchSpec(model = list(omega = 1e-6, alpha = 0.1))
    ###
    
    # AR(1)-ARCH(1)
    garchSpec(model = list(ar = 0.5))
    ###
    
    # AR(subset 5)-ARCH(1)
    garchSpec(model = list(ar = c(0.5, 0, 0, 0, 0.1)))
    ###
    
    # ARMA(1,2)-ARCH(1)
    garchSpec(model = list(ar = 0.5, ma = c(0.3, -0.3)))
    ###
    
    # ARCH(2)
    garchSpec(model = list(alpha = c(0.12, 0.04)))
    ###

    # GARCH(1,1)
    garchSpec()
    garchSpec(model = list(alpha = 0.12, beta = 0.81))
    garchSpec(model = list(omega = 2.2e-6, alpha = 0.05, beta = 0.83))
    ###

    # GARCH(1,2) and GARCH(2,1)
    garchSpec(model = list(alpha = 0.1, beta = c(0.4, 0.4))
    garchSpec(model = list(alpha = c(0.12, 0.04), beta = 0.08))
    ###

    # r[s]norm-GARCH(1,1)
    garchSpec(model = list(), cond.dist = "rnorm")
    garchSpec(model = list(dist = 2), cond.dist = "rsnorm")
    ###

    # r[s]ged-GARCH(1,1)
    garchSpec(model = list(dist = 4), cond.dist = "rged")
    garchSpec(model = list(dist = c(4, 2)), cond.dist = "rsged")
    ###

    # r[s]std-GARCH(1,1)
    garchSpec(model = list(dist = 4), cond.dist = "rstd")
    garchSpec(model = list(dist = c(4, 2)), cond.dist = "rsstd")
    ###

    # Taylor- Schwert GARCH(1,1)
    garchSpec(list(delta = 1)
    ###

    # AR(1)-t-APARCH(2, 1)
    garchSpec(model = list(mu = 1.0e-4, ar = 0.5, omega = 1.0e-6,
       alpha = c(0.1, 0.05), gamma = c(0, 0), beta = 0.8, delta = 1.8,
        dist = c(nu = 4, xi = 0.5)), cond.dist = "rsstd")
    ###
    
    
################################################################################
# Ding, Granger Engle [1993]


### Example: DGE SP500 - Investigate Data

    # Load Data -
    # Note, this may be not exactly the same data set ...
    data(sp500dge)
    # Get Index:
    x.ts = as.timeSeries(sp500dge)
    x = as.vector(x.ts)
    # Create Return Series:
    r.ts = returnSeries(x.ts)
    r = as.vector(r.ts)
    # Compute Abs Return Series:
    rabs = abs(r)
    rabs.ts = r.ts; rabs.ts@Data = matrix(rabs, ncol = 1)
    ###
        
    # Create Table 2.1:
    table21 = c(
        "sample size" = length(x),
        mean = mean(r),
        std = sd(r),
        skewness = skewness(r),
        kurtosis = kurtosis(r),
        min = min(r),
        max = max(r),
        "studentized range" = (max(r)-min(r))/sd(r),
        "normality test" =  jarqueberaTest(r)@test$statistic )
    table21
    ###
    
    # Plot Figures 2.1 - 2.3:
    par(mfrow = c(3,1), cex = 0.7)
    plot(x.ts, ylab = "", col = "steelblue", 
        main = "SP500 Daily Price Index")
    plot(r.ts, ylab = "", col = "steelblue", 
        main = "SP500 Daily Returns")
    plot(rabs.ts, ylab = "", col = "steelblue", 
        main = "SP500 Daily Absolute Returns")
    ###
    
    # Create Table 3.1:
    lags = c(1:5, 10, 20, 40, 70, 100)
    ACF = NULL
    ACF = rbind(ACF, acf(r, lag.max = 100, plot = FALSE)$acf[lags+1])
    ACF = rbind(ACF, acf(abs(r), lag.max = 100, plot = FALSE)$acf[lags+1])
    ACF = rbind(ACF, acf(r*r, lag.max = 100, plot = FALSE)$acf[lags+1])
    rownames(ACF) = c("r", "|r|", "r^2")
    colnames(ACF) = c("lag 1", as.character(lags[-1]))
    table31 = round(ACF, digits = 3)
    table31
    ###
            
    # Create Table 3.2:
    par(mfrow = c(1,1))
    d = c(0.125, 0.25, 0.5, 0.75, 1, 1.25, 1.5, 1.75, 2, 3)
    ACFD = NULL
    for (D in d) {
        ACFD = rbind(ACFD, 
            acf(abs(r)^D, lag.max = 100, plot = FALSE)$acf[lags+1])
    }
    rownames(ACFD) = as.character(d)
    colnames(ACFD) = c("lag 1", as.character(lags[-1]))
    table32 = round(ACFD, digits = 3)
    table32
    ###
    
    # Taylor Plot:
    teffectPlot(abs(r), deltas = seq(1/8, 3, length = 50), lag.max = 10) 
    ###
    

# ------------------------------------------------------------------------------


### Example: DGE MA-GARCH Model - Formula (15)
    
    # Load Time Series:
    data(sp500dge)
    # Vector of Compounded Returns:
    x = diff(log(sp500dge[, 2]))
    # Vector of Percentage Compounded Returns:
    X = 100*x
    ###
        
    # Use Rmetrics:
    fit = garchFit(~arma(0,1), ~garch(1,1), series = X)
    summary(fit)
    # Coefficient(s):
    #         Estimate  Std. Error  t value Pr(>|t|)    
    # mu     0.0436913   0.0063223    6.911 4.82e-12 ***
    # ma1    0.1439907   0.0084690   17.002  < 2e-16 ***
    # omega  0.0077464   0.0009489    8.164 2.22e-16 ***
    # alpha1 0.0914195   0.0045493   20.095  < 2e-16 ***
    # beta1  0.9061627   0.0045087  200.981  < 2e-16 ***
    # ---
    # Signif. codes:  0 '***' 0.001 '**' 0.01 '*' 0.05 '.' 0.1 ' ' 1 
    #
    # Recalculate with x - Why do we scaling of variables?
    ###

    # Use Ox: Estimate MA(1)- GARCH(1,1) With garchOxFit()
    garchOxFit(formula.mean = ~arma(0,1), formula.var = ~garch(1,1))
    #   
    # Maximum Likelihood Estimation (Std.Errors based on Numerical OPG matrix)
    #                   Coefficient    Std.Error  t-value  t-prob
    # Cst(M)               0.000440  6.0956e-005    7.212  0.0000
    # MA(1)                0.143539    0.0078410    18.31  0.0000
    # Cst(V)               0.007741   0.00062376    12.41  0.0000
    # ARCH(Alpha1)         0.091464    0.0017888    51.13  0.0000
    # GARCH(Beta1)         0.906265    0.0020807    435.6  0.0000
    # 
    # No. Observations :      17053   No. Parameters  :         5
    # Mean (Y)         :    0.00018   Variance (Y)    :   0.00013
    # Skewness (Y)     :   -0.49340   Kurtosis (Y)    :  25.58650
    # Log Likelihood   :  56826.973   Alpha[1]+Beta[1]:   0.99773
    #
    # Warning : To avoid numerical problems, the estimated parameter
    # Cst(V), and its std.Error have been multiplied by 10^4.
    ###
        
    # Use SPlus: Estimate MA(1)- GARCH(1,1) With garch():
    x = read.table("sp500dge.csv", header = TRUE, sep = ";")[, 1]
    x = diff(log(x)); X = 100*x
    Q = 1000 # Improve Precision
    fit = garch(formula.mean = ~ ma(1),formula.var =  ~garch(1, 1), series = x,
      control = bhhh.control(tol = 0.0001/Q, delta = 0.0001/Q, n.iter = 100*Q))
    summary(fit)
    # 
    # Estimated Coefficients:
    #               Value  Std.Error t value   Pr(>|t|) 
    #        C 4.376e-004 6.086e-005   7.191 3.348e-013
    #    MA(1) 1.441e-001 7.832e-003  18.403 0.000e+000
    #        A 7.778e-007 6.245e-008  12.456 0.000e+000
    #  ARCH(1) 9.184e-002 1.797e-003  51.100 0.000e+000
    # GARCH(1) 9.058e-001 2.090e-003 433.393 0.000e+000
    #
    # Compare with Q=1 - Note, we run in convergence problems.
    ### 
          
    # Summary MA(1) - GARCH(1,1)
    #
    #           DGE       RMETRICS   SPLUS     OX
    #       mu  0.000438  0.000437   0.000438  0.000440
    #    MA(1)  0.144     0.1440     0.1441    0.1435
    #    omega  0.008     0.00775    0.00778   0.00774    /10^4
    #  ARCH(1)  0.091     0.0914     0.0918    0.0915
    # GARCH(1)  0.906     0.906      0.906     0.906
    ###
    
    
# ------------------------------------------------------------------------------         


### Example: DGE Taylor Schwert MA-TSGARCH Model - Formula (17)
    
    # Load Time Series:
    data(sp500dge)
    # Vector of Compounded Returns:
    x = diff(log(sp500dge[, 2]))
    # Vector of Percentage Compounded Returns:
    X = 100*x
    ###
    

# ------------------------------------------------------------------------------         


### Example: DGE MA-APARCH Model - Formula (19)
    
    # Load Time Series:
    data(sp500dge)
    # Vector of Compounded Returns:
    x = diff(log(sp500dge[, 2]))
    # Vector of Percentage Compounded Returns:
    X = 100*x
    ###
    
    # Rmetrics:
    fit = garchFit(~arma(0,1), ~aparch(1,1), symmetric = FALSE, series = x)
    summary(fit)
    ###
    
    # nlminb / 100*x:
    
    # optim / 100*x: - 21550.48
         mu    ma1    omega  alpha1 gamma1  beta1 delta 
    0.021   0.145  0.014    0.083   0.383  0.920  1.43
    0.02003 0.1447 0.009893 0.08355 0.3804 0.9204 1.406 

    
    # Ox: Estimate MA(1)- APGARCH(1,1) With garchOxFit()
    garchOxFit(formula.mean = ~ arma(0,1), formula.var = ~ aparch(1,1))     
    #
    # Maximum Likelihood Estimation (Std.Errors based on Numerical OPG matrix)
    #                   Coefficient   Std.Error  t-value  t-prob
    # Cst(M)               0.000204 6.5105e-005    3.126  0.0018
    # MA(1)                0.144792   0.0076502    18.93  0.0000
    # Cst(V)               0.144021    0.031802    4.529  0.0000
    # ARCH(Alpha1)         0.083615   0.0025485    32.81  0.0000
    # GARCH(Beta1)         0.920108   0.0019257    477.8  0.0000
    # APARCH(Gamma1)       0.376925    0.017956    20.99  0.0000
    # APARCH(Delta)        1.417771    0.042038    33.73  0.0000
    #
    # No. Observations :     17053   No. Parameters  :         7
    # Mean (Y)         :   0.00018   Variance (Y)    :   0.00013
    # Log Likelihood   : 56981.565
    # 
    # Warning : To avoid numerical problems, the estimated parameter
    # Cst(V), and its std.Error have been multiplied by 10^4.
    ###
    
    # SPlus: Estimate MA(1)- GARCH(1,1) With pgarch():
    Q = 1000
    fit = garch(formula.mean =  ~ ma(1), formula.var =  ~ pgarch(1, 1), 
      series = x, leverage = T,
      control = bhhh.control(tol = 0.0001/Q, delta = 0.0001/Q, n.iter = 100*Q))
    # 
    # Estimated Coefficients:
    #               Value  Std.Error  t value   Pr(>|t|) 
    #        C  0.00020599 6.511e-005    3.164 7.794e-004
    #    MA(1)  0.14485265 7.654e-003   18.925 0.000e+000
    #        A  0.00001374 3.052e-006    4.502 3.391e-006
    #  ARCH(1)  0.08357483 2.560e-003   32.651 0.000e+000
    #   LEV(1) -0.37505310 1.792e-002  -20.927 0.000e+000
    # GARCH(1)  0.91994221 1.929e-003  476.838 0.000e+000
    #    POWER  1.42737881 4.232e-002   33.726 0.000e+000

      
    # Summary MA(1) - APGARCH(1,1)
    #   
    #                       R          SPLUS       G@RCH OX
    #            DGE        RMETRICS   FINMETRICS  OXMETICS
    #       mu   0.00021               0.00021     0.00020
    #       ma   0.145                 0.145       0.145
    #    omega   0.000014              0.000014    0.000014
    #    alpha   0.083                 0.084       0.084
    #    gamma  -0.373                -0.375      -0.377
    #     beta   0.920                 0.920       0.920
    #    delta   1.43                  1.43        1.42
    ###
     
    
################################################################################
# RMETRICS INERFACE TO G@ARCH OX


    # Description:
    #   Rmetrics Interface to the Garch Ox Software Package.
    # Notes:    
    #   Not yet implemented and tested are the following models:
    #   "igarch", "figarch.bbm", "figarch.chung", "fiegarch", 
    #   "fiaparch.bbm", "fiaparch.chung", "hygarch"
    ###


# ------------------------------------------------------------------------------


### Example: Load Data
    
    # Load DEMGBP Benchmark Data Set:
    data(dem2gbp)
    x = diff(log(dem2gbp[, 1]))
    ###

    
# ------------------------------------------------------------------------------


### Example: ARMA/GARCH Models - Gaussian Distribution
   
    # ARCH(2):
    arch2 = garchOxFit(
      formula.mean = ~ arma(0,0), formula.var = ~ garch(0,2))
    arch2
    arch2 = garchOxFit(
      formula.mean = ~ arma(0,0), formula.var = ~ arch(2))
    arch2
    ###
    
    # GARCH(1,1):
    garch11 = garchOxFit(
      formula.mean = ~arma(0,0), formula.var = ~garch(1,1))
      garch11
    ###
    
    # GARCH(1,2):    
    garch21 = garchOxFit(
      formula.mean = ~ arma(0,0), formula.var = ~garch(1,2))
    garch21
    ###
    
    # GARCH(2,1):    
    garch21 = garchOxFit(
      formula.mean = ~ arma(0,0), formula.var = ~garch(2,1))
    garch21
    ###
     
    # ARMA(1,0)-GARCH(1,1):   
    ar1.garch11 = garchOxFit(
      formula.mean = ~arma(1,0), formula.var = ~garch(1,1))   
      ar1.garch11     
    ###
      
    # ARMA(0,1)-GARCH(1,1):   
    ma1.garch11 = garchOxFit(
      formula.mean = ~arma(0,1), formula.var = ~garch(1,1))    
      ma1.garch11
    ###
      
    # ARMA(1,1)-GARCH(1,1): 
    arma11.garch11 = garchOxFit(
      formula.mean = ~arma(1,1), formula.var = ~garch(1,1))
      arma11.garch11  
    ###
  
        
# ------------------------------------------------------------------------------


### Example: Other than Gaussian Distributions
      
    # t-GARCH(1,1):
    garch11.t = garchOxFit(
      formula.var = ~garch(1,1), cond.dist = "t")  
    garch11.t 
    ###
    
    # ged-GARCH(1,1):     
    garch11.ged = garchOxFit(
      formula.var = ~garch(1,1), cond.dist = "ged")   
    garch11.ged   
    ###
    
    # skewt-GARCH(1,1):      
    garch11.st = garchOxFit(
      formula.var = ~garch(1,1), cond.dist = "skewed-t")  
      garch11.st    
    ###

  
# ------------------------------------------------------------------------------

  
### Example: Extended GARCH Models
      
    # Fit EGARCH(1,1):
    egarch11 = garchOxFit(
      formula.var = ~ egarch(1,1))  
    egarch11
    ###
    
    # Fit GJR(1,1):   
    gjr11 = garchOxFit(
      formula.var = ~ gjr(1,1)) 
    gjr11
    ###
    
    # Fit APARCH(1,1):  
    aparch11 = garchOxFit(
      formula.var = ~ aparch(1,1))  
    aparch11       
    ###
    
        
################################################################################
# Modelling Heteroskedastic Processes - GARCH(p,q) Processes:


### Exercise: Write tseries - Wrapper

    # His script uses the contributed tseries package from Adrian Tapletti:
    garchTsFit = function(x, order) 
    {
        require(tseries)
        fit = garch(x, order)
        llh = -(fit$n.likeli + length(x)*log(2*pi)/2)
        ans = cbind(Estimate = fit$coef, "Std. Error" = fit$asy.se.coef, 
            "t value" = fit$coef/fit$asy.se.coef)
        rownames(ans) = names(fit$coef)
        round(ans, digits = 6)
    }
    ###
    
    
# ------------------------------------------------------------------------------


### Exercise: Write Splus - Wrapper

    # This program runs under SPlus only!
    garchSplusFit = function(...)
    {
        fit = garch(..., control = bhhh.control(tol = 1.0e-12, n.iter = 10000))
        ans = cbind(fit$coef, sqrt(diag(solve(-fit$cov$A))), 
        fit$coef/sqrt(diag(solve(-fit$cov$A))))
        colIds(ans) = c("Estimate", "Std.Error", "t.value")
        round(ans, digits = 6)
    }
    ###
    

# ------------------------------------------------------------------------------


### Example: Parameter Estimation - Zero Mean

    
    # Rmetrics:
    fit1 = garchpqFit(formula.var = ~ garch(1,1),  
        init = c(0, 0.01, 0.10, 0.80), fixed = c(T, F, F, F))
    fit1  
    #              Estimate  Std. Error   t value
    #   omega      0.010866    0.002888     3.763   
    #   alpha1     0.154596    0.026784     5.772    
    #   beta1      0.804432    0.033857    23.760   
    
    # Ox - R/Interface:
    fit2 = garchOxFit(formula.var = ~ garch(1, 1), include.mean = FALSE)
    fit2
    #              Estimate  Std. Error   t value
    #   Cst(V)     0.010873    0.002887     3.766
    #   ARCH(1)    0.154640    0.026778     5.775
    #   GARCH(1)   0.804350    0.033847    23.765
    
    # R tseries:
    fit3 = garchTsFit(x, order = c(1, 1))
    fit3
    #              Estimate  Std. Error   t value
    #   omega      0.010784    0.001288     8.372
    #   alpha      0.154074    0.013823    11.147
    #   beta       0.805295    0.015966    50.439
    
 
    
# ------------------------------------------------------------------------------


### Example: GARCH(1,2) AND GARCH(2,1) Processes:


    # Note: Garch(p,q) 
    #   in Rmetrics / S-Plus  p is ARCH-order
    #   in Ox / tseries       q is ARCH-order !

    # Rmetrics:
    garchpqFit(formula.var = ~ garch(2, 1))
    #              Estimate  Std. Error   t value
    # mu          -0.006279    0.008477    -0.741  
    # omega        0.010786    0.002857     3.775  
    # alpha1       0.153372    0.002655     5.776  
    # alpha2       3.17e-10          NA        NA    
    # beta1        0.805781    0.003356    24.012 
    garchpqFit(formula.var = ~ garch(1, 2))  
    #              Estimate  Std. Error   t value
    # mu          -0.005062    0.008524    -0.594  
    # omega        0.011249    0.002983     3.771  
    # alpha1       0.168611    0.027673     6.093  
    # beta1        0.489901    0.130747     3.747  
    # beta2        0.297293    0.12587      2.362  

    # Ox:
    garchOxFit(formula.var = ~ garch(1, 2), series = dem2gbp[, 1])
    #              Estimate  Std. Error   t value
    # Cst(M)      -0.006218    0.008484    -0.733  
    # Cst(V)       0.010759    0.007692     1.399   
    # ARCH(Alpha1) 0.153439    0.026693     5.748  
    # ARCH(Alpha2) 0.000000    0.083615     0.000   
    # GARCH(Beta1) 0.805868    0.11124      7.245   
    garchOxFit(formula.var = ~ garch(2, 1), series = dem2gbp[, 1])
    #              Estimate  Std. Error   t value
    # Cst(M)      -0.005035    0.008510    -0.592   
    # Cst(V)       0.011247    0.002980     3.774  
    # ARCH(Alpha1) 0.168616    0.027663     6.095  
    # GARCH(Beta1) 0.489921    0.13074      3.747   
    # GARCH(Beta2) 0.297278    0.12586      2.362   
            
    # S-Plus:
    x = scan("dem2gbp.csv", skip = 1)
    garchSplusFit(formula.var = ~ garch(2, 1), series = x)
    #              Estimate  Std. Error   t value
    #        C    -0.002247    0.008514    -0.264
    #        A     0.001875    0.000840     2.231
    #  ARCH(1)     0.221632    0.033738     6.569
    #  ARCH(2)    -0.176475    0.035500    -4.971
    # GARCH(1)     0.947134    0.014626    64.757
    garchSplusFit(formula.var = ~ garch(1, 2), series = x)
    #              Estimate  Std. Error   t value
    #        C    -0.004895    0.008515    -0.575
    #        A     0.011198    0.002976     3.763
    #  ARCH(1)     0.168278    0.027592     6.099
    # GARCH(1)     0.486852    0.130312     3.736
    # GARCH(2)     0.300699    0.125557     2.395
    
    # R tseries:
    garchTsFit(x, order = c(1, 2))
    #              Estimate  Std. Error   t value
    # a0           0.011361    0.001568     7.245
    # a1           0.163420    0.018222     8.968
    # a2           0.000000    0.025379     0.000
    # b1           0.795568    0.022755    34.963
    garchTsFit(x, order = c(2, 1))      
    #              Estimate  Std. Error   t value
    # a0           0.011237    0.001497     7.508
    # a1           0.169283    0.016457    10.286
    # b1           0.484615    0.110617     4.381
    # b2           0.302105    0.100985     2.992
    
    
# ------------------------------------------------------------------------------       
# Garch(1,1) Forecasting:

    
    # Data:
    require(fSeries)
    data(dem2gbp)
    x = dem2gbp[, 1]
    
    # Rmetrics:
    fit = garchpqFit(formula.var = ~ garch(1, 1))   
    predict(fit, 10)
    #            Mean   Variance
    # 1975  -0.006216     0.1470
    # 1976  -0.006216     0.1518
    # 1977  -0.006216     0.1564
    # 1978  -0.006216     0.1607
    # 1979  -0.006216     0.1650
    # 1980  -0.006216     0.1690
    # 1981  -0.006216     0.1729
    # 1982  -0.006216     0.1766
    # 1983  -0.006216     0.1802
    # 1984  -0.006216     0.1836
        
    # Ox - R/Interface:
    fit = garchOxFit(formula.var = ~ garch(1, 1))  
    # Horizon   Mean    Variance
    #   1   -0.006185     0.1470
    #   2   -0.006185     0.1517
    #   3   -0.006185     0.1563
    #   4   -0.006185     0.1607
    #   5   -0.006185     0.1648
    #   6   -0.006185     0.1689
    #   7   -0.006185     0.1727
    #   8   -0.006185     0.1764
    #   9   -0.006185     0.1800
    #  10   -0.006185     0.1834
    
    # Splus:
    fit = garch(formula.var = ~ garch(1, 1), series = x,
        control = bhhh.control(tol = 1.0e-12, n.iter = 10000))
    predict(fit. 10)
    $series.pred:
     [1] -0.00609 -0.00609  -0.00609  -0.00609  -0.00609
     [6] -0.00609 -0.00609  -0.00609  -0.00609  -0.00609
    $sigma.pred:
     [1] 0.3836317 0.3898176 0.3956579 0.4011777 0.4063997 
     [6] 0.4113442 0.4160299 0.4204735 0.4246903 0.4286945
       
    
################################################################################   
        
 

#
# Examples:
#   A Compendium for R and Rmetrics users to the book 
#     "The Econometric Modelling of Financial Time Series" 
#     written by T.C. Mills
#   ISBN 0-521-62492-4
#
# Description:
#   See Chapter 2 of the book.
#
# Author:
#   (C) Rmetrics 1997-2005, Diethelm Wuertz, GPL
# 	  www.rmetrics.org
# 	  www.itp.phys.ethz.ch
# 	  www.finance.ch
#


################################################################################	


### Mills 2.1: 

	# Load Data:
	data(SP500R)
	x = SP500R[,1]
	
	# Sample Autocorrelation Function:
	rk = round(acf(x, 12)$acf[,,1][-1], 3)
	names(rk) =  paste("lag", 1:12, sep = "")
	rk
	
	# 95% Confidence Interval:
	ci95 = round(2/sqrt(length(x)), 3)
	ci95
	
	# Q(k) Statistics:
	Qk = NULL
	for (lag in 1:12 ) 
		Qk = c(Qk, Box.test(x, lag, "Ljung-Box")$statistic)
	names(Qk) =  paste("lag", 1:12, sep = "")
	round(Qk, 2)
	
	
# ------------------------------------------------------------------------------
	
	
### Mills 2.2
		
	# Time Series Data:
	data(R20); data(RS)
	x = (R20-RS)[, 1]
	time = 1952+(1:length(x))/12
	plot(time, x, type = "o", pch = 19, cex = 0.5)
	
	# Parameter Estimation:
	fit = armaFit(x ~ ar(2), "ols")@fit
	
	# Estimated Parameters and Standard Errors:
	round(rbind(coef = fit$coef, se.coef = fit$se.coef), 3)
	
	# sigma:
	round(sqrt(fit$sigma2[[1]]), 3)
	
	# Compute Sample ACF and Sample PACF:
	N = length(x)
    ACF = acf(x, lag.max = 12)$acf[,,1]
    seACF = sqrt(1/N)
    for (k in 2:12) seACF =
    	c(seACF, sqrt((1+2*sum(ACF[2:k]^2))/N))
    PACF = pacf(x, lag.max = 12)$acf[,,1]
    sePACF = rep(sqrt(1/N), times = 12)
    	
    # Reproduce Table 2.2 in Mills' Textbook:
    data.frame(round(cbind(
       "r_k" = ACF[-1], "se" = seACF,
       "phi_kk" = PACF, "se" = sePACF ), 3) )
       
    # Create Graphs:
    par(mfrow = c(2,2), cex = 0.7)
    acfPlot(x, 12, main = "ACF: UK IR Spread" )
	points(0:12, c(0,seACF), pch=19, col = "steelblue")
	pacfPlot(x, 12,main = "PACF: UK IR Spread")

	
# ------------------------------------------------------------------------------

	
### Mills 2.3	
	
	# Load Data:
	data(FTARET)
	x = FTARET[,1]
	
	# Sample Autocorrelation Function:
	round(acf(x, 12)$acf[,,1], 3)[-1]
	
	# IC Statistics:
	N = length(x)
	n = 4
	BIC = AIC = matrix(rep(0, n^2), n)
	for (p in 0:(n-1) ) {
		for (q in 0:(n-1) ) {
			Formula = paste("x ~arima(", p, ",0,", q, ")", sep = "")
			fit = armaFit(as.formula(Formula), method = "ML")@fit
			AIC[p+1, q+1] = log(fit$sigma2) + 2*(p+q) / N
			BIC[p+1, q+1] = log(fit$sigma2) + log(N)*(p+q) / N
		}
	}
	rownames(AIC) = colnames(AIC) = as.character(0:(n-1))
	print(round(max(AIC) - AIC, 3))
	rownames(BIC) = colnames(BIC) = as.character(0:(n-1))
	print(round(max(BIC) - BIC, 3))
	
	
# ------------------------------------------------------------------------------


### Mills 2.4: Modelling the UK Spread as an Integrated Process	

	# Load Data:
	data(R20); data(RS)
	x = diff((R20-RS)[, 1])
	
	# Sample ACF and Sample PACF:
	data.frame(round(rbind( 
		"r(k)" = acf(x, lag.max = 12)$acf[,,1][-1], 
		"phi(kk)" = pacf(x, lag.max = 12)$acf[,,1]), 3))
		
	# Fit AR(1):
	fit = arima(x, order = c(1, 0, 0))
	fit 
	
	# Portmanteau Statistic of Q(12):
	Box.test(x = fit$residuals, lag = 12, "Ljung-Box")$statistic

	
# ------------------------------------------------------------------------------


### Mills 2.5: Modelling the Dollar/Sterling Exchange Rate

	par (mfrow = c(2, 2), cex = 0.7)
	data(EXCHD)
	x = EXCHD[,1]
	ts.plot(x)
	
	x = diff(x)
	plot(x, type = "l", ylim = c(-0.1, 0.1))
	grid()
	
	
# ------------------------------------------------------------------------------


### Mills 2.6: Modelling the FTA ALL Share Index


	data(FTAPRICE)
	x = FTAPRICE[,1]
	par (mfrow = c(2, 2), cex = 0.7)
	ts.plot(x)
	ts.plot(x, log = "y")
	
	x = diff(log(x))
	arima(x, order = c(3, 0, 0))
	
	# Sample ACF and Sample PACF:
	data.frame(round(rbind( 
		"r(k)" = acf(x, lag.max = 12)$acf[,,1][-1], 
		"phi(kk)" = pacf(x, lag.max = 12)$acf[,,1]), 3))
				
	
# ------------------------------------------------------------------------------


### Mills 2.7: ARIMA Forecasting of Financial Time Series

	# Time Series Data:
	data(R20); data(RS)
	x = (R20-RS)[, 1]
	x[525:526]
	
	fit = armaFit(x ~ ar(2), "ols", include.mean = FALSE)	
	pred = predict(fit, 5)
	
	fit = armaFit(x ~ ar(2), "ols", include.mean = TRUE)	
	pred = predict(fit, 5)
	

################################################################################

#
# Examples:
#   A Compendium for R and Rmetrics users to the book 
#     "Modeling Financial Time Series with S-Plus" 
#     written by E. Zivot and J. Wang
#   ISBN 0-387-95549-6
#
# Description:
#   See Chapter 3 of the book.
#
# Notes:
#   This is not a COPY of the S-Plus "example.ssc" files accompanying the
#     book of Zivot and Wang. It is worth to note that this file contents a 
#     new implementation of the examples tailored to Rmetrics based on R.
#
# Author:
#   (C) Rmetrics 1997-2005, Diethelm Wuertz, GPL
# 	  www.rmetrics.org
# 	  www.itp.phys.ethz.ch
# 	  www.finance.ch
#


################################################################################
## Chapter 3 - Overview 


    # Zivot and Wang:
    #   "This chapter provides background material on time series 
    #   concepts that are used throughout the book. These concepts 
    #   are presented in an informal way, and extensive examples 
    #   using S-PLUS are used to build intuition. Section 3.2 
    #   discusses time series concepts for stationary and ergodic 
    #   univariate time series. Topics include testing for white 
    #   noise, linear and autoregressive moving average (ARMA) process, 
    #   estimation and forecasting from ARMA models, and long-run 
    #   variance estimation. Section 3.3 introduces univariate
    #   nonstationary time series and defines the important concepts 
    #   of I(0) and I(1) time series. Section 3.4 explains univariate 
    #   long memory time series. Section 3.5 covers concepts for 
    #   stationary and ergodic multivariate time series, introduces 
    #   the class of vector autoregression models, and discusses
    #   long-run variance estimation."
    ###
    
    
################################################################################
# Section 3.2 - Univariate Time Series Import


    # Chapter 3.2 - Load Data Sets:
    # Where are the unctions and Data?
    require(fBasics)
    require(fSeries)
    ###

    
    # IMPORTANT:
    # Remember, the data slot for 'timeDate' and 'timeSeries' objects 
    # is named here "@Data" and not "@.Data" what is used by S-Plus!
    ###
    
    
    # Example 1
    # Gaussian White Noise Processes ...
    # p.58
    set.seed(101)               
    y = rnorm(n = 100, sd = 1)
    # Estimate Sample Moments:
    y.bar = mean(y)
    g.hat = acf(y, lag.max = 10, type = "covariance", plot = FALSE)
    g.hat
    r.hat = acf(y, lag.max = 10, type = "correlation", plot = FALSE)    
    r.hat
    # Figure 3.1:
    # Plot Data and SACF 
    par(mfrow = c(2, 2), cex = 0.7)
    ts.plot(y, ylab = "y", main = "Series y", col = "steelblue4")
    grid()
    r.hat = acf(y, lag.max = 10, type = "correlation")  
    ###

    
    # Example 2
    # Testing for Normality ...
    # p. 60
    # Figure 3.2:
    par(mfrow = c(2, 1), cex = 0.7)
    qqnorm(y)
    qqline(y)
    # Normality tests
    normalTest(y, method = "sw")
    normalTest(y, method = "jb")
    ###

      
    # The file "DowJones30.csv" contains closing prices for 30 stocks
    # represented in the Dow Jones Industrial Average Index. 
    # Data are downloadable and can be updated from Yahoo's web site.   
    data(DowJones30)
    head(DowJones30)
    class(DowJones30)
    # Transform 'data.frame' to 'timSeries' object ...
    DowJones30 = as.timeSeries(DowJones30)
    class(DowJones30)
    c(start(DowJones30), end(DowJones30))
    ###
    
    
    # Example 3
    # Daily Returns on Microsoft ...
    # p.62
    # Note, Rmetrics uses for the computation of returns a function
    #   named 'returnSeries', this is in the tradition of the 
    #   other '*Series' functions ...
    r.msft = returnSeries(DowJones30[, "MSFT"], type = "continuous")
    r.msft@title = "Daily returns on Microsoft"
    c(start(r.msft), end(r.msft))
    # Rmetrics has a function to cut out a piece from a 'timeSeries'
    r.msft.2000 = cutSeries(r.msft, "2000-01-01", "2000-12-31")
    # Figure - 3.3:
    par(mfrow = c(3, 2), cex = 0.7)
    plot(r.msft.2000, type = "l", ylab = "r.msft", main = "MSFT",
        col = "steelblue4")
    abline(h = 0, lty = 3)
    r.acf = acf(seriesData(r.msft.2000), col = "steelblue4")
    hist(seriesData(r.msft), col = "steelblue4", border = "white")          
    qqnorm(seriesData(r.msft), col = "steelblue4")
    ###
    
    
    # Histogram/Quantile [sorry no Trellis] Plot:
    # p. 63
    # Note, Trellis plots are not yet available in Rmetrics
    #   Use alternatively the traditional plots ...
    par(mfrow = c(3, 2), cex = 0.7)
    hist(seriesData(r.msft), main = "MSFT monthly return",
        col = "steelblue4", border = "white")
    # Note, Rmetrics has a function 'histPlot' which also supports
    #   a 'timeSeries' object as input ...
    args(histPlot)
    histPlot(r.msft, main = "MSFT monthly return")
    # Quantile-Quantiles [Trellis] Plot:
    qqnorm(seriesData(r.msft), main = "MSFT monthly return",
        col = "steelblue4")
    # Add Line:
    qqline(seriesData(r.msft))
    # Note, Rmetrics has a function 'qqgaussPlot' which also supports
    #   a 'timeSeries' object as input ...
    #   [The function produces a normalized qqnorm plot]
    args(qqgaussPlot)
    qqgaussPlot(r.msft, span = 8, main = "MSFT standardized return")
    ###
    
    
    # Test for white noise using [autocorTest]:
    # p. 63
    # Note, Rmetrics has no function 'autocorTest' which performs
    #   the Box-Pierce and Ljung-Box test. Let us write one ...
    autocorTest = function(x, ...) UseMethod("autocorTest")
    autocorTest.default = 
        function(x, lag.n = 1, method = c("lb", "bp"), na.rm = FALSE) {
            x = as.vector(as.matrix(x)[,1])
            if (na.rm) x = na.omit(x)
            type = c(bp = "Box-Pierce", lb = "Ljung-Box") 
            type = type[method[1]]
            # Use Box.test() from 'stats'
            Box.test(x = x, lag = lag.n, type = type[method[1]]) }
    # Show Arguments:
    args(autocorTest.default)
    autocorTest(r.msft, lag.n = 10, method = "lb")
    # Or use directly ...
    Box.test(seriesData(r.msft), lag = 10, type = "Ljung-Box")
    ###
    

################################################################################
# Section 3.2.3 - Autoregressive Models


    # IMPORTANT NOTES:
    #   Note, there are essential differences between S-Plus and R
    #   Be aware of the details ... 
    help(arima)
    ###
    
    
    # Simulate Stationary AR(1) 
    # p. 66/67
    # with mu = 1, phi = .75 and sigma = 1
    # Note: set a seed to create reproducable results
    set.seed(101)
    # not needed: > e = rnorm(n = 100, sd = 1)
    # not needed: > e.start = rnorm(n = 25, sd = 1)
    y.ar1 = 1 + arima.sim(model = list(ar = 0.75), n = 100)
    mean(y.ar1)
    var(y.ar1)      
    # Compute true ACF:
    gamma.j = rep(0.75, 10)^seq(10)
    # Plot:
    # Figure 3.4
    par(mfrow = c(3, 2), cex = 0.7)
    ts.plot(y.ar1, main = "Simulated AR(1)", col = "steelblue4")
    grid()
    abline(h = 1)
    ts.plot(gamma.j, type = "h", main = "ACF and IRF for AR(1)",
        ylab = "Autocorrelation", xlab = "lag", col = "steelblue4")
    tmp = acf(y.ar1, lag.max = 10, col = "steelblue4")
    # Compute half life:
    log(0.5) / log(0.75)
    # Note, Rmetrics has also a synonyme function for 'ts.plot' ...
    tsPlot(y.ar1)
    ###

    
    # The file "lexrates.dat.csv) contains data for Spot and Forward 
    # Exchange Rate Data in Logarithmic Scale. The 12 data columns are:
    #   USCNS, USCNF, USDMS, USDMF, USFRS, USFRF, 
    #   USILS, USILF, USJYS, USJYF, USUKS, USUKF .
    # The first two letters abbreviate the home currency US Dollar,
    # the next two letters the foreign currency for the following six
    # countries/countries CN, DM, FR, IL, JY, UK, and the last letters
    # S or F abbreviates Spot or Forward.
    # Source:
    # Zivot E. (2000), Cointegration and forward and spot exchange 
    # rate regressions. Journal of International Money and Finance,
    # 19(6):785-812. 6:387-401. 
    # Data available from Thompson Financial, formerly Datastream.
    data(lexrates.dat) 
    lexrates.dat = as.timeSeries(lexrates.dat, format = "%m/%d/%Y")
    head(lexrates.dat)
    c(start(lexrates.dat),end(lexrates.dat))
    ###
    
        
    # ACF for Interest Rate Spreads:
    # p. 68
    # [from term structure and exchange rates]
    uscn.id = 100*(lexrates.dat[, "USCNF"] - lexrates.dat[, "USCNS"])
    # colIds(uscn.id) = "USCNID"
    uscn.id@title = "US/CA 30 day interest rate differential"
    # Figure 3.5
    # Plot:
    par(mfrow = c(3, 1), cex = 0.7)
    plot(uscn.id, type = "l", main = "Interest Rate Differential",
        col = "steelblue4")
    grid()
    abline(h = 0, lty = 3)
    tmp = acf(seriesData(uscn.id), main = "Interest Rate Differential",
        col = "steelblue4")
    ###

    
    # The file "varex.ts.csv" contains real stock returns and output 
    # growth data. The column MARKET.REAL lists continuously compounded 
    # real returns on the SP500 index, the column RF.REAL lists real 
    # interest rates of 30-day US Treasury Bills, the column INF lists
    # continuously compounded growth rate of US CPI, and the column
    # IPG lists continuously compounded growth rate of US industrial 
    # production. 
    # Data are downloadable from Economagic's web site, use the
    # Rmetrics function 'economagicImport'.
    data(varex.ts) 
    varex.ts = as.timeSeries(varex.ts)
    head(varex.ts)
    c(start(varex.ts), end(varex.ts))
    ###
    

    # Example 4: 
    # Monthly Real Interest Rates:
    # p. 71/72
    colIds(varex.ts)
    # Use alternatively ...
    colnames(seriesData(varex.ts))
    # ... or
    colnames(varex.ts@Data)
    # ... or
    varex.ts@units
    # Specify the in.format:
    smpl = cutSeries(varex.ts, from = "1961-01-01", to = end(varex.ts))
    irate.real = smpl[, "RF.REAL"]
    # Figure 3.6
    # Plot:
    par(mfrow = c(3, 2), cex = 0.5)
    tmp = acf(seriesData(irate.real))
    plot(irate.real, type = "l", col = "steelblue4",
        main = "Monthly Real Interest Rate")
    grid(lty = "solid")
    tmp = acf(seriesData(irate.real), type = "partial",
        col = "steelblue4")
    ###
    

################################################################################
# Section 3.2.4 - Moving Average Models


    # Example 5: 
    # p. 71-73
    # Simulate Signal + Noise Model - Try several samples:
    set.seed(8057)
    eps = rnorm(n = 100, sd = 1.0)
    eta = rnorm(n = 100, sd = 0.5)
    z = cumsum(eta)
    y = z + eps
    dy = diff(y)
    # Figure 3.7
    # Plot:
    par(mfrow = c(3, 2), cex = 0.7)
    ts.plot(y, main = "Signal plus Noise", ylab = "y", col = "steelblue4")
    grid()
    ts.plot(dy, main = "1st Difference", ylab = "dy", col = "steelblue4")
    tmp = acf(dy, col = "steelblue4")
    grid()
    tmp = acf(dy, type = "partial", col = "steelblue4")
    ###
    
    
    # The file "singleIndex.dat.csv" contains the monthly closing 
    # prices for Microsoft Corporation and the S&P 500 index.
    # Data are downloadable from Yahoo's web site.
    data(singleIndex.dat)
    singleIndex.dat = as.timeSeries(singleIndex.dat, format = "%d-%b-%Y")
    head(singleIndex.dat)
    c(start(singleIndex.dat), end(singleIndex.dat))
    ###

    
    # Example 6: 
    # p 73/74
    # Overlapping Annual Returns for [msft]
    sp500.mret = returnSeries(singleIndex.dat[, "SP500"], type = "continuous")
    sp500.mret@title = "Monthly Returns on SP 500 Index"
    # Use applySeries for aggregate Series ...
    # > sp500.aret = aggregateSeries(sp500.mret, moving = 12, FUN = sum)
    c(start(sp500.mret), end(sp500.mret))
    from = timeSequence(
        from = timeDate("1990-03-01"), 
        to = timeDate("2000-03-01"), 
        by = "month", 
        format = "%Y-%m-%d", 
        FinCenter = "") - 24*3600
    to = timeSequence("1991-02-01", "2001-02-01", 
        "month", format = "%Y-%m-%d", FinCenter = "") - 24*3600 
    sp500.aret = applySeries(x = sp500.mret, from, to, sum)
    sp500.aret@title = "Monthly Annual Returns on SP 500 Index"
    # Figure 3.8
    # Plot:
    par(mfrow = c(3, 2), cex = 0.5)
    plot(sp500.mret, type = "l", main = sp500.mret@title, col = "steelblue4")
    grid()
    plot(sp500.aret, type = "l", main = sp500.aret@title, col = "steelblue4")
    grid()
    tmp = acf(seriesData(sp500.aret), main = sp500.mret@title,
        col = "steelblue4")
    tmp = acf(seriesData(sp500.aret), type = "partial", 
        main = sp500.aret@title, col = "steelblue4")
    ###


################################################################################
# Section 3.2.6 - Estimation of ARMA Models and Forecasting 

    # Show Help Page:
    ?arima
    ###
    
    
    # Show Argument list:
    # p. 78
    # Use "arima" for "arima.mle"
    args(arima)
    ###
    
    
    # The file "lexrates.dat.csv" contains data for Spot and Forward 
    # Exchange Rate Data in Logarithmic Scale. The 12 data columns are:
    #   USCNS, USCNF, USDMS, USDMF, USFRS, USFRF, 
    #   USILS, USILF, USJYS, USJYF, USUKS, USUKF .
    # The first two letters abbreviate the home currency US Dollar,
    # the next two letters the foreign currency for the following six
    # countries/countries CN, DM, FR, IL, JY, UK, and the last letters
    # S or F abbreviates Spot or Forward.
    # Source:
    # Zivot E. (2000), Cointegration and forward and spot exchange 
    # rate regressions. Journal of International Money and Finance,
    # 19(6):785-812. 6:387-401. 
    # Data available from Thompson Financial, formerly Datastream.
    data(lexrates.dat)
    lexrates.dat = as.timeSeries(lexrates.dat, format = "%m/%d/%Y")
    head(lexrates.dat)
    end(lexrates.dat)
    uscn.id = 100*(lexrates.dat[, "USCNF"] - lexrates.dat[, "USCNS"])
    head(uscn.id)
    ###
    
    
    # Example 7: 
    # p. 78-80
    # Estimate ARMA(1,1) Model for [uscn.id]:
    # Get the data ...
    uscn.id.dm = uscn.id - mean(seriesData(uscn.id))
    # > arma11.mod = list(ar = 0.75, ma = 0)
    # > arma11.fit = arima.mle(uscn.id.dm, model = arma11.mod)
    # Use "arima" for "arima.mle" ...
    arma11.fit = arima(seriesData(uscn.id.dm), order = c(1, 0, 1), 
        include.mean = FALSE)
    # Print the components of the fit ...
    names(arma11.fit)
    # Print he basic fit results ...
    arma11.fit
    # Print the Standard Errors ...
    std.errs = sqrt(diag(arma11.fit$var.coef))
    names(std.errs) = colnames(arma11.fit$var.coef)
    std.errs
    ###
    
    
    # Note, Rmetrics has a function named 'armaFit', which uses a
    #   formula specification as input, which wraps several 
    #   estimation procedures and which returns a S4 object
    #   with all the information for model specification and 
    #   parameter estimation, try it ...
    args(armaFit)
    class(uscn.id.dm)
    fit = armaFit(uscn.id.dm ~ arma(1, 1), include.mean = FALSE)
    # For your information ...
    class(fit)
    slotNames(fit)
    # Print method:
    print(fit)
    # Plot method:
    par(mfrow = c(3, 2), cex = 0.7)
    plot(fit)
    # Summary method:
    summary(fit, doplot = FALSE)
    # Left to the reader, try different estimation methods!
    ###
   
       
    # Estimate ARMA(1,1) with a constant:
    # p. 80
    # > arma11.fit2 = arima.mle(uscn.id, model = arma11.mod, xreg = 1)
    # Again, use "arima" for "arima.mle" ...
    arma11.fit2 = arima(seriesData(uscn.id.dm), order = c(1, 0, 1))
    # Print Method:
    arma11.fit2
    # Graphical Diagnostics - Figure 3.9:
    # Use "tsdiag" for "plot"  ...
    tsdiag(arma11.fit2)
    ###
    
    
    # In Rmetrics this would simply read:
    # The default setting already includes a constant term.
    arma11.fit2 = armaFit(uscn.id.dm ~ arma(1, 1))
    par(mfrow = c(2, 2), cex = 0.7)
    summary(arma11.fit2)
    ###
    
        
    # Produce h-step Ahead Forecasts:
    # p. 81
    end(uscn.id.dm)
    fcst.dates = timeSequence(from = "7/1/1996", to = "6/1/1997", 
        by = "months", format = "%m/%d/%Y")
    fcst.dates
    # Predict:
    uscn.id.dm.fcst = predict(arma11.fit2, n.ahead = 12)
    # Convert to data.frame Object:
    uscn.id.dm.fcst.df = data.frame(
        date = as.character(fcst.dates),
        pred = round(uscn.id.dm.fcst$pred, 4))
    uscn.id.dm.fcst.df
    # Convert to time Series Object:
    as.timeSeries(uscn.id.dm.fcst.df)
    ### ERROR
    
        
    # Names - Forecast and Standard Errors:
    names(uscn.id.dm.fcst)
    # Print Forecasts:
    pred = as.vector(uscn.id.dm.fcst[[1]])
    # Sorry, at the moment we have no better plot facilities,
    # the poor man's approach ...
    # Subsample Data:
    smpl = cutSeries(uscn.id.dm, from = "6/1/1995", to = "12/31/1999")
    c(start(smpl), end(smpl))
    time.smpl = 1995.5 + (0:12)/12
    data.smpl = as.vector(smpl@Data)
    par(mfrow = c(2, 1), cex = 0.5)
    plot(time.smpl, data.smpl, type = "l", 
        xlim = c(1995.5, 1997.5), ylim = c(-0.3, 0.35),
        main = "US/CA 30 day interest rate differential")
    grid(lty=1)
    # Predicted Data:
    time.pred = 1996.5 + (0:11)/12
    data.pred = as.vector(pred)
    lines(time.pred, data.pred, lty = 3, col = "steelblue4")
    # Standard Errors:
    se = as.vector(uscn.id.dm.fcst[[2]])
    lines(time.pred, data.pred+2*se, lty = 3, col = "steelblue4")
    lines(time.pred, data.pred-2*se, lty = 3, col = "steelblue4")
    abline(h = 1996.5, col = "steelblue4")
    ### ERROR

    
    # Some words about OLS ...
    # R and Rmetrics have no special function for OLS, ...
    # Usually, we can use the function "lm" or OLS functions
    # from the packages "Hmisc" and "systemfit". Here we
    # use "lm" and compare the results with those from
    # OLS given in the book, to use OLS estimators from "Hmisc"
    # and "systemfit" is left to the reader ...
    ###
    
    
    # Estimate AR(2) using OLS:
    # p. 82
    # > ar2.fit = OLS(USCNID ~ ar(2), data = uscn.id)
    # > ar2.fit
    # > abs(polyroot(c(1,-ar2.fit$coef[2:3])))
    # Use "lm", unfortunately "lm" cannot handle the formula 
    # expression ~ ar(2), so her comes a workaround ...
    uscn.id.ts = mergeSeries(
        x = uscn.id, y = cbind(
            as.matrix(lagSeries(uscn.id, k=1)),
            as.matrix(lagSeries(uscn.id, k=2))))
    head(uscn.id.ts)
    # Change column names:
    colnames(uscn.id.ts@Data) = c("USCNID", "LAG1", "LAG2")
    head(uscn.id.ts)    
    # Remove NAs:
    uscn.id.ts = uscn.id.ts[-(1:2), ]
    head(uscn.id.ts)    
    # Fit by OLS/lm:
    ar2.fit = lm(USCNID ~ LAG1 + LAG2, data = uscn.id.ts)
    ar2.fit
    abs(polyroot(c(1,-ar2.fit$coef[2:3])))
    # Note, you can also use directly the R function "ar".
    ###
    
    
################################################################################
# Section 3.2.7 -  Martingales and Martingale Difference Sequences


    # Example 8: 
    # p. 84
    # Simulate ARCH(1) process
    # For Bollerslev's "garch" modeling you can find functions to 
    # model garch processes in the contributed R-package 'tseries', 
    # but unfortunately there is no function to simulate a garch
    # process. So we will write a simple one ...
    garch.sim = function(model = list(omega = 1e-06, alpha = 0.1, 
        beta = 0.8, mu = 0), n = 100, innov = NULL, n.start = 100, 
        start.innov = NULL, rand.gen = rnorm, ...) {
            # All entries in the model list must be specified!
            max.order = max(length(model$alpha), length(model$beta))
            if (is.null(start.innov)) start.innov = rand.gen(n.start, ...)
            if (is.null(innov)) innov = rand.gen(n, ...)
            h = x = z = c(start.innov, innov)
            for (i in 1:max.order) {
                h[i] = model$omega/(1-sum(model$alpha)-sum(model$beta))
                x[i] = sqrt(h[i])*z[i]+model$mu }
            n.alpha = length(model$alpha)
            n.beta = length(model$beta)
            for (i in (max.order + 1):(n.start + n)) {
                h[i] = model$omega + sum(model$alpha*x[i-(1:n.alpha)]^2) + 
                    sum(model$beta*h[i-(1:n.beta)])
                x[i] = sqrt(h[i])*z[i] + model$mu }
            list(et = x[-(1:n.start)], sigma.t = h[-(1:n.start)]) }
    # > rt = simulate.garch(model = list(a.value = 0.1, arch = 0.8), ...
    # Use "garch.sim" for "simulate.garch" ...
    set.seed(853)
    rt = garch.sim(
        model = list(omega = 0.1, alpha = 0.8, beta = 0, mu = 0), n = 250)
    # Note, omega seems unrealistic large to me ...
    class(rt)
    names(rt)
    # Plot - Figure 3.11:
    par(mfrow = c(2, 1), cex = 0.75)
    ts.plot(rt$et, ylim = c(-2,2), 
        xlab = "", ylab = "", col = "steelblue4",
        main = "Simulated returns")
    grid()
    ts.plot(rt$sigma.t, xlab = "", ylab = "", 
        col = "steelblue4",
        main = "Simulated volatility")
    grid()
    ### ???
    
    
################################################################################
# Chapter 3.2.8 -  Long-Run Variance


    # Example 9
    # p. 87
    # Long-run variance of AR(1)    
    set.seed(101)
    e = rnorm(n = 100, sd = 1)
    # use 'arima.Sim' for Splus like 'arima.sim'
    y.ar1 = 1 + arima.sim(n = 100, model = list(ar = 0.75), innov = e)
    y.ar1
    # Use "lm" to fit ...
    # > ar1.fit = OLS(y.ar1 ~ ar1, data = ar1)
    N = length(y.ar1)
    ar1 = data.frame(y.ar1 = y.ar1[-1], ar1 = y.ar1[-N])
    ar1.fit = lm(y.ar1 ~ ar1, data = ar1)
    ar1.fit
    rho.hat = coef(ar1.fit)[2]
    sig2.hat = sum(residuals(ar1.fit)^2)/ar1.fit$df.resid
    # Long range Variance:
    lrv.ar1 = sig2.hat/(1-rho.hat)^2
    as.numeric(lrv.ar1)
    # Standard Error:
    se.ybar.ar1 = sqrt(lrv.ar1/100)
    as.numeric(se.ybar.ar1)
    ###
    

    # Newey-West Estimate
    # p. 88
    # Sorry not yet available ...
    # > args(asymp.var)
    # > lrv.nw = asymp.var(y.ar1, bandwidth = 4)
    # > lrv.nw
    # > sqrt(lrv.nw/100)
    ###


################################################################################
# Chapter 3.3 - Univariate Nonstationary Time Series


    # Example 10 
    # p. 88/89
    # Trend Stationary AR(1) ...
    # with mu = 1, delta = 0.25, phi = 0.75 and sigma = 1
    # > set.seed(101)
    y.tsar1 = 1 + 0.25*seq(100) + arima.sim(model = list(ar = 0.75), n = 100)
    # Figure 3.12
    # Plot:
    par(mfrow = c(2,1), cex = 0.7)
    ts.plot(y.tsar1, xlab = "Index", ylab =" y", 
      main = "Trend Stationary AR(1)")
    abline(a = 1, b = 0.25, col = "steelblue4")
    ###
    

    # Example 11
    # p. 91
    # Simulated I(1) processes ...
    # > set.seed(101)
    set.seed(931)
    u.ar1 = arima.sim(model = list(ar = 0.75), n = 100)
    y1 = cumsum(u.ar1)
    y1.d = 1 + 0.25*seq(100) + y1
    y2 = rep(0, 100)
    for (i in 3:100) { y2[i] = 2*y2[i-1] - y2[i-2] + u.ar1[i] }
    # Figure 3.13
    # Plot:
    par(mfrow = c(3, 2), cex = 0.5)
    ts.plot(u.ar1, main = "I(0) innovations", col = "steelblue4")
    ts.plot(y1, main = "I(1) process", col = "steelblue4")
    ts.plot(y1.d, main = "I(1) process with drift", col = "steelblue4")
    abline(a = 1, b = 0.25)
    ts.plot(y2, main = "I(2) process", col = "steelblue4")
    ###


    # Example 12
    # p 91/92
    # Financial time series ...
    data(lexrates.dat)
    lexrates.dat = as.timeSeries(lexrates.dat)
    uscn.spot = lexrates.dat[, "USCNS"]
    data(singleIndex.dat)
    singleIndex.dat = as.timeSeries(singleIndex.dat)
    sp500 = singleIndex.dat[, "SP500"]
    # Figure 3.14
    # Plot:
    par(mfrow = c(3, 2), cex = 0.7)
    plot(uscn.spot, main = "Log US/CA spot exchange rate",
        reference.grid = FALSE, type = "l", col = "steelblue4")
    # R/Rmetrics has no log for timeSeries objects,
    # Use the workaround ...
    sp500.log = sp500
    sp500.log@Data = log(sp500@Data)
    plot(sp500.log, main = "Log S&P 500 index", 
       reference.grid = FALSE, type = "l", col = "steelblue4")
    # 30-Day Tbills:    ) 
    data(rf.30day) 
    # Convert to timeSeries object:
    rf.30day = as.timeSeries(rf.30day)      
    plot(rf.30day, main = "Nominal 30 day T-bill rate", ylab = "Rate",
        reference.grid = FALSE, type = "l", col = "steelblue4")
    # CPI:
    data(CPI.dat)
    CPI.dat = as.timeSeries(CPI.dat, format = "%d-%B-%Y")
    CPI.dat.log = CPI.dat
    CPI.dat.log@Data = log(CPI.dat@Data)
    plot(CPI.dat, main = "Log of US CPI", ylab = "log CPI.dat", 
        reference.grid = FALSE, type = "l", col = "steelblue4")
    ###
    

################################################################################
# Chapter 3.4 - Long Memory Time Series


    # Example 13
    # p. 93 
    # Simulated fractional white noise
    # In R you need the contributed package "fracdiff" ...
    # > require(fracdiff)   
    # > y.fwn = simulate.FARIMA(model = list(ar = 0, ma = 0, d = 0.3), n = 500)
    # Use alternatively ...
    # > args(fracdiff.sim)
    # > y.fwn = fracdiff.sim(n = 500, ar = 0, ma = 0, d = 0.3, mu = 0)$series 
    # In Rmetrics 'fracdiff' is builtin in 
    ?armaModelling
    args(armaSim)
    # Simulate:
    y.fwn = armaSim(model = list(ar = 0, d = 0.3, ma = 0), n = 500) 
    # Figure 3.15
    # Plot:
    par(mfrow = c(2, 1), cex = 0.7)
    ts.plot(y.fwn, main = "Series y.fwn", col = "steelblue4")
    grid()
    tmp = acf(y.fwn, lag.max = 50)
    ###


    # Example 14: 
    # p. 93/94
    # Long memory in financial time series
    # 'abs' does't work on 'timeDate' objects, use 'seriesData':
    msft.aret = abs(seriesData(returnSeries(DowJones30[, "MSFT"])))
    uscn.id = seriesData(100*(lexrates.dat[,"USCNF"]-lexrates.dat[,"USCNS"]))
    # Plot - Figure 3.16:
    par(mfrow = c(2, 1), cex = 0.7)
    tmp = acf(msft.aret, lag.max = 100, main = "MSFT Annual Returns")
    tmp = acf(uscn.id, lag.max = 50, main = "Monthly 30-day Interest Rates")
    ###
    
    
################################################################################
# Section 3.5.1 - Stationary and Ergodic Multivariate Time Series


    # Example 15
    # p 96/97
    # System of asset returns:
    Y = returnSeries(DowJones30[, 1:4], type = "continuous")
    colnames(seriesData(Y))
    Y@units
    # Compute means and variances and correlations
    y = seriesData(Y)
    colMeans(y) 
    var(y)                  
    cor(y)
    # Add functions for "colVars" and "colStdevs" ...
    colVars = function(x) { apply(x, MARGIN = 2, FUN = var) }
    colStdevs = function(x) { sqrt(apply(x, MARGIN = 2, FUN = var)) }
    colVars(y)
    colStdevs(y)
    ###
    
    
    # Example 16
    # p. 98/99
    # Lead-lag covariances and correlations among asset returns ...
    y = seriesData(Y)
    Ghat = acf(y[, 1:2], lag.max = 5, type = "covariance", plot = FALSE)
    Rhat = acf(y[, 1:2], lag.max = 5, plot = FALSE)
    Rhat    
    par(mfrow = c(2, 2), cex = 0.7)
    acf.plot(Rhat)
    # Use the same number of digits as in the book ...
    round(Ghat$acf[1, , ], digits = 8)
    round(Rhat$acf[1, , ], digits = 4)
    Ghat$acf[2, , ]
    round(Rhat$acf[2, , ], digits = 5)
    ###


################################################################################
# Section 3.5.2 - Multivariate Wold Representation


    # Simulate VAR(1) model: 
    # Note, can't use filter() for efficiency
    nobs = 250
    # Note, the multivariate normal distribution function 'mvrnorm' 
    #   can be found in library MASS, or we can simulate normal random 
    #   variates directly ...
    # For 
    # > e.var = rmvnorm(nobs, sd = c(1, 1), rho = 0.5)
    # we use:
    set.seed(4711)
    rho = 0.5
    X =  matrix(rnorm(2 * nobs), nobs)
    Sigma = matrix(c(1, rho, rho, 1), 2)
    eS = eigen(Sigma, sym = TRUE)
    e.var = t(eS$vectors %*% diag(sqrt(pmax(eS$values, 0)), 2) %*% t(X))
    # Show:
    e.var
    # Test:
    cov(e.var)
    # VAR(1) coef Matrix:
    pi1 = matrix(c(0.7, 0.2, 0.2, 0.7), 2, 2, byrow = TRUE)  
    # Mean vector :                            
    mu.vec = c(1, 2)                                   
    # Intercept in VAR:
    c.vec = as.vector((diag(2)-pi1)%*%mu.vec)      
    y.var = matrix(rep(0, 2*nobs), 2)
    # Initial Value is mean:
    y.var[, 1] = mu.vec                             
    for (i in 2:nobs) 
        y.var[, i] = c.vec + pi1 %*% y.var[, i-1] + e.var[i, ]
    y.var = t(y.var)
    # Show:
    dimnames(y.var) = list(NULL, c("y1", "y2"))
    as.data.frame(y.var)
    colMeans(y.var)
    # Plot:
    par(mfrow = c(2, 1), cex = 0.7)
    ts.plot(y.var, col = c("red", "blue"), ylab = "AR", 
        main = "Two correlated AR(1) processes, rho=0.5")
    ###
    
    
################################################################################
# Section 3.5.3 - Long Run Variance


    # Example 17
    # Newey-West estimate of long-run variance matrix for stock returns
    Y = returnSeries(DowJones30[, 1:4], type = "continuous")
    M.T = floor(4*(nrow(as.data.frame(Y))/100)^(2/9)) # 8
    M.T
    # Note, sorry a function for 'asymp.var' is not yet 
    #   implemented ...
    # lrv.nw = asymp.var(Y, bandwidth = M.T)
    # lrv.nw
    ### TODO
       

################################################################################

#
# Examples from the forthcoming Monograph:
# 	Rmetrics - Financial Engineering and Computational Finance
#   A Practitioner's Guide for R and SPlus Programmers
#   written by Diethelm Wuertz
#   ISBN to be published
#
# Details:
#   Examples from Chapter 3.5
#   Nonlinear and Chaotic Time Series
#
# List of Examples, Exercises and Code Snippets:
#
#   3.5.1 Example: Plot Tent Map
#       * Example: Plot Logistic Map
#   3.5.2 Example: Bifurcation Diagram of the Logistic Map
#   3.5.3 Example: Plot Henon Map
#   3.5.4 Example: Plot Ikeda Map
#       * Code Snippet: 'ikedaSim' Function
#   3.5.5 Example: Plot Lorentz Attractor  
#   3.5.6 Example: Plot Roessler Attractor 
#       * Example: Roessler ODE Solver Test
#       * Example: Lorentz ODE Solver Test
#   3.5.7 Example: Determine Time Delay for Roessler Map
#   3.5.8 Example: Determine Embedding Dimension for Roessler Map
#       * Example: USDDEM - Mutual Information
#       * Example: Roessler - Phase Space Reconstruction
#       * Example: Lorentz - Phase Space Reconstruction
#       * Example: Lorentz Attractor - 3D Plot
#		* Example: Lyapunov Slider
#		* Example: False Nearest Neighbours Slider
#		* Example: Henon Map Slider
#		* Example: Teraesvirta Neural Network Test for Nonlinearity
#	    * Example: White Neural Network Test for Nonlinearity
#		* Example: BDS Time Series Test
#
# Author:
#	(C) 1997-2005, Diethelm Wuertz, GPL
# 	  www.rmetrics.org
# 	  www.itp.phys.ethz.ch
# 	  www.finance.ch
#


################################################################################
# Simulation of Chatic Time Series:


### 3.5.1 Example: Plot Tent Map

	# Graph Frame:
	par(mfrow = c(2, 2), cex = 0.7)
	###
		
	# Tent Map:
	a = 1.99
	x = tentSim(n = 1000, parms = a, start = pi/8, doplot = TRUE)[ ,1]
	###
		
	# Plot Series:
	plot(x, type = "l", col = "steelblue")	
	abline(h = 0.5, col = "grey", lty = 3)
	title(main = paste("Tent Map \na =", as.character(a)))
	###	
	
	# Tent Map - Another Control Parameter:
	a = sqrt(2)
	x = tentSim(n = 1000, parms = a, start = pi/8, doplot = TRUE)[ ,1]
	plot(x, type = "l", col = "steelblue")	
	abline(h = 0.5, col = "grey", lty = 3)
	title(main = paste("Tent Map \na =", as.character(a)))
	###

	
# ------------------------------------------------------------------------------


### Example: Plot Logistic Map

	# Graph Frame:
	par(mfrow = c(2, 2), cex = 0.7)
	###
	
	# Logistic Map:
	for (r in c(3, 4)) {
		# Map:
		x = logisticSim(parms = r, start = pi/8, doplot = TRUE)[, 1]
		# Series:
		plot(x, type = "l", col = "steelblue")	
		title(main = paste("Logistic Series \nr =", r))
	}
	###


	
# ------------------------------------------------------------------------------


### 3.5.2 Example: Bifurcation Diagram of the Logistic Map

	# Graph Frame:
	par(mfrow = c(2, 1), cex = 0.7)
	plot(c(0,4), c(0,1), type = "n", xlab = "r", ylab = "x")
	title(main = "Logisit Map"))
	###
	
	# Bifurcation Diagram:
	for ( r in seq(0, 4, length = 801) ) {
		N = floor(r * 200 + 1)
		print(N)
		x = rep(r, times = N)
		y = logisticSim(n = N, n.skip = 100, parms = r, start = pi/8)[ ,1]
		# Fill Diagram:
		points(x, y, cex = 0.25, col = "steelblue")
	}
	###
	
	# Exercise: 
	# Create Bifurcation Diagram of the Tent Map
	###
	
	
# ------------------------------------------------------------------------------


### 3.5.3 Example: Plot Henon Map

	# Graph Frame:
	par(mfrow = c(2, 2), cex = 0.7)
	###
		
	# Show the strange attractor for a=1.4 and b=0.3:
	x = henonSim(doplot = TRUE)
	plot.ts(x[, 1], col = "steelblue", xlab = "x")
	title(main = "Henon Series \n a = 1.4  b = 0.3")
	###

	# Show the evolution of the point (0,0) for parameters 
	# a=0.2 and b=0.9991 and b=-0.9999
	x = henonSim(n = 5000, n.skip = 0, parms = c(a = 0.2, b = 0.991), 
    	start = c(0, 0), doplot = TRUE)
    x = henonSim(n = 5000, n.skip = 0, parms = c(a = 0.2, b = -0.9999), 
    	start = c(0, 0), doplot = TRUE)
    ###  	
    	
    	
# ------------------------------------------------------------------------------


### 3.5.4 Example: Plot Ikeda Map

	# Graph Frame:
	par(mfrow = c(2, 2), cex = 0.7)
	###
		
	# Show the strange attractor for the default
    # setting a=0.4, b=6, and c=0.9:
    z = ikedaSim(doplot = TRUE)
    ###

    # Series Plots - the first 100 Values:
    n = 1:100
    plot(n, z[1:100, 1], col = "steelblue",
        ylab = "x = Re(z)", type = "l",
        main = "Ikeda Series \n a = 0.4  b = 6  c = 0.9")
    plot(n, z[1:100, 2], col = "steelblue",
        ylab = "y = Im(z)", type = "l",
        main = "Ikeda Series \n a = 0.4  b = 6  c = 0.9")
    ###
    	
    	
# ------------------------------------------------------------------------------


### Code Snippet: 'ikedaSim' Function

    # Graph Frame:
	par(mfrow = c(2, 2), cex = 0.7)
	###
	
	# Write a function to generate the Ikeda Map - Use complex arithmetic:
	.ikedaSim =
    function (n = 1000, parms = c(a = 0.4, b = 6, c = 0.9))
    {
        # Settings:
        a = complex(real = 0, imag = parms[1])
        b = complex(real = 0, imag = parms[2])
        c = parms[3]
        z = rep(complex(real = 0, imag = 0), times = n)
        # Iterate:
        for (i in 2:n)
            z[i] = 1 + c*z[i-1]*exp(a-b/(1+abs(z[i-1])^2))
        # Return Value:
        data.frame(Re(z), Im(z))
    }
    ###

    # Try:
    plot(.ikedaSim(), cex = 0.25, main = "Ikeda Map")
    ###

        
# ------------------------------------------------------------------------------


### 3.5.5 Example: Plot Lorentz Attractor

	# Graph Frame:
	par(mfcol = c(3, 2), cex = 0.7)
	###
	
	# Lorentz Attractor - Use default values:
    ans = lorentzSim(times = seq(0, 40, by = 0.01),
        parms = c(sigma = 16, r = 45.92, b = 4),
        start = c(-14, -13, 47), doplot = TRUE)
    ###
    
    
# ------------------------------------------------------------------------------


### 3.5.6 Example: Plot Roessler Attractor

	# Graph Frame:
	par(mfcol = c(3, 2), cex = 0.7)
	###
	
	# Roessler Attractor - Use default values:
    ans = roesslerSim(times = seq(0, 100, by = 0.01),
        parms = c(a = 0.2, b = 0.2, c = 8),
        start = c(-1.894, -9.92, 0.025), doplot = TRUE)
    ###
    
    
# ------------------------------------------------------------------------------


### Example: Roessler ODE Solver Test

	# Compare the Roessler maps generated by the 'tseriesChaos'
	# and Rmetrics 'fSeries' package by computing their mutual
	# information.
	# Note, the difference is in usage of the Runge-Kutta solver
	# in 'fSeries' and of the "lsoda" solver in 'tseriesChaos'.
	###
	
	# Graph Frame:
	par(mfrow = c(2,2), cex = 0.7)
	###
	
	# What delivers 'tseriesChaos' ?
	require(tseriesChaos)
	lags = 60
	plot(rossler.ts, main = "lsoda Solver")
	m = mutual(rossler.ts, lag.max = lags)
	plot(0:lags, m, type = "b")
	###
	
	# What delivers 'fSeries' ?
	rossler2.mat = roesslerSim(time = seq(0, 650, by = 0.1),  
		parms = c(a = 0.15, b = 0.2, c = 10), 
		start = c(0, 0, 0), doplot = FALSE )
	rossler2.ts = ts(rossler2.mat[,2], start = 0, end = 650, deltat = 0.1)
	plot(rossler2.ts, main = "rk4 Solver")
	m2 = mutual(rossler2.ts, lag.max = lags)
	plot(0:lags, m2, type = "b")
	points(0:lags, m, pch = 19, col = "red", cex = 0.5)
	###
	
	# Almost the same ...
	###
	
		
# ------------------------------------------------------------------------------


### Example: Lorentz ODE Solver Test
	
	# Graph Frame:
	par(mfrow = c(2,2), cex = 0.7)
	###
	
	# What delivers 'tseriesChaos' ?
	require(tseriesChaos)
	lags = 60
	plot(lorenz.ts, main = "lsoda Solver")
	m = mutual(lorenz.ts, lag.max = lags)
	plot(0:lags, m, type = "b")
	###
	
	# What delivers 'fSeries' ?
	# Note the definition of the sign of 'b' is opposite!
	lorenz2.mat = lorentzSim(time = seq(0, 100, by = 0.05),  
		parms = c(sigma = 10, r = 28, b = 8/3), 
		start = c(5, 5, 5), doplot = FALSE )
	lorenz2.ts = ts(lorenz2.mat[,4], start = 0, end = 100, deltat = 0.05)
	plot(lorenz2.ts, main = "rk4 Solver")
	m2 = mutual(lorenz2.ts, lag.max = lags)
	plot(0:lags, m2, type = "b")	
	points(0:lags, m, pch = 19, col = "red", cex = 0.5)
	###
	
	# Almost the same ...
	###
	
	m3 = mutual(as.vector(lorenz2.ts), lag.max = lags)
	points(0:lags, m3, pch = 19, col = "blue", cex = 0.5)
	###
	
	
# ------------------------------------------------------------------------------


### 3.5.7 Example: Determine Time Delay for Roessler Map

	# Graph Frame:
	par(mfrow = c(2, 2), cex = 0.7)
	###
	
	# Create Default Series:
	deltat = 0.01
	times = seq(0, 100, by = deltat)
	roessler.dat = roesslerSim(times, start = c(4.72, 1.43, 0.015),
		doplot = FALSE)
	roessler.x = roessler.dat[, 2]
	roessler.ts = ts(roessler.x, start = 0, end = 100, deltat = deltat)
	plot(roessler.ts, main = "Series: Roessler", col = "steelblue")
	###
	
	# Determine tau from ACF:
	ac = acfPlot(roessler.ts, lag.max = 2/deltat, 
		main = "Autocorrelation", col = "steelblue")$acf
	tau.ac = length(ac[ac>0])
	abline(v = tau.ac, lty = 3)
	print(tau.ac)
	###
		
	# Determine tau from Mutual Information:
	mi = mutualPlot(roessler.ts, partitions = 20, lag.max = 2*tau.ac)
	tau.mi = which(mi == min(mi))[[1]] - 1
	abline(v = tau.mi, lty = 3)
	print(tau.mi)
	###
	
	
# ------------------------------------------------------------------------------


### 3.5.8 Example: Determine Embedding Dimension for Roessler Map

	# First execute Example 3.5.7, if not already done just before ...
	###
	
	# Determine Embedding m from false nearest neigbours:
	falsennPlot(roessler.ts, m = 6, d = tau.mi, t = 40, rt = 10, ylim = c(0,1)) 
	abline(h = 0, lty = 3) 
	###

	
# ------------------------------------------------------------------------------	
		

### Example: USDDEM - Mutual Information

	USDDEM = as.timeSeries(data(usddem30u))
	USDDEM.RET = returnSeries(USDDEM, digits = 12)[, 1]
	usddem.ts = as.ts(as.vector(USDDEM.RET))
	M = mutual(usddem.ts, lag.max = 100)
	plot(log(M))
	###
	
	usddemVol.ts = as.ts(100*abs(as.vector(USDDEM.RET)))
	M = mutual(usddemVol.ts, partitions = 22, lag.max = 672)
	plot(log(M))
	acf(usddemVol.ts, lag.max = 336)
	###
	
	usddemRet.ts = as.ts(100*as.vector(USDDEM.RET))
	M = mutual(usddemVol.ts, partitions = 22, lag.max = 672)
	plot(M[-1])
	acf(usddemRet.ts, lag.max = 672)
	###
	
	# Try an iid sequence:
	N = length(usddem.ts)
	Mean = mean(100*usddem.ts)
	Sd = sd(100*usddem.ts)
	rnorm.ts = as.ts(rnorm(N, Mean, Sd))
	M = mutual(rnorm.ts, partitions = 22, lag.max = 672)
	plot(M[-1], type = "b", pch = 19)
	###
	

# ------------------------------------------------------------------------------


### Example: Roessler - Phase Space Reconstruction

	# Determine m from false nearest neigbours:
	falsennPlot(roessler.ts, m = 6, d = tau.mi, t = 40, rt = 10, ylim = c(0,1)) 
	abline(h = 0, lty = 3) 
	
	# Reconstruction:
	par(mfrow = c(2, 2), cex = 0.7)
	for (d in c(50, 150, 250)) {
		x = .embeddPSR(roessler.ts, m = 3, d = d)
		plot(x[,1], x[,2], type = "l", col = "steelblue")
		title (main = paste("Delay =", d))
	}
	plot(roessler.dat[, 2:3], type = "l", col = "steelblue")
	title(main = "Roessler")
	###
	
	
# ------------------------------------------------------------------------------
 
    
### Example: Lorentz - Phase Space Reconstruction

	# Graph Frame:
	par(mfrow = c(2, 2), cex = 0.7)
	###
	
	# Create Default Series:
	parms.map = c(sigma = 16, r = 46, b = 4)
	start.map = c(-12.3, -12.5, 43)
	lorentz.dat = lorentzSim(times, parms = parms.map, start = start.map, 
		doplot = FALSE)
	lorentz.z = lorentz.dat[, 2]
	lorentz.ts = ts(lorentz.z, start = 0, end = 40, deltat = 0.01)
	plot(lorentz.ts, main = "Series", col = "steelblue")
	##
	
	# Determine tau from ACF:
	ac = acfPlot(lorentz.ts, lag.max = 100, main = "", col = "steelblue")$acf
	title(main = "Autocorrelation")
	tau.ac = length(ac[ac>0])
	abline(v = tau.ac, lty = 3)
	print(tau.ac)
	###
		
	# Determine tau from Mutual Information:
	mi = mutualPlot(lorentz.ts, partitions = 22, lag.max = 20)
	tau.mi = which(mi == min(mi))[[1]] - 1
	abline(v = tau.mi, lty = 3)
	print(tau.mi)
	###
	
	# Determine m from false nearest neigbours:
	falsennPlot(lorentz.ts, m = 6, d = tau.mi, t = 100, rt = 10, ylim = c(0,1)) 
	abline(h = 0, lty = 3)
	# Result is 3 ... 6
	###
	
	# Reconstruction:
	par(mfrow = c(2, 2), cex = 0.7)
	for (d in c(5, 10, 15)) {
		x = .embeddPSR(lorentz.ts, m = 3, d = d)
		plot(x[,1], x[,2], type = "l", col = "steelblue")
		title (main = paste("Delay =", d))
	}
	plot(lorentz.dat[, 2:3], type = "l", col = "steelblue")
	title(main = "Lorentz")
	###
	

# ------------------------------------------------------------------------------


### Example: Lorentz Attractor - 3D Plot

	require(scatterplot3d)
	par(mfrow = c(2, 2), cex = 0.7)
	lorentz.mat = lorentzSim(doplot = FALSE)[, -1]
	scatterplot3d(lorentz.mat, type = "l", color = "steelblue",
		main = "Lorentz")
	roessler.mat = roesslerSim(doplot = FALSE)[, -1]
	scatterplot3d(roessler.mat, type = "l", , color = "steelblue",
		main = "Roessler")
   	###
   	

# ------------------------------------------------------------------------------


### Example: Lyapunov Slider

	x = logisticSim(n = 5000, parms = c(r = 4), start = pi/8)[,1]
	lyapunovPlot(x, m=1, d=1, t=40, ref=200, s=100, eps=2, k = 1, doplot = TRUE) 

	x = logisticSim(n = 5000, parms = c(r = 4), start = pi/8)[,1]
	falsennPlot(x, m=10, d=1, t=10, rt=10)
	
	# Write Function:
	.logisticLyapunovSlider =
	function()
	{   # A function implemented by Diethelm Wuertz
	
	    # FUNCTION:
	    
	    # Graph Frame:
	    par(mfrow = c(1, 1), cex = 0.7)
	    
	    # Internal Function:
	    refresh.code = function(...)
	    {
	        # Sliders:
	        N = .sliderMenu(no = 1)
	        r = .sliderMenu(no = 2)
	        m = .sliderMenu(no = 3)
	        d = .sliderMenu(no = 4)
	        t = .sliderMenu(no = 5)
	        ref = .sliderMenu(no = 6)
	        s = .sliderMenu(no = 7)
	        eps = .sliderMenu(no = 8)
	        
	        # Plot Data:     
	        x = logisticSim(n = N, parms = c(r = r), start = pi/8)[,1]
			y = lyapunovPlot(x, m, d, t, ref, s, eps, k=1, doplot = FALSE)
			plot.ts(y, ylim = c(-10, 2))
			abline(h = 0, lty = 3)
	        
	        # Reset Frame:
	        par(mfrow = c(1, 1), cex = 0.7)
	    }
	  
	    # Open Slider Menu:
	    .sliderMenu(refresh.code,
	       names =       c(  "N",  "r", "m", "d", "t", "ref", "s", "eps"),
	       minima =      c( 1000,    0,   1,   1,   5,    10,  10,    10),
	       maxima =      c(10000,    4,  10,  10, 100,   500, 500,   500),
	       resolutions = c(  500,  0.1,   1,   1,   5,    10,  10,    10),
	       starts =      c( 1000,    4,   1,   1,  20,    10,  10,    10))
	}
		
	
	.logisticLyapunovSlider()


# ------------------------------------------------------------------------------


### Example: False Nearest Neighbours Slider

	x <<- logisticSim(n = 5000, parms = c(r = 4), start = pi/8)[,1]
	
	# Write Function:
	.falsennSlider =
	function()
	{   # A function implemented by Diethelm Wuertz
	
	    # FUNCTION:
	    
	    # Graph Frame:
	    par(mfrow = c(1, 1), cex = 0.7)
	    
	    # Internal Function:
	    refresh.code = function(...)
	    {
	        # Sliders:
	        m = .sliderMenu(no = 1)
	        d = .sliderMenu(no = 2)
	        t = .sliderMenu(no = 3)
	        rt = .sliderMenu(no = 4)
	       
	        # Plot Data:     
			y = falsennPlot(x, m, d, t, rt, doplot = TRUE)
	
	        
	        # Reset Frame:
	        par(mfrow = c(1, 1), cex = 0.7)
	    }
	  
	    # Open Slider Menu:
	    .sliderMenu(refresh.code,
	       names =       c(  "m", "d", "t", "rt"),
	       minima =      c(   1,   1,   5,   10),
	       maxima =      c(  10,  10, 100,  500),
	       resolutions = c(   1,   1,   5,   10),
	       starts =      c(   1,   1,  20,   10))
	}
	.falsennSlider()
	
	
# ------------------------------------------------------------------------------	


### Example: Henon Map Slider

	# Write Function:
	.henonSlider =
	function()
	{   # A function implemented by Diethelm Wuertz
	
	    # Henon Map
	    #   henonSim(x, mean = 0, sd = 1)
	        
	    # FUNCTION:
	    
	    # Graph Frame:
	    par(mfrow = c(2, 2), cex = 0.7)
	    
	    # Internal Function:
	    refresh.code = function(...)
	    {
	        # Sliders:
	        N = .sliderMenu(no = 1)
	        skip = .sliderMenu(no = 2)
	        a = .sliderMenu(no = 3)
	        b = .sliderMenu(no = 4)
	        cex = .sliderMenu(no = 5)
	        
	        # Plot Data:     
	        ans = henonSim(n = N, n.skip = skip, parms = c(a=a, b=b), 
	        	start = c(0, 0), doplot = FALSE)
	        	
	        test1 = FALSE
	        test1 = any(!is.finite(c(ans[,1], ans[,2])))
	        test2 = FALSE
	        test2 = any(is.na(c(ans[,1], ans[,2])))
	        
	        if (!test1 & !test2) {    
	        	print(head(ans))
	        	plot(ans, pch = 19, cex = cex)  
	        	title(main = paste("Henon Map \n a = ",
	        		as.character(a), " b =", as.character(b)))
	        	plot(ans[,1], type = "p", pch = 19, cex = cex)
	        	plot(ans[,1], type = "l", cex = cex)
	    	}
	        
	        # Reset Frame:
	        par(mfrow = c(2, 2), cex = 0.7)
	    }
	  
	    # Open Slider Menu:
	    .sliderMenu(refresh.code,
	       names =       c(  "N",  "skip",  "a",   "b",  "cex"),
	       minima =      c( 1000,      0,     0,    -1,   0.10),
	       maxima =      c(10000,    100,     5,    +1,   2.00),
	       resolutions = c(  500,      1,  0.01,  0.01,   0.05),
	       starts =      c( 1000,    100,  1.40,  0.30,   0.25))
	}
	

# ------------------------------------------------------------------------------


### Example: Teraesvirta Neural Network Test for Nonlinearity	
	
	# Time Series:
	par(mfrow = c(2,2), cex = 0.6)
	n = 1000
	x = runif(1000, -1, 1)  
	x = as.ts(x)
	plot(x)
	tnnTest(x)
	###
		
	# Generate time series which is nonlinear in mean:
	x[1] = 0.0
	for (i in (2:n)) {
		x[i] = 0.4*x[i-1] + tanh(x[i-1]) + rnorm (1, sd = 0.5) }
	x = as.ts(x)
	plot(x)
	tnnTest(x)
	###
	

# ------------------------------------------------------------------------------


### Example: White Neural Network Test for Nonlinearity

	# Time Series:
	n = 1000
	x = runif(1000, -1, 1)  
	x = as.ts(x)
	plot(x)
	wnnTest(x)
	###
		
	# Generate time series which is nonlinear in mean:
	x[1] = 0.0
	for (i in (2:n)) 
		x[i] = 0.4*x[i-1] + tanh(x[i-1]) + rnorm (1, sd = 0.5) 
	x = as.ts(x)
	plot(x)
	wnnTest(x)
	###
	

# ------------------------------------------------------------------------------


###	Example: BDS Time Series Test


	# This example shows how to perform the BDS time series test.
	###
	
	# BDS Test: iid Time Series:	
	par(mfrow = c(3, 1))
	x = rnorm(100)
	ts.plot(x, type = "l", main = "iid Time Series")
	bdsTest(x, m = 3)
	###
		
	# BDS Test: Non Identically Distributed Time Series:
	x = c(rnorm(50), runif(50))
	ts.plot(x, type = "l", main = "Non-iid Time Series")
	bdsTest(x, m = 3)  
	###
		
	# BDS Test: Non Independent Innovations from Quadratic Map:
	x = rep(0.2, 100)
	for (i in 2:100) x[i] = 4*(1-x[i-1])*x[i-1]
	ts.plot(x, type="l", main="Quadratic Map")
	bdsTest(x, m = 3)
	###


################################################################################

#
# Examples from the forthcoming Monograph:
#   Rmetrics - Financial Engineering and Computational Finance
#   A Practitioner's Guide for R and SPlus Programmers
#   written by Diethelm Wuertz
#   ISBN to be published
#
# Details:
#   Chapter 3.1
#   Stationary Time Series: ARMA Modelling
#
# List of Examples, Exercises and Code Snippets:
#
#   3.1.1  Example: Linear Filter Representation
#   3.1.2  Example: AR/MA Filter Representation
#   3.1.3  Example: Simulate and Plot ARMA Series
#   3.1.4  Example: Compute ARMA Sample ACF and PACF
#   3.1.5  Example: Compute True ARMA ACF/PACF
#   3.1.6  Example: Create Figures 3.1.1 and 3.1.2
#   3.1.7  Example: Sample ACF and PACF for UK Interest Rate Spread
#   3.1.8  Example: Check ARMA Stationarity and Invertibility
#   3.1.9  Example: Identify ARMA Order through the PACF
#   3.1.10 Code Snippet: .arolsFit Function
#   3.1.11 Example: Estimate ARMA Model Parameters
#   3.1.12 Example: Estimate US/CA Interest Rate Differential
#   3.1.13 Example: Select Best ARMA Model
#   3.1.14 Example: Best ARMA Model for FTA Return Series
#   3.1.15 Example: ARMA Diagnostic Analysis
#   3.1.16 Example: ARMA Diagnostics for US/CA IR Differential
#   3.1.17 Example: ARMA Forecasting from FT30 Index
#
#
# Author:
#   (C) 1997-2005, Diethelm Wuertz, GPL
#     www.rmetrics.org
#     www.itp.phys.ethz.ch
#     www.finance.ch
#


################################################################################
# Stationary ARMA Processes


### Load package:

    require(fSeries)
    ###
    
    
# ------------------------------------------------------------------------------


### 3.1.1 Example: Linear Filter Representation

    # Create 100 Innovations:
    set.seed(4711)
    u = rnorm(100)
    ###
    
    # Convolution Filter: mu = 0.1, phi0 = 1, phi1 = 0.1,
    #   phi2 = 0.1, and the remaining phi's are zero
    mu = 0.1
    phi = c(1, 0.1, 0.1)
    x = mu + filter(x = u, filter = phi, sides = 1)
    ###
    
    # Check:
    x[21]
    mu + u[21] + 0.1*(u[20]+u[19])
    ###
       
  
    
# ------------------------------------------------------------------------------


### 3.1.2 Example: AR/MA Filter Representation

    # Example: 100 Innovations:
    x = rnorm(100)
    ###
    
    # Example: Simulating an MA(2) process:
    ma = c(0.2, 0.5)
    filter(x, c(1, ma), sides = 1)
    ###
    
    # Example: Simulating an AR(2) process:
    ar = c(0.5, -0.5)
    filter(x, ar, method = "recursive")
    ###
    

# ------------------------------------------------------------------------------


### 3.1.3 Example: Simulate and Plot ARMA Series

    # Use armaSim to simulate an AR(1) with phi = 0.5, and
    # an ARMA(2,1) process with phi1 = 0.5, phi2 = -0.5,
    # and theta = 0.8.
    ###
    
    # Graphics Frame:
    par(mfrow = c(2, 1), cex = 0.7)
    ###
    
    # AR(1) Simulation:
    x = armaSim(model = list(ar = 0.5))
    plot(x, main = "AR(1): ar = 0.5")
    ###
    
    # ARMA(2,1) Simulation:
    x = armaSim(model = list(ar = c(0.5, -0.5), ma = 0.8))
    plot(x, main = "ARMA(2,1): ar = (0.5, -0.5), ma = 0.8")
    ###
    
    
# ------------------------------------------------------------------------------
    

### 3.1.6 Example: Plot ARMA Sample ACF and PACF

    # Graphics Frame:
    par(mfrow = c(2, 2), cex = 0.7)
    ###
    
    # AR(1) Sample Correlations:
    x = armaSim(model = list(ar = 0.5))
    acf(x, lag.max = 12, main = "ACF: AR(1)")
    pacf(x, lag.max = 12, main = "PACF: AR(1)")
    ###
    
    # ARMA(2,1) Sample Correlations:
    x = armaSim(model = list(ar = c(0.5, -0.5), ma = 0.8))
    acf(x, lag.max = 12, main = "ACF: ARMA(2,1)")
    pacf(x, lag.max = 12, main = "PACF: ARMA(2,1)")
    ###
    
    # SUBSET AR(5) Model 
    # Show that the PACF is the last regression coefficient ...
    set.seed(4711)
    x = armaSim(model = list(ar = c(0.5, 0.1, 0, 0, 0.2)), n = 5000)
    PACF = NULL
    for ( order in 1:7 ) {
        OLS = ar.ols(x, AIC = FALSE, order.max = order, 
            demean = TRUE, intercept = TRUE)
        PACF = c(PACF, OLS$ar[,,1][order] )
    }
    round(rbind(PACF, pacf = pacf(x, lag.max = 7)$acf[,,1]), 2)
    ###
    
    
# ------------------------------------------------------------------------------    
    
   
### 3.1.5 Example: Compute True ARMA ACF/PACF

    # Specify Model and Simulate Series:
    model = list(ar = c(0.5, 0.3))
    x = armaSim(model)
    ###
    
    # Empirical ACF - Print as data frame:
    data.frame(lag = 0:12, acf = acf(x, lag.max = 12)$acf)
    ###

    # True ACF:
    armaTrueacf(model, lag.max = 12)
    ###

    # Do the same for the PACF:
    ###
    
    # Empirical PACF - Print as data frame:
    data.frame(lag = 1:12, pacf = pacf(x, lag.max = 12)$acf)
    ###
    
    # True ACF:
    armaTrueacf(model, lag.max = 12, type = "partial")
    ###
 
    
# ------------------------------------------------------------------------------


### 3.1.6 Example: Create Figures 3.1.1 and 3.1.2

    # Create all Graphs from Figures 3.1.1 and 3.1.2
    # The solution can be found in the fSeries/demo directory
    # ...  
    
    # Create Figure 3.1.1
    par(mfrow = c(4, 3), cex = 0.6)
    # Simulate ARIMA Time Series Processes:
    set.seed(471)
    # AR(1) and AR(2) Examples:  
    x = armaSim(model = list(ar = 0.5, d = 0, ma = 0), n = 1000)
      ts.plot(x, main = "AR(1): +0.5")
      acf(x, lag.max = 12)
      acf(x, type = "partial", lag.max = 12)
    x = armaSim(model = list(ar = -0.5, d = 0, ma = 0), n = 1000)
      ts.plot(x, main = "AR(1): -0.5")
      acf(x, lag.max = 12)
      acf(x, type = "partial", lag.max = 12)
    x = armaSim(model = list(ar = c(0.5, 0.3), d = 0, ma = 0), n = 1000)
      ts.plot(x, main = "AR(2): +0.5, +0.3")
      acf(x, lag.max = 12)
      acf(x, type = "partial", lag.max = 12)    
    x = armaSim(model=list(ar = c(-0.5, 0.3), d = 0, ma = 0), n = 1000)
      ts.plot(x, main = "AR(2): -0.5, +0.3")
      acf(x, lag.max = 12)
      acf(x, type = "partial",lag.max = 12)
    ###
       
    # Create Figure 3.1.1 cont.
    par(mfrow = c(4, 3), cex = 0.6)
    # Investigate Correlations:
    set.seed(471)
    # MA and ARMA Examples:
    x = armaSim(n = 1000, model = list(ar = 0, d = 0, ma = 0.8))
      ts.plot(x, main = "MA(1): +0.8")
      acf(x, lag.max = 12)
      acf(x, type = "partial", lag.max = 12)
    x = armaSim(n = 1000, model = list(ar = 0, d = 0, ma = -0.8))
      ts.plot(x, main = "MA(1): -0.8")
      acf(x, lag.max = 12)
      acf(x, type = "partial", lag.max = 12)     
    x = armaSim(n = 1000, model = list(ar = 0.5, d = 0, ma = 0.8))
      ts.plot(x, main = "ARMA(1,1): +0.5, +0.8")
      acf(x, lag.max = 12)
      acf(x, type = "partial", lag.max = 12)   
    x = armaSim(n = 1000, model = list(ar = -0.5, d = 0, ma = 0.8))
      ts.plot(x, main = "ARMA(1,1): -0.5, +0.8")
      acf(x, lag.max = 12)
      acf(x, type = "partial", lag.max = 12)
    ###
    
    # Example: Create Figure 3.1.2
    # Compute ACF of the True Time Series Model
    par(mfcol = c(5, 2), cex = 0.6)   
    # First Model:
    model = list(ar = c(+0.5, 0.3), d = 0, ma = 0)
    x = armaSim(model, n = 1000)
    ts.plot(x, main = "AR(2): +0.5, 0.3")
    acf(x, lag.max = 12)
    armaTrueacf(model, lag.max = 12)
    acf(x, lag.max = 12, type = "partial")
    armaTrueacf(model, lag.max = 12, type = "partial")  
    # Second Model:
    model = list(ar = c(-0.5, 0.3), d = 0, ma = 0)
    x = armaSim(model, n = 1000)
    ts.plot(x, main = "AR(2): -0.5, 0.3")
    acf(x, lag.max = 12)
    armaTrueacf(model, lag.max = 12)
    acf(x, lag.max = 12, type = "partial")
    armaTrueacf(model, lag.max = 12, type = "partial")
    ###
    
    
# ------------------------------------------------------------------------------


### 3.1.7 Example: Sample ACF and PACF for UK Interest Rate Spread

    # Example 2.2 from Mills' Textbook - Load Data:
    data(R20); data(RS); x = (R20-RS)[, 1]
    ###
    
    # Compute Sample ACF and Sample PACF:
    N = length(x)
    ACF = acf(x, lag.max = 12)$acf[,,1]
    seACF = sqrt(1/N)
    for (k in 2:12) seACF =
       c(seACF, sqrt((1+2*sum(ACF[2:k]^2))/N))
    PACF = pacf(x, lag.max = 12)$acf[,,1]
    sePACF = rep(sqrt(1/N), times = 12)
    ###
    
    # Reproduce Table 2.2 in Mills' Textbook:
    data.frame(round(cbind(
       "r_k" = ACF[-1], "seACF" = seACF,
       "phi_kk" = PACF, "sePACF" = sePACF ), 3) )
   ###

    # Compute 95% Confidence Level:
    round(2/sqrt(length(x)), 3)
    ###

    # Create Graphs:
    par(mfrow = c(2,2), cex = 0.7)
    acfPlot(x, 12, main = "ACF: UK IR Spread" )
    points(0:12, c(0,seACF), pch=19, col = "steelblue")
    pacfPlot(x, 12,main = "PACF: UK IR Spread")
    ###
    
    
# ------------------------------------------------------------------------------

### 3.1.8 Example: Check ARMA Stationarity and Invertibility

    # Graphics Frame:
    par(mfcol = c(2, 3), cex = 0.7)
    ###
    
    # Compute the Roots of 1 - 1.6 B - 0.4 B^2 :
    coefficients = c(1.6, -0.4)
    root = polyroot(c(1, -coefficients))
    re = Re(root)
    im = Im(root)
    dist = sqrt(re^2 + im^2)
    # Nice Printing:
    data.frame(round(cbind(re, im, dist), digits = 3))
    ###

    # The function also allows to plot the root circles.
    # Find the roots of the polynomials
    # ($1-1.6B -0.4B^2$),
    # ($1-0.5B-0.1B^2$), and
    # ($1-0.5B+0.9B^2-0.1B^3-0.5B^4$).
    armaRoots(c(1.6, 0.4))
    armaRoots(c(0.5, -0.1))
    ###
    
    # Next graph:
    armaRoots(c(0.5, -0.9, 0.1, 0.5))
    ###
    

# ------------------------------------------------------------------------------

    
### 3.1.9 Example: Identify Order through the PACF  

    # Settings:
    par (mfrow = c(2, 2), cex = 0.7)
    set.seed(4711)
    ###
    
    # Simulate a Subset AR(5) Process:
    x = armaSim(model = list(ar = c(-0.4, 0.1, 0, 0, 0.1), 
      d = 0, ma = 0), n = 5000)
    ###
    
    # Plot:
    ts.plot(x, xlab = "t", col = "steelblue")
    title(main = "Subset AR(5) Time Series") 
    grid()
    abline(h = 0, col = "grey")
    ###
    
    # Indentify the model with the help of the PACF ...
    # PACF: Note, the PACF is consistent with a subset AR(5)  
    # model with nonzero parameters phi at positions 1, 2 and 5.
    acf(x, type = "partial", lag.max = 12, main = "Subset AR(5) PACF")
    grid()
    ###
   
  
# ------------------------------------------------------------------------------


### 3.1.10 Code Snippet: .arolsFit Function

    # Write Function:
    .arolsFit =
    function (formula = x ~ ar(1))
    {
        # Keep Call:
        Call = match.call()

        # Inspect Formula:
        if (length(formula) != 3) stop("Misspecified Formula")
        tsmodel = substr(as.character(formula[3]), 1, 2)
        if (tsmodel != "ar") stop("Misspecified Model")

        # Extract Order:
        order = substr(as.character(formula[3]), 4, nchar(formula[3])-1)
        order = as.integer(order)

        # Get time Series Data:
        ts = eval(formula[[2]], +sys.parent())
        if (class(ts) == "timeSeries")x = as.vector(ts)
        if (class(ts) == "ts") x = as.vector(ts)

        # Fit the AR Model:
        fit = ar.ols(x = x, aic = FALSE, order.max = order,
            demean = TRUE, intercept = TRUE, newdata = x)
        class(fit) = "list"

        # Add $residuals, $fitted.values, $coef, and $sigma2
        # according to Rmetrics naming conventions:
        fit$tstitle = paste("AR(", order, ") with method: OLS", sep = "")
        fit$tsmodel = "ar"
        fit$residuals = fit$resid
        fit$fitted.values = ts - fit$resid
        fit$resid = NULL
        fit$coef = c(fit$ar[,,1], fit$x.intercept)
        fit$se.coef = unlist(c(fit$asy.se.coef$ar, fit$asy.se.coef[1]))
        fit$sigma2 = fit$var.pred[[1]]
        names(fit$coef) = names(fit$se.coef) =
            c(paste("ar", 1:order, sep = ""), "intercept")

        # Return Value:
        new("fARMA",
            call = Call,
            formula = formula,
            method = fit$tstitle,
            parameter = list(order = order),
            data = list(x = ts),
            fit = fit,
            residuals = as.vector(fit$residuals),
            fitted.values = as.vector(fit$fitted.values),
            title = as.character("AR OLS Modelling"),
            description = as.character(date())
        )
    }
    ###

    # Graph Frame:
    par(mfrow = c(2, 2), cex = 0.7)
    ###
    
    # Try:
    set.seed(4711)
    x = armaSim()
    fit = .arolsFit(x ~ ar(3))
    print(fit)
    plot(fit)
    summary(fit)
    ###
    
    
# ------------------------------------------------------------------------------


### 3.1.11 Example: Parameter Estimation

    # Simulate Time Series Process:
    x = armaSim(model = list(ar = c(0.5, -0.5), ma = 0.8))
    ###
    
    # Fit Model Parameters:
    armaFit(x ~ arima(2, 0, 1))
    ###
    
    # Fitting another type of model we have to specify
    # the model trough the formula argument:
    y = armaSim(model = list(ar = 0.5), n = 2000)
    armaFit(formula = y ~ ar(1))
    ###

    # To exclude the intercept from estimation use:
    armaFit(x ~ arma(2, 1), include.mean = FALSE)
    ###

    # To estimate a subset model, fix the coefficients.
    # Since AR and ARMA don't support this option we fit
    # an ARIMA(5, 0, 0) model. Note, fixed has 6 elements,
    # 5 AR coefficients and one for the mean.
    z = armaSim(model = list(ar = c(0.5, -0.4, 0, 0 , 0.2)))
    fit = armaFit(formula = z ~ arima(5, 0, 0), fix = c(NA, NA, 0, 0, NA, NA))
    # Print the result, i.e. title, call, model, method
    # and estimated coefficients
    summary(fit)
    ###
    

# ------------------------------------------------------------------------------


### 3.1.12 Example: Estimate US/CA Interest Rate Differential

    # Load Data:
    data(lexrates.dat)
    uscn.id = 100*(lexrates.dat[,"USCNF"]-lexrates.dat[,"USCNS"])
    ###
    
    # Plot:
    plot(uscn.id, type = "l", main = "US/CA Interest Rate Differential")
    grid()
    abline(h = 0, col = "grey")
    ###
    
    # Case (i) - Demeaned Series:
    uscn.id.dm  = uscn.id - mean(uscn.id)
    fit = armaFit(uscn.id.dm ~ arima(1, 0, 1), method = "CSS",
        include.mean = FALSE)@fit
    # Estimated Parameters - S Plus ZW: 0.82913 | 0.11008
    round(fit$coef, 5)
    # Standard Errors - S-Plus: 0.04523 | 0.08041
    round(fit$se.coef, 5)
    ###
    
    # Case (ii) - Including Mean:
    fit = armaFit(uscn.id ~ arima(1, 0, 1), method = "CSS")@fit
    # Estimated Parameters - S Plus ZW: 0.82934 | 0.11065 | -0.1347
    round(fit$coef, 5)
    # Standard Errors - S-Plus: 0.04523 | 0.08041
    round(fit$se.coef, 5)
    ###     
     
# ------------------------------------------------------------------------------


### 3.1.13 Example: Select Best ARMA Model

    # Settings:
    par (mfrow = c(2, 1), cex = 0.7)
    set.seed(4732) 
    ###
    
    # Simulate time series:
    x = armaSim(n = 10000,
        model = list(ar = c(-0.4, 0.1, 0, 0, 0.1), d = 0, ma = 0)) 
    ###
    
    # Estimate the Parameters:
    fit52 = armaFit(x ~ arima(5, 0, 2),
      fixed = c(NA, NA, NA, NA, NA, NA, NA, 0))@fit
    fit51 = armaFit(x ~ arima(5, 0, 2),
      fixed = c(NA, NA, NA, NA, NA,  0, NA, 0))@fit
    fit41 = armaFit(x ~ arima(5, 0, 2),
      fixed = c(NA, NA, NA,  0, NA,  0, NA, 0))@fit
    fit31 = armaFit(x ~ arima(5, 0, 2),
      fixed = c(NA, NA,  0,  0, NA,  0, NA, 0))@fit
    fit30 = armaFit(x ~ arima(5, 0, 2),
      fixed = c(NA, NA,  0,  0, NA,  0,  0, 0))@fit
    fit20 = armaFit(x ~ arima(5, 0, 2),
      fixed = c(NA,  0,  0,  0, NA,  0,  0, 0))@fit
    fit10 = armaFit(x ~ arima(5, 0, 2),
      fixed = c(NA,  0,  0,  0,  0,  0,  0, 0))@fit
    ###
    
    # Print and Plot Results:  
    p = c(5, 5, 4, 3, 3, 2, 1)
    q = c(2, 1, 1, 1, 0, 0, 0)
    sigma2 = c(fit52$sigma2, fit51$sigma2, fit41$sigma2, 
      fit31$sigma2, fit30$sigma2, fit20$sigma2, fit10$sigma2)
    aic = c(fit52$aic, fit51$aic, fit41$aic, fit31$aic, fit30$aic,
      fit20$aic, fit10$aic)
    plot(rev(p+q), rev(aic), xlab = "p+q", ylab = "aic", 
      main = "AIC Statistics")
    cbind(p, q, sigma2, aic)
    ###
    
    
# ------------------------------------------------------------------------------


### 3.1.14 Example: Best ARMA Model for FTA Return Series

    # Example 2.3 from Mills - Load FTA Share Return Data:
    data(FTARET)
    x = FTARET[,1]
    ###
    
    # Plot:
    plot(x, type = "l", main = "FTA Return Series")
    grid()
    abline(h = 0, col = "grey")
    ###
    
    # BIC Statistics:
    N = length(x)
    n = 4
    BIC = matrix(rep(0, n^2), n)
    for (p in 0:(n-1) ) {
      for (q in 0:(n-1) ) {
       Formula = paste("x ~arima(", p, ",0,", q, ")", sep = "")
       fit = armaFit(as.formula(Formula), method = "CSS-ML")@fit
       BIC[p+1, q+1] = log(fit$sigma2) + log(N)*(p+q) / N } }
    rownames(BIC) = colnames(BIC) = as.character(0:(n-1))
    ###
    
    # Print Deviations from the Largest Value:
    print(round(max(BIC) - BIC, 3))
    #       0     1     2     3
    # 0 0.025 0.039 0.031 0.021
    # 1 0.033 0.032 0.017 0.009
    # 2 0.026 0.017 0.000 0.008
    # 3 0.029 0.015 0.003 0.005
    ###
    
    
# ------------------------------------------------------------------------------


### 3.1.15 Example: ARMA Diagnostic Analysis

    # Simulate AR(2) Time Series:
    set.seed(4711)
    model = list(ar = c(-0.40, 0.1))
    x = armaSim(n = 1000, model = model)
    ###
    
    # Estimate Parameters:
    fit = armaFit(x ~ arima(2, 0, 0))
    ###
    
    # Diagnostic Analysis:
    # The graphical output is displayed in Figure 3.1.6.
    summary(fit)
    ###
    
    
# ------------------------------------------------------------------------------


### 3.1.16 Example: ARMA Diagnostics for US/CA IR Differential

    Repeat Example 3.1.11 from Zivot and Wang [2001]:
    fit = armaFit(uscn.id ~ arima(1, 0, 1), method = "CSS")
    plot(fit)
    ###
    
    
# ------------------------------------------------------------------------------


### 3.1.17 Example: ARMA Forecasting from FT30 Index

    # Use FT30 Index Data from T. Mills:
    data(FT30)
    x = log(FT30[,1])
    fit = armaFit(x ~ arima(2, 1, 0))
    ###
    
    # Compute Forecasts and Forecast Errors:
    forecast = predict(fit, 25)
    title(main = "\n\nlog Index FT30", cex = 0.5)
    forecast
    ###
    
    # AR(2) log Returns:
    x = diff(x)
    fit = armaFit(x ~ arima(2, 0, 0))
    forecast = predict(fit, 25)
    title(main = "\n\n\log Return FT30", cex = 0.5)
    forecast
    ###

    
################################################################################    

#
# Examples from the forthcoming Monograph:
# 	Rmetrics - Financial Engineering and Computational Finance
#   A Practitioner's Guide for R and SPlus Programmers
#   written by Diethelm Wuertz
#   ISBN to be published
#
# Details:
#   Examples from Chapter 3.2
#   Time Series With Trends: Unit Root Tests 
#
# List of Examples, Exercises and Code Snippets
#
#   3.2.1 Example: Simulate I(0) and I(1) Series
#   3.2.2 Example: Print Dickey-Fuller Distribution
#   3.2.3 Example: Write Dickey-Fuller Test Function
#   3.2.4 Example: TBILLS Dickey-Fuller OLS t-Test
#   3.2.5 Example: True FARIMA Covariances and Fourier Transform
#       * Example: True FGN Covariances and Fourier Transform
#   3.2.6 Example:  
#   3.2.7 Example:
#   3.2.8 Example: 
#
#   Alternative Unit Root Tests 
#   3.2.9 Example:  
#
# Author:
#	(C) 1997-2005, Diethelm Wuertz, GPL
# 	  www.rmetrics.org
# 	  www.itp.phys.ethz.ch
# 	  www.finance.ch
#


################################################################################


### 3.2.1 Example: Simulate I(0) and I(1) Series

    # Simulate I(1) and I(0) Data:
    set.seed(201) # try other seeds ...
    e = rnorm(250)
    z.I1 = cumsum(e)
    z.I0 = armaSim(model = list(ar = 0.75, d = 0, ma = 0), n = 250, innov = e)
    x.I1 = 5.0 + 0.1*seq(250) + z.I1
    x.I0 = 5.0 + 0.1*seq(250) + z.I0
    ###

    # Reproduce Figure 4.1 in Zivot and Wang:
    par(mfrow = c(2, 1), cex = 0.7
    ts.plot(x.I1, x.I0, lty = c(1, 2), ylab = "x")
    title(main = "Simulated I(0) and I(1) Processes")
    legend(25, max(x.I1), legend = c("I(1)", "I(0)"), lty = c(1, 2))
   	###

   	
# ------------------------------------------------------------------------------


### 3.2.2 Example: Simulate the DF Distribution

    # Simulate Functions of Wiener Processes
    # According to Zivot and Wang [2003], Chapter 4
    wiener = function(nobs) {
        e = rnorm(nobs)
        y = cumsum(e)
        ym1 = y[1:(nobs-1)]
        intW2 = nobs^(-2) * sum(ym1^2)
        intWdW = nobs^(-1) * sum(ym1*e[2:nobs])
        ans = list(intW2 = intW2, intWdW = intWdW)
        ans
    }
    ###

    # Simulate DF and NB Distributions:
    nobs = nsim = 1000
    DF = NB = rep(0, nsim)
    for (i in 1:nsim) {
        BN.moments = wiener(nobs)
        NB[i] = BN.moments$intWdW/BN.moments$intW2
        DF[i] = BN.moments$intWdW/sqrt(BN.moments$intW2)
    }
    ###

    # Plot Histograms of Simulated DF and NB:
    # Distribution - Plot Figure 4.2 in Zivot and Wang:
    par(mfrow = c(2, 2), cex = 0.7)
    hist(DF, main = "Simulated DF Distribution",
        col = "steelblue", border = "white")
    hist(NB, main = "Simulated Normalized Bias",
        col = "steelblue", border = "white")
    ###


# ------------------------------------------------------------------------------


### 3.2.3 Example: Print Dickey-Fuller Distribution

    # Print t-Statistic Table for Case I: no-constant "nc"
    dfTable(trend = "nc", statistic = "t")
    #     0.010 0.025 0.050 0.100 0.900 0.950 0.975 0.990
    #  25 -2.66 -2.26 -1.95 -1.60  0.92  1.33  1.70  2.16
    #  50 -2.62 -2.25 -1.95 -1.61  0.91  1.31  1.66  2.08
    # 100 -2.60 -2.24 -1.95 -1.61  0.90  1.29  1.64  2.03
    # 250 -2.58 -2.23 -1.95 -1.62  0.89  1.29  1.63  2.01
    # 500 -2.58 -2.23 -1.95 -1.62  0.89  1.28  1.62  2.00
    # Inf -2.58 -2.23 -1.95 -1.62  0.89  1.28  1.62  2.00
	###
	
    # Interpolated Probabilities - t Statistic:
    round(pdftest(c(-2.24, -1.50, -1.61, 0), 100, "nc"), digits = 3)
    # [1] 0.025 0.135 0.100 0.613
    pdftest(-2.80, 100)
    # [1] 0.01
    # Warning message: p-value smaller/greater than printed p-value in:
    # .pTable(X, STAT, N, digits)
    ###

    # Print all Tables:
    for (trend in c("nc", "c", "ct")) {
    	for (statistic in c("t", "n")) {
    		cat ("\nTrend:", trend, "Statistic:", statistic, "\n")
    		print(dfTable(trend, statistic))
		}
	}
	###
    
    # Interpolated Quantiles:
    for (trend in c("nc", "c", "ct")) {
    	for (statistic in c("t", "n")) {
    		cat ("\nTrend:", trend, "Statistic:", statistic, "\n")
    		print(dfTable(trend, statistic))
		}
	}
	###
    
	# Interpolated Quantiles - t Statistic:
    round(qdftest(c(0.01, 0.10, 0.50), 100, "nc"), digits = 3)
    # [1] 0.025 0.135 0.100 0.613
    qdftest(0.005, 100)
    # NA
    ###
    
    
# ------------------------------------------------------------------------------


### 3.2.3 Example: Write Dickey-Fuller Test Function

    # Write the Function:
    .dfTest = function(x)
    {
        # Regression for Case I "nc" and OLS t-Statistic:
        x.diff = diff(x)[-1]
        x.lag.1 = x[2:(length(x)-1)]
        LM = summary(lm(x.diff ~ x.lag.1 - 1))

        # OLS t-Statistic:
        STAT = LM$coefficients[1]/LM$coefficients[2]
        names(STAT) = "Dickey-Fuller"

        # P Value for OLS t-Test:
        PVAL = pdftest(q = STAT, n.sample = length(x), trend = "nc")
        names(PVAL) = ""

        # Return Value - Use fHTEST Class:
        new("fHTEST", call = match.call(), data = list(x = x),
            test = list(lm = LM, statistic = STAT, p.value = PVAL),
            title = "Dickey Fuller Test", description = " Test Type: nc")
    }
    ###

    # Try -
    # A Series that has no Unit-Root:
    set.seed(4711)
    x = rnorm(500)
    .dfTest(x)
    # A Series that contains a Unit-Root:
    .dfTest(diffinv(x))
    ###
    
    
# ------------------------------------------------------------------------------


### 3.2.4 Example: TBILLS Dickey-Fuller OLS t-Test

    # Example 17.3 Hamilton - Load GNP:
    data(gnptbill)
    x = gnptbill[, "TBILL"]

    # DF Test:
    .dfTest(x)

    
# ##############################################################################
# Serial Correlation - Augmented Dickey-Fuller Test


	# ADF Test:
	adfTest()
	unitrootTest()
	urdfTest()
	
	# lags = 0 : DF Test
	

# ------------------------------------------------------------------------------


### Example: Plot Asymptotic Distribution for t and z Statistic

	# This example deals with the numerical distribution from
	#  McKinnon's response surface.
	###
	
	# Graph Frame:
	par(mfrow = c(2,2), cex = 0.7)
	###
		
	# Asymptotic Probability for t Statistic:
	plot(c(-6, 4), c(0, 1), type = "n", main = "Probability | tau Statistic", 
		xlab = "q", ylab = "punitroot(q)")
	Trends = c("nc", "c", "ct", "ctt")
	x = (-60:40)/10
	for (i in 1:4) {
		y = punitroot(q = x, n.sample = 0, trend = Trends[i], statistic = "t")
		lines(x, y, col = "steelblue")
	}
	lines(x, pnorm(x), lty = 3)
	text(seq(-2.4, 0.2, length = 5), seq(0.65, 0.45, length = 5), 
		labels = c("ctt", "ct", "c", "nc", "N"))
	grid()
	###
		
	# Asymptotic Density for t Statistic:
	plot(c(-6, 4), c(0, 0.65), type = "n", main = "Density | tau Statistic", 
		xlab = "x", ylab = "diff(punitroot(q))")
	Trends = c("nc", "c", "ct", "ctt")
	x = (-60:40)/10
	X = ((-60:40)/10+0.05)[-1]
	for (i in 1:4) {
		y = punitroot(q = x, n.sample = 0, trend = Trends[i], statistic = "t")
		Y = diff(y)/0.1
		lines(X, Y, col = "steelblue")
	}
	lines(X, dnorm(X), lty = 3)
	text(seq(-2.2, 0.8, length = 5), seq(0.6, 0.4, length = 5), 
		labels = c("ctt", "ct", "c", "nc", "N"))
	grid()
	###
		
	# Asymptotic Probability for z Statistic:
	plot(c(-40, 4), c(0, 1), type = "n", main = "Probability | z Statistic", 
		xlab = "q", ylab = "punitroot(q)")
	Trends = c("nc", "c", "ct", "ctt")
	x = (-400:40)/10
	for (i in 1:4) {
		y = punitroot(q = x, n.sample = 0, trend = Trends[i], statistic = "n")
		lines(x, y, col = "steelblue")
	}
	text(seq(-10, 0, length = 4), seq(0.65, 0.45, length = 4), 
		labels = c("ctt", "ct", "c", "nc"))
	grid()
	###
		
	# Asymptotic Density  for z Statistic:
	plot(c(-40, 4), c(0, 0.3), type = "n", main = "Density | z Statistic", 
		xlab = "x", ylab = "diff(punitroot(q))")
	Trends = c("nc", "c", "ct", "ctt")
	x = (-400:40)/10
	X = ((-400:40)/10+0.05)[-1]
	for (i in 1:4) {
		y = punitroot(q = x, n.sample = 0, trend = Trends[i], statistic = "n")
		Y = diff(y)/0.1
		lines(X, Y, col = "steelblue")
	}
	text(seq(-14.5, 0.5, length = 4), seq(0.07, 0.27, length = 4), 
		labels = c("ctt", "ct", "c", "nc"))
	grid()
	###
	
	
# ------------------------------------------------------------------------------

	
### Example: Tabulated OLS t-Statistic vs Response Surface
	
	# This example compares the tabulated OLS t-Statistic for the 
	# DF test with those computed from McKinnons Response Surface:
	
	# Cases:
	trend = c("nc", "c", "ct")
	###
	
	# Loop over all three Cases:
	for ( i in 1:3 ) {
		# Tabulated Values:
		tTable = as.matrix(dfTable(trend = trend[i], statistic = "t"))
        # Response Surface Values:
	    nobs.vec = c(25, 50, 100, 250, 500, 0)  
	    x = c(0.01, 0.025, 0.05, 0.10, 0.90, 0.95, 0.975, 0.99)
	    urTable = NULL
	    for ( nobs in nobs.vec ) {
	    	ans = qunitroot(p = x, nobs, trend[i], statistic = "t")
	        urTable = rbind(urTable, ans) 
    	}
    	cat("\nTrend = ", trend[i], "\n")
    	print(round(tTable - urTable, digits = 3))
	}
	###
	
	
# ------------------------------------------------------------------------------


### Example: Compare punitroot() with SPlus' Finmetrics :

    # This example tests and compares the results obtained from Rmetrics' 
    # "punitroot" with those obtained from Splus 6.1:
    ###

    # Statistic: "t"
    round(punitroot(q=-6:2, n.sample = 100, trend = "nc", statistic = "t"), 4)
    # R:      0.0000 0.0000 0.0001 0.0030 0.0441 0.2829 0.6803 0.9155 0.9889
    # Splus:  0.0000 0.0000 0.0001 0.0030 0.0441 0.2829 0.6803 0.9155 0.9889
    round(punitroot(q=-6:2, n.sample = 100, trend = "c", statistic = "t"), 4)
    # R:      0.0000 0.0001 0.0021 0.0383 0.2865 0.7510 0.9558 0.9964 0.9999
    # Splus:  0.0000 0.0001 0.0021 0.0383 0.2865 0.7510 0.9558 0.9964 0.9999    
    round(punitroot(q=-6:2, n.sample = 100, trend = "ct", statistic = "t"), 4)
    # R:      0.0000 0.0004 0.0117 0.1375 0.5940 0.9387 0.9958 0.9999 1.0000
    # Splus:  0.0000 0.0004 0.0117 0.1375 0.5940 0.9387 0.9958 0.9999 1.0000    
    round(punitroot(q=-6:2, n.sample = 100, trend = "ctt", statistic = "t"), 4)
    # R:      0.0001 0.0020 0.0384 0.2979 0.8077 0.9847 0.9995 1.0000 1.0000
    # Splus:  0.0001 0.0020 0.0384 0.2979 0.8077 0.9847 0.9995 1.0000 1.0000    
    ###
    
    # Statistic: "n"
    round(punitroot(q=-6:2, n.sample = 100, trend = "nc", statistic = "n"), 4)
    # R:      0.0872 0.1197 0.1654 0.2307 0.3262 0.4700 0.6803 0.9105 0.9884
    # Splus:  0.0872 0.1197 0.1654 0.2307 0.3262 0.4700 0.6803 0.9105 0.9884    
    round(punitroot(q=-6:2, n.sample = 100, trend = "c", statistic = "n"), 4)
    # R:      0.3375 0.4261 0.5318 0.6519 0.7759 0.8837 0.9558 0.9881 0.9975
    # Splus:  0.3375 0.4261 0.5318 0.6519 0.7759 0.8837 0.9558 0.9881 0.9975    
    round(punitroot(q=-6:2, n.sample = 100, trend = "ct", statistic = "n"), 4)
    # R:      0.7353 0.8144 0.8828 0.9349 0.9688 0.9874 0.9958 0.9988 0.9997
    # Splus:  0.7353 0.8144 0.8828 0.9349 0.9688 0.9874 0.9958 0.9988 0.9997    
    round(punitroot(q=-6:2, n.sample = 100, trend = "ctt", statistic = "n"), 4)
    # R:      0.9213 0.9542 0.9761 0.9889 0.9954 0.9984 0.9995 0.9998 1.0000
    # Splus:  0.9213 0.9542 0.9761 0.9889 0.9954 0.9984 0.9995 0.9998 1.0000
    ###
  
    
# ------------------------------------------------------------------------------


### Example: Compare qunitroot() with SPlus' Finmetrics:

    # This example tests and compares the results obtained from Rmetrics' 
    # "qunitroot" with those obtained from Splus 6.1:
    ###

    # q-Values:
    q = c(0.15, 0.30, 0.45, 0.60, 0.75, 0.90)
    ###
     
    # Statistic: "t"
    round(qunitroot(q, n.sample = 100, trend = "nc", statistic = "t"), 4)
    # R:      -1.3979 -0.9576 -0.6118 -0.2328  0.2265  0.8967
    # Splus:  -1.3979 -0.9576 -0.6118 -0.2328  0.2265  0.8967   
    round(qunitroot(q, n.sample = 100, trend = "c", statistic = "t"), 4)
    # R:      -2.3799 -1.9690 -1.6568 -1.3577 -1.0029 -0.4232    
    # Splus:  -2.3799 -1.9690 -1.6568 -1.3577 -1.0029 -0.4232   
    round(qunitroot(q, n.sample = 100, trend = "ct", statistic = "t"), 4)
    # R:      -2.9559 -2.5588 -2.2625 -1.9889 -1.6869 -1.2227     
    # Splus:  -2.9559 -2.5588 -2.2625 -1.9889 -1.6869 -1.2227   
    round(qunitroot(q, n.sample = 100, trend = "ctt", statistic = "t"), 4)
    # R:      -3.3927 -2.9955 -2.7002 -2.4292 -2.1354 -1.7073    
    # Splus:  -3.3928 -2.9955 -2.7002 -2.4291 -2.1354 -1.7073
    ###
    
    # Statistic: "n"
    round(qunitroot(q, n.sample = 100, trend = "nc", statistic = "n"), 4)
    # R:      -4.2999 -2.2371 -1.1160 -0.3463  0.2795  0.9382    
    # Splus:  -4.2999 -2.2372 -1.1160 -0.3463  0.2795  0.9382   
    round(qunitroot(q, n.sample = 100, trend = "c", statistic = "n"), 4)
    # R:      -9.2935 -6.4935 -4.7588 -3.4215 -2.2137 -0.8166   
    # Splus:  -9.2934 -6.4936 -4.7588 -3.4215 -2.2137 -0.8165   
    round(qunitroot(q, n.sample = 100, trend = "ct", statistic = "n"), 4)
    # R:     -15.4278 -11.8711  -9.5254  -7.6163  -5.8205  -3.7052   
    # Splus: -15.4277 -11.8710  -9.5254  -7.6163  -5.8206  -3.7050  
    round(qunitroot(q, n.sample = 100, trend = "ctt", statistic = "n"), 4)
    # R:     -20.5330 -16.4756 -13.7175 -11.4106  -9.1839  -6.5128     
    # Splus: -20.5330 -16.4755 -13.7174 -11.4107  -9.1839  -6.5126
    ###


# ------------------------------------------------------------------------------


### Example: Test Internal Function ".urcval"

	# Reproduce Figure 1 to 3 as plotted in the paper of J.G. MacKinnon
	###

    # JGM: Figure 1 to 3
    figure1to3 = function(figure) {
        x = (-80:20)/10
        plot (x = c(-8, 2), y = c(0, 1), type = "n")
        for (i in 1:12) {
            y = .urcval(x, nobs = 0, niv = i, itt = 1, itv = figure, nc = 2)
            lines(x, y) 
        }
        if (figure == 3) {
            for (i in 1:12) {
                y = .urcval(x, nobs = 0, niv = i, itt = 1, itv = 4, nc = 2)
                lines(x, y, lty = 3) 
            } 
        }
        invisible() 
    }
    ###
            
    # Plot:
    par(mfcol = c(3, 2), cex = 0.5)
    figure1to3(1)
    figure1to3(2)
    figure1to3(3)
    ###

    
# ##############################################################################
# Nelson Plosser Data
    

### Example: Plot the Nelson-Plosser US Economy Data 1909 - 1970

	# Nelson Plosser Data - Description of Columns
	# %Y%m%d - Date index from 18601231 until 19701231 
	# gnp.r  - Real GNP, [Billions of 1958 Dollars] starting 1909 
	# gnp.n  - Nominal GNP, [Millions of Current Dollars] starting 1909
	# gnp.pc - Real Per Capita GNP, [1958 Dollars], starting 1909  
	# ip 	 - Industrial Production Index, [1967 = 100], starting 1860  
	# emp 	 - Total Employment, [Thousands], starting 1890 
	# ur 	 - Total Unemployment Rate, [Percent], starting 1890
	# gnp.p  - GNP Deflator, [1958 = 100], starting 1889
	# cpi 	 - Consumer Price Index, [1967 = 100], starting 1860
	# wg.n 	 - Nominal Wages, [current Dollars], starting 1900
	# wg.r 	 - Real Wages, [Nominal wages/CPI], starting 1900
	# M 	 - Money Stock (M2), [Billions of USD, annual avgs], starting 1889
	# vel 	 - Velocity of Money, starting 1869
	# bnd 	 - Bond Yields of 30-year Corporate Bonds, [% pa], starting 1900
	# sp 	 - Stock Prices, [Index; 1941 - 43 = 100], starting 1871
	###
	
	
# ------------------------------------------------------------------------------

	
### Example: Nelson Plosser Paper - Plot Data:

	# Load Data:
    data(nelsonplosser)
   	Instrument = c("Real GnP", "Nominal GNP", "Per Capita GNP", "CPI",
		"Employment", "Unemployment", "GNP deflator", "CPI", "Nominal Wages",
		"Real Wages", "M2", "Velocity M2", "BondYields", "Stock Prices") 
    Years = 1909:1970
    nelsonplosser = nelsonplosser[50:111, -1]
    Dim = dim(nelsonplosser)[2]
    colName = colnames(nelsonplosser)
    
    # Plot:
    par(mfrow = c(3, 3), cex = 0.5)
    for (i in 1:9)
    	plot(Years, nelsonplosser[, i], xlab = "Year", ylab = colName[i],
    		type = "b", pch = 19, col = "steelblue4", main = Instrument[i])
    ###
    
    # Continue:
    for (i in 10:Dim)
    	plot(Years, nelsonplosser[, i], xlab = "Year", ylab = colName[i],
    		type = "b", pch = 19, col = "steelblue4", main = Instrument[i])		
    ###
 
    
# ------------------------------------------------------------------------------
   
    
### Example: Reproduce Nelson Plosser Paper - Table 2


	# Create Table 2:
    data(nelsonplosser)
    Instrument = c("Real GnP", "Nominal GNP", "Per Capita GNP", "CPI",
		"Employment", "Unemployment", "GNP deflator", "CPI", "Nominal Wages",
		"Real Wages", "M2", "Velocity M2", "BondYields", "Stock Prices") 
    Table.2 = NULL
    for ( i in 1:14 ) {
	    x = na.omit(nelsonplosser[, i+1])
	    N = length(x)
	    To = 1970
	    From = To - N + 1
	    if (i != 13) x = log(x)
	    r = round(acf(x, plot = FALSE)$acf[2:7], digits = 2)
	    Table.2 = rbind(Table.2, c(N, From, To, r))    	
    }
    colnames(Table.2) = c("T", "From", "To", paste("r", 1:6, sep = ""))
    rownames(Table.2) = Instrument
    Table.2
    ###

    
# ------------------------------------------------------------------------------


### Nelson Plotter Paper - Create Table 5
    

    # Create Table 5:
    data(nelsonplosser)
    Instrument = c("Real GnP", "Nominal GNP", "Per Capita GNP", "CPI",
		"Employment", "Unemployment", "GNP deflator", "CPI", "Nominal Wages",
		"Real Wages", "M2", "Velocity M2", "BondYields", "Stock Prices") 
	k = c(2, 2, 2, 6, 3, 4, 2, 4, 3, 2, 2, 1, 3, 3)
    Table.5 = NULL
    for ( i in 1:14 ) {
	    x = na.omit(nelsonplosser[, i+1])
	    T = length(x)
	    if (i != 13) x = log(x)
	    ans = adfTest(x, type = "ct", lags = k[i])
	    lm = summary(ans@test$lm)
	    mu.hat = round(lm$coefficients[1, 1], digits = 3)
	    t.mu = round(lm$coefficients[1, 3], digits = 2)
	    gamma.hat = round(lm$coefficients[3, 1], digits = 3)
	    t.gamma = round(lm$coefficients[3, 3], digits = 2)
	    rho1.hat = round(lm$coefficients[2, 1], digits = 3)+1
	    t.rho1 = round(lm$coefficients[2, 3], digits = 2)
	    seps = round(lm$sigma, digits = 3)
	    r1 = round(acf(lm$residuals)$acf[2], digits = 3)
	    vec = c(T, k[i], mu.hat, t.mu, gamma.hat, t.gamma, rho1.hat, 
	    	t.rho1, seps, r1)
	    Table.5 = rbind(Table.5, vec)    	
    }
    colnames(Table.5) = c("T", "lag", "mu", "t.mu", "gam", "t.gam", "rho1",
	    	"t.rho1)", "s.eps", "r.1")
    rownames(Table.5) = Instrument
    Table.5
    ###
    
    
# ******************************************************************************
# ERS Unit Root Test:


ptCvals = 
function(type = c("constant", "trend"))
{
    # Description:
    #   Returns Pt level values for the ERS unit root test.
    
    # Details:
    #   These are the numbers given in Table 1 of the paper
    #   of Elliott, Rothenberg and Stock.
    
    # TABLE:
    
    # Level Values:
    if (type[1] ==  "constant") {
        # Constant:
        ans = matrix(c(
            # 50   100   200   Inf
            1.87, 1.95, 1.91, 1.99,    # constant  # 0.010   # c =  -7.0
            2.39, 2.47, 2.47, 2.55,                # 0.025
            2.97, 3.11, 3.17, 3.26,                # 0.050
            3.91, 4.17, 4.33, 4.48                 # 0.100
        ), 4, 4) 
        colnames(ans) = c("1%", "2.5%", "5%", "10%")
        rownames(ans) = c("50", "100", "200", "Inf")
    } else if (type[1] == "trend") {
        # Trend:
        ans = matrix(c(
            # 50   100   200   Inf
            4.22, 4.26, 4.05, 3.96,    # trend     # 0.010   # c = -13.5
            4.94, 4.90, 4.83, 4.78,                # 0.025
            5.72, 5.64, 5.66, 5.62,                # 0.050
            6.77, 6.79, 6.86, 6.89                 # 0.100
         ), 4, 4)
         colnames(ans) = c("1%", "2.5%", "5%", "10%")
         rownames(ans) = c("50", "100", "200", "Inf")
    } else {
        stop("type must be either constant or trend")
    }
    
    # Return Value:
    ans
}   


	ptCvals("constant")
	ptCvals("trend")


# ------------------------------------------------------------------------------
   
 
### Example: complement the ERS level values by your own MC values
   
	ptCvalsMC = 
	function(N = Inf, mcSteps = 1000, mcLoops = 20, dcSteps = 1000,
	c = -7, method = 1:2, trace = TRUE)
	{   
	    # Description:
	    #   Try to replicate the results for P_t listed in Table 1 
	    #   of the paper of Elliott, Rothenberg, and Stock for finite
	    #   sample lengths N.
	    
	    # Arguments:
	    #   N - an integer value, the sample size. If N is infinite
	    #       the asymptotic limit is evaluated using "dcSteps"
	    #       discretization steps.   
	    #   mcSteps - the number of Monte Carlo steps per MC loop for
	    #       a finite sample.
	    #   mcLoops - the number of Monte Carlo loops, only used for 
	    #       finite samples.
	    #   dcSteps - if "N" is infinite, then "dcSteps"
	    #       determines the number of discretization steps.
	    #   c - constant value, by default c=-7 as used by ERS.
	    #   method - selects one from two alternative methods to
	    #       compute omega, for details see ERS.
	    #   trace - a logical flag, should the simulation be traced?
	    
	    # Details:
	    #   The numbers in Table 1 of ERS are:
	    #             1%    2.5%      5%     10%
	    #    50     1.87    2.39    2.97    3.91
	    #   100     1.95    2.47    3.11    4.17
	    #   200     1.91    2.47    3.17    4.33
	    #   Inf     1.99    2.55    3.26    4.48
	    
	    # Notes:
	    #   The function is slow, but sufficient enough for educational 
	    #   purposes.
	    
	    # FUNCTION:
	    
	    # Settings:
	    statistic = rep(0, times = mcSteps * mcLoops)
	    ahat = 1 + c/N
	    za1 = c(1, rep(1 - ahat, N - 1))
	    index = c("1%" = 0.01, "2.5%" = 0.025, "5%" = 0.05, "10%" = 0.1) 
	    
	    # Simulate:
	    if (N == Inf) {
	        # Brownian Motion Approximation:
	        # c^2 * INTRGRAL(W^2) - c * W^2(1) ] =
	        # c^2 * INTRGRAL(W^2) - c * (2 * INTEGRAL(WdW) + 1) ]
	        statistic = rep(0, times = mcSteps)
	        n = dcSteps
	        i = 0
	        for (i in 1:mcSteps) {
	            i = i + 1
	            r = rnorm(n)
	            y = cumsum(r)
	            intWdW = sum(y[-n]*r[-1])/n
	            intW2 = sum(y[-n]^2)/n^2
	            statistic[i] = c^2 * intW2 - c * ( 2*intWdW + 1 )
	        }
	        if (trace) {
	            # Print Results after each Loop:
	            P = matrix(sort(statistic)[index*mcSteps], ncol = length(index))
	            colnames(P) = names(index)
	            rownames(P) = as.character(mcSteps)
	            print(as.data.frame(P))
	        }
	    } else {
	        # Finite Sample Regression:   
	        i = 0
	        for (m in 1:mcLoops) {
	            for (n in 1:mcSteps) {
	                i = i + 1
	                y = as.vector(filter(rnorm(N), filter = 1, "recursive"))    
	                ya = c(y[1], y[-1] - ahat * y[-N])
	                yd.reg = lm(ya ~ -1 + za1)    
	                sig.res = sum(residuals(yd.reg)^2)
	                sig.null = sum(diff(y)^2)  
	                if (method[1] == 1) {
	                    omega2 = sig.null/N    
	                } else if (method[1] == 2) {               
	                    omega2 = (summary(lm(diff(y) ~ y[-N]))$sigma)^2
	                }
	                statistic[i] = (sig.res - ahat * sig.null)/omega2
	            }                       
	            if (trace) {
	                # Print Results after each Loop:
	                p = sort(statistic[1:(m*mcSteps)])
	                P = t(p[round(index * m * mcSteps, digits = 0)])
	                colnames(P) = names(index)
	                rownames(P) = as.character(m*mcSteps)
	                print(as.data.frame(P))
	            }
	        }   
	    }
	            
	    # Return Value:
	    invisible(statistic)
	}


# ------------------------------------------------------------------------------
  
    # Monte Carlo Results using method 1 for omega:
    # omega2 = sig.null/N
              
    
    # N=20:           1%    2.5%      5%     10%
    #    20000      1.96    2.34    2.81    3.59    # zeroth run
    #    20000      1.98    2.41    2.85    3.61    # first run
    #    20000      1.97    2.44    2.91    3.65    # second run
    #    20000      1.98    2.40    2.83    3.53    # third run 
    #    20000      1.92    2.33    2.81    3.56    # fourth run
    p.0020 = c(     1.96,   2.38,   2.84,   3.59 )  # MEAN  
                    
    # N=25:           1%    2.5%      5%     10%
    #    20000      1.95    2.42    2.88    3.67    # zeroth run
    #    20000      1.91    2.39    2.92    3.73    # first run
    #    20000      1.90    2.38    2.87    3.66    # second run
    #    20000                                      # third run 
    #    20000                                      # fourth run
    p.0025 = c(     1.92,   2.40,   2.89,   3.69 )  # MEAN
    
    # N=33:           1%    2.5%      5%     10%
    #    20000      1.91    2.38    2.91    3.73    # zeroth run
    #    20000      1.90    2.38    2.88    3.74    # first run
    #    20000      1.94    2.40    2.90    3.75    # second run
    #    20000                                      # third run 
    #    20000                                      # fourth run 
    p.0033 = c(     1.92,   2.39,   2.90,   3.74 )  # MEAN
       
    # N=50:           1%    2.5%      5%     10%
    #    20000      1.87    2.39    2.97    3.91    # ERS
    #    20000      1.88    2.37    2.98    3.95    # first run
    #    20000      1.90    2.41    2.96    3.97    # second run
    #    20000      1.93    2.36    2.98    3.95    # third run
    #    20000      1.92    2.41    2.98    3.95    # fourth run
    p.0050 = c(     1.90,   2.39,   2.97,   3.95 )  # MEAN
                
    # N=100:          1%    2.5%      5%     10%
    #    20000      1.95    2.47    3.11    4.17    # ERS
    #    20000      1.91    2.41    3.07    4.14    # first run
    #    20000      1.93    2.50    3.08    4.15    # second run
    #    20000      1.96    2.44    3.05    4.15    # third run
    #    20000      1.90    2.49    3.12    4.13    # fourth run
     p.0100 = c(    1.93,   2.46,   3.09,   4.15 )  # MEAN
         
    # N=200:          1%    2.5%      5%     10%
    #    20000      1.91    2.47    3.17    4.33    # ERS
    #    20000      1.90    2.49    3.16    4.35    # first run
    #    20000      1.88    2.44    3.16    4.33    # second run
    #    20000      1.91    2.48    3.14    4.24    # third run
    #    20000      1.85    2.47    3.16    4.31    # fourth run
    p.0200 = c(     1.89,   2.47,   3.16,   4.31 )  # MEAN
         
    # N=1000:         1%    2.5%      5%     10%
    #    20000      1.92    2.57    3.30    4.46    # zeroth run
    #    20000      1.93    2.51    3.26    4.43    # first run
    #    20000      1.93    2.55    3.27    4.52    # second run
    #    20000      1.98    2.56    3.28    4.47    # third run
    #    20000      1.94    2.49    3.20    4.42    # fourth run
    p.1000 = c(     1.94,   2.54,   3.26,   4.46 )  # MEAN
         
    # N=Inf           1%    2.5%      5%     10%
    #    20000      1.99    2.55    3.26    4.48    # ERS
    #                 1%    2.5%      5%     10%
    #    20000      1.94    2.56    3.34    4.51    # 1000 dcSteps
    #    20000      1.98    2.58    3.35    4.60    # 1000
    #    20000      1.94    2.60    3.33    4.54    # 1000
    #    20000      1.93    2.57    3.29    4.54    # 1000
    #    20000      1.99    2.59    3.32    4.60    # 1000
    #               1.96    2.58    3.33    4.56    # MEAN
    #                 1%    2.5%      5%     10%
    #    20000      2.02    2.64    3.38    4.60    # 2000 dcSteps
    #    20000      2.00    2.60    3.28    4.54    # 2000
    #    20000      1.93    2.60    3.41    4.66    # 2000
    #    20000      1.99    2.60    3.35    4.54    # 2000
    #    20000      1.94    2.52    3.33    4.54    # 2000
    p.Inf = c(      1.98,   2.59,   3.35,   4.58 )  # MEAN
 

# ------------------------------------------------------------------------------   


    # Monte Carlo Results using method 2 for omega:
    # omega2 = (summary(lm(diff(y) ~ y[-N]))$sigma)^2
    
    # N= 50:      
    #    20000      1.87    2.39    2.97    3.91    # ERS
    #    20000      1.92    2.38    2.93    3.83    # first run
    #    20000      1.88    2.37    3.00    3.96    # second run
    #    20000      1.95    2.40    2.96    3.95    # third run
    #    20000 
                    
    # N=100:
    #    20000      1.95    2.47    3.11    4.17    # ERS
    #    20000      1.89    2.43    3.13    4.21    # first run
    #    20000 
    #    20000 
    #    20000 
         
    # N=200:
    #    20000      1.91    2.47    3.17    4.33    # ERS
    #    20000      1.96    2.52    3.15    4.30    # first run
    #    20000 
    #    20000 
    #    20000 
        
    # ... yields the same MC simulation results 
  

# ------------------------------------------------------------------------------


### Plot the Response Surface:

    # Bind MC Simulation Results:
    p = rbind(p.0020, p.0025, p.0033, p.0050, p.0100, p.0200, p.1000, p.Inf)   
    colnames(p) = c("1%", "2.5%", "5%", "10%") 
    x = c(20, 25, 33, 50, 100, 200, 1000, Inf)
    rownames(p) = as.character(x)
    p
    
    # Settings:
    par(mfrow = c(2, 2), cex = 0.7)
    ymin =     c(1.85, 2.30, 2.80, 3.50)
    ymax =     c(2.02, 2.64, 3.45, 4.80)
    ESR050 =   c(1.87, 2.39, 2.97, 3.91)
    ESR100 =   c(1.95, 2.47, 3.11, 4.17)
    ESR200 =   c(1.91, 2.47, 3.17, 4.33)
    asymp =    c(1.98, 2.58, 3.33, 4.56)
    ESRasymp = c(1.99, 2.55, 3.26, 4.48)
    index = c("1%", "2.5%", "5%", "10%")
    
    # Plot:
    for ( k in 1:4) {
        data = as.data.frame(cbind(x = p[,k], 
            y1 = 1/x, y2 = 1/x^2, y3 = 1/x^3, y4 = 1/x^4))
        fit = lm(x ~ y1 + y2 + y3 + y4, data)
        N = 20:1200
        y = NULL
        for (i in N) y = c(y, sum(fit$coef*c(1, 1/i, 1/i^2, 1/i^3, 1/i^4)))
        plot(N, y, type = "l", col = "red", ylim = c(ymin[k], ymax[k]))
        points(x, p[, k])
        points(c(50, 100, 200), c(ESR050[k], ESR100[k], ESR200[k]), 
            col = "blue") 
        abline(h = asymp[k], lty = 3)
        abline(h = ESRasymp[k], lty = 3, col = "blue")
        title(main = paste(index[k], "Response Surface"))
        text(x = max(N)/2, y = ymax[k] - 0.07*(ymax[k] - ymin[k]),
            "mean from 5 samples with 20'000 replications")
        text(x = 0.8*max(N), y = ymax[k] - 0.93*(ymax[k] - ymin[k]),
            "4-th order 1/N Fit")
    }


# ------------------------------------------------------------------------------


Pt.trend = 
function(N, mcSteps = 100, mcLoops = 100, c = -13.5)
{   
    statistic = rep(0, times = mcSteps*mcLoops)
    ahat = 1 + c/N
    za1 = c(1, rep(1 - ahat, N - 1))
    za2 = c(1, 2:N - ahat * (1:(N - 1)))
    index = c("1%" = 0.01, "2.5%" = 0.025, "5%" = 0.05, "10%" = 0.1) 
    
    i = 0
    for (m in 1:mcLoops) {
        for (n in 1:mcSteps) {
            i = i + 1
            y = filter(rnorm(N), filter = 1, "recursive")     
            ya = c(y[1], y[2:N] - ahat * y[1:(N - 1)])
            yd.reg = summary(lm(ya ~ -1 + za1 + za2))          
            sig.res = sum(residuals(yd.reg)^2)
            sig.null = sum(diff(y)^2)    
            y.l = y[-N]
            y.diff = diff(y)  
            omega = summary(lm(y.diff ~ y.l))$sigma
            statistic[i] = (sig.res - ahat * sig.null)/omega^2
        }               
        # Printing:
        p = sort(statistic[1:(m*mcSteps)])
        P = t(p[round(index * m * mcSteps, digits = 0)])
        colnames(P) = names(index)
        rownames(P) = as.character(m*mcSteps)
        print(as.data.frame(P))
    }           
    # Return Value:
    statistic
}


# ------------------------------------------------------------------------------


lm.fast = 
function(x, y)
{
    # Description:
    #	A fast lm function, everything what is not really need
    #	for the MC Simulation is rempved from the function 'lm'
    
    # Access the Fortran routine:
    z = .Fortran("dqrls", qr = x, n = nrow(x), p = ncol(x), 
        y = y, ny = NCOL(y), tol = as.double(1.0e-7), 
        coefficients = mat.or.vec(ncol(x), NCOL(y)), 
        residuals = y, effects = y, rank = integer(1), 
        pivot = 1:ncol(x), qraux = double(ncol(x)), 
        work = double(2 * ncol(x)), PACKAGE = "base") 
        
    # Compute Omega:      
    omega = sum(z$residuals^2)/(nrow(x) - z$rank)
    
    # Return Value:
    omega
}


################################################################################
# PART V: Alternative Unit Root Tests (adapted from 'urca')

    # Description:
    #	Examples how to use Unit Root Tests from 'Rmetrics':
    # 		urerTest()
    # 		urkpssTest()
    # 		urppTest()
    #		urspTest()
    # 		urzaTest()
    

# ------------------------------------------------------------------------------


### Example: ERS Test


    urersTest(GNP, type = "DF-GLS", model = "const", lag.max = 4) 
    urersTest(GNP, type = "DF-GLS", model = "trend", lag.max = 4) 
    ###
    
    urersTest(GNP, type = "P-test", model = "const", lag.max = 4)   
    urersTest(GNP, type = "P-test", model = "trend", lag.max = 4)   
    ###
    
 
# ------------------------------------------------------------------------------

   
### Example: KPSS Test


    urkpssTest(log(GNP), type = "tau", lags = "nil")  
    urkpssTest(log(GNP), type = "mu", lags = "nil") 
    ###
    
    urkpssTest(log(GNP), type = "tau", lags = "short")  
    urkpssTest(log(GNP), type = "mu", lags = "short") 
    ###
       
    urkpssTest(log(GNP), type = "tau", lags = "long")  
    urkpssTest(log(GNP), type = "mu", lags = "long") 
    ###
          
    urkpssTest(log(GNP), type = "tau", use.lag = 5)  
    urkpssTest(log(GNP), type = "mu", use.lag = 5)   
    ###
    
    
# ------------------------------------------------------------------------------

   
### Example: PP Test


    urppTest(GNP, type = "Z-alpha", model = "constant", lags = "short")
    urppTest(GNP, type = "Z-tau", model = "constant", lags = "short")
    urppTest(GNP, type = "Z-alpha", model = "trend", lags = "short")
    urppTest(GNP, type = "Z-tau", model = "trend", lags = "short")
    ###
       
    urppTest(GNP, type = "Z-alpha", model = "constant", lags = "long")
    urppTest(GNP, type = "Z-tau", model = "constant", lags = "long")
    urppTest(GNP, type = "Z-alpha", model = "trend", lags = "long")
    urppTest(GNP, type = "Z-tau", model = "trend", lags = "long")
    ###
    
    urppTest(GNP, type = "Z-alpha", model = "constant", use.lag = 5)
    urppTest(GNP, type = "Z-tau", model = "constant", use.lag = 5)
    urppTest(GNP, type = "Z-alpha", model = "trend", use.lag = 5)
    urppTest(GNP, type = "Z-tau", model = "trend", use.lag = 5)
    ###
    

# ------------------------------------------------------------------------------

   
### Example: SP Test


    urspTest(GNP, type = "tau", pol.deg = 1, signif = 0.01)
    urspTest(GNP, type = "tau", pol.deg = 2, signif = 0.01)
    urspTest(GNP, type = "tau", pol.deg = 3, signif = 0.01)
    urspTest(GNP, type = "tau", pol.deg = 4, signif = 0.01)
    ###
    
    urspTest(GNP, type = "rho", pol.deg = 1, signif = 0.01)
    urspTest(GNP, type = "rho", pol.deg = 2, signif = 0.01)
    urspTest(GNP, type = "rho", pol.deg = 3, signif = 0.01)
    urspTest(GNP, type = "rho", pol.deg = 4, signif = 0.01)
    ###
    
    
# ------------------------------------------------------------------------------

   
### Example: ZA Test


    urzaTest(GNP, model = "intercept", lag = 2)
    urzaTest(GNP, model = "trend", lag = 2)
    urzaTest(GNP, model = "both", lag = 2)
    ###
    
    
################################################################################
# PART VI: Use Bernhard Pfaff's contributed 'urca' package


    # Description:
    #   This part shows the usage of unit root tests from Bernhard Pfaff's
    #   contributed R package 'urca'. Note, you have to install the 'urca'
    #   package and to load it calling "library(urca)" or "require(urca)".
   
    # Arguments:
    #   Unit Root Tests from 'urca' Package:
    # 	ur.df()
    #		...
    # 	ur.ers(y, type = c("DF-GLS", "P-test"), model = c("constant", "trend"), 
    #		lag.max = 4)
    # 	ur.kpss(y, type = c("mu", "tau"), lags = c("short", "long", "nil"), 
    #		use.lag = NULL)
    # 	ur.pp(x, type = c("Z-alpha", "Z-tau"), model = c("constant", "trend"), 
    #		lags = c("short", "long"), use.lag = NULL)
    # 	ur.sp(y, type = c("tau", "rho"), pol.deg = c(1, 2, 3, 4), signif = 
    #		c(0.01, 0.05, 0.1))
    # 	ur.za(y, model = c("intercept", "trend", "both"), lag)

    # Details:
    # 	Function Overview:
    # 	TABLE:
    #             ur.df  ur.ers    ur.kpss  ur.pp     ur.sp          ur.za
    # 	------------------------------------------------------------------------
    #  	type             DF-GLS    mu       Z-alpha   tau            -
    #  	                 P-test    tau      Z-tau     rho            -
    # 	pol.deg          -         -        -         1:4            -
    #  	signif                                        0.01,0.05,0.1
    #  	model            constant  -        constant  -              intercept
    #   	             trend     -        trend     -              trend
    #       	         -         -        -         -              both
    #  	lag.max          4         -        -         -              -
    #  	lags             -         short    short     -              - 
    #  	                 -         long     long      -              -
    #   	             -         nil      -         -              -
    #  	use.lags         -         NULL     NULL      -              -
    # ------------------------------------------------------------------------

    
# ------------------------------------------------------------------------------


### Example: Load and Plot Real GPD from Nelson-Plotter Data:


    # Requirements:
    require(urca)
    ###
    
    # GNP Data:
    data(nporg)
    gnp = na.omit(nporg[, "gnp.r"])
    dgnp = diff(gnp)
    lgnp = log(gnp)
    dlgnp = diff(lgnp)
    par(mfrow = c(2, 2), cex = 0.7)
    gnp.log = log(gnp)
    ###
       
    # Plot:
    plot(gnp, type = "b", main = "Nelson-Plosser Data")
    plot(diff(gnp), type = "b", main = "Differenced")
    abline(h = mean(diff(gnp)), lty = 3)
    # Plot Log Data:
    plot(gnp.log, type = "b", main = "Log: Nelson-Plosser Data")
    plot(diff(gnp.log), type = "b", main = "Differenced")
    abline(h = mean(diff(gnp.log)), lty = 3)
    ###
    

# ------------------------------------------------------------------------------


### Example: DF and ADF Test


    # ur.df(y, type = c("none", "drift", "trend"), lags = 1)


# ------------------------------------------------------------------------------


### Example: ERS - ERS Test


    args(ur.ers)
    # function (y, type = c("DF-GLS", "P-test"), model = c("constant", 
    #   "trend"), lag.max = 4) 
    ###

    # DF-GLS | constant:
    ers.gnp = ur.ers(dgnp, type = "DF-GLS", model = "constant", lag.max = 4)
    print(ers.gnp)
    plot(ers.gnp)
    summary(ers.gnp)
    ###
    
    # P-test | constant:
    ers.gnp = ur.ers(dgnp, type = "P-test", model = "constant", lag.max = 4)
    print(ers.gnp)
    summary(ers.gnp)
    ###
        
    # DF-GLS | trend:
    ers.gnp = ur.ers(gnp, type = "DF-GLS", model = "trend", lag.max = 4)
    print(ers.gnp)
    plot(ers.gnp)
    summary(ers.gnp)
    ###
        
    # P-test | trend:
    ers.gnp = ur.ers(gnp, type = "P-test", model = "trend", lag.max = 4)
    print(ers.gnp)
    summary(ers.gnp)
    ###


# ------------------------------------------------------------------------------


### Example: KSPP - KSPP Test
 

    args(ur.kpss)
    #   function (y, type = c("mu", "tau"), lags = c("short", "long", 
    #       "nil"), use.lag = NULL) 
    # Arguments:
    #   type - Type of deterministic part,
    #       mu:     constant
    #       tau:    constant with linear trend
    #   lags - Maximum number of lags used for error term correction, or
    #       short:  trunc(4 * (n/100)^0.25)
    #       long:   trunc(12 * (n/100)^0.25)
    #       nil:    0
    #   use.lag - User specified number of lags. 
    ###

    # KPSS | tau | short:
    kpss.gnp = ur.kpss(lgnp, type = "tau", lags = "short")
    print(kpss.gnp)
    plot(kpss.gnp)
    summary(kpss.gnp)
    ###

    # KPSS | tau | long:
    kpss.gnp = ur.kpss(lgnp, type = "tau", lags = "long")
    print(kpss.gnp)
    plot(kpss.gnp)
    summary(kpss.gnp)
    ###
        
    # KPSS | tau | 6 lags:
    kpss.gnp = ur.kpss(lgnp, type = "tau", use.lag = 6)
    print(kpss.gnp)
    plot(kpss.gnp)
    summary(kpss.gnp)
    ####
    
    # KPSS | mu | short:
    kpss.gnp = ur.kpss(dlgnp, type = "mu", lags = "short")
    print(kpss.gnp)
    plot(kpss.gnp)
    summary(kpss.gnp)
    ###
        
    # KPSS | mu | long:
    kpss.gnp = ur.kpss(dlgnp, type = "mu", lags = "long")
    print(kpss.gnp)
    plot(kpss.gnp)
    summary(kpss.gnp)
    ###
        
    # KPSS | mu | 6 lags:
    kpss.gnp = ur.kpss(dlgnp, type = "mu", use.lag = 6)
    print(kpss.gnp)
    plot(kpss.gnp)
    summary(kpss.gnp)
    ###


# ------------------------------------------------------------------------------


### Example: PP - Phillips & Perron Unit Root Test


    args(ur.pp)
    # function (x, type = c("Z-alpha", "Z-tau"), model = c("constant", 
    #   "trend"), lags = c("short", "long"), use.lag = NULL) 
    # Arguments:
    #   type
    #   model
    #   lags
    #   use.lag
    ###
    
    # PP | Ztau | trend | short:
    pp.gnp = ur.pp(gnp, type = "Z-tau", model = "trend", lags = "short")
    print(pp.gnp)
    plot(pp.gnp)
    summary(pp.gnp)
    ###
    
    # PP | Ztau | trend | long:
    pp.gnp = ur.pp(gnp, type = "Z-tau", model = "trend", lags = "long")
    print(pp.gnp)
    plot(pp.gnp)
    summary(pp.gnp)
    ###
    
    # PP | Ztau | trend | 6 lags:
    pp.gnp = ur.pp(gnp, type = "Z-tau", model = "trend", use.lag = 6)
    print(pp.gnp)
    plot(pp.gnp)
    summary(pp.gnp)
    ###
        
    # PP | Ztau | constant | short:
    pp.gnp = ur.pp(diff(gnp), type = "Z-tau", model = "constant", 
        lags = "short")
    print(pp.gnp)
    plot(pp.gnp)
    summary(pp.gnp)
    ###
    
    # PP | Ztau | trend | long:
    pp.gnp = ur.pp(diff(gnp), type = "Z-tau", model = "constant", 
        lags = "long")
    print(pp.gnp)
    plot(pp.gnp)
    summary(pp.gnp)
    ###
    
    # PP | Ztau | constant | 6 lags:
    pp.gnp = ur.pp(diff(gnp), type = "Z-tau", model = "constant", 
        use.lags = 6)
    print(pp.gnp)
    plot(pp.gnp)
    summary(pp.gnp)
    ###
    
    # PP | Zalpha | trend:
    pp.gnp = ur.pp(gnp, type = "Z-alpha", model = "trend")
    print(pp.gnp)
    plot(pp.gnp)
    summary(pp.gnp)
    ###
    
    # PP | Zalpha | constant:
    pp.gnp = ur.pp(diff(gnp), type = "Z-alpha", model = "constant")
    print(pp.gnp)
    plot(pp.gnp)
    summary(pp.gnp)
    ###


# ------------------------------------------------------------------------------


### Example: SP - Schmidt & Phillips Unit Root Test


    args(ur.sp)
    # function (y, type = c("tau", "rho"), pol.deg = c(1, 2, 3, 4), 
    #   signif = c(0.01, 0.05, 0.1)) 
    ###

    # SP:
    sp.gnp = ur.sp(gnp, type = "tau", pol.deg = 1, signif = 0.05) 
    print(sp.gnp)
    plot(sp.gnp)
    summary(sp.gnp)
    ###
    
    # SP:
    ur.sp(gnp, type = c("tau", "rho"), pol.deg = c(1, 2, 3, 4), 
      signif = c(0.01, 0.05, 0.1)) 
    ###
    

# ------------------------------------------------------------------------------


### Example: ZA - Zivot and Andrews Unit Root Test


    args(ur.za)
    # function (y, model = c("intercept", "trend", "both"), lag) 
    ###

    # ZA | intercept | 2 lags:
    za.gnp = ur.za(gnp, model = "intercept", lag = 2)
    plot(za.gnp)
    summary(za.gnp)
    ###
        
    # ZA | trend | 2 lags:
    za.gnp = ur.za(gnp, model = "trend", lag = 2)
    plot(za.gnp)
    summary(za.gnp)
    ###
            
    # ZA | both | 2 lags:
    za.gnp = ur.za(gnp, model = "both", lag = 2)
    plot(za.gnp)
    summary(za.gnp)
    ###
        
    # ZA:
    za.gnp = urzaTest(gnp, model = "intercept", lag = 2)
    summary(za.gnp)
    ###
    
    # ZA:
    za.gnp = urzaTest(gnp, model = "trend", lag = 2)
    summary(za.gnp)
    ###
    
    # ZA:
    za.gnp = urzaTest(gnp, model = "both", lag = 2)
    summary(za.gnp)
    ###


################################################################################


#
# Example: 
#	Stationarit Tests
#


################################################################################
# Tests:
	
		
	# KPSS Test for Stationarity:
	# A time series which is level stationary:
	x = rnorm(1000)
	tskpssTest(x)
	# A time series which contains a unit-root:
	y = cumsum(x)
	tskpssTest(y)
	# A time series which is trend stationary:
	x = 0.3*(1:1000)+rnorm(1000)
	tskpssTest(x, null = "Trend")
	###


################################################################################

	


	# SPlus:
	x = (nelson.dat[,"RGNP"]@data)[,1]
	x = x[!is.na(x)] 
	x = exp(x[1:62])
	
	# - c - ct - nc - 
	lag = 1 # always one for "pp"
	bw = floor(4 * (length(x)/100)^(2/8)) 
	win  = "bartlett"
	
	round(unitroot(x, method = "pp", trend = "c",  stat = "t", lags = lag, 
		bandwidth = bw, window = win)$sval, 5)
	round(unitroot(x, method = "pp", trend = "ct", stat = "t", lags = lag, 
		bandwidth = bw, window = win)$sval, 5)
	
	round(unitroot(x, method = "pp", trend = "c",  stat = "n", lags = lag, 
		bandwidth = bw, window = win)$sval, 5)
	round(unitroot(x, method = "pp", trend = "ct", stat = "n", lags = lag, 
		bandwidth = bw, window = win)$sval, 5)
	
	
	
	
	# R - urca
	require(urca)
	data(nporg)
	x = nporg[, "gnp.r"]	
	x = x[!is.na(x)] 
	
	ur.pp(x, type = "Z-tau",   model = "constant")
	ur.pp(x, type = "Z-tau",   model = "trend")
	
	ur.pp(x, type = "Z-alpha", model = "constant")
	ur.pp(x, type = "Z-alpha", model = "trend")
	
	
	
	# tseries:
	flag = TRUE
	pp.test(x, alternative = "explosive",  type = "Z(t_alpha)", lshort = flag)$statistic 
	pp.test(x, alternative = "stationary", type = "Z(t_alpha)", lshort = flag)$statistic  
	pp.test(x, alternative = "explosive",  type = "Z(alpha)",   lshort = flag)$statistic  
	pp.test(x, alternative = "stationary", type = "Z(alpha)",   lshort = flag)$statistic  


	
	
# ------------------------------------------------------------------------------


\noindent In the next example we show how to reproduce the numbers
of the table performing a Monte carlo simulation:


\vspace{0.5cm}


\addtocounter{example}{+1}


\begin{footnotesize}
\textbf{$\square$ Example 3.5.\theexample: Compare Asymptotic and MC
Results for a Series of length 1000}

    \begin{verbatim}
    # Simulate p-values:
    > set.seed(1953)
    > nobs = nsim = 1000
    > DF = rep(0, nsim)
    > for (i in 1:nsim) {
        BN.moments = wiener(nobs)
        DF[i] = BN.moments$intWdW/sqrt(BN.moments$intW2) }

    # Compare Asymptotic Limit - Table vs MC:
    > STAT = as.numeric(adfTable("nc")["Inf", ])
    > PVAL.TAB = as.numeric(colnames.adfTable("nc")))
    > PVAL.MC = NULL
    > for (i in 1:length(STAT)) {
        PVAL.MC = c(PVAL.MC, length(DF[DF<=STAT[[i]]])/1000) }

    # Output:
    > data.frame(STAT, PVAL.TAB, PVAL.MC)

       STAT PVAL.TAB PVAL.MC
    1 -2.58    0.010   0.009
    2 -2.23    0.025   0.029
    3 -1.95    0.050   0.053
    4 -1.62    0.100   0.104
    5  0.89    0.900   0.898
    6  1.28    0.950   0.947
    7  1.62    0.975   0.973
    8  2.00    0.990   0.984
    \end{verbatim}

\end{footnotesize}



# ------------------------------------------------------------------------------





\noindent The following two examples show how to simulate time
series processes specified by equations (\ref{DF1}) and (\ref{DF3})
using recursive filtering implemented in the function
\texttt{filter()}. We test two cases $\phi=1$ and $\phi=0.99$ ...


\vspace{0.5cm}


\addtocounter{example}{+1}


\begin{footnotesize}
\textbf{$\square$ Example 1.5.\theexample: DF Test of Type
"no-constant"}

    \begin{verbatim}
    # Recursive Filter: x[i] = s[i] + filter*x[i-1]
    > set.seed(4711)
    > s = rnorm(5000)

    # phi=1 non-stationary Series:
    > x = as.ts(filter(x = s, filter = 1, method = "recursive"))
    > plot(x, type = "l", main = paste("phi =", phi))
    > .dfTest(x, type = "nc")

    # phi = 0.99 stationary Series
    > x = as.ts(filter(x = s, filter = 1, method = "recursive"))
    > plot(x, type = "l", main = paste("phi =", phi))
    > .dfTest(x, type = "nc")
    \end{verbatim}

\end{footnotesize}


\vspace{0.5cm}


\addtocounter{example}{+1}


\begin{footnotesize}
\textbf{$\square$ Example 1.5.\theexample: DF Test of Type "constant
+ trend"}

    \begin{verbatim}
    # Recursive Filter: x[i] = s[i] + filter*x[i-1]
    > set.seed(4711)
    > c1 = 0.01
    > c2 = 1e-6
    > s = c1 + c2*(1:5000) + rnorm(5000)

    # phi=1 non-stationary Series:
    > x = as.ts(filter(x = s, filter = 1, method = "recursive"))
    > plot(x, type = "l", main = paste("phi =", phi))
    > adfTest(x, type = "ct")

    # phi = 0.99 stationary Series
    > x = as.ts(filter(x = s, filter = 1, method = "recursive"))
    > plot(x, type = "l", main = paste("phi =", phi))
    > adfTest(x, type = "ct")
    \end{verbatim}

\end{footnotesize}



# ------------------------------------------------------------------------------


	.dfTest = function(x)
	{	
        # Regression and Summary:
        x.diff = diff(x)[-1]
        x.lag.1 = x[2:(length(x)-1)]
        LM = lm(x.diff ~ x.lag.1 - 1)
        test = list(lm = summary(LM))

        # Statistic:
        STAT = test$lm$coefficients[1]/test$lm$coefficients[2]
        names(STAT) = "Dickey-Fuller"
        test$statistic = STAT

        # P Value:
        PVAL = padf(q = STAT, n.sample = length(x), trend = "nc")
        names(PVAL) = ""
        test$p.value = PVAL

        # Return Value:
        new("fHTEST", call = match.call(), data = list(x = x),
            test = test, title = "Dickey Fuller Test", 
            description = " Test Type: nc")
    }
    

	set.seed(4711)
	x = rnorm(1001)
	.dfTest(x)
	x = diffinv(x)
	.dfTest(x)
    
# ------------------------------------------------------------------------------


### 3 Compute ADF Test for Chicken and Egg Data, compare with STATA/Splus


    # Compute the ADF Test for the "eggs" data and campare the results
    # with those obtained from the STATA and SPLUS functions:

    # Data:
    eggs = c(
        3581, 3532, 3327, 3255, 3156, 3081, 3166, 3443, 3424, 3561, 3640,
        3840, 4456, 5000, 5366, 5154, 5130, 5077, 5032, 5148, 5404, 5322,
        5323, 5307, 5402, 5407, 5500, 5442, 5442, 5542, 5339, 5358, 5403,
        5345, 5435, 5474, 5540, 5836, 5777, 5629, 5704, 5806, 5742, 5502,
        5461, 5382, 5377, 5408, 5608, 5777, 5825, 5625, 5800, 5656)
    chic = c(
        468491, 449743, 436815, 444523, 433937, 389958, 403446, 423921, 
        389624, 418591, 438288, 422841, 476935, 542047, 582197, 516497, 
        523227, 467217, 499644, 430876, 456549, 430988, 426555, 398156, 
        396776, 390708, 383690, 391363, 374281, 387002, 369484, 366082, 
        377392, 375575, 382262, 394118, 393019, 428746, 425158, 422096, 
        433280, 421763, 404191, 408769, 394101, 379754, 378361, 386518, 
        396933, 400585, 392110, 384838, 378609, 364584)
    year = 1930:1983
    ###
    
    # Plot:
    plot(chic, type = "l")  
    ### 
      
    # STATA - Results:
    statisticSTATA = c(nc = -0.712, c = -1.618, ct = -1.998)
    p.valueSTATA   = c(nc = NA,     c =  0.474, ct =  0.603)   
    # SPLUS - Results:
    if (FALSE) {
        # Splus Code:
        chic = as.vector(ts[, 1])
        unitroot(x = chic, trend = "nc", lags = 2, asymptotic = FALSE)
        unitroot(x = chic, trend = "c",  lags = 2, asymptotic = FALSE)
        unitroot(x = chic, trend = "ct", lags = 2, asymptotic = FALSE) }    
    statisticSPLUS = c(nc = -0.7122, c = -1.618,  ct = -1.998 )
    p.valueSPLUS   = c(nc =  0.4034, c =  0.4663, ct =  0.5886) 
    ###
  
    # Start Settings:
    ans1 = ans2 = NULL
    rowNames = c("nc", "c", "ct")   
    # Compute from adfTest:
    for (type in rowNames) {
        res1 = adfTest(x = chic, type = type, lags = 1)
        res2 = unitrootTest(x = chic, type = type, lags = 1)
        ans1 = rbind(ans1, c(res1$statistic, res1$p.value)) 
        ans2 = rbind(ans2, c(res2$statistic, res2$p.value)) 
    }        
    # Bind:
    ans = cbind(ans1, ans2)    
    # Add SPLUS results:
    ans = cbind(round(ans, digits = 3), statisticSPLUS, p.valueSPLUS)    
    # Add STATA results:
    ans = cbind(round(ans, digits = 3), statisticSTATA, p.valueSTATA)   
    # Add row and column names:
    rownames(ans) = rowNames
    colnames(ans) = c(
        "sADF", "pADF", "sJGM", "pJGM", "sSPLUS", "pSPLUS", "sSTATA", "pSTATA")
    ###
    
    # Print All Result:
    print(ans)
    ###
    

#
# Example:
#   A Compendium for R and Rmetrics users to the book 
#     "Analysis of Financial Time Series", Wiley 2002, 
#     written by Ruey Tsay
#   ISBN 0-471-41544-8 
#
# Details:
#   Downloadable from: http://www.gsb.uchicago.edu/fac/ruey.tsay/teaching/fts/
#
# Notes:
#   Diethelm Wuertz
#     www.rmetrics.org
#     www.itp.phys.ethz.ch
#     www.finance.ch
#
# Author:
#   (C) 2002-2004, Diethelm Wuertz, GPL
#


################################################################################


tsaySeries = 
function(query = "d-ibmln", file = "tempfile", 
source = "http://www.gsb.uchicago.edu/fac/ruey.tsay/teaching/fts/", 
save = FALSE, sepCSV = ";", try = TRUE, ...) 
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Downloads *.dat data sets from R Tsay's textbook
    
    # Value:
    #   A data frame.
        
    # Examples:
    #   tsaySeries(query = "d-ibmln")   1-column file
    #   tsaySeries(query = "d-vwew")    3-columns file

    # FUNCTION:
     
    # Download:
    if (try) {
        # Try for Internet Connection:
        z = try(tsaySeries(query = query, file = file, source = source, 
            save = save, try = FALSE))
        if (class(z) == "try-error" || class(z) == "Error") {
            return("No Internet Access") 
        } else {
            return(z) 
        } 
    } else { 
        # File name:
        queryFile = paste(query, ".dat", sep = "")
        
        # For S-Plus Compatibility:
        if (class(version) != "Sversion") {
            # R:
            method = NULL
        } else { 
            # SPlus
            method = "wget"
        }
    
        # Download and temporarily store:
        download.file(url = paste(source, queryFile, sep = ""), 
            destfile = file, method = method) 
        
        # Scan the file and transform into data frame:
        ans = read.table(file, ...)
        
        # Save download ?
        if (save) {
            write.table(z, file, quote = FALSE, col.names = FALSE, 
                sep = sepCSV) 
        } else {
            unlink(file) 
        } 
        
        # Return Value:
        return(ans)
    }
    
    # Return Value:
    invisible()
}


################################################################################

# Function Builtin: uroot [No Gui]
#   This function Builtin will be used when the original package 'uroot'
#   is not available for your hardware configuration and/or operating 
#   system. 

# Package: uroot
# Version: 1.4
# Date: 2005/10/10
# Title: Unit Root Tests and Graphics for Seasonal Time Series
# Author: Javier López-de-Lacalle <javlacalle@yahoo.es> and
#   Ignacio Díaz-Emparanza <Ignacio.Diaz-Emparanza@ehu.es>
# Maintainer: Javier López-de-Lacalle <javlacalle@yahoo.es>
# Depends: R (>= 2.0.0), methods
# Imports: graphics
# Suggests: tcltk, xtable
# Collate: adf.R ch.R graphics.R hegy.R kpss.R makegui.R misc.R rec-test.R 
#   stepdate.R urootgui.R urt-cvtables.R xtable.R
# Description: This package contains several functions for analysing quarterly 
#   and monthly time series. Unit root test: ADF, KPSS, HEGY, and CH, as well 
#   as graphics: Buys-Ballot and seasonal cycles, among others, have been 
#   implemented to accomplish either an analytical or a graphical analysis. 
#   Combined use of both enables the user to characterize the seasonality as
#   deterministic, stochastic or a mixture of them. An easy to use graphical 
#   user interface is also provided to run some of the implemented functions.
# License: GPL version 2 or newer. The terms of this license are in a file 
#   called COPYING which is provided with R.
# Packaged: Tue Oct 18 12:56:27 2005; root


################################################################################


# adf.R
# ch.R
# graphics.R
# hegy.R
# kpss.R
# misc.R
# rec-test.R
# stepdate.R
# urt-cvtables.R
# xtable.R

##~ significance codes (*,**) en regvarcoefs...

setClassUnion("maybeRegvar", c("NULL", "numeric", "matrix", "data.frame")) # NULL y numeric para ltrunc en KPPS Y CH rect. 
setClassUnion("maybeLags", c("NULL", "list", "character", "numeric", "matrix")) ##~ "list"
setClass("adfstat", representation(wts="ts", itsd="numeric", regvar="maybeRegvar", selectlags="list",
  regvarcoefs="maybeRegvar", lagsorder="maybeLags", lagcoefs="maybeLags", res="numeric", lmadf="lm",
  stat="matrix"))

ADF.test <- function(wts, itsd, regvar=0, selectlags=list(mode="signf", Pmax=NULL))
{
  s  <- frequency(wts); t0 <- start(wts); N  <- length(wts)
  if(s==1 && itsd[3] != 0){
     detreg$detcomp <- c(detreg$detcomp[1:2], 0)
     cat("  Seasonal dummies are not considered for annual data.\n")
  }

  # Dependent variable.
  Deltay <- matrix(c(NA, diff(wts, lag=1)), ncol=1)

  # Regressor variables.
  Intercept <- matrix(rep(1, N), ncol=1)[,itsd[1]]
  Trend     <- matrix(c(1:N), ncol=1)[,itsd[2]]
  SDummy <- data.frame(SeasDummy=SeasDummy(wts, "alg"))[,itsd[-c(1,2)]]

  if(!identical(regvar, 0) && length(names(regvar)) == 0)
    regvar <- data.frame(Regvar=regvar)

  if(identical(itsd, c(0,0,0)) && identical(regvar, 0))
    Mdetreg <- numeric(0)
  if(!identical(itsd, c(0,0,0)) && identical(regvar, 0))
    Mdetreg <- as.matrix(data.frame(Intercept, Trend, SDummy))
  if(!identical(itsd, c(0,0,0)) && !identical(regvar, 0))
    Mdetreg <- as.matrix(data.frame(Intercept, Trend, SDummy, regvar))
  if(identical(itsd, c(0,0,0)) && !identical(regvar, 0))
    Mdetreg <- as.matrix(data.frame(regvar))
  regvarnames <- dimnames(Mdetreg)[[2]]

  # DF regression without lags.
  Madfreg <- as.matrix(data.frame(adf.reg=c(NA, wts[1:(N-1)])))
  ifelse(length(Mdetreg) == 0,
    lmdf <- lm(Deltay[,1] ~ 0+Madfreg),
    lmdf <- lm(Deltay[,1] ~ 0+Mdetreg + Madfreg))

  # Lags selection.
  if(class(selectlags[[1]]) == "numeric"){
    selP <- selectlags[[1]]
  } else
      switch(selectlags[[1]],
        aic   = selP <- selPabic(lmdet=lmdf, type="aic", Pmax=selectlags[[2]]),
        bic   = selP <- selPabic(lmdet=lmdf, type="bic", Pmax=selectlags[[2]]),
        signf = selP <- selPsignf(lmdet=lmdf, cvref=NULL, Pmax=selectlags[[2]]),)

  # ADF regression.
  if(identical(selP, 0) || length(selP)==0){
    ifelse(length(Mdetreg)==0, lmadf <- lm(Deltay[,1] ~ 0+Madfreg),
                               lmadf <- lm(Deltay[,1] ~ 0+Mdetreg + Madfreg))
  } else{
      Mlags <- ret(Deltay, max(selP)+2)[,-1]; aux <- dimnames(Mlags)[[2]]
      Mlags <- data.frame(Mlags[,selP]); lagnames <- aux[selP]
      Mlags <- as.matrix(Mlags)
      ifelse(length(Mdetreg)==0, lmadf <- lm(Deltay[,1] ~ 0+Madfreg + Mlags),
                                 lmadf <- lm(Deltay[,1] ~ 0+Mdetreg + Madfreg + Mlags))
    }

  # lmadf estimates.
  coefs <- coef(summary(lmadf)); Ncoef <- length(coef(lmadf))
  colnames <- dimnames(coefs)[[2]]
  ifelse(Ncoef==1, ref<-1, ref <- which(dimnames(coefs)[[1]] == "Madfreg"))

  # determiistic components estimates.
  if(ref > 1){
    regvarcoefs <- coefs[1:(ref-1),1:4]
    dim(regvarcoefs) <- c((ref-1), 4)
    dimnames(regvarcoefs) <- list(regvarnames, colnames)
  } else
      regvarcoefs <- NULL

  # ADF statistic and p-value.
  adfreg <- t(as.data.frame(coefs[ref,1:4]))
  code <- paste("DF", paste(itsd[1:2], collapse=""), "0", sep="")
  adfreg[,4] <- interpolpval(code=code, stat=adfreg[,3], N=N)$pval
  dimnames(adfreg) <- list("adf.reg", colnames[1:4])

  # Lags estimates
  if(ref < Ncoef){
    lagcoefs <- coefs[(ref+1):Ncoef,1:4]
    dim(lagcoefs) <- c(length((ref+1):Ncoef), 4); lagcoefs <- data.frame(lagcoefs)
    dimnames(lagcoefs) <- list(lagnames, colnames); lagcoefs <- as.matrix(lagcoefs)
  } else
      lagcoefs <- NULL

  new("adfstat", wts=wts, itsd=itsd, regvar=regvar, selectlags=selectlags, regvarcoefs=regvarcoefs,
    lagsorder=selP, lagcoefs=lagcoefs, res=residuals(lmadf), lmadf=lmadf, stat=adfreg)
}

setMethod("show", "adfstat",
  function(object)
  {
    lmadf <- object@lmadf
    coefs <- coef(lmadf); coefnames <- names(coefs)
    ifelse(length(coefnames)==1, ref <- 1, ref <- which(coefnames=="Madfreg"))

    cat("  --------- ------ - ------ ----\n")
    cat("  Augmented Dickey & Fuller test\n")
    cat("  --------- ------ - ------ ----\n\n")

    cat("  Null hypothesis: Unit root.\n")
    cat("  Alternative hypothesis: Stationarity.\n")

    cat("\n----\n  ADF statistic:\n\n")
    print(round(object@stat, 3))
    cat("\n  Lag orders:", object@lagsorder)
    cat("\n  Number of available observations:", length(object@res),"\n")
  }
)

setMethod("summary", "adfstat",
  function(object)
  {
    lmadf <- object@lmadf
    coefs <- coef(lmadf); coefnames <- names(coefs)
    ifelse(length(coefnames)==1, ref <- 1, ref <- which(coefnames=="Madfreg"))

    ##~ Mostrando p-values.
    cat("  --------- ------ - ------ ----\n")
    cat("  Augmented Dickey & Fuller test\n")
    cat("  --------- ------ - ------ ----\n\n")

    cat("----\n  Deterministic regressors estimates:\n\n")
    if(ref > 1){
      object@regvarcoefs[,1:4] <- round(object@regvarcoefs[,1:4], 3)
      print(object@regvarcoefs)
    } else
        cat("    None selected.\n")

    cat("\n----\n  ADF regressor estimate:\n\n")
    print(round(object@stat, 3))

    cat("\n----\n  Selected lags estimates:\n\n")
    if(ref < length(coefnames)){
      object@lagcoefs[,1:4] <- round(object@lagcoefs[,1:4], 3)
      print(object@lagcoefs)
    } else
        cat("    None selected.\n")

    cat("\n  Number of available observations:", length(object@res),"\n")
  }
)

setClass("chstat", representation(wts="ts", frec="numeric", DetTr="logical", ltrunc="numeric",
  Fhat="matrix", Omfhat="matrix", MA="matrix", stat="numeric"))

CH.test <- function(wts, frec=NULL, f0=1, DetTr=FALSE, ltrunc=NULL)
{
  s <- frequency(wts); t0 <- start(wts); N <- length(wts)
  if(class(frec)=="NULL") frec <- rep(1, s/2)
  if(class(ltrunc)=="NULL") ltrunc <- round(s*(N/100)^0.25)

  # Regressors for the auxiliar regression

  R1 <- SeasDummy(wts, "trg")
  VFEalg <- SeasDummy(wts, "alg")
  tiempo <- c(1:N)
 
  if(DetTr ==FALSE){
    if(f0 == 1){
      lmch  <- lm(wts[2:N] ~ wts[1:(N-1)] + R1[2:N,1:(s-1)])
      ehat <- matrix(lmch$residuals, ncol=1)
    }
    if(f0 == 0){
      lmch  <- lm(wts ~ R1[,1:(s-1)])
      ehat <- matrix(lmch$residuals, ncol=1)
    }
  }
  if(DetTr ==TRUE){
    if(f0 == 1){
      lmch  <- lm(wts[2:N] ~ wts[1:(N-1)] + tiempo[1:(N-1)] + R1[2:N,1:(s-1)])
      ehat <- matrix(lmch$residuals, ncol=1)
    }
    if(f0 == 0){
      lmch  <- lm(wts ~ tiempo + R1[,1:(s-1)])
      ehat <- matrix(lmch$residuals, ncol=1)
    }
  }

  # Fhat
  Fhat <- Fhataux <- matrix(nrow=length(ehat), ncol=(s-1))
 
  #ifelse(f0 == 1, op <- 1, op <- 0) # también cambia varnw[3:13...]
  for(i in 1:length(ehat))
    Fhataux[i,] <- R1[i+f0,]*ehat[i]   # No producto matricial %*%
 
  for(i in 1:nrow(Fhat)){
    for(n in 1:(s-1))
      Fhat[i,n] <- sum(Fhataux[1:i,n])
  }
 
  # Omega supra-f estimate  (Omfhat)
  
  wnw <- 1 - seq(1,ltrunc,1)/(ltrunc+1)
  Ne <- nrow(Fhataux)
  Omnw <- 0
  for(k in 1:ltrunc)
    Omnw <- Omnw + (t(Fhataux)[,(k+1):Ne] %*% Fhataux[1:(Ne-k),]) * wnw[k]
  Omfhat <- (crossprod(Fhataux) + Omnw + t(Omnw))/Ne
  
  # Matriz A
  # frec <- c(0,1)          # input for quarterly series
  # frec <- c(1,0,0,0,0,0)  # input for monthly series

  #sq     <- seq(1,11,2)
  sq <- seq(1,(s-1),2)
  frecob <- rep(0,(s-1))

  for(i in 1:length(frec)){
    if(frec[i] == 1 && i == s/2)
       frecob[sq[i]]     <- 1
    if(frec[i] == 1 && i < s/2)
       frecob[sq[i]] <- frecob[sq[i]+1] <- 1
  }
 
  a <- length(which(frecob == 1))
  A <- matrix(0, nrow=s-1, ncol=a)
 
  j <- 1
  for(i in 1:(s-1))
    if(frecob[i] == 1){
      A[i,j] <- 1
      ifelse(frecob[i] == 1, j <- j+1, j <- j)
    }

  # Statistic (equation (13) Canova & Hansen (1995))
 
  stL <- (1/N^2)*sum(diag( solve(t(A) %*% Omfhat %*% A)
                           %*%
                           t(A) %*% t(Fhat) %*% Fhat %*% A ))
  
  new("chstat", wts=wts, frec=frec, DetTr=DetTr, ltrunc=ltrunc,
    Fhat=Fhat, Omfhat=Omfhat, MA=A, stat=stL)
}

setMethod("show", "chstat",
  function(object)
  {
    s <- frequency(object@wts)
    if(s == 4)
      fnames <- c("pi/2", "pi")
    if(s == 12)
      fnames <- c("pi/6", "pi/3", "pi/2", "2pi/3", "5pi/6", "pi")
    ref <- which(object@frec==1)
    cvtable <- lookupCVtable(code=paste("CHp", sum(object@frec*c(rep(2, s/2-1),1)), sep=""))[1,]
    dimnames(cvtable)[[1]] <- ""

    cat("\n  ------ - ------ ----")
    cat("\n  Canova & Hansen test")
    cat("\n  ------ - ------ ----\n\n")

    cat("  Null hypothesis: Stationarity.\n")
    cat("  Alternative hypothesis: Unit root.\n")
    cat("  Frequency of the tested cycles:", paste(fnames[ref], collate=","), "\n\n")

    cat(c("  L-statistic:", round(object@stat, 3), " \n"))
    cat(c("  Lag truncation parameter:", object@ltrunc, "\n\n"))
    cat("  Critical values:\n\n")
    print(cvtable)
    cat("\n")
  }
)

rmg <- function(wts, krmg=NULL)
{
 # k es el número de periodos entre los que
   # se calcula el rango y la media

  N <- length(wts)   
  if(class(krmg) == "NULL")
    krmg <- integer(sqrt(N))
  media <- c(1:(N-krmg+1))
  rango <- c(1:(N-krmg+1))

  for(i in 1:length(media)){
    media[i]<- mean(wts[i:(i+(krmg-1))])
    rango[i]<- (max(wts[i:(i+(krmg-1))])-min(wts[i:(i+(krmg-1))]))
                          }
  cor.mr <- cor(media, rango, use = "complete")

  plot(media, rango, pch=20, main="Range-mean plot", xlab="Mean", ylab="Range")
  mtext(as.expression(substitute(cor(R,M)==cor.mr,
        list(cor.mr=round(cor.mr, 4)))), side = 3, line = 0.35, cex=0.7)

  cat("\n  Correlation range-mean: ", round(cor.mr, 4), "\n")
}

##~ Ver hacer como método de una clase sts, clase sts todo lo de ts más atributo Mseas. Ver class mts ???
##~ chequeado para s=4, s=12.
##~ probarlo con diferentes start(wts) end(wts)

# Build a matrix containing seasonal paths.

Msts <- function(wts)  ##~ hacer que trate a las columnas como ts, ts.union.
{
  s <- frequency(wts)
  seas.data <- split(wts, cycle(wts))
  Mseas <- matrix(NA, nrow=ceiling(length(wts)/s), ncol=s)
  ref1 <- c(rep(2, start(wts)[2]-1), rep(1, s-start(wts)[2]+1))
  ref2 <- c(rep(0, end(wts)[2]), rep(1, s-end(wts)[2]))
  for(i in 1:s)
    Mseas[ref1[i]:(nrow(Mseas)-ref2[i]),i] <- seas.data[[i]]  # unlist(seas.data[[i]])

  ynames <- as.integer(time(wts))
  if(s==4)
    snames <- c("Qtr1", "Qtr2", "Qtr3", "Qtr4")
  else if(s==12)
    snames <- month.abb
  else
    snames <- paste("Seas", 1:s, sep="")

  Mseas <- matrix(Mseas, nrow=nrow(Mseas), ncol=ncol(Mseas),
           dimnames=list(as.character(ynames[1]:ynames[length(ynames)]), snames))

#  for(i in 1:ncol(Mseas))
#    Mseas[,i] <- ts(Mseas[,i], frequency=1, start=start(wts))
#  as.matrix(Mseas)
  Mseas
}

# Buys-Ballot plot.
##~ poner np-nl como opción.
bbplot <- function(wts, colour=c("SlateBlue","SeaGreen","red","magenta"))
{
  s <- frequency(wts)
  if(s==4){
    nl <- 4; np <- 1; fr <- 2
    snames <- c("Qrt1", "Qrt2", "Qrt3", "Qrt4")
  }
  else if(s==12){
    nl <- 3; np <- fr <- 4
    snames <- month.abb
  }
  else{
    if(identical(c(s/2 - as.integer(s/2)), 0)){
      nl <- 4; np <- s/nl
    }
    else{
      np <- floor((s+1)/4); nl <- c(rep(4, np-1), s/np+1)
    }
  }

  Mseas <- Msts(wts)

  aux <- Mseas[nrow(Mseas),]
  labaux <- c(na.omit(aux), Mseas[(nrow(Mseas)-1),which(is.na(aux))])

  xlim <- c(start(wts)[1], end(wts)[1]+1.5)
  ylim <- c(min(wts), max(wts))
  aux1 <- seq(1,s,nl); aux2 <- seq(nl,s,nl)

  if(s==4)
    opar <- par(mar=c(3,3.5,2,2), las=1)
  if(s==12)
    opar <- par(mfrow=c(fr/2, fr/2), mar=c(3,3.5,2,2), las=1)
  for(i in 1:np){
    ref <- aux1[i]:aux2[i]
    ts.plot(ts(Mseas[,ref], start=start(wts)[1]), xlab="", ylab="",
      xlim=xlim, ylim=ylim , col=colour)

    #text(xlim[2]-0.2, as.matrix(Mseas[,ref])[nrow(Mseas),], month.abb[ref])
    text(xlim[2]-0.2, labaux[ref], snames[ref], col=colour)
  }
  par(opar)
}

# Buys-Ballot annual plot.

bbaplot <- function(wts, years=NULL, colour=c("SlateBlue","SeaGreen","red","magenta"))
{
  if(class(years) == "NULL")
    years <- c(start(wts)[1], as.integer((start(wts)[1]+end(wts)[1])/2), end(wts)[1])

  s <- frequency(wts)
  c1 <- which(years < start(wts)[1])
  c2 <- which(years > end(wts)[1])
  if(length(c1) != 0 || length(c2) != 0)
    stop("  Years", years[c1], years[c2], "are out of the sample.")

  Mseas <- Msts(wts)
  ylabs <- numeric(0)
  ref <- numeric(0)
  for(i in 1:length(years))
    ref <- c(ref, which(as.numeric(dimnames(Mseas)[[1]]) == years[i]))

  opar <- par(las=1)
  ts.plot(t(Mseas[ref,]), xlab="Seasons", ylab="", xlim=c(1,s+0.7), col=colour)

  for(j in 1:length(years)){
    aux <- na.omit(Mseas[ref[j],])
    ylabs <- c(ylabs, aux[length(aux)])
  }

  text(s+0.6, ylabs, years, col=colour)
  par(opar)
}

# Buys-Ballot 3D plot.


bb3D <- function(wts, color=TRUE, x=30, y=30)
{
  require(tcltk)
  ttplot <- tktoplevel()
  tkconfigure(ttplot, cursor="fleur")
  tkwm.title(ttplot, "Rotate")

  bbpersp <- function(wts=wts, color=color, x=x, y=y)
  {
    if(color==TRUE)
       colores <- "lightgoldenrod"
    if(color==FALSE)
       colores <- grey((0:6)/6)

    Mseas <- Msts(wts)
  
    if(frequency(wts) == 12){ xlabel <- "Months"; ntic <- frequency(wts)/2}
    if(frequency(wts) == 4) { xlabel <- "Quarters"; ntic <- frequency(wts)}
    xx <- c(1:ncol(Mseas))
    yy <- c(start(wts)[1]:(start(wts)[1]+nrow(Mseas)-1))
  
    persp(xx, yy, t(Mseas), # main="Buys-Ballot 3D"
          theta = x, phi = y, expand = 0.5, xlab=xlabel, ylab="", zlab="", 
          shade=0.4, col = colores, ticktype="detailed", nticks=ntic)
  }

  bbpersp(wts, color=color, x=as.integer(x), y=as.integer(y))

  RightClick2 <- function(x,y)
  {
    rootx <- as.integer(tkwinfo("rootx",ttplot))
    rooty <- as.integer(tkwinfo("rooty",ttplot))
    xTxt <- as.integer(x)+rootx
    yTxt <- as.integer(y)+rooty
    bbpersp(wts, color=color, x=as.integer(x), y=as.integer(y))
  }
  tkbind(ttplot, "<Button-3>", RightClick2)
}

# Buys-Ballot contour plot.

bbcn <- function(wts, color=TRUE)  # MMp ó Mq de bbmp() y quarterg()
{
  if(color==TRUE)
     colores <- terrain.colors(200)
  if(color==FALSE)
     colores <- grey((0:32)/32)
  if(frequency(wts) == 12)
     xlabel <- month.abb
  if(frequency(wts) == 4){ xlabel <- c("Qrtr1", "Qrtr2", "Qrtr3", "Qrtr4")}

  Mseas <- Msts(wts)
  x <- c(1:ncol(Mseas))
  y <- c(start(wts)[1]:(start(wts)[1]+nrow(Mseas)-1))

  image(x, y, t(Mseas), # main="Buys-Ballot contour"
        las=1, xlab="", ylab="", xaxt="n", col = colores)
  mtext(xlabel[1:frequency(wts)], side=1, line=1, at=c(1:frequency(wts))) #, cex=0.7)
  contour(x, y, t(Mseas), add = TRUE, drawlabels = TRUE, col="blue")
}

##~ plotcycles: poner el polinomio en lugar de frecuencias (en doc tabla con frecuencias).

plotcycles <- function(wts)
{
  s <- frequency(wts)
  if(s==4)
   pdim <- c(2,2)
  if(s==12)
   pdim <- c(4,2)

  mains <- c("Frequency zero", "Frequency pi", "Frequencies (pi/2; 3pi/2)", "Frequencies (2pi/3; 4pi/3)",
             "Frequencies (pi/3; 5pi/3)", "Frequencies (5pi/6; 7pi/6)", "Frequencies (pi/6; 11pi/6)")

  Mfilt <- matrix(nrow=length(wts), ncol=(s/2+1))

  for(i in 1:ncol(Mfilt)){
    factors <- rep(1, (s/2+1))
    factors[i] <- 0
    Mfilt[,i] <- factorsdiff(wts, factors=factors)$Fil.wts
    ts(Mfilt, frequency=s, start=start(wts))
  }

  opar <- par(mfrow=pdim, las=1)
  plot(diff(wts, lag=s), xlab="", ylab="", main="Seasonal difference")
  for(i in 1:ncol(Mfilt)){
    fts <- ts(Mfilt[,i], frequency=s, start=start(wts))
    plot(fts, xlab="", ylab="", main=mains[i])
  }
  par(opar)
}

##~ F-st para VFE seleccionadas. y p.value para F.2:s F1:s, buscar tablas.
##~ significance codes (*,**) en regvarcoefs...

setClass("hegystat", representation(wts="ts", itsd="numeric", regvar="maybeRegvar", hegyreg="matrix",
  selectlags="list", regvarcoefs="maybeRegvar", hegycoefs="matrix", lagsorder="maybeLags",
  lagcoefs="maybeLags", res="numeric", lmhegy="lm", stats="matrix"))

HEGY.test <- function(wts, itsd, regvar=0, selectlags=list(mode="signf", Pmax=NULL))
{
  s  <- frequency(wts); t0 <- start(wts); N <- length(wts)

  # Dependent variable.
  Deltay <- matrix(c(rep(NA, s), diff(wts, lag=s)), ncol=1)

  # Regressor variables.
  Intercept <- matrix(rep(1, N), ncol=1)[,itsd[1]]
  Trend     <- matrix(c(1:N), ncol=1)[,itsd[2]]
  SDummy <- data.frame(SeasDummy=SeasDummy(wts, "alg"))[,itsd[-c(1,2)]]

  if(!identical(regvar, 0) && length(names(regvar)) == 0)
    regvar <- data.frame(Regvar=regvar)

  if(identical(itsd, c(0,0,0)) && identical(regvar, 0))
    Mdetreg <- numeric(0)
  if(!identical(itsd, c(0,0,0)) && identical(regvar, 0))
    Mdetreg <- as.matrix(data.frame(Intercept, Trend, SDummy))
  if(!identical(itsd, c(0,0,0)) && !identical(regvar, 0))
    Mdetreg <- as.matrix(data.frame(Intercept, Trend, SDummy, regvar))
  if(identical(itsd, c(0,0,0)) && !identical(regvar, 0))
    Mdetreg <- as.matrix(data.frame(regvar))
  regvarnames <- dimnames(Mdetreg)[[2]]

  # HEGY regression without lags.
  Mhegyreg <- hegy.reg(wts)
  ifelse(length(Mdetreg) == 0,
    lmdf <- lmhegyp <- lm(Deltay[,1] ~ 0+Mhegyreg),
    lmdf <- lmhegyp <- lm(Deltay[,1] ~ 0+Mdetreg + Mhegyreg))

  # Lags selection.
  if(class(selectlags[[1]]) == "numeric"){
    selP <- selectlags[[1]]
  } else
      switch(selectlags[[1]],
        aic   = selP <- selPabic(lmdet=lmhegyp, type="aic", Pmax=selectlags[[2]]),
        bic   = selP <- selPabic(lmdet=lmhegyp, type="bic", Pmax=selectlags[[2]]),
        signf = selP <- selPsignf(lmdet=lmhegyp, cvref=NULL, Pmax=selectlags[[2]]),)

  # HEGY regression.
  # lmdetlag: regression with deterministic components and lags (without the hegy regressors).
  # lmhegy: lmdetlag including the hegy regressors.
  if(identical(selP, 0) || length(selP)==0){
    if(length(Mdetreg)==0){
      lmdetlag <- lm(Deltay[,1] ~ 0)
      lmhegy <- lmhegyout <- lm(Deltay[,1] ~ 0+Mhegyreg)
    } else{
        lmdetlag <- lm(Deltay[,1] ~ 0+Mdetreg)
        lmhegy <- lmhegyout <- lm(Deltay[,1] ~ 0+Mdetreg + Mhegyreg)
      }
  } else{
      Mlags <- ret(Deltay, max(selP)+2)[,-1]; aux <- dimnames(Mlags)[[2]]
      Mlags <- data.frame(Mlags[,selP]); lagnames <- aux[selP]
      Mlags <- as.matrix(Mlags)
      if(length(Mdetreg)==0){
        lmdetlag <- lm(Deltay[,1] ~ 0+ Mlags)
        lmhegy <- lmhegyout <- lm(Deltay[,1] ~ 0+Mhegyreg + Mlags)
      } else{
          lmdetlag <- lm(Deltay[,1] ~ 0+Mdetreg + Mlags)
          lmhegy <- lmhegyout <- lm(Deltay[,1] ~ 0+Mdetreg + Mhegyreg + Mlags)
      }
    }

  # lmhegy estimates.
  coefs <- coef(summary(lmhegy)); Ncoef <- length(coef(lmhegy))
  colnames <- dimnames(coefs)[[2]]
  ifelse(Ncoef==s, ref<-1, ref <- which(dimnames(coefs)[[1]] == "MhegyregYpi1"))

  if(ref > 1){
    regvarcoefs <- coefs[1:(ref-1),1:4]
    dim(regvarcoefs) <- c((ref-1), 4)
    dimnames(regvarcoefs) <- list(regvarnames, colnames)
  } else
      regvarcoefs <- NULL

  # hegyreg
  ##~ Con bootshegy puede ocurrir que Mhegyreg tiene columnas casi 0 y estimación es NA, entonces coefs[ref:(ref+s-1),1:4] eliman esos NAs y ref ya no sirve como referencia.
  hegycoefs <- coefs[ref:(ref+s-1),1:4]  ##~ Añadir F_1:s, F_2:s
  dimnames(hegycoefs)[[1]] <- dimnames(Mhegyreg)[[2]]

  if((ref+s-1) < Ncoef){
    lagcoefs <- coefs[(ref+s):Ncoef,1:4]
    dim(lagcoefs) <- c(length((ref+s):Ncoef), 4); lagcoefs <- data.frame(lagcoefs)
    dimnames(lagcoefs) <- list(lagnames, colnames); lagcoefs <- as.matrix(lagcoefs)
  } else
      lagcoefs <- NULL

  # HEGY Statistics and p-values.
  # tpi
  if(s==4) c1 <- "HEGY";
  if(s==12) c1 <- "BM"
  c2 <- paste(itsd[1:2], sep="", collapse="")
  ifelse(itsd[3] != 0, c3 <-1, c3 <-0)

  for(i in 1:s){
    code <- paste(c(c1, c2, c3, "tpi", i), sep="", collapse="")
    hegycoefs[i,4] <- interpolpval(code=code, stat=hegycoefs[i,3], N=N)$pval
  }

  # tpi1-tpi2, Fpi_
  EtFst <- matrix(nrow=(s/2+3), ncol=2)
  EtFst[1:2,] <- hegycoefs[1:2,3:4]

  code <- paste(c(c1, c2, c3, "Foddeven"), sep="", collapse="")
  for(i in 1:(s/2-1)){
    lmpart <- update(lmdetlag, . ~ . + Mhegyreg[,c(1:s)[-c(2*i+1, 2*i+2)]])
    lmhegy <- update(lmpart, . ~ . + Mhegyreg[,c(2*i+1, 2*i+2)])
    EtFst[i+2,1] <- anova(lmpart, lmhegy, test="F")$F[2]
    EtFst[i+2,2] <- interpolpval(code=code, stat=EtFst[i+2,1], N=N)$pval
  }

  lmpart <- update(lmdetlag, . ~ . + Mhegyreg[,1])
  lmhegy <- update(lmpart, . ~ . + Mhegyreg[,2:s])
  EtFst[(s/2+2),1] <- anova(lmpart, lmhegy, test="F")$F[2]

  lmhegy <- update(lmdetlag, . ~ . + Mhegyreg[,1:s])
  EtFst[(s/2+3),1] <- anova(lmdetlag, lmhegy, test="F")$F[2]

  EtFsnames <- c("tpi_1", "tpi_2",
                 paste("Fpi", paste(seq(3,s,2),seq(4,s,2), sep=":"), sep="_"),
                 paste("Fpi_2:", s, sep=""), paste("Fpi_1:", s, sep=""))
  #dim(EtFst) <- c((s/2+3), 2);
  dimnames(EtFst) <- list(EtFsnames, c("Stat.", "p-value"))

  new("hegystat", wts=wts, itsd=itsd, regvar=regvar, hegyreg=Mhegyreg, selectlags=selectlags,
    regvarcoefs=regvarcoefs, hegycoefs=hegycoefs, lagsorder=selP, lagcoefs=lagcoefs,
    res=residuals(lmhegy), lmhegy=lmhegyout, stats=EtFst)
}

setMethod("show", "hegystat",
  function(object)
  {
    s <- frequency(object@wts); lmhegy <- object@lmhegy
    coefs <- coef(lmhegy); coefnames <- names(coefs)
    ifelse(length(coefnames)==1, ref <- 1, ref <- which(coefnames=="MhegyregYpi1"))

    ##~ Mostrando p-values.
    cat("  ---- ----\n")
    cat("  HEGY test\n")
    cat("  ---- ----\n\n")

    cat("  Null hypothesis: Unit root.\n")
    cat("  Alternative hypothesis: Stationarity.\n")

    cat("\n----\n  HEGY statistics:\n\n")
    print(round(object@stats, 3))
    cat("\n  Lag orders:", object@lagsorder)
    cat("\n  Number of available observations:", length(object@res),"\n")
  }
)

setMethod("summary", "hegystat",
  function(object)
  {
    s <- frequency(object@wts); lmhegy <- object@lmhegy
    coefs <- coef(lmhegy); coefnames <- names(coefs)
    ifelse(length(coefnames)==1, ref <- 1, ref <- which(coefnames=="MhegyregYpi1"))

    ##~ Mostrando p-values.
    cat("  ---- ----\n")
    cat("  HEGY test\n")
    cat("  ---- ----\n\n")

    cat("----\n  Deterministic regressors estimates:\n\n")
    if(ref > 1){
      print(round(object@regvarcoefs, 3))
    } else
        cat("    None selected.\n")

    cat("\n----\n  HEGY regressors estimates:\n\n")
    print(round(object@hegycoefs, 3))

    cat("\n----\n  Selected lags estimates:\n\n")
    if((ref+s-1) < length(coefnames)){
      print(round(object@lagcoefs, 3))
    } else
        cat("    None selected.\n")

    cat("\n  Number of available observations:", length(object@res),"\n")
  }
)

setClass("kpssstat", representation(wts="ts", lmkpss="lm", ltrunc="numeric", levelst="numeric",
  trendst="numeric"))

KPSS.test <- function(wts, ltrunc=NULL)
{
  tiempo <- c(1:length(wts))
  ML <- ret(wts, 2)

  ##~ ver
  if(class(ltrunc)=="NULL")
    ltrunc <- as.integer(3*sqrt(length(wts))/13)
  #ltrunc <- as.integer(3*sqrt(length(wts))/13)  # ver PP.test, artículo KPSS
  #ltrunc <- as.integer(10*sqrt(length(wts))/14)
  #ltrunc <- as.integer(4*(length(wts)/100)^(1/4))
  #ltrunc <- as.integer(12*(length(wts)/100)^(1/4))

  lmkpss <- lm(ML[,1] ~ tiempo)
  ehat <- residuals(lmkpss)
  Sa  <- cumsum(ehat)
  N <- length(ehat)

  # estimador consistente de la varianza de los residuos:
  if(ltrunc == 0)
    s.2a <- 1/N*sum(ehat^2)
  if(ltrunc > 0){
    auxa <- c(1:ltrunc)
    for(i in 1:ltrunc)
      auxa[i] <- (1-i/(ltrunc+1))*sum(ehat[(i+1):N]*ehat[1:(N-i)])
    s.2a <- (1/N)*sum(ehat^2)+(2/N)*sum(auxa)
  }

  Trend <- N^(-2)*sum(Sa^2/s.2a)

  # para la hipótesis nula de estacionariedad en tendencia los
  # residuos son ee=var-mean(var),
  # se analiza la serie extrayendo la media y la tendencia.

  wts2 <- wts - mean(na.omit(wts))
  Sb    <- cumsum(wts2)

  # estimador consistente de la varianza de los residuos:
  if(ltrunc==0)
    s.2b <- 1/N*sum(wts2[1:N]^2)
  if(ltrunc>0){
    auxb <- c(1:ltrunc)
    for(i in 1:ltrunc)
      auxb[i] <- (1-i/(ltrunc+1))*sum(wts2[(i+1):N]*wts2[1:(N-i)])
    s.2b <- (1/N)*sum(wts2[1:N]^2)+(2/N)*sum(auxb)
  }

  Level <- N^(-2)*sum(Sb[1:N]^2/s.2b)

  new("kpssstat", wts=wts, lmkpss=lmkpss, ltrunc=ltrunc, levelst=Level, trendst=Trend)
}

setMethod("show", "kpssstat",
  function(object){
    cvl <- data.frame(rbind(c(0.347, 0.463, 0.574, 0.739)))
    dimnames(cvl) <- list("", c("0.10", "0.05", "0.025", "0.01"))
    cvt <- data.frame(rbind(c(0.119, 0.146, 0.176, 0.216)))
    dimnames(cvt) <- list("", c("0.10", "0.05", "0.025", "0.01"))

    cat("\n  ---- ----")
    cat("\n  KPSS test")
    cat("\n  ---- ----\n\n")

    cat("  Null hypotheses: Level stationarity and stationarity around a linear trend.\n")
    cat("  Alternative hypothesis: Unit root.\n")

    cat(c("----\n  Statistic for the null hypothesis of \n   level stationarity:",
        round(object@levelst, 3), "\n"))
    cat("\n    Critical values:\n\n")
    print(cvl)
    cat(c("----\n  Statistic for the null hypothesis of \n   trend stationarity:",
        round(object@trendst, 3), "\n"))
    cat("\n    Critical values:\n\n")
    print(cvt)
    cat(c("----\n  Lag truncation parameter:", object@ltrunc, "\n\n"))
  }
)

## Auxiliar functions

ret <- function(wts, k)
{
  N <- length(wts)
  wts.r <- matrix(NA, nrow=N, ncol=k); wts.r[,1] <- wts
  for(i in 1:(k-1))
    wts.r[(i+1):N, (i+1)] <- wts[1:(N-i)]
  wts.r <- data.frame(wts.r); dimnames(wts.r)[[2]] <- paste("Lag", 0:(k-1), sep=".")
  as.matrix(wts.r)
}

SeasDummy <- function(wts, type)
{
  s <- frequency(wts); t0 <- start(wts); N <- length(wts)

  if(type == "alg"){        # Empleada en Barsky & Miron (1989)
   auxD <- matrix(0,nrow=N, ncol=s)
   sq   <- seq(1,N,s)
   k    <- 0

   for(j in 1:s){
     ifelse(sq[length(sq)] + k > N, n <- length(sq)-1, n <- N)
     for(i in 1:n)
       auxD[sq[i]+k,j] <- 1
     k <- k+1
   }
   VFE <- auxD
   if(t0[2] != 1){
      VFE <- matrix(nrow=N, ncol=s)
      VFE[,1:(t0[2]-1)] <- auxD[,(s-t0[2]+2):s]; VFE[,t0[2]:s] <- auxD[,1:(s-t0[2]+1)]
                  }
   if(t0[2] == 1){ VFE <- auxD }
  }

  if(type == "trg"){        # Empleada en Granger & Newbold (1986)
   qq  <- s/2
   VFE <- matrix(nrow=N, ncol=(s-1))

   sq1 <- seq(1,qq*2,2)
   sq2 <- seq(2,qq*2,2)
   j   <- c(1:(qq-1))

   for(i in 1:N){
     for(k in 1:(s-qq-1)){
         VFE[i,sq1[k]] <- cos((j[k]*pi/qq)*i)
         VFE[i,sq2[k]] <- sin((j[k]*pi/qq)*i)
     }
     VFE[i,(s-1)] <- (-1)^i
   }
  }
  VFE
}

contts <- function(lm, a)
{
  var.coef <- vcov(lm)[a,a]
  se.coef  <- sqrt(var.coef)
  et       <- lm$coef[a]/se.coef
  list(se.coef=se.coef, t.stat=et)
}

# HEGY regressors

hegy.reg <- function(wts)
{
  s <- frequency(wts); ML <- ret(ret(wts, 2)[,2], s+1)

  if(s==4){
    y1 <- ML[,1] + ML[,2] + ML[,3] + ML[,4]
    y2 <- -(ML[,1] - ML[,2] + ML[,3] - ML[,4])
    y4 <- -(ML[,1] - ML[,3])
    y3 <- ret(y4, 2)[,2]
    Mypi <- data.frame(y1, y2, y3, y4)
  }

  if(s==12){
    y1 <- ML[,1] + ML[,2] + ML[,3] + ML[,4] + ML[,5] + ML[,6] +
          ML[,7] + ML[,8] + ML[,9] + ML[,10] + ML[,11] + ML[,12]
    y2 <- -(ML[,1] - ML[,2] + ML[,3] - ML[,4] + ML[,5] - ML[,6] +
            ML[,7] - ML[,8] + ML[,9] - ML[,10] + ML[,11] - ML[,12])
    y3 <- -(ML[,2] - ML[,4] + ML[,6] - ML[,8] + ML[,10] - ML[,12])
    y4 <- -(ML[,1] - ML[,3] + ML[,5] - ML[,7] + ML[,9] - ML[,11])
    y5 <- -0.5*(ML[,1] + ML[,2] - 2*ML[,3] + ML[,4] + ML[,5] - 2*ML[,6] +
                ML[,7] + ML[,8] - 2*ML[,9] + ML[,10] + ML[,11] - 2*ML[,12])
    y6 <- (sqrt(3)/2)*(ML[,1] - ML[,2] + ML[,4] - ML[,5] + ML[,7] - ML[,8] + ML[,10] - ML[,11])
    y7 <- 0.5*(ML[,1] - ML[,2] - 2*ML[,3] - ML[,4] + ML[,5] + 2*ML[,6] +
               ML[,7] - ML[,8] - 2*ML[,9] - ML[,10] + ML[,11] + 2*ML[,12])
    y8 <- -(sqrt(3)/2)*(ML[,1] + ML[,2] - ML[,4] - ML[,5] + ML[,7] + ML[,8] - ML[,10] - ML[,11])
    y9 <- -0.5*(sqrt(3)*ML[,1] - ML[,2] + ML[,4] - sqrt(3)*ML[,5] + 2*ML[,6] - sqrt(3)*ML[,7] +
                ML[,8] - ML[,10] + sqrt(3)*ML[,11] - 2*ML[,12])
    y10 <- 0.5*(ML[,1] - sqrt(3)*ML[,2] + 2*ML[,3] - sqrt(3)*ML[,4] + ML[,5] - ML[,7] +
                sqrt(3)*ML[,8] - 2*ML[,9] + sqrt(3)*ML[,10] - ML[,11])
    y11 <- 0.5*(sqrt(3)*ML[,1] + ML[,2] - ML[,4] - sqrt(3)*ML[,5] - 2*ML[,6] - sqrt(3)*ML[,7] -
                ML[,8] + ML[,10] + sqrt(3)*ML[,11] + 2*ML[,12])
    y12 <- -0.5*(ML[,1] + sqrt(3)*ML[,2] + 2*ML[,3] + sqrt(3)*ML[,4] + ML[,5] - ML[,7] -
                 sqrt(3)*ML[,8] - 2*ML[,9] - sqrt(3)*ML[,10] - ML[,11])
    Mypi <- data.frame(y1, y2, y3, y4, y5, y6, y7, y8, y9, y10, y11, y12)
  }

  dimnames(Mypi)[[2]] <- paste("Ypi", 1:s, sep="")
  Mypi <- as.matrix(Mypi)
  Mypi
}

crpp <- function(vcoef1, vrfil1, vcoef2, vrfil2)
{
  n1 <- length(vcoef1)
  n2 <- length(vcoef2)
  fcoef <- rep(NA, n1*n2)
  rfil  <- rep(NA, n1*n2)
  fcoef0 <- rep(0, n1*n2)
  rfil0  <- rep(0, n1*n2)
  k <- 1
  for(i in 1:n1){
    for(j in 1:n2){
       fcoef0[k] <- vcoef1[i]*vcoef2[j]
       rfil0[k]  <- vrfil1[i]+vrfil2[j]
       k <- k+1
                  }
                }
  # Simplificar
  for(i in 1:(n1*n2)){
     simpl <- which(rfil0 == rfil0[i])
     if(length(simpl)>0){
        fcoef[i] <- sum(fcoef0[simpl]); fcoef0[simpl] <- NA
        rfil[i]  <- rfil0[i]  ; rfil0[simpl]  <- NA
                        }
                   }
  fcoef[which(fcoef==0)] <- rfil[which(fcoef==0)] <- NA
  fcoef <- na.omit(fcoef)[1:length(na.omit(fcoef))]
  rfil  <- na.omit(rfil)[1:length(na.omit(rfil))]

  # Ordenar
  fcoef0 <- rfil0 <- c(1:length(rfil))
  for(j in 1:length(rfil)){
    wm        <- which.min(rfil)
    rfil0[j]  <- rfil[wm]
    fcoef0[j] <- fcoef[wm]
    rfil[wm]  <- fcoef[wm] <- Inf
                          }
  rfil <- rfil0; fcoef <- fcoef0
  list(fcoef, rfil)
}

factorsdiff <- function(wts, factors)
{
  N     <- length(wts)
  ML    <- ret(wts, frequency(wts)+1)
  VCOEF <- cbind(c(1,-1,0),c(1,1,0),c(1,1,0),c(1,1,1),c(1,-1,1), c(1,sqrt(3),1),c(1,-sqrt(3),1))
  VRFIL <- cbind(c(0,1,0),c(0,1,0),c(0,2,0),c(0,1,2), c(0,1,2),c(0,1,2),c(0,1,2))

  if(length(which(factors == 1)) == 1)
  {
    Rfil  <- c(1, 1, 2, 1, 2, 1, 2, 1, 2, 1, 2)
    Fcoef <- c(-1,1,1,1,1,-1,1,sqrt(3),1,-sqrt(3),1)

    frfil <- which(factors == 1)
    Fil.vari <-  ML[,1] + Fcoef[frfil]*ML[,Rfil[frfil]+1]

    auxt0 <- length(wts)-length(na.omit(Fil.vari))
    Fil.vari <- ts(Fil.vari, frequency=frequency(wts), start=start(wts))
    fcoef <- Fcoef[frfil]
    rfil <- Rfil[frfil]
  }

  if(length(which(factors == 1)) > 1)
  {
    frfil <- which(factors == 1)
    fcoefrfil <- crpp(VCOEF[,frfil[1]], VRFIL[,frfil[1]], VCOEF[,frfil[2]], VRFIL[,frfil[2]])
    fcoef <- fcoefrfil[[1]]
    rfil  <- fcoefrfil[[2]]
    if(length(which(factors == 1)) > 2){
      for(i in 3:length(frfil)){
        fcoefrfil <- crpp(fcoef, rfil, VCOEF[,frfil[i]], VRFIL[,frfil[i]])
        fcoef <- fcoefrfil[[1]]
        rfil  <- fcoefrfil[[2]]
                               }
                                      }
    Fil.vari.aux  <- matrix(nrow=N, ncol=length(rfil))
    Fil.vari      <- matrix(nrow=N, ncol=1)

    for(i in 1:length(rfil))
       Fil.vari.aux[,i] <- fcoef[i]*ML[,(rfil[i]+1)]
    for(i in 1:N)
       Fil.vari[i,1] <- sum(Fil.vari.aux[i,])
    Fil.vari <- ts(Fil.vari, frequency=frequency(wts), start=start(wts))
  }
  list(Fil.wts=Fil.vari, fcoef, rfil)
}

## selectP

# Basado en top-down AIC y BIC.  ##~ Probar bic en lm1 y aic en lm2.

selPabic <- function(lmdet, type, Pmax=NULL)
{
  if(mode(Pmax) != "numeric") Pmax <- round(10*log10(length(lmdet$model[,1])))
  switch(type, aic = k <- 2,
               bic = k <- log(length(lmdet$model[,1])),)

  ML <- ret(lmdet$model[,1], Pmax+1)[,-1]
  drop <- NULL
  for(i in Pmax:1){
    ifelse(length(drop) == 0,
      lm1 <- lm(lmdet$model[,1] ~ 0+as.matrix(lmdet$model[,-1]) + ML[,c(1:Pmax)]),
      lm1 <- lm(lmdet$model[,1] ~ 0+as.matrix(lmdet$model[,-1]) + ML[,c(1:Pmax)[-drop]]))
    aic1 <- AIC(lm1, k=k)
    #ifelse(length(drop) == (Pmax-1),
    ifelse(identical(drop, as.numeric(c(2:Pmax))),
      aic2 <- AIC(lm(lmdet$model[,1] ~ 0+as.matrix(lmdet$model[,-1])), k=k),
      aic2 <- AIC(lm(lmdet$model[,1] ~ 0+as.matrix(lmdet$model[,-1]) + ML[,c(1:Pmax)[-c(drop,i)]]), k=k))

    if(aic1 >= aic2)
      drop <- c(drop, i)
  }

  ifelse(length(drop) == 0, lags <- c(1:Pmax), lags <- c(1:Pmax)[-drop])
  lags
}

# Basado en retardos significativos, al 10% por defecto.
## ** en bsadf puede ocurrit que matriz de retardos tiene columas distintas pero todas aproximadamente cero, entonces el coeficiente estimado es NA, hay que quitarlo. En selPabic no se considera esto.

selPsignf <- function(lmdet, cvref=1.65, Pmax=NULL)
{
  if(mode(cvref) != "numeric") cvref <- 1.65  # 10% approx.
  if(mode(Pmax) != "numeric") Pmax <- round(10*log10(length(lmdet$model[,1])))

  ref <- ncol(model.matrix(lmdet))
  ML <- ret(lmdet$model[,1], Pmax+1)[,-1]
  drop <- NULL; cond <- TRUE

  while(cond == TRUE){
    lmref <- lm(lmdet$model[,1] ~ 0+as.matrix(lmdet$model[,-1]) + ML)
    #Nreg <- length(coef(lmref))
    #tstats <- coef(summary(lmref))[(ref+1):Nreg,3]; drop <- which(abs(tstats) < cvref)  **
    rcoefs <- na.omit(coef(summary(lmref))[,3]); Nreg <- length(coef(lmref))
    aux1 <- which(is.na(coef(lmref)[(ref+1):Nreg]))
    tstats <- rcoefs[(ref+1):length(rcoefs)]; drop <- c(aux1, which(abs(tstats) < cvref))

    if(length(aux1) == 0){
      cond <- FALSE
      aux <- names(data.frame(ML))[-drop]
      lags <- as.numeric(substr(aux, 5, nchar(aux)))
    }
    if(length(aux1) == ncol(ML)){
      cond <- FALSE
      lags <- numeric(0)
    }
    if(length(aux1) > 0 && length(drop) < ncol(ML)){
      aux <- dimnames(ML)[[2]][-drop]
      ML <- as.matrix(data.frame(ML[,-drop]))
      dimnames(ML)[[2]] <- aux
    }
  }
  lags
}

#polymake <- function(roots)
#{
#  coefs <- rep(NA, length(roots))
#  coefs[1] <- 1
#
#  coefs[2] <- -roots[1]
#  if(length(roots) > 1){
#    for(i in 2:length(roots)){
#      coefs[i+1] <- -coefs[i]*roots[i]
#      for(j in i:2)
#        coefs[j] <- coefs[j] - coefs[j-1]*roots[i]
#    }
#  }
#
#  #coefs <- c(1, coefs)
#  coefs <- coefs/coefs[length(coefs)]
#  #coefs <- round(coefs[c(length(coefs):1)], 2)  ##~ ver. al redondear una raíz 0.999 pasa a ser 1.
#  coefs <- Re(coefs[c(length(coefs):1)])  ## para posibles problemas de redondeo.
#  coefs
#}

elapsedtime <- function(ptm1, ptm2)
{
  elaps <- (ptm2 - ptm1)[1]  # en segundos

  if(elaps < 60)
         units <- "seconds"
  else if(elaps < 3600){
         elaps <- elaps/60
         units <- "minutes" }
  else if(elaps < 86400){
         elaps <- elaps/3600
         units <- "hours" }
  else { elaps <- elaps/86400
         units <- "days" }

  list(elaps=as.numeric(elaps), units=units)
}

#elapsedtime <- function(time1, time2)
#{
#  t1 <- as.numeric(unlist(strsplit(substring(time1, 9,19), ":")))
#  t2 <- as.numeric(unlist(strsplit(substring(time2, 9,19), ":")))
#
#  d1<- as.numeric(unlist(strsplit(substring(time1, 1,8), "/")))
#  d2<- as.numeric(unlist(strsplit(substring(time2, 1,8), "/")))
#
#  elaps <- ISOdatetime(year=d2[3],month=d2[1],day=d2[2], hour=t2[1], min=t2[2], sec=t2[3]) -
#           ISOdatetime(year=d1[3],month=d1[1],day=d1[2], hour=t1[1], min=t1[2], sec=t1[3])
#
#  if(length(which(d1 != d2)) == 0){
#    units <- c("hours", "minutes", "seconds")[which(t1 != t2)[1]]
#  } else
#      units <- c("years", "days", "months")[which(d1 != d2)[1]]
#
#  list(elaps=as.numeric(elaps), units=units)
#}

# Función para redondear las tabla que se exportan (usando cat...) permitiendo que el último
# decimal sea cero.
  # tabla es una coulumna de matriz de datos
  # colum es una columna de la tabla
  # digits es el número de decimales (se permite que el último sea cero)
# format indicando un valor de digits vale si es una matriz con todo números, no otos caracteres, **,...

Tround <- function(tabla, column, digits)
{
  catround <- function(x, digits)
  {
    rx <- as.character(round(x, digits=digits))

    rxchar <- rep(NA, nchar(rx))
    for(i in 1:nchar(rx))
      rxchar[i] <- substring(rx, i, i)

    if(length(which(rxchar==".")) == 0)
    {
       aux1 <- rep("0", digits); aux2 <- "0"
       for(i in 1:(digits-1))
          aux2 <-  paste(aux2, aux1[i], sep="")
       rx <- paste(rx, aux2, sep=".")
    }
    if(digits > 0 && length(which(rxchar==".")) > 0)
    {
      logic <- FALSE; i <- 1
      if(substr(rx, 2, 2) != "")
      {
        while(logic == FALSE){
          logic <- substr(rx, i, i) == "."
          i <- i+1
        }
        if(nchar(substr(rx, i, i+digits)) < digits){
           n0 <- digits - nchar(substr(rx, i, i+digits))
           aux1 <- rep("0", n0)
           for(i in 1:(n0-1))
              aux2 <-  paste(aux1[i], aux1[i+1], sep="")
           rx <- paste(rx, aux2, sep="")
        }
      }
      if(nchar(rx) == 1){
        aux1 <- rep("0", digits)
        for(i in 1:(digits-1))
          aux2 <-  paste(aux1[i], aux1[i+1], sep="")
        rx <- paste(rx, aux2, sep=".")
      }
    }
    rx
  }

  for(i in 1:nrow(tabla))
    tabla[i,column] <- catround(as.numeric(tabla[i,column]), digits)
  tabla
}

##~ Poner en help: regvar es cero, no se ha implementado este argumento aquí.

# ADF recursive test.

setClass("adfrecst", representation(wts="ts", type="character", nsub="numeric", itsd="numeric",
  regvar="numeric", selectlags="list", recstats="matrix", elaps="list"))

ADF.rectest <- function(wts, type="moving", nsub=48, itsd, selectlags=list(mode="signf", Pmax=NULL),
  trace=list(remain=1, plot=0, elaps=1))
{
  s <- frequency(wts); N <- length(wts); t0 <- start(wts); tN <- end(wts)

  if(type == "moving"){
    iter <- length(wts)-nsub; lss <- 1 }
  if(type == "backw" || type == "forw"){
    iter <- as.integer((N-nsub)/s); lss <- 2 }

  subsdates <- rep(NA, iter+lss)
  Mst <- matrix(NA, nrow=iter+lss, ncol=2)
  code <- paste("DF", paste(itsd[1:2], collapse=""), "0", sep="")

  refiter <- seq(0,100,5); ptm1 <- proc.time()
  for(i in 0:iter)
  {
    switch(type,
      "moving" = { t0ss <- stepdate(as.vdate(wts), i)@ys
                   tNss <- stepdate(as.vdate(wts), i+nsub-1)@ys },
      "forw"   = { t0ss <- as.vdate(wts)@ys
                   tNss <- stepdate(as.vdate(wts), nsub+i*s-1)@ys },
      "backw"  = { t0ss <- stepdate(as.vdate(wts, N), -(nsub+i*s-1))@ys
                   tNss <- stepdate(as.vdate(wts), N-1)@ys },)

    t0ss <- as.numeric(t0ss); tNss <- as.numeric(tNss)
    wtsss <- window(wts, start=t0ss, end=tNss)

    Mst[i+1,1] <- ADF.test(wts=wtsss, itsd=itsd, regvar=0, selectlags=selectlags)@stat[,3]
    Mst[i+1,2] <- interpolpval(code=code, stat=Mst[(i+1),1], N=length(wtsss), swarn=FALSE)$pvlab
    subsdates[i+1] <- paste(t0ss[1], ":", t0ss[2], "-", tNss[1], ":", tNss[2], sep="")

    if(trace[2] == 1){
      opar <- par(mfrow=c(2,1), mar=c(3,4.2,2.5,2), las=1)
      plot(wts, xlab="", ylab="", main="Subsamples")
      abline(v=(t0ss[1] + t0ss[2]/s-1/s), lty=2, col="blue")
      abline(v=(tNss[1] + tNss[2]/s-1/s), lty=2, col="blue")
      plot(Mst[1:(i+1)], xlim=c(1,iter+1), ylab="ADF statistic", xlab="Iteration", main="ADF statistics")
      par(opar)
    }

    if(trace[1] == 1){
      refaux <- which(refiter == as.integer((i/iter)*100))
      if(length(refiter[refaux]) == 1){
        refiter[refaux] <- NA
        cat(paste("  ", as.integer((i/iter)*100), "% complete.\n", sep=""))
      }
    }
  }

  if(type == "backw" || type == "forw"){
    Mst[nrow(Mst),1] <- ADF.test(wts=wts, itsd=itsd, regvar=0, selectlags=selectlags)@stat[,3]
    Mst[nrow(Mst),2] <- interpolpval(code=code, stat=Mst[nrow(Mst),1], N=length(wts), swarn=FALSE)$pvlab
    subsdates[nrow(Mst)] <- paste(t0[1], ":", t0[2], "-", tN[1], ":", tN[2], sep="")
  }
  Mst <- matrix(Mst, nrow=iter+lss, ncol=2, dimnames=list(subsdates, c("adf.stat", " ")))

  ptm2 <- proc.time(); elaps <- elapsedtime(ptm1, ptm2)
  if(trace[3] == 1)
    cat("\n  Elapsed time:", elaps$elaps, elaps$units, ".\n")

  new("adfrecst", wts=wts, type=type, nsub=nsub, itsd=itsd, regvar=0, selectlags=selectlags,
    recstats=Mst, elaps=elaps)
}

setMethod("show", "adfrecst",
  function(object)
  {
    iter <- nrow(object@recstats); elaps <- object@elaps
    sts <- Tround(matrix(as.numeric(object@recstats[,1])), column=1, digits=2)
    sts <- format(sts, justify="right")
    pvls <- format(object@recstats[,2], justify="left")

    smpls <- dimnames(object@recstats)[[1]]
    aux <- max(nchar(smpls))
    for(i in 1:length(smpls)){
      refnst <- rep(" ", aux-nchar(smpls[i]))
      if(length(refnst) > 0)
        smpls[i] <- paste(smpls[i], refnst, sep="")[1]
    }

    cat("\n  --- --------- ----")
    cat("\n  ADF recursive test")
    cat("\n  --- --------- ----\n\n")
    cat("  ADF statistics in each subsample:\n\n")

    for(i in 1:iter)
      cat(" ", smpls[i], " ", sts[i], pvls[i], "\n")

    cat("\n Signif. codes:  0 '***' 0.01 '**' 0.025 '*' 0.05 '.' 0.1 ' ' 1 \n")
    switch(object@type,
      "moving" = cat("\n Based on", iter, "subsamples of length", object@nsub, ".\n"),
      "backw"  = cat("\n Based on", iter, "backwards subsamples.\n"),
      "forw"   = cat("\n Based on", iter, "forwards subsamples.\n"),)
    cat(" Computation time:", elaps$elaps, elaps$units, ".\n\n")
  }
)

setMethod("plot", signature(x="adfrecst", y="missing"),
  function(x,...)
  {
    plot(as.numeric(x@recstats[,1]), xlim=c(1,nrow(x@recstats)), ylab="ADF statistic",
      xlab="Iteration", main="ADF statistics", las=1)
  }
)

# KPSS recursive test.

setClass("kpssrecst", representation(wts="ts", type="character", nsub="numeric", ltrunc="maybeRegvar",
  recstats="matrix", elaps="list"))

KPSS.rectest <- function(wts, type="moving", nsub=48, ltrunc=NULL, trace=list(remain=1, plot=0, elaps=1))
{
  s <- frequency(wts); N <- length(wts); t0 <- start(wts); tN <- end(wts)

  if(type == "moving"){
    iter <- length(wts)-nsub; lss <- 1 }
  if(type == "backw" || type == "forw"){
    iter <- as.integer((N-nsub)/s); lss <- 2 }

  subsdates <- rep(NA, iter+lss)
  Mst <- matrix(NA, nrow=iter+lss, ncol=4)

  refiter <- seq(0,100,5); ptm1 <- proc.time()
  for(i in 0:iter)
  {
    switch(type,
      "moving" = { t0ss <- stepdate(as.vdate(wts), i)@ys
                   tNss <- stepdate(as.vdate(wts), i+nsub-1)@ys },
      "forw"   = { t0ss <- as.vdate(wts)@ys
                   tNss <- stepdate(as.vdate(wts), nsub+i*s-1)@ys },
      "backw"  = { t0ss <- stepdate(as.vdate(wts, N), -(nsub+i*s-1))@ys
                   tNss <- stepdate(as.vdate(wts), N-1)@ys },)

    t0ss <- as.numeric(t0ss); tNss <- as.numeric(tNss)
    wtsss <- window(wts, start=t0ss, end=tNss)

    out <- KPSS.test(wts=wtsss, ltrunc=ltrunc)
    Mst[i+1,1] <- out@levelst
    Mst[i+1,2] <- interpolpval(code="KPSSlevel", stat=Mst[(i+1),1], N=length(wtsss), swarn=FALSE)$pvlab
    Mst[i+1,3] <- out@trendst
    Mst[i+1,4] <- interpolpval(code="KPSStrend", stat=Mst[(i+1),3], N=length(wtsss), swarn=FALSE)$pvlab

    subsdates[i+1] <- paste(t0ss[1], ":", t0ss[2], "-", tNss[1], ":", tNss[2], sep="")

    if(trace[2] == 1){
      opar <- par(mfrow=c(3,1), mar=c(3,4.2,2.5,2), las=1)
      plot(wts, xlab="", ylab="", main="Subsamples")
      abline(v=(t0ss[1] + t0ss[2]/s-1/s), lty=2, col="blue")
      abline(v=(tNss[1] + tNss[2]/s-1/s), lty=2, col="blue")
      plot(Mst[1:(i+1),1], xlim=c(1,iter+1),
        ylab="KPSS statistic", xlab="Iteration", main="KPSS Level.stat")
      plot(Mst[1:(i+1),2], xlim=c(1,iter+1),
        ylab="KPSS statistic", xlab="Iteration", main="KPSS Trend.stat")
      par(opar)
    }

    if(trace[1] == 1){
      refaux <- which(refiter == as.integer((i/iter)*100))
      if(length(refiter[refaux]) == 1){
        refiter[refaux] <- NA
        cat(paste("  ", as.integer((i/iter)*100), "% complete.\n", sep=""))
      }
    }
  }

  if(type == "backw" || type == "forw"){
    out <- KPSS.test(wts=wts, ltrunc=ltrunc)
    Mst[nrow(Mst),1] <- out@levelst
    Mst[nrow(Mst),2] <- interpolpval(code="KPSSlevel", stat=Mst[nrow(Mst),1],
                                     N=length(wts), swarn=FALSE)$pvlab
    Mst[nrow(Mst),3] <- out@trendst
    Mst[nrow(Mst),4] <- interpolpval(code="KPSStrend", stat=Mst[nrow(Mst),3],
                                     N=length(wts), swarn=FALSE)$pvlab
    subsdates[nrow(Mst)] <- paste(t0[1], ":", t0[2], "-", tN[1], ":", tN[2], sep="")
  }
  Mst <- matrix(Mst, nrow=iter+lss, ncol=4,
           dimnames=list(subsdates, c("level.stat", "pvl", "trend.stat", "pvl")))

  ptm2 <- proc.time(); elaps <- elapsedtime(ptm1, ptm2)
  if(trace[3] == 1)
    cat("\n  Elapsed time:", elaps$elaps, elaps$units, ".\n")

  new("kpssrecst", wts=wts, type=type, nsub=nsub, ltrunc=ltrunc, recstats=Mst, elaps=elaps)
}

setMethod("show", "kpssrecst",
  function(object)
  {
    iter <- nrow(object@recstats); elaps <- object@elaps
    stsl <- Tround(matrix(as.numeric(object@recstats[,1])), column=1, digits=2)
    stsl <- format(stsl, justify="right")
    pvll <- format(object@recstats[,2], justify="left")
    stst <- Tround(matrix(as.numeric(object@recstats[,3])), column=1, digits=2)
    stst <- format(stst, justify="right")
    pvlt <- format(object@recstats[,4], justify="left")

    smpls <- dimnames(object@recstats)[[1]]
    aux <- max(nchar(smpls))
    for(i in 1:length(smpls)){
      refnst <- rep(" ", aux-nchar(smpls[i]))
      if(length(refnst) > 0)
        smpls[i] <- paste(smpls[i], refnst, sep="")[1]
    }

    cat("\n  ---- --------- ----")
    cat("\n  KPSS recursive test")
    cat("\n  ---- --------- ----\n\n")
    cat("  KPSS statistics in each subsample:\n\n")

    cat(rep(" ", nchar(smpls[1])/2), "    Level", "      Trend", "\n")
    for(i in 1:iter)
      cat(" ", smpls[i], " ", stsl[i], pvll[i], "  ", stst[i], pvlt[i], "\n")

    cat("\n Signif. codes:  0 '***' 0.01 '**' 0.025 '*' 0.05 '.' 0.1 ' ' 1 \n")
    switch(object@type,
      "moving" = cat("\n Based on", iter, "subsamples of length", object@nsub, ".\n"),
      "backw"  = cat("\n Based on", iter, "backwards subsamples.\n"),
      "forw"   = cat("\n Based on", iter, "forwards subsamples.\n"),)
    cat(" Computation time:", elaps$elaps, elaps$units, ".\n\n")
  }
)

setMethod("plot", signature(x="kpssrecst", y="missing"),
  function(x,...)
  {
    Mst <- x@recstats
    opar <- par(mfrow=c(2,1), mar=c(3,4.2,2.5,2), las=1)
    plot(as.numeric(Mst[,1]), xlim=c(1,nrow(Mst)),
      ylab="KPSS statistic", xlab="Iteration", main="KPSS Level.stat")
    plot(as.numeric(Mst[,3]), xlim=c(1,nrow(Mst)),
      ylab="KPSS statistic", xlab="Iteration", main="KPSS Trend.stat")
    par(opar)
  }
)

# HEGY recursive test.

setClass("hegyrecst", representation(wts="ts", type="character", nsub="numeric", itsd="numeric",
  regvar="numeric", selectlags="list", recstats="matrix", elaps="list"))

HEGY.rectest <- function(wts, type="moving", nsub=72, itsd, selectlags=list(mode="signf", Pmax=NULL),
  trace=list(remain=1, plot=0, elaps=1))
{
  s <- frequency(wts); N <- length(wts); t0 <- start(wts); tN <- end(wts)
  if(s==4)  pdim <- c(3,2)
  if(s==12) pdim <- c(5,2)

  if(type == "moving"){
    iter <- length(wts)-nsub; lss <- 1 }
  if(type == "backw" || type == "forw"){
    iter <- as.integer((N-nsub)/s); lss <- 2 }

  if(s==4)  c1 <- "HEGY"
  if(s==12) c1 <- "BM"
  c2 <- paste(itsd[1:2], sep="", collapse="")
  ifelse(itsd[3] != 0, c3 <-1, c3 <-0)
  codeaux <- paste(c1, c2, c3, sep="")

  etfsnames <- c(paste("tpi_", 1:2, sep=""),
                 paste("Fpi", paste(seq(3,s,2),seq(4,s,2), sep=":"), sep="_"),
                 paste("Fpi_2:", s, sep=""), paste("Fpi_1:", s, sep=""))

  out <- matrix(nrow=iter+lss, ncol=((s/2+3)*2))  #ncol=(s+s/2+1))  ##~ no poner tpi_>2
  subsdates <- rep(NA, nrow(out))

  refiter <- seq(0,100,5); ptm1 <- proc.time()
  for(i in 0:iter)
  {
    switch(type,
      "moving" = { t0ss <- stepdate(as.vdate(wts), i)@ys
                   tNss <- stepdate(as.vdate(wts), i+nsub-1)@ys },
      "forw"   = { t0ss <- as.vdate(wts)@ys
                   tNss <- stepdate(as.vdate(wts), nsub+i*s-1)@ys },
      "backw"  = { t0ss <- stepdate(as.vdate(wts, N), -(nsub+i*s-1))@ys
                   tNss <- stepdate(as.vdate(wts), N-1)@ys },)

    t0ss <- as.numeric(t0ss); tNss <- as.numeric(tNss)
    wtsss <- window(wts, start=t0ss, end=tNss)

    hegy.out <- HEGY.test(wts=wtsss, itsd=itsd, regvar=0, selectlags=selectlags)
    subsdates[i+1] <- paste(t0ss[1], ":", t0ss[2], "-", tNss[1], ":", tNss[2], sep="")

    out[i+1,c(1,3)] <- hegy.out@hegycoefs[1:2,3]  # hegy.out@hegycoefs[,3]
    out[i+1,2] <- interpolpval(code=paste(codeaux, "tpi1", sep=""), stat=out[i+1,1],
                               N=length(wtsss), swarn=FALSE)$pvlab
    out[i+1,4] <- interpolpval(code=paste(codeaux, "tpi2", sep=""), stat=out[i+1,3],
                               N=length(wtsss), swarn=FALSE)$pvlab

    out[i+1,seq(5,ncol(out),2)] <- hegy.out@stats[3:(s/2+3),1]
    codeF <- paste(codeaux, "Foddeven", sep="")
    for(j in seq(6,5+(s/2-1)*2,2))
      out[i+1,j] <- interpolpval(code=codeF, stat=out[i+1,j-1], N=length(wtsss), swarn=FALSE)$pvlab

    if(trace[2] == 1){
      opar <- par(mfrow=pdim, mar=c(3,4.2,2.5,2), las=1)
      plot(wts, xlab="", ylab="", main="Subsamples")
      abline(v=(t0ss[1] + t0ss[2]/s-1/s), lty=2, col="blue")
      abline(v=(tNss[1] + tNss[2]/s-1/s), lty=2, col="blue")
      k<-1
      for(j in seq(1,ncol(out),2)){
        plot(out[1:(i+1),j], xlim=c(1,iter+1), ylab="", xlab="Iteration",
          main=paste(etfsnames[k], "statistics", sep=" "))
        k<-k+1
      }
      par(opar)
    }

    if(trace[1] == 1){
      refaux <- which(refiter == as.integer((i/iter)*100))
      if(length(refiter[refaux]) == 1){
        refiter[refaux] <- NA
        cat(paste("  ", as.integer((i/iter)*100), "% complete.\n", sep=""))
      }
    }
  }

  if(type == "backw" || type == "forw"){
    hegy.out <- HEGY.test(wts=wts, itsd=itsd, regvar=0, selectlags=selectlags)
    subsdates[iter+lss] <- paste(t0[1], ":", t0[2], "-", tN[1], ":", tN[2], sep="")

    out[nrow(out),c(1,3)] <- hegy.out@hegycoefs[1:2,3]  # hegy.out@hegycoefs[,3]
    out[nrow(out),2] <- interpolpval(code=paste(codeaux, "tpi1", sep=""),
                          stat=out[nrow(out),1], N=length(wts), swarn=FALSE)$pvlab
    out[nrow(out),4] <- interpolpval(code=paste(codeaux, "tpi2", sep=""),
                          stat=out[nrow(out),3], N=length(wts), swarn=FALSE)$pvlab

    out[nrow(out),seq(5,ncol(out),2)] <- hegy.out@stats[3:(s/2+3),1]
    codeF <- paste(codeaux, "Foddeven", sep="")
    for(j in seq(6,5+(s/2-1)*2,2))
      out[nrow(out),j] <- interpolpval(code=codeF, stat=out[nrow(out),j-1],
                                       N=length(wts), swarn=FALSE)$pvlab
  }

  etfsn <- rep(NA, ncol(out))
  etfsn[seq(1,ncol(out),2)] <- etfsnames
  etfsn[seq(2,ncol(out),2)] <- " "
  out <- matrix(out, nrow=nrow(out), ncol=ncol(out), dimnames=list(subsdates, etfsn))

  ptm2 <- proc.time(); elaps <- elapsedtime(ptm1, ptm2)
  if(trace[3] == 1)
    cat("\n  Elapsed time:", elaps$elaps, elaps$units, ".\n")

  new("hegyrecst", wts=wts, type=type, nsub=nsub, itsd=itsd, regvar=0, selectlags=selectlags,
    recstats=out, elaps=elaps)
}

setMethod("show", "hegyrecst",
  function(object)
  {
    iter <- nrow(object@recstats); elaps <- object@elaps; s <- frequency(object@wts)
    out <- object@recstats[,1:((s/2+1)*2)]      # Sin tomar F_2:s, F_1:s
    aux1 <- seq(1,ncol(out),2); aux2 <- aux1+1  # aux2 <- seq(2,ncol(out),2)
    auxout <- matrix(as.numeric(out[,aux1]), ncol=ncol(out)/2)
    for(i in 1:ncol(auxout))
      auxout <- Tround(auxout, column=i, digits=2)
    out[,aux1] <- format(auxout, justify="right")
    out[,aux2] <- format(out[,aux2], justify="left")

    smpls <- dimnames(out)[[1]]
    aux <- max(nchar(smpls))
    for(i in 1:length(smpls)){
      refnst <- rep(" ", aux-nchar(smpls[i]))
      if(length(refnst) > 0)
        smpls[i] <- paste(smpls[i], refnst, sep="")[1]
    }

    out2 <- matrix(ncol=ncol(out), nrow=nrow(out)+1)
    out2[1,aux1] <- dimnames(out)[[2]][aux1]
    out2[1,aux2] <- "   "
    out2[2:nrow(out2),] <- out
    out2[,aux1] <- format(out2[,aux1], justify="right")

    cat("\n  ---- --------- ----")
    cat("\n  HEGY recursive test")
    cat("\n  ---- --------- ----\n\n")
    cat("  HEGY statistics in each subsample:\n\n")

    cat(rep(" ", nchar(smpls[1])/2+1), out2[1,1:4], "\n")
    for(i in 2:(iter+1))
      cat(" ", smpls[i-1], " ", out2[i,1:4], "\n")
    if(ncol(out2) > 4){
      cat("\n", rep(" ", nchar(smpls[1])/2+1), out2[1,5:ncol(out2)], "\n")
      for(i in 2:(iter+1))
        cat(" ", smpls[i-1], " ", out2[i,5:ncol(out2)], "\n")
    }

    cat("\n\n Signif. codes:  0 '***' 0.01 '**' 0.025 '*' 0.05 '.' 0.1 ' ' 1 \n")
    switch(object@type,
      "moving" = cat("\n Based on", iter, "subsamples of length", object@nsub, ".\n"),
      "backw"  = cat("\n Based on", iter, "backwards subsamples.\n"),
      "forw"   = cat("\n Based on", iter, "forwards subsamples.\n"),)
    cat(" Computation time:", elaps$elaps, elaps$units, ".\n\n")
  }
)

setMethod("plot", signature(x="hegyrecst", y="missing"),
  function(x,...)
  {
    out <- x@recstats; s <- frequency(x@wts)
    if(frequency(x@wts)==4)  pdim <- c(3,2)
    if(frequency(x@wts)==12) pdim <- c(5,2)
    etfsnames <- c(paste("tpi_", 1:2, sep=""),
                 paste("Fpi", paste(seq(3,s,2),seq(4,s,2), sep=":"), sep="_"),
                 paste("Fpi_2:", s, sep=""), paste("Fpi_1:", s, sep=""))

    opar <- par(mfrow=pdim, mar=c(3,4.2,2.5,2), las=1)
    k<-1
    for(j in seq(1,ncol(x@recstats),2)){
      plot(out[,j], xlim=c(1,nrow(out)), ylab="", xlab="Iteration",
        main=paste(etfsnames[k], "statistics", sep=" "))
      k<-k+1
    }
    par(opar)
  }
)


setClass("chrecst", representation(wts="ts", type="character", nsub="numeric", frec="numeric", f0="numeric",
  DetTr="logical", ltrunc="maybeRegvar", recstats="matrix", elaps="list"))

CH.rectest <- function(wts, type="moving", nsub=48, frec=NULL, f0=1, DetTr=FALSE, ltrunc=NULL,
  trace=list(remain=1, plot=0, elaps=1))
{
  s <- frequency(wts); N <- length(wts); t0 <- start(wts); tN <- end(wts)
  if(class(frec)=="NULL") frec <- rep(1, s/2)

  if(type == "moving"){
    iter <- length(wts)-nsub; lss <- 1 }
  if(type == "backw" || type == "forw"){
    iter <- as.integer((N-nsub)/s); lss <- 2 }

  code <- paste("CHp", sum(frec*c(rep(2, s/2-1),1)), sep="")
  subsdates <- rep(NA, iter+lss)
  Mst <- matrix(NA, nrow=iter+lss, ncol=2)

  refiter <- seq(0,100,5); ptm1 <- proc.time()
  for(i in 0:iter)
  {
    switch(type,
      "moving" = { t0ss <- stepdate(as.vdate(wts), i)@ys
                   tNss <- stepdate(as.vdate(wts), i+nsub-1)@ys },
      "forw"   = { t0ss <- as.vdate(wts)@ys
                   tNss <- stepdate(as.vdate(wts), nsub+i*s-1)@ys },
      "backw"  = { t0ss <- stepdate(as.vdate(wts, N), -(nsub+i*s-1))@ys
                   tNss <- stepdate(as.vdate(wts), N-1)@ys },)

    t0ss <- as.numeric(t0ss); tNss <- as.numeric(tNss)
    wtsss <- window(wts, start=t0ss, end=tNss)

    Mst[i+1,1] <- CH.test(wts=wtsss, frec=frec, f0=f0, DetTr=DetTr, ltrunc=ltrunc)@stat
    Mst[i+1,2] <- interpolpval(code=code, stat=Mst[(i+1),1], N=length(wtsss), swarn=FALSE)$pvlab
    subsdates[i+1] <- paste(t0ss[1], ":", t0ss[2], "-", tNss[1], ":", tNss[2], sep="")

    if(trace[2] == 1){
      opar <- par(mfrow=c(2,1), mar=c(3,4.2,2.5,2), las=1)
      plot(wts, xlab="", ylab="", main="Subsamples")
      abline(v=(t0ss[1] + t0ss[2]/s-1/s), lty=2, col="blue")
      abline(v=(tNss[1] + tNss[2]/s-1/s), lty=2, col="blue")
      plot(Mst[1:(i+1),1], xlim=c(1,iter+1), ylab="CH statistic", xlab="Iteration", main="CH statistics")
      par(opar)
    }

    if(trace[1] == 1){
      refaux <- which(refiter == as.integer((i/iter)*100))
      if(length(refiter[refaux]) == 1){
        refiter[refaux] <- NA
        cat(paste("  ", as.integer((i/iter)*100), "% complete.\n", sep=""))
      }
    }
  }

  if(type == "backw" || type == "forw"){
    Mst[nrow(Mst),1] <- CH.test(wts=wts, frec=frec, f0=f0, DetTr=DetTr, ltrunc=ltrunc)@stat
    Mst[nrow(Mst),2] <- interpolpval(code=code, stat=Mst[nrow(Mst),1], N=length(wts), swarn=FALSE)$pvlab
    subsdates[nrow(Mst)] <- paste(t0[1], ":", t0[2], "-", tN[1], ":", tN[2], sep="")
  }
  Mst <- matrix(Mst, nrow=iter+lss, ncol=2, dimnames=list(subsdates, c("ch.stat", " ")))

  ptm2 <- proc.time(); elaps <- elapsedtime(ptm1, ptm2)
  if(trace[3] == 1)
    cat("\n  Elapsed time:", elaps$elaps, elaps$units, ".\n")

  new("chrecst", wts=wts, type=type, nsub=nsub, frec=frec, f0=f0, DetTr=DetTr, ltrunc=ltrunc,
    recstats=Mst, elaps=elaps)
}

setMethod("show", "chrecst",
  function(object)
  {
    iter <- nrow(object@recstats); elaps <- object@elaps
    out <- matrix(c(as.numeric(object@recstats[,1]), object@recstats[,2]),
             ncol=2, dimnames=dimnames(object@recstats))
    out <- Tround(out, column=1, digits=2)
    out[,1] <- format(out[,1], justify="right")
    out[,2] <- format(out[,2], justify="left")

    smpls <- dimnames(out)[[1]]
    aux <- max(nchar(smpls))
    for(i in 1:length(smpls)){
      refnst <- rep(" ", aux-nchar(smpls[i]))
      if(length(refnst) > 0)
        smpls[i] <- paste(smpls[i], refnst, sep="")[1]
    }

    cat("\n  -- --------- ----")
    cat("\n  CH recursive test")
    cat("\n  -- --------- ----\n\n")
    cat("  CH statistics in each subsample:\n\n")

    for(i in 1:iter)
      cat(" ", smpls[i], " ", out[i,], "\n")

    cat("\n Signif. codes:  0 '***' 0.01 '**' 0.025 '*' 0.05 '.' 0.1 ' ' 1 \n")
    switch(object@type,
      "moving" = cat("\n Based on", iter, "subsamples of length", object@nsub, ".\n"),
      "backw"  = cat("\n Based on", iter, "backwards subsamples.\n"),
      "forw"   = cat("\n Based on", iter, "forwards subsamples.\n"),)
    cat(" Computation time:", elaps$elaps, elaps$units, ".\n\n")
  }
)

setMethod("plot", signature(x="chrecst", y="missing"),
  function(x,...)
  {
    out <- x@recstats
    plot(out[,1], xlim=c(1,nrow(out)),
      ylab="CH statistic", xlab="Iteration", main="CH statistics", las=1)
  }
)

setClass("vdate", representation(input="numeric", output="matrix", wts="ts",
  ys="matrix", obs="matrix", Myso="matrix"))

Mdates <- function(wts, yso)
{
  ys <- as.integer(time(wts))
  seas <- cycle(wts)@.Data

  Myso <- matrix(nrow=length(seas), ncol=4,
          dimnames=list(c(1:length(seas)), c("Year", "Season", "Observation", "ys")))
  Myso[,1] <- ys
  Myso[,2] <- seas
  Myso[,3] <- c(1:nrow(Myso))
  Myso[,4] <- paste(ys, seas, sep=":")

  if(length(yso) == 2){
    ys <- matrix(t(yso), ncol=2, dimnames=list("", c("Year", "Season")))
    obs <- out <- which(Myso[,4] == paste(yso[1], yso[2], sep=":"))
    if(length(out) != 0){
      obs <- matrix(obs, dimnames=list("", "Observation")) }
  }
  if(length(yso) == 1){
    obs <- matrix(yso, dimnames=list("", "Observation"))
    ys <- out <- Myso[which(Myso[,3] == yso),1:2]
    #if(nrow(out) != 0)
    #  dimnames(ys)[[1]] <- ""
  }

  new("vdate", input=as.numeric(yso), output=as.matrix(t(out)), wts=wts,
    ys=matrix(ys), obs=matrix(obs), Myso=Myso)
}

setMethod("show", "vdate",
  function(object)
  {
    input <- object@input
    output <- object@output

    if(length(input) == 1){
      if(length(output) == 0){
        cat("  Observation", as.numeric(object@obs), "is out of sample.\n")
      } else{
          refys <- paste(object@ys[[1]], object@ys[[2]], sep=":")
          cat("  Observation", as.numeric(object@obs), "corresponds to date", refys, ".\n")
        }
    }
    if(length(input) == 2){
      refys <- paste(object@ys[[1]], object@ys[[2]], sep=":")
      if(length(output) == 0){
        cat("  Date", refys, "is out of sample.\n")
      } else{
          refys <- paste(object@ys[[1]], object@ys[[2]], sep=":")
          cat("  Date", refys, "corresponds to observation", as.numeric(object@obs), ".\n")
        }
    }
  }
)

setMethod("as.numeric", "vdate",
  function(x,...)
  {
    out <- x@output
    out
  }
)

as.vdate <- function(object, yso=1){
}
setMethod("as.vdate", "ts",
  function(object, yso)
  {
    #Mdates(object, yso=start(object))
    Mdates(object, yso=yso)
  }
)

stepdate <- function(object, step=1){
}
setMethod("stepdate", "vdate",
  function(object, step)
  {
    obs0 <- object@obs
    if(obs0+step > length(object@wts))
      stop("Observation ", obs0+step, " is out of sample.\n")
    ys0 <- object@ys
    Myso <- object@Myso

    obsout <- matrix(obs0+step, dimnames=list("", "Observation"))

    ref <- which(Myso[,4] == paste(ys0[1], ys0[2], sep=":"))
    ysout <- Myso[ref+step,4]
    ysout <- matrix(unlist(strsplit(ysout, ":")), nrow=1,
             dimnames=list("", c("Year", "Season")))

    new("vdate", input=object@input, output=object@output, wts=object@wts,
      ys=ysout, obs=obsout, Myso=object@Myso)
  }
)

interpolpval <- function(code, stat, N, swarn=TRUE)
{
  table <- lookupCVtable(code)
  alphas <- dimnames(table)[[2]]
  Nref <- as.numeric(dimnames(table)[[1]]) # table[1:nrow(table),1]
  pvlref <- 0

  selrow <- rep(NA, ncol(table))
  for (i in 1:ncol(table))
    selrow[i] <- approx(Nref, table[,i], N, rule = 2)$y

  pval <- approx(selrow, alphas, stat, rule = 2)$y
  if(is.na(approx(selrow, alphas, stat, rule = 1)$y))
  {
    if(substr(code, 1,2) == "DF" || substr(code, 6,8) == "tpi" || substr(code, 8,10) == "tpi")
    {
      if(pval == min(as.numeric(alphas))){
        if(swarn==TRUE)
          warning("p-value is smaller than printed p-value")
        pvalw <- paste("<", format.pval(pval), sep=" ")
      } else{
          if(swarn==TRUE)
            warning("p-value is greater than printed p-value")
          pvalw <- paste(">", format.pval(pval), sep=" ")
      }
    }
    if(substr(code, 1,2) == "KP" || substr(code, 1,2) == "CH" ||
       substr(code, 6,9) == "Fodd" || substr(code, 8,11) == "Fodd")
    {
      if(pval == min(as.numeric(alphas))){
        if(swarn==TRUE)
          warning("p-value is smaller than printed p-value")
        pvalw <- paste("<", format.pval(pval), sep=" ")
      } else{
          if(swarn==TRUE)
            warning("p-value is greater than printed p-value")
          pvalw <- paste(">", format.pval(pval), sep=" "); pvlref <- -1
      }
    }
  } else
    pvalw <- format.pval(pval)

  ref1 <- c(1, 0.1, 0.05, 0.025, 0.01, 0.001)
  ref2 <- c(" ", ".", "*", "**", "***")
  #ref2 <- c("   ", ".  ", "*  ", "** ", "***")
  pvl <- ref2[length(which(pval <= ref1))+pvlref]

  list(pval=pval, pvalw=as.character(pvalw), pvlab=pvl)
}

lookupCVtable <- function(code)
{
  if(code=="DF000")
  {
    table <- data.frame(CV1 = -c(2.66, 2.62, 2.60, 2.58, 2.58, 2.58),
                        CV2 = -c(2.26, 2.25, 2.24, 2.24, 2.23, 2.23),
                        CV3 = -c(1.95, 1.95, 1.95, 1.95, 1.95, 1.95),
                        CV4 = -c(1.60, 1.61, 1.61, 1.62, 1.62, 1.62))
    dimnames(table) <- list(c(25, 50, 100, 250, 500, 100000),
                            c("0.01", "0.025", "0.05", "0.10"))
  }

  if(code=="DF100")
  {
    table <- data.frame(CV1 = -c(3.75, 3.58, 3.51, 3.46, 3.44, 3.43),
                        CV2 = -c(3.33, 3.22, 3.17, 3.14, 3.13, 3.12),
                        CV3 = -c(3.00, 2.93, 2.89, 2.88, 2.87, 2.86),
                        CV4 = -c(2.63, 2.60, 2.58, 2.57, 2.57, 2.57))
    dimnames(table) <- list(c(25, 50, 100, 250, 500, 100000),
                            c("0.01", "0.025", "0.05", "0.10"))
  }

  if(code=="DF110")
  {
    table <- data.frame(CV1 = -c(4.38, 4.15, 4.04, 3.99, 3.98, 3.96),
                        CV2 = -c(3.95, 3.80, 3.73, 3.69, 3.68, 3.66),
                        CV3 = -c(3.60, 3.50, 3.45, 3.43, 3.42, 3.41),
                        CV4 = -c(3.24, 3.18, 3.15, 3.13, 3.13, 3.12))
    dimnames(table) <- list(c(25, 50, 100, 250, 500, 100000),
                            c("0.01", "0.025", "0.05", "0.10"))
  }

  if(code == "KPSSlevel")
  {
    table <- data.frame(rbind(c(0.347, 0.463, 0.574, 0.739),
                              c(0.347, 0.463, 0.574, 0.739)))
    dimnames(table) <- list(c("100000","100001"), c("0.10", "0.05", "0.025", "0.01"))
  }

  if(code == "KPSStrend")
  {
    table <- data.frame(rbind(c(0.119, 0.146, 0.176, 0.216),
                              c(0.119, 0.146, 0.176, 0.216)))
    dimnames(table) <- list(c("100000","100001"), c("0.10", "0.05", "0.025", "0.01"))
  }

  if(code=="BM000tpi1")
  {
    table <- data.frame(CV1 = c(-2.51, -2.52, -2.57),
                        CV2 = c(-2.18, -2.21, -2.24),
                        CV3 = c(-1.89, -1.91, -1.95),
                        CV4 = c(-1.58, -1.59, -1.62))
    dimnames(table) <- list(c(240, 480, 10000), c("0.01", "0.025", "0.05", "0.10"))
  }
  if(code=="BM100tpi1")
  {
    table <- data.frame(CV1 = c(-3.35, -3.40, -3.41),
                        CV2 = c(-3.06, -3.11, -3.12),
                        CV3 = c(-2.80, -2.85, -2.86),
                        CV4 = c(-2.51, -2.55, -2.57))
    dimnames(table) <- list(c(240, 480, 10000), c("0.01", "0.025", "0.05", "0.10"))
  }
  if(code=="BM101tpi1")
  {
    table <- data.frame(CV1 = c(-3.32, -3.37, -3.41),
                        CV2 = c(-3.02, -3.06, -3.12),
                        CV3 = c(-2.76, -2.81, -2.86),
                        CV4 = c(-2.47, -2.53, -2.57))
    dimnames(table) <- list(c(240, 480, 10000), c("0.01", "0.025", "0.05", "0.10"))
  }
  if(code=="BM110tpi1")
  {
    table <- data.frame(CV1 = c(-3.87, -3.92, -3.97),
                        CV2 = c(-3.58, -3.63, -3.67),
                        CV3 = c(-3.32, -3.37, -3.40),
                        CV4 = c(-3.06, -3.09, -3.12))
    dimnames(table) <- list(c(240, 480, 10000), c("0.01", "0.025", "0.05", "0.10"))
  }
  if(code=="BM111tpi1")
  {
    table <- data.frame(CV1 = c(-3.83, -3.85, -3.97),
                        CV2 = c(-3.54, -3.57, -3.67),
                        CV3 = c(-3.28, -3.32, -3.40),
                        CV4 = c(-2.99, -3.04, -3.12))
    dimnames(table) <- list(c(240, 480, 10000), c("0.01", "0.025", "0.05", "0.10"))
  }

  if(code=="BM000tpi2")
  {
    table <- data.frame(CV1 = c(-2.53, -2.52, -2.57),
                        CV2 = c(-2.16, -2.20, -2.24),
                        CV3 = c(-1.87, -1.91, -1.95),
                        CV4 = c(-1.57, -1.59, -1.62))
    dimnames(table) <- list(c(240, 480, 10000), c("0.01", "0.025", "0.05", "0.10"))
  }
  if(code=="BM100tpi2")
  {
    table <- data.frame(CV1 = c(-2.48, -2.54, -2.57),
                        CV2 = c(-2.15, -2.20, -2.24),
                        CV3 = c(-1.89, -1.91, -1.95),
                        CV4 = c(-1.57, -1.59, -1.62))
    dimnames(table) <- list(c(240, 480, 10000), c("0.01", "0.025", "0.05", "0.10"))
  }
  if(code=="BM101tpi2")
  {
    table <- data.frame(CV1 = c(-3.28, -3.37, -3.41),
                        CV2 = c(-3.01, -3.07, -3.12),
                        CV3 = c(-2.76, -2.81, -2.86),
                        CV4 = c(-2.48, -2.52, -2.57))
    dimnames(table) <- list(c(240, 480, 10000), c("0.01", "0.025", "0.05", "0.10"))
  }
  if(code=="BM110tpi2")
  {
    table <- data.frame(CV1 = c(-2.52, -2.55, -2.57),
                        CV2 = c(-2.18, -2.20, -2.24),
                        CV3 = c(-1.88, -1.93, -1.95),
                        CV4 = c(-1.55, -1.60, -1.62))
    dimnames(table) <- list(c(240, 480, 10000), c("0.01", "0.025", "0.05", "0.10"))
  }
  if(code=="BM111tpi2")
  {
    table <- data.frame(CV1 = c(-3.31, -3.40, -3.41),
                        CV2 = c(-3.02, -3.08, -3.12),
                        CV3 = c(-2.75, -2.84, -2.86),
                        CV4 = c(-2.47, -2.54, -2.57))
    dimnames(table) <- list(c(240, 480, 10000), c("0.01", "0.025", "0.05", "0.10"))
  }

  if(code=="BM000tpi3" || code=="BM000tpi5" || code=="BM000tpi7" || code=="BM000tpi9" || code=="BM000tpi11")
  {
    table <- data.frame(CV1 = -c(2.50, 2.52, 2.56),
                        CV2 = -c(2.16, 2.18, 2.23),
                        CV3 = -c(1.88, 1.90, 1.95),
                        CV4 = -c(1.55, 1.57, 1.59))
    dimnames(table) <- list(c(240, 480, 10000), c("0.01", "0.025", "0.05", "0.10"))
  }
  if(code=="BM100tpi3" || code=="BM100tpi5" || code=="BM100tpi7" || code=="BM100tpi9" || code=="BM100tpi11")
  {
    table <- data.frame(CV1 = -c(2.51, 2.56, 2.56),
                        CV2 = -c(2.16, 2.20, 2.23),
                        CV3 = -c(1.87, 1.90, 1.95),
                        CV4 = -c(1.54, 1.57, 1.59))
    dimnames(table) <- list(c(240, 480, 10000), c("0.01", "0.025", "0.05", "0.10"))
  }
  if(code=="BM101tpi3" || code=="BM101tpi5" || code=="BM101tpi7" || code=="BM101tpi9" || code=="BM101tpi11")
  {
    table <- data.frame(CV1 = -c(3.83, 3.86, 3.91),
                        CV2 = -c(3.51, 3.55, 3.61),
                        CV3 = -c(3.25, 3.29, 3.35),
                        CV4 = -c(2.95, 2.99, 3.05))
    dimnames(table) <- list(c(240, 480, 10000), c("0.01", "0.025", "0.05", "0.10"))
  }
  if(code=="BM110tpi3" || code=="BM110tpi5" || code=="BM110tpi7" || code=="BM110tpi9" || code=="BM110tpi11")
  {
    table <- data.frame(CV1 = -c(2.49, 2.53, 2.56),
                        CV2 = -c(2.16, 2.20, 2.23),
                        CV3 = -c(1.88, 1.91, 1.95),
                        CV4 = -c(1.54, 1.57, 1.59))
    dimnames(table) <- list(c(240, 480, 10000), c("0.01", "0.025", "0.05", "0.10"))
  }
  if(code=="BM111tpi3" || code=="BM111tpi5" || code=="BM111tpi7" || code=="BM111tpi9" || code=="BM111tpi11")
  {
    table <- data.frame(CV1 = -c(3.79, 3.85, 3.91),
                        CV2 = -c(3.50, 3.55, 3.61),
                        CV3 = -c(3.24, 3.29, 3.35),
                        CV4 = -c(2.95, 3.00, 3.05))
    dimnames(table) <- list(c(240, 480, 10000), c("0.01", "0.025", "0.05", "0.10"))
  }

  if(code=="BM000tpi4" || code=="BM000tpi6" || code=="BM000tpi8" || code=="BM000tpi10" || code=="BM000tpi12")
  {
    table <- data.frame(CV1 = c(-2.31, -2.33, -2.30),
                        CV2 = c(-1.95, -1.96, -1.94),
                        CV3 = c(-1.63, -1.65, -1.63),
                        CV4 = c(-1.27, -1.28, -1.28),
                        CV5 = c(1.25, 1.27, 1.27),
                        CV6 = c(1.61, 1.63, 1.63),
                        CV7 = c(1.93, 1.94, 1.94),
                        CV8 = c(2.29, 2.32, 2.32))
    dimnames(table) <- list(c(240, 480, 10000),
                            c("0.01", "0.025", "0.05", "0.10", "0.90", "0.95", "0.975", "0.99"))
  }
  if(code=="BM100tpi4" || code=="BM100tpi6" || code=="BM100tpi8" || code=="BM100tpi10" || code=="BM100tpi12")
  {
    table <- data.frame(CV1 = c(-2.30, -2.32, -2.30),
                        CV2 = c(-1.93, -1.95, -1.94),
                        CV3 = c(-1.62, -1.63, -1.63),
                        CV4 = c(-1.27, -1.27, -1.28),
                        CV5 = c(1.24, 1.27, 1.27),
                        CV6 = c(1.60, 1.62, 1.63),
                        CV7 = c(1.91, 1.93, 1.94),
                        CV8 = c(2.28, 2.30, 2.32))
    dimnames(table) <- list(c(240, 480, 10000),
                            c("0.01", "0.025", "0.05", "0.10", "0.90", "0.95", "0.975", "0.99"))
  }
  if(code=="BM101tpi4" || code=="BM101tpi6" || code=="BM101tpi8" || code=="BM101tpi10" || code=="BM101tpi12")
  {
    table <- data.frame(CV1 = c(-2.61, -2.65, -2.72),
                        CV2 = c(-2.21, -2.25, -2.31),
                        CV3 = c(-1.85, -1.90, -1.95),
                        CV4 = c(-1.45, -1.49, -1.54),
                        CV5 = c(1.46, 1.49, 1.53),
                        CV6 = c(1.86, 1.91, 1.95),
                        CV7 = c(2.20, 2.25, 2.30),
                        CV8 = c(2.60, 2.63, 2.72))
    dimnames(table) <- list(c(240, 480, 10000),
                            c("0.01", "0.025", "0.05", "0.10", "0.90", "0.95", "0.975", "0.99"))
  }
  if(code=="BM110tpi4" || code=="BM110tpi6" || code=="BM110tpi8" || code=="BM110tpi10" || code=="BM110tpi12")
  {
    table <- data.frame(CV1 = c(-2.28, -2.30, -2.30),
                        CV2 = c(-1.93, -1.94, -1.94),
                        CV3 = c(-1.61, -1.63, -1.63),
                        CV4 = c(-1.25, -1.27, -1.28),
                        CV5 = c(1.24, 1.25, 1.27),
                        CV6 = c(1.59, 1.61, 1.63),
                        CV7 = c(1.90, 1.92, 1.94),
                        CV8 = c(2.26, 2.28, 2.32))
    dimnames(table) <- list(c(240, 480, 10000),
                            c("0.01", "0.025", "0.05", "0.10", "0.90", "0.95", "0.975", "0.99"))
  }
  if(code=="BM111tpi4" || code=="BM111tpi6" || code=="BM111tpi8" || code=="BM111tpi10" || code=="BM111tpi12")
  {
    table <- data.frame(CV1 = c(-2.57, -2.66, -2.72),
                        CV2 = c(-2.18, -2.27, -2.31),
                        CV3 = c(-1.85, -1.91, -1.95),
                        CV4 = c(-1.45, -1.49, -1.54),
                        CV5 = c(1.45, 1.49, 1.53),
                        CV6 = c(1.86, 1.90, 1.95),
                        CV7 = c(2.19, 2.25, 2.30),
                        CV8 = c(2.60, 2.64, 2.72))
    dimnames(table) <- list(c(240, 480, 10000),
                            c("0.01", "0.025", "0.05", "0.10", "0.90", "0.95", "0.975", "0.99"))
  }

  if(code=="BM000Foddeven")
  {
    table <- data.frame(CV1 = c(2.34, 2.38, 2.40),
                        CV2 = c(3.03, 3.08, 3.10),
                        CV3 = c(3.71, 3.78, 3.79),
                        CV4 = c(4.60, 4.70, 4.68))
    dimnames(table) <- list(c(240, 480, 10000), c("0.10", "0.05", "0.025", "0.01"))
  }
  if(code=="BM100Foddeven")
  {
    table <- data.frame(CV1 = c(2.32, 2.36, 2.40),
                        CV2 = c(3.01, 3.06, 3.10),
                        CV3 = c(3.68, 3.76, 3.79),
                        CV4 = c(4.60, 4.66, 4.68))
    dimnames(table) <- list(c(240, 480, 10000), c("0.10", "0.05", "0.025", "0.01"))
  }
  if(code=="BM101Foddeven")
  {
    table <- data.frame(CV1 = c(5.27, 5.42, 5.64),
                        CV2 = c(6.26, 6.42, 6.67),
                        CV3 = c(7.19, 7.38, 7.63),
                        CV4 = c(8.35, 8.60, 8.79))
    dimnames(table) <- list(c(240, 480, 10000), c("0.10", "0.05", "0.025", "0.01"))
  }
  if(code=="BM110Foddeven")
  {
    table <- data.frame(CV1 = c(2.30, 2.36, 2.40),
                        CV2 = c(2.97, 3.05, 3.10),
                        CV3 = c(3.64, 3.72, 3.79),
                        CV4 = c(4.53, 4.62, 4.68))
    dimnames(table) <- list(c(240, 480, 10000), c("0.10", "0.05", "0.025", "0.01"))
  }
  if(code=="BM111Foddeven")
  {
    table <- data.frame(CV1 = c(5.25, 5.44, 5.64),
                        CV2 = c(6.23, 6.43, 6.67),
                        CV3 = c(7.14, 7.35, 7.63),
                        CV4 = c(8.33, 8.52, 8.79))
    dimnames(table) <- list(c(240, 480, 10000), c("0.01", "0.025", "0.05", "0.10"))
  }

  if(code=="HEGY000tpi1")
  {
    table <- data.frame(CV1 = c(-2.72, -2.60, -2.62, -2.62),
                        CV2 = c(-2.29, -2.26, -2.25, -2.23),
                        CV3 = c(-1.95, -1.97, -1.93, -1.94),
                        CV4 = c(-1.59, -1.61, -1.59, -1.62))
    dimnames(table) <- list(c(48, 100, 136, 200), c("0.01", "0.025", "0.05", "0.10"))
  }
  if(code=="HEGY100tpi1")
  {
    table <- data.frame(CV1 = c(-3.66, -3.47, -3.51, -3.48),
                        CV2 = c(-3.25, -3.14, -3.17, -3.13),
                        CV3 = c(-2.96, -2.88, -2.89, -2.87),
                        CV4 = c(-2.62, -2.58, -2.58, -2.57))
    dimnames(table) <- list(c(48, 100, 136, 200), c("0.01", "0.025", "0.05", "0.10"))
  }
  if(code=="HEGY101tpi1")
  {
    table <- data.frame(CV1 = c(-3.77, -3.55, -3.56, -3.51),
                        CV2 = c(-3.39, -3.22, -3.23, -3.18),
                        CV3 = c(-3.08, -2.95, -2.94, -2.91),
                        CV4 = c(-2.72, -2.63, -2.62, -2.59))
    dimnames(table) <- list(c(48, 100, 136, 200), c("0.01", "0.025", "0.05", "0.10"))
  }
  if(code=="HEGY110tpi1")
  {
    table <- data.frame(CV1 = c(-4.23, -4.07, -4.09, -4.05),
                        CV2 = c(-3.85, -3.73, -3.75, -3.70),
                        CV3 = c(-3.56, -3.47, -3.46, -3.44),
                        CV4 = c(-3.21, -3.16, -3.16, -3.15))
    dimnames(table) <- list(c(48, 100, 136, 200), c("0.01", "0.025", "0.05", "0.10"))
  }
  if(code=="HEGY111tpi1")
  {
    table <- data.frame(CV1 = c(-4.46, -4.09, -4.15, -4.05),
                        CV2 = c(-4.04, -3.80, -3.80, -3.74),
                        CV3 = c(-3.71, -3.53, -3.52, -3.49),
                        CV4 = c(-3.37, -3.22, -3.21, -3.18))
    dimnames(table) <- list(c(48, 100, 136, 200), c("0.01", "0.025", "0.05", "0.10"))
  }

  if(code=="HEGY000tpi2")
  {
    table <- data.frame(CV1 = c(-2.67, -2.61, -2.60, -2.60),
                        CV2 = c(-2.27, -222, -2.23, -2.24),
                        CV3 = c(-1.95, -1.92, -1.94, -1.95),
                        CV4 = c(-1.60, -1.57, -1.61, -1.61))
    dimnames(table) <- list(c(48, 100, 136, 200), c("0.01", "0.025", "0.05", "0.10"))
  }
  if(code=="HEGY100tpi2")
  {
    table <- data.frame(CV1 = c(-2.68, -2.61, -2.60, -2.58),
                        CV2 = c(-2.27, -2.24, -2.21, -2.22),
                        CV3 = c(-1.95, -1.95, -1.91, -1.92),
                        CV4 = c(-1.60, -1.60, -1.58, -1.59))
    dimnames(table) <- list(c(48, 100, 136, 200), c("0.01", "0.025", "0.05", "0.10"))
  }
  if(code=="HEGY101tpi2")
  {
    table <- data.frame(CV1 = c(-3.75, -3.60, -3.49, -3.50),
                        CV2 = c(-3.37, -3.22, -3.15, -3.16),
                        CV3 = c(-3.04, -2.94, -2.90, -2.89),
                        CV4 = c(-2.69, -2.63, -2.59, -2.60))
    dimnames(table) <- list(c(48, 100, 136, 200), c("0.01", "0.025", "0.05", "0.10"))
  }
  if(code=="HEGY110tpi2")
  {
    table <- data.frame(CV1 = c(-2.65, -2.58, -2.65, -2.59),
                        CV2 = c(-2.24, -2.24, -2.25, -2.25),
                        CV3 = c(-1.91, -1.94, -1.96, -1.95),
                        CV4 = c(-1.57, -1.60, -1.63, -1.62))
    dimnames(table) <- list(c(48, 100, 136, 200), c("0.01", "0.025", "0.05", "0.10"))
  }
  if(code=="HEGY111tpi2")
  {
    table <- data.frame(CV1 = c(-3.80, -3.60, -3.57, -3.52),
                        CV2 = c(-3.41, -3.22, -3.18, -3.18),
                        CV3 = c(-3.08, -2.94, -2.93, -2.91),
                        CV4 = c(-2.73, -2.63, -2.61, -2.60))
    dimnames(table) <- list(c(48, 100, 136, 200), c("0.01", "0.025", "0.05", "0.10"))
  }

  if(code=="HEGY000tpi3")
  {
    table <- data.frame(CV1 = -c(2.66, 2.55, 2.58, 2.58),
                        CV2 = -c(2.23, 2.18, 2.21, 2.24),
                        CV3 = -c(1.93, 1.90, 1.92, 1.92),
                        CV4 = -c(1.52, 1.53, 1.56, 1.55))
    dimnames(table) <- list(c(48, 100, 136, 200), c("0.01", "0.025", "0.05", "0.10"))
  }
  if(code=="HEGY100tpi3")
  {
    table <- data.frame(CV1 = -c(2.64, 2.23, 1.90, 1.52),
                        CV2 = -c(2.61, 2.23, 1.90, 1.54),
                        CV3 = -c(2.53, 2.18, 1.88, 1.53),
                        CV4 = -c(2.57, 2.21, 1.90, 1.53))
    dimnames(table) <- list(c(48, 100, 136, 200), c("0.01", "0.025", "0.05", "0.10"))
  }
  if(code=="HEGY101tpi3")
  {
    table <- data.frame(CV1 = -c(4.31, 4.06, 4.06, 4.00),
                        CV2 = -c(3.92, 3.72, 3.72, 3.67),
                        CV3 = -c(3.61, 3.44, 3.44, 3.38),
                        CV4 = -c(3.24, 3.14, 3.11, 3.07))
    dimnames(table) <- list(c(48, 100, 136, 200), c("0.01", "0.025", "0.05", "0.10"))
  }
  if(code=="HEGY110tpi3")
  {
    table <- data.frame(CV1 = -c(2.68, 2.56, 2.56, 2.58),
                        CV2 = -c(2.27, 2.19, 2.20, 2.21),
                        CV3 = -c(1.92, 1.89, 1.90, 1.92),
                        CV4 = -c(1.52, 1.54, 1.52, 1.56))
    dimnames(table) <- list(c(48, 100, 136, 200), c("0.01", "0.025", "0.05", "0.10"))
  }
  if(code=="HEGY111tpi3")
  {
    table <- data.frame(CV1 = -c(4.46, 4.12, 4.05, 4.04),
                        CV2 = -c(4.02, 3.76, 3.72, 3.69),
                        CV3 = -c(3.66, 3.48, 3.44, 3.41),
                        CV4 = -c(3.28, 3.14, 3.12, 3.10))
    dimnames(table) <- list(c(48, 100, 136, 200), c("0.01", "0.025", "0.05", "0.10"))
  }

  if(code=="HEGY000tpi4")
  {
    table <- data.frame(CV1 = c(-2.51, -2.43, -2.44, -2.43),
                        CV2 = c(-2.11, -2.01, -1.99, -1.98),
                        CV3 = c(-1.76, -1.68, -1.68, -1.65),
                        CV4 = c(-1.35, -1.32, -1.31, -1.30),
                        CV5 = c(1.33, 1.31, 1.30, 1.29),
                        CV6 = c(1.72, 1.67, 1.66, 1.67),
                        CV7 = c(2.05, 2.00, 1.99, 1.97),
                        CV8 = c(2.49, 2.40, 2.38, 2.36))
    dimnames(table) <- list(c(48, 100, 136, 200),
                            c("0.01", "0.025", "0.05", "0.10", "0.90", "0.95", "0.975", "0.99"))
  }
  if(code=="HEGY100tpi4")
  {
    table <- data.frame(CV1 = c(-2.44, -2.38, -2.36, -2.36),
                        CV2 = c(-2.06, -1.99, -1.98, -1.98),
                        CV3 = c(-1.72, -1.68, -1.68, -1.66),
                        CV4 = c(-1.33, -1.30, -1.31, -1.29),
                        CV5 = c(1.30, 1.28, 1.27, 1.28),
                        CV6 = c(1.68, 1.65, 1.65, 1.65),
                        CV7 = c(2.04, 1.97, 1.97, 1.96),
                        CV8 = c(2.41, 2.32, 2.31, 2.30))
    dimnames(table) <- list(c(48, 100, 136, 200),
                            c("0.01", "0.025", "0.05", "0.10", "0.90", "0.95", "0.975", "0.99"))
  }
  if(code=="HEGY101tpi4")
  {
    table <- data.frame(CV1 = c(-2.86, -2.78, -2.72, -2.74),
                        CV2 = c(-2.37, -2.32, -2.31, -2.33),
                        CV3 = c(-1.98, -1.96, -1.96, -1.96),
                        CV4 = c(-1.53, -1.53, -1.52, -1.54),
                        CV5 = c(1.54, 1.52, 1.51, 1.53),
                        CV6 = c(1.96, 1.93, 1.92, 1.95),
                        CV7 = c(2.35, 2.29, 2.28, 2.32),
                        CV8 = c(2.81, 2.73, 2.71, 2.78))
    dimnames(table) <- list(c(48, 100, 136, 200),
                            c("0.01", "0.025", "0.05", "0.10", "0.90", "0.95", "0.975", "0.99"))
  }
  if(code=="HEGY110tpi4")
  {
    table <- data.frame(CV1 = c(-2.41, -2.38, -2.36, -2.35),
                        CV2 = c(-2.05, -1.97, -1.97, -1.97),
                        CV3 = c(-1.70, -1.65, -1.64, -1.66),
                        CV4 = c(-1.33, -1.28, -1.29, -1.29),
                        CV5 = c(1.26, 1.28, 1.26, 1.26),
                        CV6 = c(1.64, 1.65, 1.62, 1.64),
                        CV7 = c(1.96, 1.98, 1.92, 1.96),
                        CV8 = c(2.37, 2.32, 2.31, 2.30))
    dimnames(table) <- list(c(48, 100, 136, 200),
                            c("0.01", "0.025", "0.05", "0.10", "0.90", "0.95", "0.975", "0.99"))
  }
  if(code=="HEGY111tpi4")
  {
    table <- data.frame(CV1 = c(-2.75, -2.76, -2.71, -2.65),
                        CV2 = c(-2.26, -2.32, -2.78, -2.27),
                        CV3 = c(-1.91, -1.94, -1.94, -1.92),
                        CV4 = c(-1.48, -1.51, -1.51, -1.48),
                        CV5 = c(1.51, 1.51, 1.53, 1.55),
                        CV6 = c(1.97, 1.92, 1.96, 1.97),
                        CV7 = c(2.34, 2.28, 2.31, 2.31),
                        CV8 = c(2.78, 2.69, 2.78, 2.71))
    dimnames(table) <- list(c(48, 100, 136, 200),
                            c("0.01", "0.025", "0.05", "0.10", "0.90", "0.95", "0.975", "0.99"))
  }

  if(code=="HEGY000Foddeven")
  {
    table <- data.frame(CV1 = c(2.45, 2.39, 2.41, 2.42),
                        CV2 = c(3.26, 3.12, 3.14, 3.16),
                        CV3 = c(4.04, 3.89, 3.86, 3.92),
                        CV4 = c(5.02, 4.89, 4.81, 4.81))
    dimnames(table) <- list(c(48, 100, 136, 200), c("0.10", "0.05", "0.025", "0.01"))
  }
  if(code=="HEGY100Foddeven")
  {
    table <- data.frame(CV1 = c(2.32, 2.35, 2.36, 2.37),
                        CV2 = c(3.04, 3.08, 3.00, 3.12),
                        CV3 = c(3.78, 3.81, 3.70, 3.86),
                        CV4 = c(4.78, 4.77, 4.73, 4.76))
    dimnames(table) <- list(c(48, 100, 136, 200), c("0.10", "0.05", "0.025", "0.01"))
  }
  if(code=="HEGY101Foddeven")
  {
    table <- data.frame(CV1 = c(5.50, 5.56, 5.56, 5.56),
                        CV2 = c(6.60, 6.57, 6.63, 6.61),
                        CV3 = c(7.68, 7.72, 7.66, 7.53),
                        CV4 = c(9.22, 8.74, 8.92, 8.93))
    dimnames(table) <- list(c(48, 100, 136, 200), c("0.10", "0.05", "0.025", "0.01"))
  }
  if(code=="HEGY110Foddeven")
  {
    table <- data.frame(CV1 = c(2.23, 2.31, 2.33, 2.34),
                        CV2 = c(2.95, 2.98, 3.04, 3.07),
                        CV3 = c(3.70, 3.71, 3.69, 3.76),
                        CV4 = c(4.64, 4.70, 4.57, 4.66))
    dimnames(table) <- list(c(48, 100, 136, 200), c("0.10", "0.05", "0.025", "0.01"))
  }
  if(code=="HEGY111Foddeven")
  {
    table <- data.frame(CV1 = c(5.37, 5.52, 5.55, 5.56),
                        CV2 = c(6.55, 6.60, 6.62, 6.57),
                        CV3 = c(7.70, 7.52, 7.59, 7.56),
                        CV4 = c(9.27, 8.79, 8.77, 8.96))
    dimnames(table) <- list(c(48, 100, 136, 200), c("0.10", "0.05", "0.025", "0.01"))
  }

  if(code=="CHp1")
  {
    table <- data.frame(rbind(c(0.353, 0.470, 0.593, 0.748),
                              c(0.353, 0.470, 0.593, 0.748)))
    dimnames(table) <- list(c("100000","100001"), c("0.10", "0.05", "0.025", "0.01"))
  }
  if(code=="CHp2")
  {
    table <- data.frame(rbind(c(0.610, 0.749, 0.898, 1.070),
                              c(0.610, 0.749, 0.898, 1.070)))
    dimnames(table) <- list(c("100000","100001"), c("0.10", "0.05", "0.025", "0.01"))
  }
  if(code=="CHp3")
  {
    table <- data.frame(rbind(c(0.846, 1.010, 1.160, 1.350),
                              c(0.846, 1.010, 1.160, 1.350)))
    dimnames(table) <- list(c("100000","100001"), c("0.10", "0.05", "0.025", "0.01"))
  }
  if(code=="CHp4")
  {
    table <- data.frame(rbind(c(1.07, 1.24, 1.39, 1.60),
                              c(1.07, 1.24, 1.39, 1.60)))
    dimnames(table) <- list(c("100000","100001"), c("0.10", "0.05", "0.025", "0.01"))
  }
  if(code=="CHp5")
  {
    table <- data.frame(rbind(c(1.28, 1.47, 1.63, 1.88),
                              c(1.28, 1.47, 1.63, 1.88)))
    dimnames(table) <- list(c("100000","100001"), c("0.10", "0.05", "0.025", "0.01"))
  }
  if(code=="CHp6")
  {
    table <- data.frame(rbind(c(1.49, 1.68, 1.89, 2.12),
                              c(1.49, 1.68, 1.89, 2.12)))
    dimnames(table) <- list(c("100000","100001"), c("0.10", "0.05", "0.025", "0.01"))
  }
  if(code=="CHp7")
  {
    table <- data.frame(rbind(c(1.69, 1.90, 2.10, 2.35),
                              c(1.69, 1.90, 2.10, 2.35)))
    dimnames(table) <- list(c("100000","100001"), c("0.10", "0.05", "0.025", "0.01"))
  }
  if(code=="CHp8")
  {
    table <- data.frame(rbind(c(1.89, 2.11, 2.33, 2.59),
                              c(1.89, 2.11, 2.33, 2.59)))
    dimnames(table) <- list(c("100000","100001"), c("0.10", "0.05", "0.025", "0.01"))
  }
  if(code=="CHp9")
  {
    table <- data.frame(rbind(c(2.10, 2.32, 2.55, 2.82),
                              c(2.10, 2.32, 2.55, 2.82)))
    dimnames(table) <- list(c("100000","100001"), c("0.10", "0.05", "0.025", "0.01"))
  }
  if(code=="CHp10")
  {
    table <- data.frame(rbind(c(2.29, 2.54, 2.76, 3.05),
                              c(2.29, 2.54, 2.76, 3.05)))
    dimnames(table) <- list(c("100000","100001"), c("0.10", "0.05", "0.025", "0.01"))
  }
  if(code=="CHp11")
  {
    table <- data.frame(rbind(c(2.49, 2.75, 2.99, 3.27),
                              c(2.49, 2.75, 2.99, 3.27)))
    dimnames(table) <- list(c("100000","100001"), c("0.10", "0.05", "0.025", "0.01"))
  }
  if(code=="CHp12")
  {
    table <- data.frame(rbind(c(2.69, 2.96, 3.18, 2.51),
                              c(2.69, 2.96, 3.18, 2.51)))
    dimnames(table) <- list(c("100000","100001"), c("0.10", "0.05", "0.025", "0.01"))
  }

  table
}

urt.xtable <- function(x, caption=NULL, label=NULL, align=NULL, vsep=NULL, digits=NULL, display=NULL,...){
}
save.xtable <- function(x, caption="ADF test", label="Tadf", align="lrrrr", vsep=NULL, digits=NULL,
  display=NULL, type="latex", file=NULL, append=FALSE, floating=TRUE, table.placement="ht",
  caption.placement="top", latex.environments=c("center"), size=NULL, hline.after=NULL,...){
}

## ADF

setMethod("urt.xtable", "adfstat",
  function(x, caption="ADF test", label="Tadf", align="lrrrr", vsep=NULL, digits=NULL, display=NULL,...)
  {
    require(xtable) || stop("The package xtable is not available")
    if(class(x@regvarcoefs) == "NULL" && class(x@lagcoefs) == "NULL")
      Mout <- matrix(x@stat, ncol=4, byrow=TRUE)
    if(class(x@regvarcoefs) == "matrix" && class(x@lagcoefs) == "NULL")
      Mout <- matrix(t(c(t(x@regvarcoefs), t(x@stat))), ncol=4, byrow=TRUE)
    if(class(x@regvarcoefs) == "NULL" && class(x@lagcoefs) == "matrix")
      Mout <- matrix(t(c(t(x@stat), t(x@lagcoefs))), ncol=4, byrow=TRUE)
    if(class(x@regvarcoefs) == "matrix" && class(x@lagcoefs) == "matrix")
      Mout <- matrix(t(c(t(x@regvarcoefs), t(x@stat), t(x@lagcoefs))), ncol=4, byrow=TRUE)

    regnames <- c(dimnames(x@regvarcoefs)[[1]], "adf.stat", dimnames(x@lagcoefs)[[1]])
    cnames <- c("Estimate" , "Std.Error", "t-stat", "p-value")
    Mout <- matrix(Mout, ncol=4, dimnames=list(regnames, cnames))

    xtable(x=Mout, caption=caption, label=label, align=align, vsep=vsep, digits=digits, display=display)
  }
)

setMethod("save.xtable", "adfstat",
  function(x, caption="ADF test", label="Tadf", align="lrrrr", vsep=NULL, digits=NULL, display=NULL,
    type="latex", file=NULL, append=FALSE, floating=TRUE, table.placement="ht",
    caption.placement="top", latex.environments=c("center"), size=NULL, hline.after=NULL,...)
  {
    require(xtable) || stop("The package xtable is not available")
    outfile <- tclvalue(tkgetSaveFile(filetypes='{"Text files" {".tex"}} {"All Files" {"*"}}'))
    if(!nchar(outfile)){
      tkmessageBox(title="Stop", message="No file was chosen.", icon="error")
      #outfile <- "Tadf.tex"
    }

    regnames <- c(dimnames(x@regvarcoefs)[[1]], "adf.stat", dimnames(x@lagcoefs)[[1]])
    Tout <- urt.xtable(x, caption=caption, label=label, align=align,
                       vsep=vsep, digits=digits, display=display)

    hline.after <- hlref0 <- which(regnames=="adf.stat")
    if(hlref0 > 1)
      hline.after <- c(hline.after-1, hline.after)

    print.xtable(x=Tout, type=type, file=outfile, append=append, floating=floating,
      table.placement=table.placement, caption.placement=caption.placement,
      latex.environments=latex.environments, size=size, hline.after=hline.after)

    cat("\n  The table has been saved at", outfile, ".\n")
  }
)

## HEGY

setMethod("urt.xtable", "hegystat",
  function(x, caption="HEGY test", label="Thegy", align=NULL, vsep=NULL, digits=NULL, display=NULL,...)
  {
    require(xtable) || stop("The package xtable is not available")
    s <- frequency(x@wts); refrv <- length(x@regvarcoefs[,1])
    hegyout <- matrix(nrow=(s+s/2+1), ncol=4)
    hegyout[1:s,] <- x@hegycoefs
    hegyout[(s+1):(s+s/2+1),3:4] <- x@stats[3:(s/2+3),]

    etfsnames <- c(paste("tpi_", 1:s, sep=""),
                   paste("Fpi", paste(seq(3,s,2),seq(4,s,2), sep=":"), sep="_"),
                   paste("Fpi_2:", s, sep=""), paste("Fpi_1:", s, sep=""))

    if(class(x@regvarcoefs) == "NULL" && class(x@lagcoefs) == "NULL")
      Mout <- hegyout
    if(class(x@regvarcoefs) == "matrix" && class(x@lagcoefs) == "NULL")
      Mout <- matrix(t(c(t(x@regvarcoefs), t(hegyout))), ncol=4, byrow=TRUE)
    if(class(x@regvarcoefs) == "NULL" && class(x@lagcoefs) == "matrix")
      Mout <- matrix(t(c(t(hegyout), t(x@lagcoefs))), ncol=4, byrow=TRUE)
    if(class(x@regvarcoefs) == "matrix" && class(x@lagcoefs) == "matrix")
      Mout <- matrix(t(c(t(x@regvarcoefs), t(hegyout), t(x@lagcoefs))), ncol=4, byrow=TRUE)

    regnames <- c(dimnames(x@regvarcoefs)[[1]], etfsnames, dimnames(x@lagcoefs)[[1]])
    cnames <- c("Estimate" , "Std.Error", "Statistics", "p-value")
    Mout <- matrix(Mout, ncol=4, dimnames=list(regnames, cnames))

    #xtable(x=Mout[1:(s+refrv),],
    #  caption=caption, label=label, align=align, vsep=vsep, digits=digits, display=display)
    xtable(x=Mout[,3:4], caption=caption, label=label, align=align, vsep=vsep, digits=digits, display=display)
  }
)

setMethod("save.xtable", "hegystat",
  function(x, caption="HEGY test", label="Thegy", align=NULL, vsep=NULL, digits=NULL, display=NULL,
    type="latex", file=NULL, append=FALSE, floating=TRUE, table.placement="ht",
    caption.placement="top", latex.environments=c("center"), size=NULL, hline.after=NULL,...)
  {
    require(xtable) || stop("The package xtable is not available")
    outfile <- tclvalue(tkgetSaveFile(filetypes='{"Text files" {".tex"}} {"All Files" {"*"}}'))
    if(!nchar(outfile)){
      tkmessageBox(title="Stop", message="No file was chosen.", icon="error")
      #outfile <- "Thegy.tex"
    }

    etfsnames <- c(paste("tpi_", 1:s, sep=""),
                   paste("Fpi", paste(seq(3,s,2),seq(4,s,2), sep=":"), sep="_"),
                   paste("Fpi_2:", s, sep=""), paste("Fpi_1:", s, sep=""))
    regnames <- c(dimnames(x@regvarcoefs)[[1]], etfsnames, dimnames(x@lagcoefs)[[1]])

    Tout <- urt.xtable(x, caption=caption, label=label, align=align, vsep=vsep,
                       digits=digits, display=display)

    hline.after <- hlref0 <- which(regnames=="tpi_1")
    if(hlref0 > 1)
      hline.after <- c(hline.after-1, hline.after)
    hline.after <- c(hline.after, frequency(x@wts)+s+s/2+1)

    print.xtable(x=Tout, type=type, file=outfile, append=append, floating=floating,
      table.placement=table.placement, caption.placement=caption.placement,
      latex.environments=latex.environments, size=size, hline.after=hline.after)

    cat("\n  The table has been saved at", outfile, ".\n")
  }
)

# KPSS

setMethod("urt.xtable", "kpssstat",
  function(x, caption="KPSS test", label="Tkpss", align=NULL, vsep=NULL, digits=NULL, display=NULL,...)
  {
    require(xtable) || stop("The package xtable is not available")
    #Mout <- matrix(NA, nrow=5, ncol=3)
    #Mout[,1] <- c("0","1","2","3","4")

    ifelse(x@ltrunc-3 < 0, lt0<-0, lt0<-x@ltrunc-3)
    aux <- length(lt0:(x@ltrunc+3))
    Mout <- matrix(NA, nrow=aux, ncol=3)
    j <- 1
    for(i in lt0:(x@ltrunc+3)){
      out <- KPSS.test(wts=x@wts, ltrunc=i)
      Mout[j,1] <- i
      Mout[j,2] <- round(out@levelst, 2)
      Mout[j,3] <- round(out@trendst, 2)
      j <- j+1
    }
    Mout <- matrix(Mout, ncol=3, dimnames=list(rep("",aux), c("Trunc", "Level.st", "Trend.st")))
    xtable(Mout, caption=caption, label=label, align=align, vsep=vsep, digits=digits, display=display)
  }
)

setMethod("save.xtable", "kpssstat",
  function(x, caption="KPSS test", label="Tkpss", align=NULL, vsep=NULL, digits=NULL, display=NULL,
    type="latex", file=NULL, append=FALSE, floating=TRUE, table.placement="ht",
    caption.placement="top", latex.environments=c("center"), size=NULL, hline.after=NULL,...)
  {
    require(xtable) || stop("The package xtable is not available")
    outfile <- tclvalue(tkgetSaveFile(filetypes='{"Text files" {".tex"}} {"All Files" {"*"}}'))
    if(!nchar(outfile)){
      tkmessageBox(title="Stop", message="No file was chosen.", icon="error")
      #outfile <- "Tkpss.tex"
    }

    Tout <- urt.xtable(x)

    print.xtable(x=Tout, type=type, file=outfile, append=append, floating=floating,
      table.placement=table.placement, caption.placement=caption.placement,
      latex.environments=latex.environments, size=size, hline.after=hline.after)

    cat("\n  The table has been saved at", outfile, ".\n")
  }
)

# CH

setMethod("urt.xtable", "chstat",
  function(x, caption="CH test", label="Tch", align=NULL, vsep=NULL, digits=NULL, display=NULL,...)
  {
    require(xtable) || stop("The package xtable is not available")
    s <- frequency(x@wts)
    if(s==4)
      fnames <- c("$L_{\\pi/2}$", "$L_{\\pi$}", "$L_f$")
    if(s==12)
      fnames <- c("$L_{\\pi/6}$", "$L_{\\pi/3}$", "$L_{\\pi/2}$",
                  "$L_{2\\pi/3}$", "$L_{5\\pi/6}$", "$L_{\\pi}$", "$L_f$")

    Mout <- matrix(nrow=(s/2+1), ncol=2)
    for(i in 1:(s/2)){
      frec <- rep(0, s/2); frec[i] <- 1
      Mout[i,1] <- CH.test(wts=x@wts, frec=frec, f0=0, DetTr=x@DetTr, ltrunc=NULL)@stat
      Mout[i,2] <- CH.test(wts=x@wts, frec=frec, f0=1, DetTr=x@DetTr, ltrunc=NULL)@stat
    }
    Mout[(s/2+1),1] <- CH.test(wts=x@wts, frec=rep(1,s/2), f0=0, DetTr=x@DetTr, ltrunc=NULL)@stat
    Mout[(s/2+1),2] <- CH.test(wts=x@wts, frec=rep(1,s/2), f0=1, DetTr=x@DetTr, ltrunc=NULL)@stat

    Mout <- matrix(Mout, ncol=2, dimnames=list(fnames, c("$y_t$", "$\\Delta\\,y_t$")))

    xtable(Mout, caption=caption, label=label, align=align, vsep=vsep, digits=digits, display=display)
  }
)

setMethod("save.xtable", "chstat",
  function(x, caption="CH test", label="Tch", align=NULL, vsep=NULL, digits=NULL, display=NULL,
    type="latex", file=NULL, append=FALSE, floating=TRUE, table.placement="ht",
    caption.placement="top", latex.environments=c("center"), size=NULL, hline.after=NULL,...)
  {
    require(xtable) || stop("The package xtable is not available")
    outfile <- tclvalue(tkgetSaveFile(filetypes='{"Text files" {".tex"}} {"All Files" {"*"}}'))
    if(!nchar(outfile)){
      tkmessageBox(title="Stop", message="No file was chosen.", icon="error")
      #outfile <- "Tch.tex"
    }

    Tout <- urt.xtable(x)

    print.xtable(x=Tout, type=type, file=outfile, append=append, floating=floating,
      table.placement=table.placement, caption.placement=caption.placement,
      latex.environments=latex.environments, size=size, hline.after=hline.after)

    cat("\n  The table has been saved at", outfile, ".\n")
  }
)

## Output in recursive testing.


recadf.save.xtable <- function(wts, nsub=72, itsd, selectlags=list(mode="signf", Pmax=NULL),
  trace=list(remain=1, plot=0, elaps=1),
  caption="ADF recursive test", label="Tadfrec", align="lcrlcrl", vsep=NULL, digits=NULL,
  display=NULL, type="latex", file=NULL, append=FALSE, floating=TRUE, table.placement="ht",
  caption.placement="top", latex.environments=c("center"), size=NULL, hline.after=NULL,...)
{
    require(xtable) || stop("The package xtable is not available")
    outfile <- tclvalue(tkgetSaveFile(filetypes='{"Text files" {".tex"}} {"All Files" {"*"}}'))
    if(!nchar(outfile)){
      tkmessageBox(title="Stop", message="No file was chosen.", icon="error")
      stop(call="No file was chosen.")
    }

    rec.bw <- ADF.rectest(wts=wts, type="backw", nsub=nsub, itsd=itsd, selectlags=selectlags, trace=trace)
    rec.fw <- ADF.rectest(wts=wts, type="forw", nsub=nsub, itsd=itsd, selectlags=selectlags, trace=trace)

    fwsmpls <- dimnames(rec.fw@recstats)[[1]]
    fwsts <- Tround(matrix(as.numeric(rec.fw@recstats[,1])), column=1, digits=2)
    fwsts <- format(fwsts, justify="right")
    fwpvl <- format(rec.fw@recstats[,2], justify="left")

    bwsmpls <- dimnames(rec.bw@recstats)[[1]]
    bwsts <- Tround(matrix(as.numeric(rec.bw@recstats[,1])), column=1, digits=2)
    bwsts <- format(bwsts, justify="right")
    bwpvl <- format(rec.bw@recstats[,2], justify="left")

    Mout <- matrix(c(fwsmpls, fwsts, fwpvl,
                     bwsmpls, bwsts, bwpvl), ncol=6,
                   dimnames=list(rep("", length(bwsmpls)), c("Sample","Stats","","Sample","Stats","")))

    Tout <- xtable(x=as.data.frame(Mout), caption=caption, label=label, align=align,
                   vsep=vsep, digits=digits, display=display)

    print.xtable(x=Tout, type=type, file=outfile, append=append, floating=floating,
      table.placement=table.placement, caption.placement=caption.placement,
      latex.environments=latex.environments, size=size, hline.after=hline.after)

    msg <- paste("The table has been saved at", outfile)
    tkmessageBox(title="xtable", message=msg, icon="info")
}

rechegy.save.xtable <- function(wts, nsub=72, itsd, refstat, selectlags=list(mode="signf", Pmax=NULL),
  trace=list(remain=1, plot=0, elaps=1),
  caption="HEGY recursive test", label="Thegyrec", align="lcrlcrl", vsep=NULL, digits=NULL,
  display=NULL, type="latex", file=NULL, append=FALSE, floating=TRUE, table.placement="ht",
  caption.placement="top", latex.environments=c("center"), size=NULL, hline.after=NULL,...)
{
    require(xtable) || stop("The package xtable is not available")
    outfile <- tclvalue(tkgetSaveFile(filetypes='{"Text files" {".tex"}} {"All Files" {"*"}}'))
    if(!nchar(outfile)){
      tkmessageBox(title="Stop", message="No file was chosen.", icon="error")
      stop(call="No file was chosen.")
    }

    refstat2 <- which(c("tpi1","","tpi2","","Fpi3:4","","Fpi5:6","",
                        "Fpi7:8","","Fpi9:10","","Fpi11:12") == refstat)
    if(length(refstat2)==0)
      stop(call="Select a correct statistic's name.")
    rec.bw <- HEGY.rectest(wts=wts, type="backw", nsub=nsub, itsd=itsd, selectlags=selectlags, trace=trace)
    rec.fw <- HEGY.rectest(wts=wts, type="forw", nsub=nsub, itsd=itsd, selectlags=selectlags, trace=trace)

    fwsmpls <- dimnames(rec.fw@recstats)[[1]]
    fwsts <- Tround(matrix(as.numeric(rec.fw@recstats[,refstat2])), column=1, digits=2)
    fwsts <- format(fwsts, justify="right")
    fwpvl <- format(rec.fw@recstats[,refstat2+1], justify="left")

    bwsmpls <- dimnames(rec.bw@recstats)[[1]]
    bwsts <- Tround(matrix(as.numeric(rec.bw@recstats[,refstat2])), column=1, digits=2)
    bwsts <- format(bwsts, justify="right")
    bwpvl <- format(rec.bw@recstats[,refstat2+1], justify="left")

    Mout <- matrix(c(fwsmpls, fwsts, fwpvl,
                     bwsmpls, bwsts, bwpvl), ncol=6,
                   dimnames=list(rep("", length(bwsmpls)), c("Sample","Stats","","Sample","Stats","")))

    Tout <- xtable(x=as.data.frame(Mout), caption=caption, label=label, align=align,
                   vsep=vsep, digits=digits, display=display)

    print.xtable(x=Tout, type=type, file=outfile, append=append, floating=floating,
      table.placement=table.placement, caption.placement=caption.placement,
      latex.environments=latex.environments, size=size, hline.after=hline.after)

    cat(paste("Statistic ", refstat, "\n"))
    msg <- paste("The table has been saved at", outfile)
    tkmessageBox(title="xtable", message=msg, icon="info")
}

reckpss.save.xtable <- function(wts, nsub=48, testtype="level", ltrunc=NULL,
  trace=list(remain=1, plot=0, elaps=1),
  caption="KPSS recursive test", label="Tkpssrec", align="lcrlcrl", vsep=NULL, digits=NULL,
  display=NULL, type="latex", file=NULL, append=FALSE, floating=TRUE, table.placement="ht",
  caption.placement="top", latex.environments=c("center"), size=NULL, hline.after=NULL,...)
{
    require(xtable) || stop("The package xtable is not available")
    outfile <- tclvalue(tkgetSaveFile(filetypes='{"Text files" {".tex"}} {"All Files" {"*"}}'))
    if(!nchar(outfile)){
      tkmessageBox(title="Stop", message="No file was chosen.", icon="error")
      stop(call="No file was chosen.")
    }

    if(testtype=="level")
      ref <- 1
    if(testtype=="trend")
      ref <- 3
    rec.bw <- KPSS.rectest(wts=wts, type="backw", nsub=nsub,ltrunc=ltrunc, trace=trace)
    rec.fw <- KPSS.rectest(wts=wts, type="forw", nsub=nsub, ltrunc=ltrunc, trace=trace)

    fwsmpls <- dimnames(rec.fw@recstats)[[1]]
    fwsts <- Tround(matrix(as.numeric(rec.fw@recstats[,ref])), column=1, digits=2)
    fwsts <- format(fwsts, justify="right")
    fwpvl <- format(rec.fw@recstats[,ref+1], justify="left")

    bwsmpls <- dimnames(rec.bw@recstats)[[1]]
    bwsts <- Tround(matrix(as.numeric(rec.bw@recstats[,ref])), column=1, digits=2)
    bwsts <- format(bwsts, justify="right")
    bwpvl <- format(rec.bw@recstats[,ref+1], justify="left")

    Mout <- matrix(c(fwsmpls, fwsts, fwpvl,
                     bwsmpls, bwsts, bwpvl), ncol=6,
                   dimnames=list(rep("", length(bwsmpls)), c("Sample","Stats","","Sample","Stats","")))

    Tout <- xtable(x=as.data.frame(Mout), caption=caption, label=label, align=align,
                   vsep=vsep, digits=digits, display=display)

    print.xtable(x=Tout, type=type, file=outfile, append=append, floating=floating,
      table.placement=table.placement, caption.placement=caption.placement,
      latex.environments=latex.environments, size=size, hline.after=hline.after)

    msg <- paste("The table has been saved at", outfile)
    tkmessageBox(title="xtable", message=msg, icon="info")
}

recch.save.xtable <- function(wts, nsub=48, frec=NULL, f0=1, DetTr=FALSE, ltrunc=NULL,
  trace=list(remain=1, plot=0, elaps=1),
  caption="CH recursive test", label="Tchrec", align="lcrlcrl", vsep=NULL, digits=NULL,
  display=NULL, type="latex", file=NULL, append=FALSE, floating=TRUE, table.placement="ht",
  caption.placement="top", latex.environments=c("center"), size=NULL, hline.after=NULL,...)
{
    require(xtable) || stop("The package xtable is not available")
    outfile <- tclvalue(tkgetSaveFile(filetypes='{"Text files" {".tex"}} {"All Files" {"*"}}'))
    if(!nchar(outfile)){
      tkmessageBox(title="Stop", message="No file was chosen.", icon="error")
      stop(call="No file was chosen.")
    }
    chrec.bw <- CH.rectest(wts=wts, type="backw", nsub=nsub, frec=frec, f0=f0, DetTr=DetTr,
                           ltrunc=ltrunc, trace=trace)
    chrec.fw <- CH.rectest(wts=wts, type="forw", nsub=nsub, frec=frec, f0=f0, DetTr=DetTr,
                           ltrunc=ltrunc, trace=trace)

    fwsmpls <- dimnames(chrec.fw@recstats)[[1]]
    fwsts <- Tround(matrix(as.numeric(chrec.fw@recstats[,1])), column=1, digits=2)
    fwsts <- format(fwsts, justify="right")
    fwpvl <- format(chrec.fw@recstats[,2], justify="left")

    bwsmpls <- dimnames(chrec.bw@recstats)[[1]]
    bwsts <- Tround(matrix(as.numeric(chrec.bw@recstats[,1])), column=1, digits=2)
    bwsts <- format(bwsts, justify="right")
    bwpvl <- format(chrec.bw@recstats[,2], justify="left")

    Mout <- matrix(c(fwsmpls, fwsts, fwpvl,
                     bwsmpls, bwsts, bwpvl), ncol=6,
                   dimnames=list(rep("", length(bwsmpls)), c("Sample","Stats","","Sample","Stats","")))

    Tout <- xtable(x=as.data.frame(Mout), caption=caption, label=label, align=align,
                   vsep=vsep, digits=digits, display=display)

    print.xtable(x=Tout, type=type, file=outfile, append=append, floating=floating,
      table.placement=table.placement, caption.placement=caption.placement,
      latex.environments=latex.environments, size=size, hline.after=hline.after)

    msg <- paste("The table has been saved at", outfile)
    tkmessageBox(title="xtable", message=msg, icon="info")
}

# Function Builtin: urca  
#   This function Builtin will be used when the original package 'urca'
#   is not available for your hardware configuration and/or operating 
#   system. 

# Package: urca
# Version: 0.9-7
# Date: 2006-09-03
# Title: Unit root and cointegration tests for time series data
# Author: Bernhard Pfaff <bernhard.pfaff@pfaffikus.de>
# Maintainer: Bernhard Pfaff <bernhard@pfaffikus.de>
# Depends: R (>= 2.0.0)
# Imports: nlme, methods, graphics, stats
# LazyLoad: yes
# Description: Unit root and cointegration tests encountered in applied 
#   econometric analysis are implemented.
# License: GPL version 2 or newer
# Packaged: Sun Sep  3 17:25:36 2006; bp


################################################################################
# PART I: Copy from contributed Package nlme ...


BIC =
function (object, ...) 
{
    UseMethod("BIC")
}


BIC.logLik =
function(object, ...)
{
    # BIC for logLik objects
    ans = -2 * (c(object) - attr(object, "df") * log(attr(object, "nobs"))/2)
    
    # Return Value:
    ans
}


BIC.lm = 
function(object, ...)
{
    # BIC for various fitted objects
    if ((rt = nargs()) > 1) {
        object = list(object, ...)
        val = lapply(object, logLik)
        val = as.data.frame(t(sapply(val, 
            function(el) c(attr(el, "df"), BIC(el)))))
        names(val) = c("df", "BIC")
        row.names(val) = as.character(match.call()[-1])
    } else {
        val = BIC(logLik(object))
    }
    
    # Return Value:
    val
}


################################################################################
# PART II: Copy from Contributed Package urca ...

##
## Setting classes for unit root tests
##

setClass("urca", representation(test.name="character"))

setClass("ur.ers", representation(y="vector",
                                  yd="vector",
                                  type="character",
                                  model="character",
                                  lag="integer",
                                  cval="matrix",
                                  teststat="numeric",
                                  testreg="ANY"),
         contains="urca")

setClass("ca.jo", representation(x="ANY",
                                 Z0="matrix",
                                 Z1="matrix",
                                 ZK="matrix",
                                 type="character",
                                 model="character",
                                 const="logical",
                                 lag="integer",
                                 P="integer",
                                 season="ANY",
                                 dumvar="ANY",
                                 cval="ANY",
                                 teststat="ANY",
                                 lambda="vector",
                                 Vorg="matrix",
                                 V="matrix",
                                 W="matrix",
                                 PI="matrix",
                                 DELTA="matrix",
                                 GAMMA="matrix",
                                 R0="matrix",
                                 RK="matrix",
                                 bp="ANY"),
         contains="urca")

setClass("cajo.test", representation(Z0="matrix",
                                     Z1="matrix",
                                     ZK="matrix",
                                     H="ANY",
                                     A="ANY",
                                     B="ANY",
                                     type="character",
                                     const="logical",
                                     teststat="numeric",
                                     pval="vector",
                                     lambda="vector",
                                     Vorg="matrix",
                                     V="matrix",
                                     W="matrix",
                                     PI="matrix",
                                     DELTA="ANY",
                                     DELTA.bb="ANY",
                                     DELTA.ab="ANY",
                                     DELTA.aa.b="ANY",
                                     GAMMA="matrix"),
         contains="urca")

setClass("ur.kpss", representation(y="vector",
                                   type="character",
                                   lag="integer",
                                   cval="matrix",
                                   teststat="numeric",
                                   res="vector"),
         contains="urca")

setClass("ca.po", representation(z="ANY",
                                 type="character",
                                 model="character",
                                 lag="integer",
                                 cval="matrix",
                                 res="matrix",
                                 teststat="numeric",
                                 testreg="ANY"),
         contains="urca")

setClass("ur.pp", representation(y="vector",
                                 type="character",
                                 model="character",
                                 lag="integer",
                                 cval="matrix",
                                 teststat="numeric",
                                 testreg="ANY",
                                 auxstat="matrix",
                                 res="vector"),
         contains="urca")

setClass("ur.df", representation(y="vector",
                                 model="character",
                                 lags="integer",
                                 cval="matrix",
                                 res="vector",
                                 teststat="matrix",
                                 testreg="ANY"),
         contains="urca")

setClass("ur.sp", representation(y="vector",
                                 type="character",
                                 polynomial="integer",
                                 signif="numeric",
                                 teststat="numeric",
                                 cval="numeric",
                                 res="vector",
                                 testreg="ANY"),
         contains="urca")

setClass("ur.za", representation(y="vector",
                                 model="character",
                                 lag="integer",
                                 teststat="numeric",
                                 cval="vector",
                                 bpoint="integer",
                                 tstats="vector",
                                 res="vector",
                                 testreg="ANY"),
         contains="urca")

setClassUnion("otherornull", c("ANY", "character", "integer", "matrix", "vector", "NULL")) 

setClass("sumurca", representation(classname="character",
                                   test.name="character",
                                   testreg="ANY",
                                   teststat="otherornull",
                                   cval="otherornull",
                                   bpoint="otherornull",
                                   signif="otherornull",
                                   model="otherornull",
                                   type="otherornull",
                                   auxstat="otherornull",
                                   lag="otherornull",
                                   H="otherornull",
                                   A="otherornull",
                                   lambda="otherornull",
                                   pval="otherornull",
                                   V="otherornull",
                                   W="otherornull",
                                   P="otherornull")
         )
                                   



##
## Functions for unit root tests and cointegration analysis
##

##
## Elliott, Rothenberg & Stock-Test
##
ur.ers <- function(y, type=c("DF-GLS", "P-test"), model=c("constant", "trend"), lag.max=4){
  type <- match.arg(type)
  model <- match.arg(model)
  lag.max <- as.integer(lag.max)
  if(lag.max < 0){
    warning("\nlag.max bust be greater or equal to one and integer; setting lag.max=4")
  lag.max <- 4}
  lag.max <- lag.max+1
  idx <- 2:lag.max
  y <- na.omit(as.vector(y))
  nobs <- length(y)
  if(nobs < 50){
    rowsel <- 1
  }else if(nobs < 100){
    rowsel <- 2
  }else if(nobs <= 200){
    rowsel <- 3
  }else if(nobs > 200){
    rowsel <- 4}
  if(model=="constant"){
    ahat <- 1 - 7.0/nobs
    ya <- c(y[1], y[2:nobs]-ahat*y[1:(nobs-1)])
    za1 <- c(1, rep(1-ahat, nobs-1))
    yd.reg <- summary(lm(ya ~ -1 + za1))
    yd <- y - coef(yd.reg)[1]
  }else if(model=="trend"){
    ahat <- 1 - 13.5/nobs
    ya <- c(y[1], y[2:nobs]-ahat*y[1:(nobs-1)])
    za1 <- c(1, rep(1-ahat, nobs-1))
    trd <- 1:nobs
    za2 <- c(1, trd[2:nobs]-ahat*trd[1:(nobs-1)])
    yd.reg <- summary(lm(ya ~ -1 + za1 + za2))
    yd <- y - coef(yd.reg)[1] - coef(yd.reg)[2]*trd 
  }
  what <- function(x, z=y){
    z.l <-  z[1:(nobs-1)]
    z.diff <- diff(z)
    z.dlags <- embed(diff(z), x)[, -1]
    data.what <- data.frame(cbind(z.diff[-(1:(x-1))], z.l[-(1:(x-1))], z.dlags))
    bic <- BIC(lm(data.what))
    return(bic)
  }
  if(type=="P-test"){
    cvals.ptest <- array(c(1.87, 1.95, 1.91, 1.99, 2.97, 3.11, 3.17, 3.26, 3.91, 4.17, 4.33, 4.48, 4.22, 4.26, 4.05, 3.96, 5.72, 5.64, 5.66, 5.62, 6.77, 6.79, 6.86, 6.89), c(4, 3, 2))
    res <- residuals(yd.reg)
    if(model=="constant"){
      null.res <- c(0, diff(y))
      cvals <- as.matrix(t(cvals.ptest[rowsel, , 1]))
      model <- "with intercept"
    }else if(model=="trend"){
      null.res <- c(0, diff(y))
      null.res <- null.res - mean(null.res)
      cvals <- as.matrix(t(cvals.ptest[rowsel, , 2]))
      model <- "with intercept and trend"
    }
  sig.null <- sum(null.res^2)
  sig.res <- sum(res^2)
  if(lag.max > 1){
    bic <- sapply(idx, what, z=y)
    BIC.opt <- which.min(bic)+1
    y.l <-  y[1:(nobs-1)]
    y.diff <- diff(y)
    y.dlags <- embed(diff(y), BIC.opt)[, -1]
    data.what <- data.frame(cbind(y.diff[-(1:(BIC.opt-1))], y.l[-(1:(BIC.opt-1))], y.dlags))
    what.reg <- summary(lm(data.what))
    npar <- nrow(what.reg$coef)
    sumlc <- sum(what.reg$coef[3:npar,1])
    lag.max <- BIC.opt-1
  }else if(lag.max <= 1){
    y.diff <- diff(y)
    y.l <- y[1:(nobs-1)]
    what.reg <- summary(lm(y.diff ~ y.l))
    sumlc <- 0
    lag.max <- lag.max-1
  }
  what.sq <- what.reg$sigma^2/(1-sumlc)^2
  teststat <- (sig.res - ahat*sig.null)/what.sq
  test.reg <- NULL
  }else if(type=="DF-GLS"){
    if(model=="constant"){
      cvals <- as.matrix(t(c(-2.5658-1.960/nobs-10.04/(nobs**2),-1.9393-0.398/nobs,-1.6156-0.181/nobs)))
      model <- "with intercept"
    }else if(model=="trend"){
      cvals.dfgls.tau <- matrix(-1*c(3.77, 3.58, 3.46, 3.48, 3.19, 3.03, 2.93, 2.89, 2.89, 2.74, 2.64, 2.57), nrow=4, ncol=3)
      cvals <- as.matrix(t(cvals.dfgls.tau[rowsel,]))
      model <- "with intercept and trend"
    }
    yd.l <-  yd[1:(nobs-1)]
    yd.diff <- diff(yd)
    if(lag.max > 1){
      yd.dlags <- embed(diff(yd), lag.max)[, -1]
      data.dfgls <- data.frame(cbind(yd.diff[-(1:(lag.max-1))], yd.l[-(1:(lag.max-1))], yd.dlags))
      colnames(data.dfgls) <- c("yd.diff", "yd.lag", paste("yd.diff.lag", 1:(lag.max-1), sep=""))
      dfgls.form <- formula(paste("yd.diff ~ -1 + ", paste(colnames(data.dfgls)[-1], collapse=" + ")))
    }else if(lag.max <=1){
      data.dfgls <- data.frame(cbind(yd.diff, yd.l))
      colnames(data.dfgls) <- c("yd.diff", "yd.lag")
      dfgls.form <- formula("yd.diff ~ -1 + yd.lag")
    }
    dfgls.reg <- summary(lm(dfgls.form, data=data.dfgls))
    teststat <- coef(dfgls.reg)[1,3]
    test.reg <- dfgls.reg
    lag.max <- lag.max-1
  }
  colnames(cvals) <- c("1%", "5%", "10%")
  rownames(cvals) <- c("critical values")
  new("ur.ers", y=y, yd=yd, type=type, model=model, lag=as.integer(lag.max), cval=round(cvals, 2), teststat=teststat, testreg=test.reg, test.name="Elliot, Rothenberg \& Stock")
}
##
## Johansen Procedure
##
ca.jo <- function(x, type=c("eigen", "trace"), constant=FALSE, K=2, spec=c("longrun", "transitory"), season=NULL, dumvar=NULL, ctable=c("A1", "A2", "A3"))
{
    x <- as.matrix(x)
    colnames(x) <- make.names(colnames(x))
    type <- match.arg(type)
    spec <- match.arg(spec)
    ctable <- match.arg(ctable)
    K <- as.integer(K)
    if (K < 2) {
        stop("\nK must be at least K=2.\n")
    }
    P <- ncol(x)
    arrsel <- P
    N <- nrow(x)
    if (!is.null(season)) {
        s <- season - 1
    } else {
        s <- 0
    }
    if (N * P < P + s * P + K * P^2 + P * (P + 1)/2) 
        stop("\nInsufficient degrees of freedom.\n")
    if (P > 5) 
        warning("\nToo many variables, critical values cannot be computed.\n")
    if (!(is.null(season))) {
        dum <- (diag(season) - 1/season)[, -season]
        dums <- dum
        while (nrow(dums) < N) {
            dums <- rbind(dums, dum)
        }
        dums <- dums[1:N, ]
        if (NA %in% x) {
            idx.NA <- 1:N
            ind <- as.logical(sapply(idx.NA, function(z) sum(is.na(x[z, 
                ]) * 1)))
            ind2 <- ind * (1:N)
            dums <- dums[-ind2, ]
        }
        colnames(dums) <- paste("sd", 1:ncol(dums), sep="")
    }
    if (!(is.null(dumvar))) {
        dumvar <- as.matrix(dumvar)
        colnames(dumvar) <- make.names(colnames(dumvar))
        if (!(nrow(dumvar) == nrow(x))) {
            stop("\nUnequal row length between dummy variables and x matrix.\n")
        }
        if (NA %in% x) {
            idx.NA <- 1:N
            ind <- as.logical(sapply(idx.NA, function(z) sum(is.na(x[z, 
                ]) * 1)))
            ind2 <- ind * (1:N)
            dumvar <- dumvar[-ind2, ]
        }
    }
    x <- na.omit(x)
    N <- nrow(x)
    Z <- embed(diff(x), K)
    Z0 <- Z[, 1:P]
    a1 <- array(c(2.816, 12.099, 18.697, 24.712, 30.774, 3.962, 
        14.036, 20.778, 27.169, 33.178, 6.936, 17.936, 25.521, 
        31.943, 38.341, 2.816, 13.338, 26.791, 43.964, 65.063, 
        3.962, 15.197, 29.509, 47.181, 68.905, 6.936, 19.31, 
        35.397, 53.792, 76.955), c(5, 3, 2))
    a2 <- array(c(6.691, 12.783, 18.959, 24.917, 30.818, 8.083, 
        14.595, 21.279, 27.341, 33.262, 11.576, 18.782, 26.154, 
        32.616, 38.858, 6.691, 15.583, 28.436, 45.248, 65.956, 
        8.083, 17.844, 31.256, 48.419, 69.977, 11.576, 21.962, 
        37.291, 55.551, 77.911), c(5, 3, 2))
    a3 <- array(c(7.563, 13.781, 19.796, 25.611, 31.592, 9.094, 
        15.752, 21.894, 28.167, 34.397, 12.74, 19.834, 26.409, 
        33.121, 39.672, 7.563, 17.957, 32.093, 49.925, 71.472, 
        9.094, 20.168, 35.068, 53.347, 75.328, 12.741, 24.988, 
        40.198, 60.054, 82.969), c(5, 3, 2))
    if (ctable == "A1") {
        cvals <- a1
    } else if (ctable == "A2") {
        cvals <- a2
    } else if (ctable == "A3") {
        cvals <- a3
    }
    if (constant) {
        if (spec == "longrun") {
            ZK <- cbind(x[-c((N - K + 1):N), ], 1)
            Lnotation <- K
          } else if (spec == "transitory") {
            ZK <- cbind(x[-N, ], 1)[K:(N - 1), ]
            Lnotation <- 1
          }
        colnames(ZK) <- c(paste(colnames(x), ".l", Lnotation, sep=""), "constant")
        Z1 <- Z[, -c(1:P)]
        temp1 <- NULL
        for(i in 1:(K-1)){
          temp <- paste(colnames(x), ".dl", i, sep="")
          temp1 <- c(temp1, temp)
        }
        colnames(Z1) <- temp1
        P <- P + 1
        idx <- 0:(P - 2)
        model <- "without linear trend and constant in cointegration"
    } else {
        Z1 <- Z[, -c(1:P)]
        Z1 <- cbind(1, Z1)
        temp1 <- NULL
        for(i in 1:(K-1)){
          temp <- paste(colnames(x), ".dl", i, sep="")
          temp1 <- c(temp1, temp)
        }
        temp1 <- c("constant", temp1)
        colnames(Z1) <- temp1
        if (spec == "longrun") {
            ZK <- x[-c((N - K + 1):N), ]
            Lnotation <- K
          }
        else if (spec == "transitory") {
            ZK <- x[-N, ][K:(N - 1), ]
            Lnotation <- 1
           }
        colnames(ZK) <- paste(colnames(x), ".l", Lnotation, sep="")
        idx <- 0:(P - 1)
        model <- "with linear trend"
      }
    N <- nrow(Z0)
    if (!(is.null(season))) {
      if(constant) {
        Z1 <- cbind(dums[-(1:K), ], Z1)
      } else {
        Z1 <- cbind(Z1[, 1], dums[-(1:K), ], Z1[, -1])
        colnames(Z1) <- c("constant", colnames(Z1)[-1])
      }
    }
    if (!(is.null(dumvar))) {
      if(constant){
        Z1 <- cbind(dumvar[-(1:K), ], Z1)
      } else {
        Z1 <- cbind(Z1[, 1], dumvar[-(1:K), ], Z1[, -1])
        colnames(Z1) <- c("constant", colnames(Z1)[-1])
      }
    }
    M00 <- crossprod(Z0)/N
    M11 <- crossprod(Z1)/N
    MKK <- crossprod(ZK)/N
    M01 <- crossprod(Z0, Z1)/N
    M0K <- crossprod(Z0, ZK)/N
    MK0 <- crossprod(ZK, Z0)/N
    M10 <- crossprod(Z1, Z0)/N
    M1K <- crossprod(Z1, ZK)/N
    MK1 <- crossprod(ZK, Z1)/N
    M11inv <- solve(M11)
    R0 <- Z0 - t(M01 %*% M11inv %*% t(Z1))
    RK <- ZK - t(MK1 %*% M11inv %*% t(Z1))
    S00 <- M00 - M01 %*% M11inv %*% M10
    S0K <- M0K - M01 %*% M11inv %*% M1K
    SK0 <- MK0 - MK1 %*% M11inv %*% M10
    SKK <- MKK - MK1 %*% M11inv %*% M1K
    Ctemp <- chol(SKK, pivot = TRUE)
    pivot <- attr(Ctemp, "pivot")
    oo <- order(pivot)
    C <- t(Ctemp[, oo])
    Cinv <- solve(C)
    S00inv <- solve(S00)
    valeigen <- eigen(Cinv %*% SK0 %*% S00inv %*% S0K %*% t(Cinv))
    lambda <- valeigen$values
    e <- valeigen$vector
    V <- t(Cinv) %*% e
    Vorg <- V
    V <- sapply(1:P, function(x) V[, x]/V[1, x])
    W <- S0K %*% V %*% solve(t(V) %*% SKK %*% V)
    PI <- S0K %*% solve(SKK)
    DELTA <- S00 - S0K %*% V %*% solve(t(V) %*% SKK %*% V) %*% 
        t(V) %*% SK0
    GAMMA <- M01 %*% M11inv - PI %*% MK1 %*% M11inv
    if (type == "trace") {
        type <- "trace statistic"
        teststat <- as.matrix(rev(sapply(idx, function(x) -N * 
            sum(log(1 - lambda[(x + 1):P])))))
        colnames(teststat) <- "trace"
        if (arrsel > 5) {
            cval <- NULL
        }
        else {
            cval <- round(cvals[1:arrsel, , 2], 2)
            colnames(cval) <- c("10%", "5%", "1%")
            rownames(cval) <- c(paste("r <= ", (arrsel - 1):1, 
                " |", sep = ""), "r = 0  |")
        }
    }
    else if (type == "eigen") {
        type <- "maximal eigenvalue statistic (lambda max)"
        teststat <- as.matrix(rev(sapply(idx, function(x) -N * 
            log(1 - lambda[x + 1]))))
        colnames(teststat) <- "lambda max."
        if (arrsel > 5) {
            cval <- NULL
        }
        else {
            cval <- round(cvals[1:arrsel, , 1], 2)
            colnames(cval) <- c("10%", "5%", "1%")
            rownames(cval) <- c(paste("r <= ", (arrsel - 1):1, 
                " |", sep = ""), "r = 0  |")
        }
    }
  
    colnames(V) <- colnames(ZK)
    rownames(V) <- colnames(ZK) 
    rownames(W) <- colnames(x)
    colnames(W) <- colnames(ZK)
    colnames(Vorg) <- colnames(V)
    rownames(Vorg) <- rownames(V)
    rownames(PI) <- colnames(x)
    colnames(PI) <- colnames(W)
    colnames(Z0) <- paste(colnames(x), ".d", sep="")
    colnames(R0) <- paste("R0", colnames(Z0), sep=".")
    colnames(RK) <- paste("RK", colnames(ZK), sep=".")
   
    new("ca.jo", x = x, Z0 = Z0, Z1 = Z1, ZK = ZK, type = type, model = model, const = constant, lag = K, P = arrsel, season = season, dumvar = dumvar, cval = cval, teststat = as.vector(teststat), lambda = lambda, Vorg = Vorg, V = V, W = W, PI = PI, DELTA = DELTA, GAMMA = GAMMA, R0 = R0, RK = RK, bp = NA, test.name = "Johansen-Procedure")  
}
##
## auxiliary function for residuals' diagnostics and tests
##
##
## alphaols
##
alphaols <- function(z, reg.number = NULL) 
{
  if (!(class(z) == "ca.jo")) {
    stop("\nPlease, provide object of class 'ca.jo' as 'z'.\n")
  }
  RKV <- z@RK%*%z@V
  colnames(RKV) <- paste("V", colnames(z@RK), sep=".")
  P <- z@P
  data.mat <- data.frame(z@R0, RKV)
  text <- colnames(data.mat)[-c(1:P)]
  text1 <- paste(text, "", sep = "+", collapse = "")
  text2 <- paste("~", substr(text1, 1, nchar(text1) - 1))
  if (!is.null(reg.number)) {
    reg.number <- as.integer(reg.number)
    if (reg.number > ncol(z@R0) || reg.number < 1) {
      stop("\nPlease, provide a valid number of the regression within \n the VECM, numbering from 1st to last row.\n")
    }
    form1 <- formula(paste("z@R0[, reg.number]", text2, "-1"))
    return(lm(substitute(form1), data = data.mat))
  }
  else if (is.null(reg.number)) {
    form1 <- formula(paste("z@R0", text2, "-1"))
    return(lm(substitute(form1), data = data.mat))
  }
}
##
## alrtest
##
alrtest <- function(z, A, r){
  if(!(class(z)=="ca.jo")){
    stop("\nPlease, provide object of class 'ca.jo' as 'z'.\n")
  }
  r <- as.integer(r)
  A <- as.matrix(A)
  if(!(nrow(A)==z@P)){
    stop("\nRow number of 'A' is unequal to VAR order.\n")
  }
  if(r >= z@P || r<1){
    stop("\nCount of cointegrating relationships is out of allowable range.\n")
  }
  type <- "Estimation and testing under linear restrictions on beta"
  B <- qr.Q(qr(A), complete=TRUE)[,-c(1:ncol(A))]
  N <- nrow(z@Z0)
  M00 <- crossprod(z@Z0)/N
  M11 <- crossprod(z@Z1)/N
  MKK <- crossprod(z@ZK)/N
  M01 <- crossprod(z@Z0, z@Z1)/N
  M0K <- crossprod(z@Z0, z@ZK)/N
  MK0 <- crossprod(z@ZK, z@Z0)/N
  M10 <- crossprod(z@Z1, z@Z0)/N
  M1K <- crossprod(z@Z1, z@ZK)/N
  MK1 <- crossprod(z@ZK, z@Z1)/N
  M11inv <- solve(M11)
  S00 <- M00 - M01%*%M11inv%*%M10
  S0K <- M0K - M01%*%M11inv%*%M1K
  SK0 <- MK0 - MK1%*%M11inv%*%M10
  SKK <- MKK - MK1%*%M11inv%*%M1K
  Sab <- t(A)%*%S00%*%B
  Skb <- t(S0K)%*%B
  Sbb <- t(B)%*%S00%*%B
  Sbbinv <- solve(Sbb)
  RA <- z@R0%*%A - z@R0%*%B%*%Sbbinv%*%t(Sab)
  RK <- z@RK - z@R0%*%B%*%Sbbinv%*%t(Skb)
  Saa.b <- crossprod(RA, RA)/N
  Sak.b <- crossprod(RA, RK)/N
  Ska.b <- crossprod(RK, RA)/N
  Skk.b <- crossprod(RK, RK)/N
  Ctemp <- chol(Skk.b, pivot=TRUE)
  pivot <- attr(Ctemp, "pivot")
  oo <- order(pivot)
  C <- t(Ctemp[,oo])
  Cinv <- solve(C)
  Saa.binv <- solve(Saa.b)
  valeigen <- eigen(Cinv%*%Ska.b%*%Saa.binv%*%Sak.b%*%t(Cinv))
  lambda.res <- valeigen$values
  e <- valeigen$vector
  V <- t(Cinv)%*%e
  V <- as.matrix(V[,1:r])
  Vorg <- V
  idx <- 1:r
  V <- sapply(idx, function(x) V[ , x] / V[1,x])
  PHI <- solve(t(A)%*%A)%*%Sak.b%*%Vorg
  ALPHA <- as.matrix(A%*%PHI)
  ALPHAorg <- ALPHA
  ALPHA <- sapply(idx, function(x) ALPHA[ , x] * Vorg[1,x])
  PI <- ALPHA %*% t(V)
  GAMMA <- M01%*%M11inv - PI%*%MK1%*%M11inv
  DELTA.bb <- Sbb
  DELTA.ab <- Sab - t(A)%*%ALPHA%*%t(V)%*%Skb
  DELTA.aa.b <- Saa.b - t(A)%*%ALPHA%*%t(ALPHA)%*%A
  lambda <- z@lambda
  teststat <- N*sum(log((1-lambda.res[1:r])/(1-lambda[1:r])))
  df <- r*(z@P - ncol(A))
  pval <- c(1-pchisq(teststat, df), df)
  new("cajo.test", Z0=z@Z0, Z1=z@Z1, ZK=z@ZK, const=z@const, H=NULL, A=A, B=B, type=type, teststat=teststat, pval=pval, lambda=lambda.res, Vorg=Vorg, V=V, W=ALPHA, PI=PI, DELTA=NULL, DELTA.bb=DELTA.bb, DELTA.ab=DELTA.ab, DELTA.aa.b=DELTA.aa.b, GAMMA=GAMMA, test.name="Johansen-Procedure")
}
##
## ablrtest
##
ablrtest <- function(z, H, A, r){
    if(!(class(z)=="ca.jo")){
      stop("\nPlease, provide object of class 'ca.jo' as 'z'.\n")
    }
    r <- as.integer(r)
    A <- as.matrix(A)
    H <- as.matrix(H)
    if(!(nrow(A)==z@P)){
      stop("\nRow number of 'A' is unequal to VAR order.\n")
    }
    if(r >= z@P || r<1){
      stop("\nCount of cointegrating relationships is out of allowable range.\n")
    }
    if(z@const==TRUE){
      P <- z@P + 1
    }else{
      P <- z@P
    }
    if(!(nrow(H)==P)){
      stop("\nRow number of 'H' is unequal to VAR order.\n")
    }
    type <- "Estimation and testing under linear restrictions on alpha and beta"
    N <- nrow(z@Z0)
    B <- qr.Q(qr(A), complete=TRUE)[,-c(1:ncol(A))]
    M00 <- crossprod(z@Z0)/N
    M11 <- crossprod(z@Z1)/N
    MKK <- crossprod(z@ZK)/N
    M01 <- crossprod(z@Z0, z@Z1)/N
    M0K <- crossprod(z@Z0, z@ZK)/N
    MK0 <- crossprod(z@ZK, z@Z0)/N
    M10 <- crossprod(z@Z1, z@Z0)/N
    M1K <- crossprod(z@Z1, z@ZK)/N
    MK1 <- crossprod(z@ZK, z@Z1)/N
    M11inv <- solve(M11)
    S00 <- M00 - M01%*%M11inv%*%M10
    S0K <- M0K - M01%*%M11inv%*%M1K
    SK0 <- MK0 - MK1%*%M11inv%*%M10
    SKK <- MKK - MK1%*%M11inv%*%M1K
    Sab <- t(A)%*%S00%*%B
    Skb <- t(S0K)%*%B
    Sbb <- t(B)%*%S00%*%B
    Sbbinv <- solve(Sbb)
    RA <- z@R0%*%A - z@R0%*%B%*%Sbbinv%*%t(Sab)
    RK <- z@RK - z@R0%*%B%*%Sbbinv%*%t(Skb)
    Saa.b <- crossprod(RA, RA)/N
    Sak.b <- crossprod(RA, RK)/N
    Ska.b <- crossprod(RK, RA)/N
    Skk.b <- crossprod(RK, RK)/N
    Ctemp <- chol(t(H)%*%Skk.b%*%H, pivot=TRUE)
    pivot <- attr(Ctemp, "pivot")
    oo <- order(pivot)
    C <- t(Ctemp[,oo])
    Cinv <- solve(C)
    Saa.binv <- solve(Saa.b)
    valeigen <- eigen(Cinv%*%t(H)%*%Ska.b%*%Saa.binv%*%Sak.b%*%H%*%t(Cinv))
    lambda.res <- valeigen$values
    e <- valeigen$vector
    V <- H%*%t(Cinv)%*%e
    Vorg <- V
    idx <- 1:r
    V <- sapply(idx, function(x) V[ , x] / V[1,x])
    PHI <- solve(t(A)%*%A)%*%Sak.b%*%Vorg
    ALPHA <- as.matrix(A%*%PHI)
    ALPHAorg <- ALPHA
    ALPHA <- sapply(idx, function(x) ALPHA[ , x] * Vorg[1,x])
    PI <- ALPHA %*% t(V)
    GAMMA <- M01%*%M11inv - PI%*%MK1%*%M11inv
    DELTA.bb <- Sbb
    DELTA.ab <- Sab - t(A)%*%ALPHA%*%t(V)%*%Skb
    DELTA.aa.b <- Saa.b - t(A)%*%ALPHA%*%t(ALPHA)%*%A
    lambda <- z@lambda
    teststat <- N*sum(log((1-lambda.res[1:r])/(1-lambda[1:r])))
    df <- r*(z@P - ncol(A)) + r*(z@P - ncol(H))
    pval <- c(1-pchisq(teststat, df), df)
    new("cajo.test", Z0=z@Z0, Z1=z@Z1, ZK=z@ZK, const=z@const, H=H, A=A, B=B, type=type, teststat=teststat, pval=pval, lambda=lambda.res, Vorg=Vorg, V=V, W=ALPHA, PI=PI, DELTA=NULL, DELTA.bb=DELTA.bb, DELTA.ab=DELTA.ab, DELTA.aa.b=DELTA.aa.b, GAMMA=GAMMA, test.name="Johansen-Procedure")
}
##
## blrtest
##
blrtest <- function(z, H, r){
  if(!(class(z)=="ca.jo")){
    stop("\nPlease, provide object of class 'ca.jo' as 'z'.\n")
  }
  if(r >= z@P || r < 1){
    stop("\nCount of cointegrating relationships is out of allowable range.\n")
  }
  if(z@const==TRUE){
    P <- z@P + 1
  }else{
    P <- z@P
  }
  r <- as.integer(r)
  H <- as.matrix(H)
  if(!(nrow(H)==P)){
    stop("\nRow number of 'H' is unequal to VAR order.\n")
  }
  type <- "Estimation and testing under linear restrictions on beta"
  N <- nrow(z@Z0)
  M00 <- crossprod(z@Z0)/N
  M11 <- crossprod(z@Z1)/N
  MKK <- crossprod(z@ZK)/N
  M01 <- crossprod(z@Z0, z@Z1)/N
  M0K <- crossprod(z@Z0, z@ZK)/N
  MK0 <- crossprod(z@ZK, z@Z0)/N
  M10 <- crossprod(z@Z1, z@Z0)/N
  M1K <- crossprod(z@Z1, z@ZK)/N
  MK1 <- crossprod(z@ZK, z@Z1)/N
  M11inv <- solve(M11)
  S00 <- M00 - M01%*%M11inv%*%M10
  S0K <- M0K - M01%*%M11inv%*%M1K
  SK0 <- MK0 - MK1%*%M11inv%*%M10
  SKK <- MKK - MK1%*%M11inv%*%M1K
  Ctemp <- chol(t(H)%*%SKK%*%H, pivot=TRUE)
  pivot <- attr(Ctemp, "pivot")
  oo <- order(pivot)
  C <- t(Ctemp[,oo])
  Cinv <- solve(C)
  S00inv <- solve(S00)
  valeigen <- eigen(Cinv%*%t(H)%*%SK0%*%S00inv%*%S0K%*%H%*%t(Cinv))
  e <- valeigen$vector
  V <- H%*%t(Cinv)%*%e
  Vorg <- V
  idx <- ncol(V)
  V <- sapply(1:idx, function(x) V[,x]/V[1,x])
  W <- S0K%*%V%*%solve(t(V)%*%SKK%*%V)
  PI <- W %*% t(V)
  DELTA <- S00 - S0K%*%V%*%solve(t(V)%*%SKK%*%V)%*%t(V)%*%SK0
  GAMMA <- M01%*%M11inv - PI%*%MK1%*%M11inv
  lambda.res <- valeigen$values
  lambda <- z@lambda
  teststat <- N*sum(log((1-lambda.res[1:r])/(1-lambda[1:r])))
  df <- r*(P - ncol(H))
  pval <- c(1-pchisq(teststat, df), df)
  new("cajo.test", Z0=z@Z0, Z1=z@Z1, ZK=z@ZK, const=z@const, H=H, A=NULL, B=NULL, type=type, teststat=teststat, pval=pval, lambda=lambda.res, Vorg=Vorg, V=V, W=W, PI=PI, DELTA=DELTA, DELTA.bb=NULL, DELTA.ab=NULL, DELTA.aa.b=NULL, GAMMA=GAMMA, test.name="Johansen-Procedure")
}
##
## bh5lrtest
##
bh5lrtest <- function (z, H, r) 
{
    if (!(class(z) == "ca.jo")) {
        stop("\nPlease, provide object of class 'ca.jo' as 'z'.\n")
    }
    if (r >= z@P || r < 1) {
        stop("\nCount of cointegrating relationships is out of allowable range.\n")
    }
    if (z@const == TRUE) {
        P <- z@P + 1
    } else {
        P <- z@P
    }
    r <- as.integer(r)
    H <- as.matrix(H)
    if (!(nrow(H) == P)) {
        stop("\nRow number of 'H' is unequal to VAR order.\n")
    }
    if(ncol(H) > r - 1){
      stop("\nToo many columns in H for provided r.\n")
    }
    r1 <- ncol(H)
    r2 <- r - r1
    type <- "Estimation and testing under partly known beta"
    N <- nrow(z@Z0)
    M00 <- crossprod(z@Z0)/N
    M11 <- crossprod(z@Z1)/N
    MKK <- crossprod(z@ZK)/N
    M01 <- crossprod(z@Z0, z@Z1)/N
    M0K <- crossprod(z@Z0, z@ZK)/N
    MK0 <- crossprod(z@ZK, z@Z0)/N
    M10 <- crossprod(z@Z1, z@Z0)/N
    M1K <- crossprod(z@Z1, z@ZK)/N
    MK1 <- crossprod(z@ZK, z@Z1)/N
    M11inv <- solve(M11)
    S00 <- M00 - M01 %*% M11inv %*% M10
    S0K <- M0K - M01 %*% M11inv %*% M1K
    SK0 <- MK0 - MK1 %*% M11inv %*% M10
    SKK <- MKK - MK1 %*% M11inv %*% M1K
    S00.h <- S00 - S0K%*%H%*%solve(t(H)%*%SKK%*%H)%*%t(H)%*%SK0
    S0K.h <- S0K - S0K%*%H%*%solve(t(H)%*%SKK%*%H)%*%t(H)%*%SKK
    SK0.h <- SK0 - SKK%*%H%*%solve(t(H)%*%SKK%*%H)%*%t(H)%*%SK0
    SKK.h <- SKK - SKK%*%H%*%solve(t(H)%*%SKK%*%H)%*%t(H)%*%SKK
    valeigen <- eigen(SKK.h)
    C <- valeigen$vectors[ ,1:(P-r1)]%*%diag(1/sqrt(valeigen$values[1:(P-r1)]))
    valeigen <- eigen(t(C)%*%SK0.h%*%solve(S00.h)%*%S0K.h%*%C)
    PSI <- C%*%valeigen$vectors[,1:r2]
    Dtemp <- chol(t(H)%*%SKK%*%H, pivot = TRUE)
    pivot <- attr(Dtemp, "pivot")
    oo <- order(pivot)
    D <- t(Dtemp[, oo])
    Dinv <- solve(D)
    rho <- eigen(Dinv %*% t(H) %*% SK0 %*% solve(S00) %*% S0K %*% H %*% t(Dinv))
    Vorg <- cbind(H, PSI)
    idx <- ncol(PSI)
    PSI <- sapply(1:idx, function(x) PSI[, x]/PSI[1, x])
    V <- cbind(H, PSI)
    W <- S0K %*% V %*% solve(t(V) %*% SKK %*% V)
    PI <- W %*% t(V)
    DELTA <- S00 - S0K %*% V %*% solve(t(V) %*% SKK %*% V) %*% t(V) %*% SK0
    GAMMA <- M01 %*% M11inv - PI %*% MK1 %*% M11inv
    lambda.res <- valeigen$values
    lambda <- z@lambda
    teststat <- N *(sum(log(1 - rho$values[1:r1])) + sum(log(1-lambda.res[1:r2])) - sum(log(1 - lambda[1:r])))
    df <- (P - r)*r1
    pval <- c(1 - pchisq(teststat, df), df)
    new("cajo.test", Z0 = z@Z0, Z1 = z@Z1, ZK = z@ZK, const = z@const,         H = H, A = NULL, B = NULL, type = type, teststat = teststat, 
        pval = pval, lambda = lambda.res, Vorg = Vorg, V = V, 
        W = W, PI = PI, DELTA = DELTA, DELTA.bb = NULL, DELTA.ab = NULL,       DELTA.aa.b = NULL, GAMMA = GAMMA, test.name = "Johansen-Procedure")
}
##
## bh6lrtest
##
bh6lrtest <- function (z, H, r, r1, conv.val=0.0001, max.iter=50) 
{
    if (!(class(z) == "ca.jo")) {
        stop("\nPlease, provide object of class 'ca.jo' as 'z'.\n")
    }
    if (r >= z@P || r < 1) {
        stop("\nCount of cointegrating relationships is out of allowable range.\n")
    }
    if (z@const == TRUE) {
        P <- z@P + 1
    } else {
        P <- z@P
    }
    r <- as.integer(r)
    H <- as.matrix(H)
    if (!(nrow(H) == P)) {
        stop("\nRow number of 'H' is unequal to VAR order.\n")
    }
    s <- ncol(H)
    r2 <- r - r1
    lambda <- z@lambda
    type <- "Estimation and testing under partly known beta"
    N <- nrow(z@Z0)
    M00 <- crossprod(z@Z0)/N
    M11 <- crossprod(z@Z1)/N
    MKK <- crossprod(z@ZK)/N
    M01 <- crossprod(z@Z0, z@Z1)/N
    M0K <- crossprod(z@Z0, z@ZK)/N
    MK0 <- crossprod(z@ZK, z@Z0)/N
    M10 <- crossprod(z@Z1, z@Z0)/N
    M1K <- crossprod(z@Z1, z@ZK)/N
    MK1 <- crossprod(z@ZK, z@Z1)/N
    M11inv <- solve(M11)
    S00 <- M00 - M01 %*% M11inv %*% M10
    S0K <- M0K - M01 %*% M11inv %*% M1K
    SK0 <- MK0 - MK1 %*% M11inv %*% M10
    SKK <- MKK - MK1 %*% M11inv %*% M1K
    Dtemp <- chol(t(H)%*%SKK%*%H, pivot = TRUE)
    pivot <- attr(Dtemp, "pivot")
    oo <- order(pivot)
    D <- t(Dtemp[, oo])
    Dinv <- solve(D)
    valeigen <- eigen(Dinv %*% t(H) %*% SK0 %*% solve(S00) %*% S0K %*% H %*% t(Dinv))
    beta1 <- H%*%valeigen$vectors[,1:r1]
    i <- 0
    last <- 1
    diff <- 1
    while(diff > conv.val){
      S00.b1 <- S00 - S0K%*%beta1%*%solve(t(beta1)%*%SKK%*%beta1)%*%t(beta1)%*%SK0
      S0K.b1 <- S0K - S0K%*%beta1%*%solve(t(beta1)%*%SKK%*%beta1)%*%t(beta1)%*%SKK
      SK0.b1 <- SK0 - SKK%*%beta1%*%solve(t(beta1)%*%SKK%*%beta1)%*%t(beta1)%*%SK0
      SKK.b1 <- SKK - SKK%*%beta1%*%solve(t(beta1)%*%SKK%*%beta1)%*%t(beta1)%*%SKK
      valeigen <- eigen(SKK.b1)
      C <- valeigen$vectors[ ,1:(P-r1)]%*%diag(1/sqrt(valeigen$values[1:(P-r1)]))
      valeigen <- eigen(t(C)%*%SK0.b1%*%solve(S00.b1)%*%S0K.b1%*%C)
      lambda.res <- valeigen$values
      diff <- t(lambda.res-last)%*%(lambda.res-last)
      last <- lambda.res
      beta2 <- C%*%valeigen$vectors[,1:r2]
      S00.b2 <- S00 - S0K%*%beta2%*%solve(t(beta2)%*%SKK%*%beta2)%*%t(beta2)%*%SK0
      S0K.b2 <- S0K - S0K%*%beta2%*%solve(t(beta2)%*%SKK%*%beta2)%*%t(beta2)%*%SKK
      SK0.b2 <- SK0 - SKK%*%beta2%*%solve(t(beta2)%*%SKK%*%beta2)%*%t(beta2)%*%SK0
      SKK.b2 <- SKK - SKK%*%beta2%*%solve(t(beta2)%*%SKK%*%beta2)%*%t(beta2)%*%SKK
      valeigen <- eigen(t(H)%*%SKK.b2%*%H)
      C <- valeigen$vectors[ ,1:s]%*%diag(1/sqrt(valeigen$values[1:s]))
      valeigen <- eigen(t(C)%*%t(H)%*%SK0.b2%*%solve(S00.b2)%*%S0K.b2%*%H%*%C)
      beta1 <- H%*%valeigen$vectors[,1:r1]
      i <- i + 1
      if(i>max.iter){
        warning("\nNo convergence, used last iterations values.\n")
        break
      }
    }
    Vorg <- cbind(beta1, beta2)
    V <- Vorg
    idx <- ncol(V)
    V <- sapply(1:idx, function(x) V[, x]/V[1, x])
    W <- S0K %*% V %*% solve(t(V) %*% SKK %*% V)
    PI <- W %*% t(V)
    DELTA <- S00 - S0K %*% V %*% solve(t(V) %*% SKK %*% V) %*% t(V) %*% SK0
    GAMMA <- M01 %*% M11inv - PI %*% MK1 %*% M11inv
    Dtemp <- chol(t(beta1)%*%SKK%*%beta1, pivot = TRUE)
    pivot <- attr(Dtemp, "pivot")
    oo <- order(pivot)
    D <- t(Dtemp[, oo])
    Dinv <- solve(D)
    valeigen <- eigen(Dinv %*% t(beta1) %*% SK0 %*% solve(S00) %*% S0K %*% beta1 %*% t(Dinv))
    rho <- valeigen$values
    teststat <- N*(sum(log(1-rho[1:r1])) + sum(log(1-lambda.res[1:r2])) - sum(log(1-lambda[1:r])))
    df <- (P - s - r2)*r1
    pval <- c(1 - pchisq(teststat, df), df)
    new("cajo.test", Z0 = z@Z0, Z1 = z@Z1, ZK = z@ZK, const = z@const, H = H, A = NULL, B = NULL, type = type, teststat = teststat, pval = pval, lambda = lambda.res, Vorg = Vorg, V = V, W = W, PI = PI, DELTA = DELTA, DELTA.bb = NULL, DELTA.ab = NULL, DELTA.aa.b = NULL, GAMMA = GAMMA, test.name = "Johansen-Procedure")
}
##
## cajools
##
cajools <- function(z, reg.number=NULL)
{
  if (!(class(z) == "ca.jo") && !(class(z) == "cajo.test")) {
    stop("\nPlease, provide object of class 'ca.jo' or 'cajo.test' as 'z'.\n")
  }
  P <- z@P
  data.mat <- data.frame(z@Z0, z@Z1, z@ZK)
  text <- colnames(data.mat)[-c(1:P)]
  text1 <- paste(text, "", sep="+", collapse="")
  text2 <- paste("~", substr(text1, 1, nchar(text1)-1))
  if (!is.null(reg.number)) {
    reg.number <- as.integer(reg.number)
    if (reg.number > ncol(z@Z0) || reg.number < 1) {
      stop("\nPlease, provide a valid number of the regression within \n the VECM, numbering from 1st to last row.\n")
    }
    form1 <- formula(paste("z@Z0[, reg.number]", text2, "-1"))
    return(lm(substitute(form1), data=data.mat))
  } else if (is.null(reg.number)) {
    form1 <- formula(paste("z@Z0", text2, "-1"))
    return(lm(substitute(form1), data=data.mat))
  } 
}
##
## cajolst
##
cajolst <- function (x, trend = TRUE, K = 2, season = NULL) 
{
    x <- as.matrix(x)
    K <- as.integer(K)
    if(K < 2){
      stop("\nK must be at least K=2.\n")
    }
    P <- ncol(x)
    arrsel <- P
    N <- nrow(x)
    if (!is.null(season)) {
        s <- season - 1
    }
    else {
        s <- 0
    }
    if (N * P < P + s * P + K * P^2 + P * (P + 1)/2) 
        stop("\nInsufficient degrees of freedom.\n")
    if (P > 5) 
        warning("\nToo many variables, critical values cannot be computed.\n")
    if (!(is.null(season))) {
        dum <- (diag(season) - 1/season)[, -season]
        dums <- dum
        while (nrow(dums) < N) {
            dums <- rbind(dums, dum)
        }
        dums <- dums[1:N, ]
        if (NA %in% x) {
            idx.NA <- 1:N
            ind <- as.logical(sapply(idx.NA, function(z) sum(is.na(x[z, 
                ]) * 1)))
            ind2 <- ind * (1:N)
            dums <- dums[-ind2, ]
        }
    }
    x2 <- na.omit(x)
    Ntot <- nrow(x2)
    y <- embed(x2, (K + 1))
    rhs <- y[, -c(1:P)]
    if (!trend) {
        rhs <- y[, -c(1:P)]
    }
    else {
        trd <- seq(K + 1, nrow(y) + K)
        rhs <- cbind(trd, y[, -c(1:P)])
    }
    N <- nrow(y)
    if (!(is.null(season))) {
        rhs <- cbind(dums[-(1:K), ], rhs)
    }
    lhs <- y[, 1:P]
    idx <- 1:(N - 1)
    tau <- function(t) {
        dt <- c(rep(0, t), rep(1, N - t))
        det(crossprod(resid(lm(lhs ~ dt + rhs))))
    }
    tau.hat <- sapply(idx, tau)
    tau.opt <- which.min(tau.hat) + K
    tau.bp <- tau.opt + 1
    dt <- c(rep(0, tau.opt), rep(1, N - tau.opt))
    if(!trend & is.null(season)){
      rhs.aux <- dt
    } else {
      rhs.aux <- cbind(dt, rhs[, -c((ncol(rhs)-K*ncol(x)+1):ncol(rhs))])
    }
    reg.opt <- lm(lhs ~ rhs.aux)
    dt <- c(rep(0, tau.opt), rep(1, Ntot - tau.opt))
    uv <- c(rep(1, Ntot))
    if (!trend) {
        if (!is.null(season)) {
            yfit <- x - uv%*%t(coef(reg.opt)[1, ]) - dt %*% t(coef(reg.opt)[2, ]) - dums %*% coef(reg.opt)[3:(2 + season - 1), ]
        }else{
            yfit <- x - uv%*%t(coef(reg.opt)[1, ]) - dt %*% t(coef(reg.opt)[2, ])
        }
    }else if (trend){
        trd <- 1:Ntot
        if (!is.null(season)) {
            yfit <- x - uv%*%t(coef(reg.opt)[1, ]) - dt %*% t(coef(reg.opt)[2, ]) - dums %*% coef(reg.opt)[3:(2 + season - 1), ] - trd %*% t(coef(reg.opt)[season + 2, ])
        }else{
            yfit <- x - uv%*%t(coef(reg.opt)[1, ]) - dt %*% t(coef(reg.opt)[2, ]) - trd %*% t(coef(reg.opt)[3, ])
        }
    }
    x <- na.omit(yfit)
    N <- nrow(x)
    spec <- "transitory"
    Z <- embed(diff(x), K)
    Z0 <- Z[, 1:P]
    Z1 <- Z[, -c(1:P)]
    ZK <- x[-N, ][K:(N - 1), ]
    idx <- 0:(P - 1)
    if (trend) {
      cvals <- matrix(c(5.423, 13.784, 25.931, 42.083, 61.918, 6.785, 15.826, 28.455, 45.204, 65.662, 10.042, 19.854, 33.757, 51.601, 73.116), nrow=5, ncol=3)
      model <- "with linear trend in shift correction"
    }else if(!trend){
      cvals <- matrix(c(2.996, 10.446, 21.801, 36.903, 55.952, 4.118, 12.276, 24.282, 40.067, 59.749, 6.888, 16.420, 29.467, 46.305, 67.170), nrow=5, ncol=3)
      model <- "without linear trend in shift correction"
    }
    N <- nrow(Z0)
    M00 <- crossprod(Z0)/N
    M11 <- crossprod(Z1)/N
    MKK <- crossprod(ZK)/N
    M01 <- crossprod(Z0, Z1)/N
    M0K <- crossprod(Z0, ZK)/N
    MK0 <- crossprod(ZK, Z0)/N
    M10 <- crossprod(Z1, Z0)/N
    M1K <- crossprod(Z1, ZK)/N
    MK1 <- crossprod(ZK, Z1)/N
    M11inv <- solve(M11)
    R0 <- Z0 - t(M01 %*% M11inv %*% t(Z1))
    RK <- ZK - t(MK1 %*% M11inv %*% t(Z1))
    S00 <- M00 - M01 %*% M11inv %*% M10
    S0K <- M0K - M01 %*% M11inv %*% M1K
    SK0 <- MK0 - MK1 %*% M11inv %*% M10
    SKK <- MKK - MK1 %*% M11inv %*% M1K
    Ctemp <- chol(SKK, pivot = TRUE)
    pivot <- attr(Ctemp, "pivot")
    oo <- order(pivot)
    C <- t(Ctemp[, oo])
    Cinv <- solve(C)
    S00inv <- solve(S00)
    valeigen <- eigen(Cinv %*% SK0 %*% S00inv %*% S0K %*% t(Cinv))
    lambda <- valeigen$values
    e <- valeigen$vector
    V <- t(Cinv) %*% e
    rownames(V) <- colnames(x)
    Vorg <- V
    V <- sapply(1:P, function(x) V[, x]/V[1, x])
    W <- S0K %*% V %*% solve(t(V) %*% SKK %*% V)
    PI <- S0K %*% solve(SKK)
    DELTA <- S00 - S0K %*% V %*% solve(t(V) %*% SKK %*% V) %*% 
        t(V) %*% SK0
    GAMMA <- M01 %*% M11inv - PI %*% MK1 %*% M11inv
    type <- "trace statistic"
    teststat <- as.matrix(rev(sapply(idx, function(x) N * sum(log(1 + lambda[(x + 1):P])))))
    colnames(teststat) <- "trace"
    if (arrsel > 5) {
      cval <- NULL
    } else {
      cval <- round(cvals[1:arrsel, ], 2)
      colnames(cval) <- c("10%", "5%", "1%")
      rownames(cval) <- c(paste("r <= ", (arrsel - 1):1, " |", sep = ""), "r = 0  |")
    }
    temp1 <- NULL
    for (i in 1:(K - 1)) {
      temp <- paste(colnames(x), ".dl", i, sep = "")
      temp1 <- c(temp1, temp)
    }
    colnames(Z1) <- temp1
    colnames(ZK) <- paste(colnames(x), "l1", sep=".")
    colnames(Z0) <- paste(colnames(x), "d", sep=".")
    colnames(V) <- colnames(ZK)
    rownames(V) <- colnames(ZK)
    colnames(W) <- colnames(V)
    rownames(W) <- colnames(x)
    colnames(Vorg) <- colnames(V)
    rownames(Vorg) <- rownames(V)
    rownames(PI) <- colnames(x)
    colnames(PI) <- colnames(W)
    colnames(R0) <- paste("R0", colnames(Z0), sep = ".")
    colnames(RK) <- paste("RK", colnames(ZK), sep = ".")
    
    new("ca.jo", x = x, Z0 = Z0, Z1 = Z1, ZK = ZK, type = type,         model = model, const = FALSE, lag = K, P = arrsel, 
        season = season, dumvar = NULL, cval = cval, teststat = as.vector(teststat), 
        lambda = lambda, Vorg = Vorg, V = V, W = W, PI = PI, 
        DELTA = DELTA, GAMMA = GAMMA, R0 = R0, RK = RK, bp = tau.bp, 
        test.name = "Johansen-Procedure")
}
##
## lttest
##
lttest <- function(z, r){
  if(!(class(z)=="ca.jo")){
    stop("\nObject 'x' must be of class 'ca.jo'\n")
  }
  r <- as.integer(r)
  if(r >= z@P || r < 1){
    stop("\nProvide number of cointegration vectors in valid range.\n")
  }
  idx <- r + 1
  df <- length(idx:z@P)
  N <- nrow(z@Z0)
  test1 <- ca.jo(z@x, constant=TRUE, K=z@lag, season=z@season, dumvar=z@dumvar)
  lambda1 <- test1@lambda
  test2 <- ca.jo(z@x, constant=FALSE, K=z@lag, season=z@season, dumvar=z@dumvar)
  lambda2 <- test2@lambda
  teststat <- -N*sum(log((1-lambda1[idx:z@P])/(1-lambda2[idx:z@P])))
  pval <- 1 - pchisq(teststat, df)
  lttest <- as.matrix(t(c(teststat, pval)))
  colnames(lttest) <- c("test statistic", "p-value")
  rownames(lttest) <- "LR test"
  cat("LR-test for no linear trend\n")
  cat("\n")
  cat(paste("H0: H*2(r<=", r, ")\n", sep=""))
  cat(paste("H1: H2(r<=", r, ")\n", sep=""))
  cat("\n")
  cat("Test statistic is distributed as chi-square\n")
  cat(paste("with", df, "degress of freedom\n", sep=" "))
  print(round(lttest, 2))
}
##
## plotres
##
plotres <- function (x){
  if (!(class(x) == "ca.jo"))
    stop("\nObject is not of class 'ca.jo' \n")
  resids <- x@Z0 - x@Z1%*%t(x@GAMMA) - x@ZK%*%t(x@PI)
  oldpar <- par(no.readonly = TRUE)
  on.exit(par(oldpar))
  par(mfrow = c(1, 1))
  for (i in 1:x@P) {
    layout(matrix(c(1, 2, 1, 3), 2, 2))
    plot.ts(resids[, i], main = paste("Residuals of ", i, ". VAR regression", sep = ""), ylab = "", xlab = "")
    abline(h = 0, col = "red")
    acf(x@R0[, i], main = "Autocorrelations of Residuals")
    pacf(x@R0[, i], main = "Partial Autocorrelations of Residuals")
    if (interactive()){
      cat("\nType <Return> to continue: ")
      readline()
    }
  }
}
##
## KPSS-Test
##
ur.kpss <- function(y, type=c("mu", "tau"), lags=c("short", "long", "nil"), use.lag=NULL){
  y <- na.omit(as.vector(y))
  n <- length(y)
  type <- match.arg(type)
  lags <- match.arg(lags)
  if(!(is.null(use.lag))){
    lmax <- as.integer(use.lag)
    if(lmax < 0){
      warning("\nuse.lag has to be positive and integer; lags='short' used.")
    lmax <- trunc(4*(n/100)^0.25)}
  }else if(lags == "short"){
    lmax <- trunc(4*(n/100)^0.25)
  }else if(lags == "long"){
    lmax <- trunc(12*(n/100)^0.25)
  }else if(lags == "nil"){
    lmax <- 0
  }
  if(type=="mu"){
    cval <- as.matrix(t(c(0.347, 0.463, 0.574, 0.739)))
    colnames(cval) <- c("10%", "5%", "2.5%", "1%")
    rownames(cval) <- "critical values"
    res <- y - mean(y)
  }else if(type=="tau"){
    cval <- as.matrix(t(c(0.119, 0.146, 0.176, 0.216)))
    colnames(cval) <- c("10%", "5%", "2.5%", "1%")
    rownames(cval) <- "critical values"
    trend <- 1:n
    res <- residuals(lm(y ~ trend))
  }
  S <- cumsum(res)
  nominator <- sum(S^2)/n^2
  s2 <- sum(res^2)/n
  if(lmax == 0){
    denominator <- s2
  }else{
    index <- 1:lmax
    x.cov <- sapply(index, function(x) t(res[-c(1:x)])%*%res[-c((n-x+1):n)])
    bartlett <- 1-index/(lmax+1)
    denominator <- s2 + 2/n*t(bartlett)%*%x.cov
  }
  teststat <- nominator/denominator
  new("ur.kpss", y=y, type=type, lag=as.integer(lmax), teststat=as.numeric(teststat), cval=cval, res=res , test.name="KPSS") 
}
##
## Phillips-Ouliaris Test
##
ca.po <- function(z, demean=c("none", "constant", "trend"), lag=c("short", "long"), type=c("Pu", "Pz"), tol=NULL){
  z <- na.omit(as.matrix(z))
  if(ncol(z)<2 || ncol(z)>6){
    stop("Please provide a matrix with at least two and maximal six columns")}
  demean <- match.arg(demean)
  lag <- match.arg(lag)
  type <- match.arg(type)
  nobs <- nrow(z)
  m <- ncol(z)
  zl <- z[2:nobs,]
  zr <- z[1:(nobs-1),]
  nobs <- nobs-1
  if(lag == "short"){
    lmax <- trunc(4*(nobs/100)^0.25)
  }else if(lag == "long"){
    lmax <- trunc(12*(nobs/100)^0.25)
  }
  if(demean=="none"){
    ari3 <- 1
    model <- "none"
    res <- residuals(lm(zl ~ zr - 1))
    if(type=="Pu"){
      resu <- residuals(lm(z[,1] ~ z[,-1] -1))
      test.reg <- summary(lm(z[,1] ~ z[,-1] -1))
    }else if(type=="Pz"){
      test.reg <- summary(lm(zl ~ zr - 1))}
  }else if(demean=="constant"){
    ari3 <- 2
    model <- "with constant only"
    res <- residuals(lm(zl ~ zr))
    if(type=="Pu"){
      resu <- residuals(lm(z[,1] ~ z[,-1]))
      test.reg <- summary(lm(z[,1] ~ z[,-1]))
    }else if(type=="Pz"){
      test.reg <- summary(lm(zl ~ zr))}
  }else if(demean=="trend"){
    ari3 <- 3
    model <- "with constant and linear trend"
    trd <- 1:nobs
    res <- residuals(lm(zl ~ zr + trd))
    if(type=="Pu"){
      trd <- 1:(nobs+1)
      resu <- residuals(lm(z[,1] ~ z[,-1] + trd))
      test.reg <- summary(lm(z[,1] ~ z[,-1] + trd))
    }else if(type=="Pz"){
      test.reg <- summary(lm(zl ~ zr + trd))}
  }
  xi2 <- 1/nobs*t(res)%*%res
  index <- 1:lmax
  wsl <- 1-index/(lmax+1)
  xi.mat <- sapply(index, function(x){
    wsl[x]*(t(res[-c(1:x),])%*%res[-c((nobs-x+1):nobs),] +  t(res[-c((nobs-x+1):nobs),])%*%res[-c(1:x),])
  })
  xi.mat <- array(xi.mat, c(m, m, lmax))
  smat <- matrix(0, m, m)
  for(i in 1:lmax)
    smat <- smat + xi.mat[,,i]
  omega <- xi2 + 1/nobs*smat
  if(type=="Pz"){
    Mzz <- (1/nobs*t(zl)%*%zl)
    Mzzinv <- solve(Mzz, tol=tol)
    teststat <- nobs*sum(diag(omega%*%Mzzinv))
    cvals <- array(c(20.3933, 26.7022, 33.5359, 39.2826, 44.3725, 25.9711, 32.9392, 40.1220, 46.2691, 51.8614, 38.3413, 46.4097, 55.7341, 63.2149, 69.4939, 27.8536, 33.6955, 39.6949, 45.3308, 50.3537, 33.713, 40.5252, 46.7281, 53.2502, 57.7855, 48.0021, 53.8731, 63.4128, 71.5214, 76.7705, 41.2488, 46.1061, 52.0015, 57.3667, 61.6155, 48.8439, 53.8300, 60.2384, 65.8706, 70.7416, 65.1714, 69.2629, 78.3470, 84.5480, 91.0392)  , c(5, 3, 3))
    cval <- as.matrix(t(cvals[m-1, ,ari3]))
  }else if(type=="Pu"){
    w11 <- omega[1,1]
    w21 <- omega[2:m,1]
    O22 <- omega[-1,-1]
    O22inv <- solve(O22, tol=tol)
    w112 <- w11 - t(w21)%*%O22inv%*%w21
    ssqr <- 1/nobs*sum(resu^2)
    teststat <- as.numeric(nobs*w112/ssqr)
    cvals <- array(c(33.9267, 62.1436, 99.2664, 143.0775, 195.6202, 40.8217, 71.2751, 109.7426, 155.8019, 210.2910, 55.1911, 89.6679, 131.5716, 180.4845, 237.7723, 47.5877, 80.2034, 120.3035, 168.8572, 225.2303, 55.2202, 89.7619, 132.2207, 182.0749, 241.3316, 71.9273, 109.4525, 153.4504, 209.8054, 270.5018, 71.9586, 113.4929, 163.1050, 219.5098, 284.0100, 81.3812, 124.3933, 175.9902, 234.2865, 301.0949, 102.0167, 145.8644, 201.0905, 264.4988, 335.9054), c(5, 3, 3))
    cval <- as.matrix(t(cvals[m-1, ,ari3]))
    res <- as.matrix(resu)
  }
  colnames(cval) <- c("10\%", "5\%", "1\%")
  rownames(cval) <- "critical values"
  new("ca.po", z=z, type=type, model=model, lag=as.integer(lmax), cval=cval, res=res, teststat=teststat, testreg=test.reg, test.name="Phillips \& Ouliaris")
}
##
## Augmented-Dickey-Fuller Test
##
ur.df <- function (y, type = c("none", "drift", "trend"), lags = 1) 
{
    if (ncol(as.matrix(y)) > 1) 
        stop("\ny is not a vector or univariate time series.\n")
    if (any(is.na(y))) 
        stop("\nNAs in y.\n")
    y <- as.vector(y)
    lag <- as.integer(lags)
    if (lag < 0) 
        stop("\nLags must be set to an non negative integer value.\n")
    CALL <- match.call()
    DNAME <- deparse(substitute(y))
    type <- type[1]
    x.name <- deparse(substitute(y))
    lags <- lags + 1
    z <- diff(y)
    n <- length(z)
    x <- embed(z, lags)
    z.diff <- x[, 1]
    z.lag.1 <- y[lags:n]
    tt <- lags:n
    if (lags > 1) {
        z.diff.lag = x[, 2:lags]
        if (type == "none") {
            result <- lm(z.diff ~ z.lag.1 - 1 + z.diff.lag)
            tau <- coef(summary(result))[1, 3]
            teststat <- as.matrix(tau)
            colnames(teststat) <- 'tau1'
          }
        if (type == "drift") {
            result <- lm(z.diff ~ z.lag.1 + 1 + z.diff.lag)
            tau <- coef(summary(result))[2, 3]
            phi1.reg <- lm(z.diff ~ -1 + z.diff.lag)
            phi1 <- anova(phi1.reg, result)$F[2]
            teststat <- as.matrix(t(c(tau, phi1)))
            colnames(teststat) <- c('tau2', 'phi1')
          }
        if (type == "trend") {
            result <- lm(z.diff ~ z.lag.1 + 1 + tt + z.diff.lag)
            tau <- coef(summary(result))[2, 3]
            phi2.reg <- lm(z.diff ~ -1 + z.diff.lag)
            phi3.reg <- lm(z.diff ~ z.diff.lag)
            phi2 <- anova(phi2.reg, result)$F[2]
            phi3 <- anova(phi3.reg, result)$F[2]
            teststat <- as.matrix(t(c(tau, phi2, phi3)))
            colnames(teststat) <- c('tau3', 'phi2', 'phi3')
          }
    }
    else {
        if (type == "none") {
            result <- lm(z.diff ~ z.lag.1 - 1)
            tau <- coef(summary(result))[1, 3]
            teststat <- as.matrix(tau)
            colnames(teststat) <- 'tau1'
        }
        if (type == "drift") {
            result <- lm(z.diff ~ z.lag.1 + 1)
            phi1.reg <- lm(z.diff ~ -1)
            phi1 <- anova(phi1.reg, result)$F[2]
            tau <- coef(summary(result))[2, 3]
            teststat <- as.matrix(t(c(tau, phi1)))
            colnames(teststat) <- c('tau2', 'phi1')
        }
        if (type == "trend") {
            result <- lm(z.diff ~ z.lag.1 + 1 + tt)
            phi2.reg <- lm(z.diff ~ -1)
            phi3.reg <- lm(z.diff ~ 1)
            phi2 <- anova(phi2.reg, result)$F[2]
            phi3 <- anova(phi3.reg, result)$F[2]
            tau <- coef(summary(result))[2, 3]
            teststat <- as.matrix(t(c(tau, phi2, phi3)))
            colnames(teststat) <- c('tau3', 'phi2', 'phi3')
        }
    }
    rownames(teststat) <- 'statistic'
    testreg <- summary(result)
    res <- residuals(testreg)
    if(n < 25)
      rowselec <- 1
    if(25 <= n & n < 50)
      rowselec <- 2
    if(50 <= n & n < 100)
      rowselec <- 3
    if(100 <= n & n < 250)
      rowselec <- 4
    if(250 <= n & n < 500)
      rowselec <- 5
    if(n > 500)
      rowselec <- 6
    if (type == "none"){ 
        cval.tau1 <- rbind(
                           c(-2.66, -1.95, -1.60),
                           c(-2.62, -1.95, -1.61),
                           c(-2.60, -1.95, -1.61),
                           c(-2.58, -1.95, -1.62),
                           c(-2.58, -1.95, -1.62),
                           c(-2.58, -1.95, -1.62))
        cvals <- t(cval.tau1[rowselec, ])
        testnames <- 'tau1'
      }
    if (type == "drift"){ 
        cval.tau2 <- rbind(
                           c(-3.75, -3.00, -2.63),
                           c(-3.58, -2.93, -2.60),
                           c(-3.51, -2.89, -2.58),
                           c(-3.46, -2.88, -2.57),
                           c(-3.44, -2.87, -2.57),
                           c(-3.43, -2.86, -2.57))
        cval.phi1 <- rbind(
                           c(7.88, 5.18, 4.12),
                           c(7.06, 4.86, 3.94),
                           c(6.70, 4.71, 3.86),
                           c(6.52, 4.63, 3.81),
                           c(6.47, 4.61, 3.79),
                           c(6.43, 4.59, 3.78))
        cvals <- rbind(
                      cval.tau2[rowselec, ],
                      cval.phi1[rowselec, ])
        testnames <- c('tau2', 'phi1')
      }
    if (type == "trend"){ 
        cval.tau3 <- rbind(
                           c(-4.38, -3.60, -3.24),
                           c(-4.15, -3.50, -3.18),
                           c(-4.04, -3.45, -3.15),
                           c(-3.99, -3.43, -3.13),
                           c(-3.98, -3.42, -3.13),
                           c(-3.96, -3.41, -3.12))
        cval.phi2 <- rbind(
                           c(8.21, 5.68, 4.67),
                           c(7.02, 5.13, 4.31),
                           c(6.50, 4.88, 4.16),
                           c(6.22, 4.75, 4.07),
                           c(6.15, 4.71, 4.05),
                           c(6.09, 4.68, 4.03))
        cval.phi3 <- rbind(
                           c(10.61, 7.24, 5.91),
                           c( 9.31, 6.73, 5.61),
                           c( 8.73, 6.49, 5.47),
                           c( 8.43, 6.49, 5.47),
                           c( 8.34, 6.30, 5.36),
                           c( 8.27, 6.25, 5.34))  
        cvals <- rbind(
                      cval.tau3[rowselec, ],
                      cval.phi2[rowselec, ],
                      cval.phi3[rowselec, ])

        testnames <- c('tau3', 'phi2', 'phi3')
      }
    colnames(cvals) <- c('1%', '5%', '10%')
    rownames(cvals) <- testnames
   
    new("ur.df", y = y, model = type, cval=cvals, lags=lag, teststat = teststat, testreg=testreg, res=res, test.name="Augmented Dickey-Fuller Test")
}
##
## Phillips-Perron Test
##
ur.pp <- function(x, type=c("Z-alpha", "Z-tau"), model=c("constant", "trend"), lags=c("short", "long"), use.lag=NULL){
  x <- na.omit(as.vector(x))
  n <- length(x)
  y <- x[-1]
  y.l1 <- x[-n]
  n <- n-1
  lags <- match.arg(lags)
  model <- match.arg(model)
  type <- match.arg(type)
  if(!(is.null(use.lag))){
    lmax <- as.integer(use.lag)
    if(lmax < 0){
      warning("\nuse.lag has to be positive and integer; lags='short' used.")
      lmax <- trunc(4*(n/100)^0.25)}
  }else if(lags == "short"){
    lmax <- trunc(4*(n/100)^0.25)
  }else if(lags == "long"){
    lmax <- trunc(12*(n/100)^0.25)}
  if(model=="trend"){
    cval <- as.matrix(t(c(-3.9638-8.353/n-47.44/(n^2), -3.4126-4.039/n-17.83/(n^2), -3.1279-2.418/n-7.58/(n^2))))
    colnames(cval) <- c("1%", "5%", "10%")
    rownames(cval) <- "critical values"
    model <- "with intercept and trend"
    trend <- (1:n) - n/2
    test.reg <- summary(lm(y ~ y.l1 + trend))
    res <- residuals(test.reg)
    my.tstat <- coef(test.reg)[1, 3]
    beta.tstat <- coef(test.reg)[3, 3]
    res <- residuals(test.reg)
    s <- 1/n*(sum(res^2))
    myybar <- (1/n^2)*sum((y-mean(y))^2)
    myy <- (1/n^2)*sum(y^2)
    mty <- (n^(-5/2))*(t(1:n)%*%y)
    my <- (n^(-3/2))*sum(y)
    idx <- 1:lmax
    coprods <- sapply(idx, function(l) t(res[-c(1:l)])%*%(res[-c((n-l+1):n)]))
    weights <- 1 - idx/(lmax+1)
    sig <- s + (2/n)*(t(weights)%*%coprods)
    lambda <- 0.5*(sig-s)
    lambda.prime <- lambda/sig
    M <- (1-n^(-2))*myy - 12*mty^2 + 12*(1 + 1/n)*mty*my - (4 + 6/n + 2/n^2)*my^2
    my.stat <- sqrt(s/sig)*my.tstat - lambda.prime*sqrt(sig)*my/(sqrt(M)*sqrt((M+my^2)))
    beta.stat <- sqrt(s/sig)*beta.tstat - lambda.prime*sqrt(sig)*(0.5*my - mty)/(sqrt(M/12)*sqrt(myybar))
    aux.stat <- as.matrix(c(round(my.stat, 4), round(beta.stat, 4)))
    rownames(aux.stat) <- c("Z-tau-mu", "Z-tau-beta")
    colnames(aux.stat) <- "aux. Z statistics"
    if(type=="Z-tau"){
      tstat <- (coef(test.reg)[2, 1] - 1)/coef(test.reg)[2, 2]
      teststat <- sqrt(s/sig)*tstat-lambda.prime*sqrt(sig)/sqrt(M)
    }else if(type=="Z-alpha"){
      alpha <- coef(test.reg)[2, 1]
      teststat <- n*(alpha-1)-lambda/M
    }
  }else if(model=="constant"){
    cval <- as.matrix(t(c(-3.4335-5.999/n-29.25/(n^2), -2.8621-2.738/n-8.36/(n^2), -2.5671-1.438/n-4.48/(n^2))))
    colnames(cval) <- c("1%", "5%", "10%")
    rownames(cval) <- "critical values"
    model <- "with intercept"
    test.reg <- summary(lm(y ~ y.l1))
    my.tstat <- coef(test.reg)[1, 3]
    res <- residuals(test.reg)
    s <- 1/n*(sum(res^2))
    myybar <- (1/n^2)*sum((y-mean(y))^2)
    myy <- (1/n^2)*sum(y^2)
    my <- (n^(-3/2))*sum(y)
    idx <- 1:lmax
    coprods <- sapply(idx, function(l) t(res[-c(1:l)])%*%(res[-c((n-l+1):n)]))
    weights <- 1 - idx/(lmax+1)
    sig <- s + (2/n)*(t(weights)%*%coprods)
    lambda <- 0.5*(sig-s)
    lambda.prime <- lambda/sig
    my.stat <- sqrt(s/sig)*my.tstat + lambda.prime*sqrt(sig)*my/(sqrt(myy)*sqrt(myybar))
    aux.stat <- as.matrix(round(my.stat, 4))
    rownames(aux.stat) <- "Z-tau-mu"
    colnames(aux.stat) <- "aux. Z statistics"
    if(type=="Z-tau"){
      tstat <- (coef(test.reg)[2, 1] - 1)/coef(test.reg)[2, 2]
      teststat <- sqrt(s/sig)*tstat-lambda.prime*sqrt(sig)/sqrt(myybar)
    }else if(type=="Z-alpha"){
      alpha <- coef(test.reg)[2, 1]
      teststat <- n*(alpha-1)-lambda/myybar
    }
  }
  new("ur.pp", y=y, type=type, model=model, lag=as.integer(lmax), cval=cval, teststat=as.numeric(teststat), testreg=test.reg, auxstat=aux.stat, res=res, test.name="Phillips-Perron")
}
##
## Schmidt-Phillips Test
##
ur.sp <- function(y, type=c("tau", "rho"), pol.deg=c(1, 2, 3, 4), signif=c(0.01, 0.05, 0.1)){
  y <- na.omit(as.vector(y))
  type <- match.arg(type)
  signif <- signif[1]
  signif.val <- c(0.01, 0.05, 0.1)
  if(!(signif %in% signif.val)){
    warning("\nPlease, provide as signif one of c(0.01, 0.05, 0.1); signif=0.01 used")
  signif <- 0.01}
  pol.deg <- pol.deg[1]
  if(!(pol.deg %in% c(1:4))){
    warning("\nPlease, provide as polynomial degree one of c(1, 2, 3, 4); po.deg=1 used")
  pol.deg <- 1}
  n <- length(y)
  lag <- trunc(12*(n/100)^0.25)
  idx <- 1:lag
  trend1 <- 1:n
  y.diff <- diff(y)
  if(pol.deg==1){
    yi.hat <- (y[n]-y[1])/(n-1)
    phi.y <- y[1]-yi.hat
    S.hat <- y - phi.y - yi.hat*trend1
    S.hat.l1 <- S.hat[-n]
    test.reg <- summary(lm(y.diff ~ 1 + S.hat.l1))
    sp.data <- data.frame(cbind(y[2:n],  y[1:(n-1)], trend1[2:n]))
    colnames(sp.data) <- c("y", "y.lagged", "trend.exp1")
    corr.reg <- summary(lm(sp.data))
    res <- residuals(corr.reg)
    sig.eps <- (1/n)*sum(res^2)
    coprods <- sapply(idx, function(x) t(res[-c(1:x)])%*%(res[-c((n-x):(n-1))]))
    weights <- (2*(lag-idx)/lag)^2
    sig <- sig.eps + (2/n)*(t(weights)%*%coprods)
    omega2.hat <- sig.eps/sig
  }else if(pol.deg==2){
    trend2 <- trend1^2
    S.hat <- c(0, cumsum(residuals(summary(lm(y.diff ~ trend1[2:n])))))
    test.reg <- summary(lm(y.diff ~ S.hat[-n] + trend1[2:n]))
    sp.data <- data.frame(cbind(y[2:n],  y[1:(n-1)], trend1[2:n], trend2[2:n]))
    colnames(sp.data) <- c("y", "y.lagged", "trend.exp1", "trend.exp2")
    corr.reg <- summary(lm(sp.data))
    res <- residuals(corr.reg)
    sig.eps <- (1/n)*sum(res^2)
    coprods <- sapply(idx, function(x) t(res[-c(1:x)])%*%(res[-c((n-x):(n-1))]))
    weights <- (2*(lag-idx)/lag)^2
    sig <- sig.eps + (2/n)*(t(weights)%*%coprods)
    omega2.hat <- sig.eps/sig
  }else if(pol.deg==3){
    trend2 <- trend1^2
    trend3 <- trend1^3    
    S.hat <- c(0, cumsum(residuals(summary(lm(y.diff ~ trend1[2:n] + trend2[2:n])))))
    test.reg <- summary(lm(y.diff ~ S.hat[-n] + trend1[2:n] + trend2[2:n]))
    sp.data <- data.frame(cbind(y[2:n],  y[1:(n-1)], trend1[2:n], trend2[2:n], trend3[2:n]))
    colnames(sp.data) <- c("y", "y.lagged", "trend.exp1", "trend.exp2", "trend.exp3")
    corr.reg <- summary(lm(sp.data))
    res <- residuals(corr.reg)
    sig.eps <- (1/n)*sum(res^2)
    coprods <- sapply(idx, function(x) t(res[-c(1:x)])%*%(res[-c((n-x):(n-1))]))
    weights <- (2*(lag-idx)/lag)^2
    sig <- sig.eps + (2/n)*(t(weights)%*%coprods)
    omega2.hat <- sig.eps/sig
  }else if(pol.deg==4){
    trend2 <- trend1^2
    trend3 <- trend1^3
    trend4 <- trend1^4
    S.hat <- c(0, cumsum(residuals(summary(lm(y.diff ~ trend1[2:n] + trend2[2:n] + trend3[2:n])))))
    test.reg <- summary(lm(y.diff ~ S.hat[-n] + trend1[2:n] + trend2[2:n] + trend3[2:n]))
    sp.data <- data.frame(cbind(y[2:n],  y[1:(n-1)], trend1[2:n], trend2[2:n], trend3[2:n], trend4[2:n]))
    colnames(sp.data) <- c("y", "y.lagged", "trend.exp1", "trend.exp2", "trend.exp3", "trend.exp4")
    corr.reg <- summary(lm(sp.data))
    res <- residuals(corr.reg)
    sig.eps <- (1/n)*sum(res^2)
    coprods <- sapply(idx, function(x) t(res[-c(1:x)])%*%(res[-c((n-x):(n-1))]))
    weights <- (2*(lag-idx)/lag)^2
    sig <- sig.eps + (2/n)*(t(weights)%*%coprods)
    omega2.hat <- sig.eps/sig
  }
  if(type=="rho"){
    rho <- n*coef(test.reg)[2,1]
    teststat <- rho/omega2.hat
    cval <- .spcv(obs=n, type="rho", pol.deg=pol.deg, signif=signif)
  }else if(type=="tau"){
    tau <- coef(test.reg)[2,3]
    teststat <- tau/sqrt(omega2.hat)
    cval <- .spcv(obs=n, type="tau", pol.deg=pol.deg, signif=signif)
  }
  new("ur.sp", y=y, type=type, polynomial=as.integer(pol.deg), teststat=as.numeric(teststat), cval=cval, signif=signif, res=res, testreg=corr.reg, test.name="Schmidt-Phillips")
}
##
## Function for critical values of ur.sp
##
.spcv <- function(obs, type, pol.deg, signif){
  obs.ranges <- c(25, 50, 100, 200, 500, 1000, 1e30)
  dim.1 <- which(obs.ranges >= obs, arr.ind=TRUE)[1]
  signif.val <- c(0.01, 0.05, 0.1)
  dim.2 <- which(signif==signif.val, arr.ind=TRUE)
  dim.3 <- pol.deg
  if(type=="tau"){
  cvs.tau <- -1*c(3.9, 3.73, 3.63, 3.61, 3.59, 3.58, 3.56, 3.18, 3.11, 3.06, 3.04, 3.04, 3.02, 3.02, 2.85, 2.8, 2.77, 2.76, 2.76, 2.75, 2.75, 4.52, 4.28, 4.16, 4.12, 4.08, 4.06, 4.06, 3.78, 3.77, 3.65, 3.6, 3.55, 3.55, 3.53, 3.52, 3.41, 3.34, 3.31, 3.28, 3.26, 3.26, 3.26, 5.07, 4.73, 4.59, 4.53, 4.5, 4.49, 4.44, 4.26, 4.08, 4.03, 3.99, 3.96, 3.95, 3.93, 3.89, 3.77, 3.72, 3.69, 3.68, 3.68, 3.67, 5.57, 5.13, 4.99, 4.9, 4.85, 4.83, 4.81, 4.7, 4.47, 4.39, 4.33, 4.31, 4.31, 4.29, 4.3, 4.15, 4.1, 4.06, 4.03, 4.03, 4.01)
  cv.array <- array(cvs.tau, dim=c(7, 3, 4), dimnames=c("obs", "signif", "pol.deg"))
  cval <- cv.array[dim.1, dim.2, dim.3]
}else if(type=="rho"){
    cvs.rho <- -1*c(20.4, 22.8, 23.8, 24.8, 25.3, 25.3, 25.2, 15.7, 17.0, 17.5, 17.9, 18.1, 18.1, 18.1, 13.4, 14.3, 14.6, 14.9, 15.0, 15.0, 15.0, 24.6, 28.4, 30.4, 31.8, 32.4, 32.5, 32.6, 20.1, 22.4, 23.7, 24.2, 24.8, 24.6, 24.7, 17.8, 19.5, 20.4, 20.7, 21.0, 21.1, 21.1, 28.1, 33.1, 36.3, 38.0, 39.1, 39.5, 39.7, 23.8, 27.0, 29.1, 30.1, 30.6, 30.8, 30.6, 21.5, 24.0, 25.4, 26.1, 26.6, 26.7, 26.7, 31.0, 37.4, 41.8, 44.0, 45.3, 45.7, 45.8, 26.9, 31.2, 34.0, 35.2, 36.2, 36.6, 36.4, 24.7,28.1, 30.2, 31.2, 31.8, 32.0, 31.9)
  cv.array <- array(cvs.rho, dim=c(7, 3, 4), dimnames=c("obs", "signif", "pol.deg"))
  cval <- cv.array[dim.1, dim.2, dim.3]}
  return(cval)
}
##
## Zivot-Andrews Test
##
ur.za <- function(y, model=c("intercept", "trend", "both"), lag=NULL){
  y <- na.omit(as.vector(y))
  n <- length(y)
  model <- match.arg(model)
  if(is.null(lag)) lag <- 0
  lag <- as.integer(lag)
  if(length(lag) > 1 || lag < 0){
    warning("\nPlease, specify maximal number of lags for differenced series as positive integer; lag=1 is now used.")
    lag <- 1}
  datmat <- matrix(NA, n, lag + 3)
  if(n < ncol(datmat) + 2){
    stop("\nInsufficient number of obeservations.")}
  idx <- 1:(n-1)
  trend <- seq(1, n)
  datmat[,1] <- y
  datmat[,2] <- c(NA, y)[1:n]
  datmat[,3] <- trend
  datmat <- as.data.frame(datmat)
  colnames(datmat)[1:3] <- c("y", "y.l1", "trend")
  if(lag > 0){
    for(i in 1:lag){
      datmat[ , i + 3] <- c(rep(NA, i + 1), diff(y))[1:n]
    }
  colnames(datmat) <- c("y", "y.l1", "trend", paste("y.dl", 1:lag, sep=""))
  }
  if(model=="intercept"){
    roll <- function(z){
      du <- c(rep(0, z), rep(1, (n-z)))
      rollmat <- cbind(datmat, du)
      roll.reg <- coef(summary(lm(rollmat)))
      (roll.reg[2,1]-1.0)/roll.reg[2,2]
    }
    roll.stat <- sapply(idx, roll)
    cval <- c(-5.34, -4.8, -4.58)
    bpoint <- which.min(roll.stat)
    du <- c(rep(0, bpoint), rep(1, (n-bpoint)))
    testmat <- cbind(datmat, du)
    test.reg <- summary(lm(testmat)) 
  }else if(model=="trend"){
    roll <- function(z){
      dt <- c(rep(0, z), 1:(n-z))
      rollmat <- cbind(datmat, dt)
      roll.reg <- coef(summary(lm(rollmat)))
      (roll.reg[2,1]-1.0)/roll.reg[2,2]
    }
    roll.stat <- sapply(idx, roll)
    cval <- c(-4.93, -4.42, -4.11)
    bpoint <- which.min(roll.stat)
    dt <- c(rep(0, bpoint), 1:(n-bpoint))
    testmat <- cbind(datmat, dt)
    test.reg <- summary(lm(testmat)) 
  }else if(model=="both"){
    test.reg <- summary(lm(datmat))
    roll <- function(z){
      du <- c(rep(0, z), rep(1, (n-z)))
      dt <- c(rep(0, z), 1:(n-z))
      rollmat <- cbind(datmat, du, dt)
      roll.reg <- coef(summary(lm(rollmat)))
      (roll.reg[2,1]-1.0)/roll.reg[2,2]
    }
    roll.stat <- sapply(idx, roll)
    cval <- c(-5.57, -5.08, -4.82)
    bpoint <- which.min(roll.stat)
    du <- c(rep(0, bpoint), rep(1, (n-bpoint)))
    dt <- c(rep(0, bpoint), 1:(n-bpoint))
    testmat <- cbind(datmat, du, dt)
    test.reg <- summary(lm(testmat)) 
  }
  teststat <- roll.stat[bpoint]
  new("ur.za", y=y, model=model, lag=lag, teststat=teststat, cval=cval, bpoint=bpoint, tstats=roll.stat, res=test.reg$residuals, testreg=test.reg, test.name="Zivot-Andrews")
}
##
## Setting methods for classes
##
show.urca <- function(object){
  title <- paste("#", object@test.name, "Unit Root / Cointegration Test #", sep=" ")
  row <- paste(rep("#", nchar(title)), collapse="")
  cat("\n")
  cat(row, "\n")
  cat(title, "\n")
  cat(row, "\n")
  cat("\n")
  cat("The value of the test statistic is:", round(object@teststat, 4), "\n")
  cat('\n')
}

setMethod("show", "ur.kpss", show.urca)
setMethod("show", "ca.jo", show.urca)
setMethod("show", "cajo.test", show.urca)
setMethod("show", "ca.po", show.urca)
setMethod("show", "ur.pp", show.urca)
setMethod("show", "ur.df", show.urca)
setMethod("show", "ur.sp", show.urca)
setMethod("show", "ur.za", show.urca)
setMethod("show", "ur.ers", show.urca)

setMethod("summary", "ur.ers", function(object){
  return(new("sumurca", classname="ur.ers", test.name=object@test.name, testreg=object@testreg, teststat=object@teststat, cval=object@cval, bpoint=NULL, signif=NULL, model=object@model, type=object@type, auxstat=NULL, lag=NULL, H=NULL, A=NULL, lambda=NULL, pval=NULL, V=NULL, W=NULL, P=NULL))  
})

setMethod("summary", "ca.jo", function(object){
  return(new("sumurca", classname="ca.jo", test.name=object@test.name, testreg=NULL, teststat=object@teststat, cval=object@cval, bpoint=NULL, signif=NULL, model=object@model, type=object@type, auxstat=NULL, lag=NULL, H=NULL, A=NULL, lambda=object@lambda, pval=NULL, V=object@V, W=object@W, P=object@P))
})

setMethod("summary", "cajo.test", function(object){
  return(new("sumurca", classname="cajo.test", test.name=object@test.name, testreg=NULL, teststat=object@teststat, cval=NULL, bpoint=NULL, signif=NULL, model=NULL, type=object@type, auxstat=NULL, lag=NULL, H=object@H, A=object@A, lambda=object@lambda, pval=object@pval, V=object@V, W=object@W, P=NULL))
})

setMethod("summary", "ur.kpss", function(object){
  return(new("sumurca", classname="ur.kpss", test.name=object@test.name, testreg=NULL, teststat=object@teststat, cval=object@cval, bpoint=NULL, signif=NULL, model=NULL, type=object@type, auxstat=NULL, lag=object@lag, H=NULL, A=NULL, lambda=NULL, pval=NULL, V=NULL, W=NULL, P=NULL))
})

setMethod("summary", "ca.po", function(object){
  return(new("sumurca", classname="ca.po", test.name=object@test.name, testreg=object@testreg, teststat=object@teststat, cval=object@cval, bpoint=NULL, signif=NULL, model=object@model, type=object@type, auxstat=NULL, lag=NULL, H=NULL, A=NULL, lambda=NULL, pval=NULL, V=NULL, W=NULL, P=NULL))
})

setMethod("summary", "ur.pp", function(object){
  return(new("sumurca", classname="ur.pp", test.name=object@test.name, testreg=object@testreg, teststat=object@teststat, cval=object@cval, bpoint=NULL, signif=NULL, model=object@model, type=object@type, auxstat=object@auxstat, lag=NULL, H=NULL, A=NULL, lambda=NULL, pval=NULL, V=NULL, W=NULL, P=NULL))
})

setMethod("summary", "ur.df", function(object){
  return(new("sumurca", classname="ur.df", test.name=object@test.name, testreg=object@testreg, teststat=object@teststat, cval=object@cval, bpoint=NULL, signif=NULL, model=object@model, type=NULL, auxstat=NULL, lag=NULL, H=NULL, A=NULL, lambda=NULL, pval=NULL, V=NULL, W=NULL, P=NULL))
})

setMethod("summary", "ur.sp", function(object){
  return(new("sumurca", classname="ur.sp", test.name=object@test.name, testreg=object@testreg, teststat=object@teststat, cval=object@cval, bpoint=NULL, signif=object@signif, model=NULL, type=NULL, auxstat=NULL, lag=NULL, H=NULL, A=NULL, lambda=NULL, pval=NULL, V=NULL, W=NULL, P=NULL))
})

setMethod("summary", "ur.za", function(object){
  return(new("sumurca", classname="ur.za", test.name=object@test.name, testreg=object@testreg, teststat=object@teststat, cval=object@cval, bpoint=object@bpoint, signif=NULL, model=NULL, type=NULL, auxstat=NULL, lag=NULL, H=NULL, A=NULL, lambda=NULL, pval=NULL, V=NULL, W=NULL, P=NULL))
})

setMethod("show", "sumurca", function(object){
  if(object@classname=="ur.za"){
    title <- paste("#", object@test.name, "Unit Root Test #", sep=" ")
    row <- paste(rep("#", nchar(title)), collapse="")
    cat("\n")
    cat(row, "\n")
    cat(title, "\n")
    cat(row, "\n")
    cat("\n")
    print(object@testreg)
    cat('\n')
    cat('Teststatistic:', round(object@teststat, 4), '\n')
    cat('Critical values: 0.01=', object@cval[1], '0.05=', object@cval[2], '0.1=', object@cval[3], '\n')
    cat('\n')
    cat('Potential break point at position:', object@bpoint, '\n')
    cat('\n')
    invisible(object)
  }else if(object@classname=="ur.sp"){
    title <- paste("#", object@test.name, "Unit Root Test #", sep=" ")
    row <- paste(rep("#", nchar(title)), collapse="")
    cat("\n")
    cat(row, "\n")
    cat(title, "\n")
    cat(row, "\n")
    cat("\n")
    print(object@testreg)
    cat('\n')
    cat('Value of test-statistic is:', round(object@teststat, 4), '\n')
    cat('Critical value for a significance level of', object@signif, '\n')
    cat('is:', object@cval, '\n')
    cat('\n')
    invisible(object)
  }else if(object@classname=="ur.pp"){
    title <- paste("#", object@test.name, "Unit Root Test #", sep=" ")
    row <- paste(rep("#", nchar(title)), collapse="")
    cat("\n")
    cat(row, "\n")
    cat(title, "\n")
    cat(row, "\n")
    cat("\n")
    cat('Test regression', object@model, '\n')
    cat('\n')
    print(object@testreg)
    cat('\n')
    cat('Value of test-statistic, type:', object@type,' is:', round(object@teststat, 4), '\n')
    cat('\n')
    print(object@auxstat)
    cat('\n')
    cat('Critical values for Z statistics: \n')
    print(object@cval)
    cat('\n')
    invisible(object)
  }else if(object@classname=="ur.df"){
    title <- paste("#", object@test.name, "Unit Root Test #", sep=" ")
    row <- paste(rep("#", nchar(title)), collapse="")
    cat("\n")
    cat(row, "\n")
    cat(title, "\n")
    cat(row, "\n")
    cat("\n")
    cat('Test regression', object@model, '\n')
    cat('\n')
    print(object@testreg)
    cat('\n')
    cat('Value of test-statistic is:', round(object@teststat, 4), '\n')
    cat('\n')
    cat('Critical values for test statistics: \n')
    print(object@cval)
    cat('\n')
    invisible(object)
  }else if(object@classname=="ca.po"){
    title <- paste("#", object@test.name, "Unit Root Test #", sep=" ")
    row <- paste(rep("#", nchar(title)), collapse="")
    cat("\n")
    cat(row, "\n")
    cat(title, "\n")
    cat(row, "\n")
    cat("\n")
    cat("Test of type", object@type, "\ndetrending of series", object@model, "\n")
    cat("\n")
    print(object@testreg)
    cat('\n')
    cat('Value of test-statistic is:', round(object@teststat, 4), '\n')
    cat('\n')
    cat('Critical values of', object@type, "are:\n")
    print(object@cval)
    cat('\n')
    invisible(object)
    }else if(object@classname=="ur.kpss"){
      title <- paste("#", object@test.name, "Unit Root Test #", sep=" ")
      row <- paste(rep("#", nchar(title)), collapse="")
      cat("\n")
      cat(row, "\n")
      cat(title, "\n")
      cat(row, "\n")
      cat("\n")
      cat('Test is of type:', object@type, 'with', object@lag, 'lags. \n')
      cat('\n')
      cat('Value of test-statistic is:', round(object@teststat, 4), '\n')
      cat('\n')
      cat('Critical value for a significance level of: \n')
      print(object@cval)
      cat('\n')
      invisible(object)
    }else if(object@classname=="cajo.test"){
      title <- paste("#", object@test.name, "#", sep=" ")
      row <- paste(rep("#", nchar(title)), collapse="")
      cat("\n")
      cat(row, "\n")
      cat(title, "\n")
      cat(row, "\n")
      cat("\n")
      cat(object@type, "\n")
      cat("\n")
      cat("The VECM has been estimated subject to: \n")
      cat("beta=H*phi and/or alpha=A*psi\n")
      if(!is.null(object@H)){
        cat("\n")
        print(object@H)
        cat("\n")
      }
      if(!is.null(object@A)){
        cat("\n")
        print(object@A)
        cat("\n")
      }
      cat("Eigenvalues of restricted VAR (lambda):\n")
      print(round(object@lambda, 4))
      cat('\n')
      cat("The value of the likelihood ratio test statistic:\n")
      cat(round(object@teststat, 2), "distributed as chi square with", object@pval[2], "df.\n")
      cat("The p-value of the test statistic is:", round(object@pval[1], 2), "\n")
      cat("\n")
      cat("Eigenvectors, normalised to first column\n")
      cat("of the restricted VAR:\n")
      cat("\n")
      print(round(object@V, 4))
      cat("\n")
      cat("Weights W of the restricted VAR:\n")
      cat("\n")
      print(round(object@W, 4))
      cat("\n")
      invisible(object)
    }else if(object@classname=="ca.jo"){
      title <- paste("#", object@test.name, "#", sep=" ")
      row <- paste(rep("#", nchar(title)), collapse="")
      cat("\n")
      cat(row, "\n")
      cat(title, "\n")
      cat(row, "\n")
      cat("\n")
      cat("Test type:", object@type, ",", object@model, "\n")
      cat("\n")
      cat("Eigenvalues (lambda):\n")
      print(object@lambda)
      cat('\n')
      if(!(is.null(object@cval))){
        res1 <- as.matrix(round(object@teststat, 2))
        colnames(res1) <- "test"
        result <- cbind(res1, object@cval)
        cat("Values of teststatistic \& critical values of test:\n")
        cat("\n")
        print(result)
        cat("\n")
      }else{
        cat("Values of test statistic\n")
        cat("\n")
        result <- as.matrix(object@teststat)
        rownames(result) <- c(paste("r <= ", (object@P-1):1, " |",sep=""), "r = 0  |")
        print(result)
        cat("\n")
        invisible(x)
      }
      cat("Eigenvectors, normalised to first column:\n")
      cat("(These are the cointegration relations)\n")
      cat("\n")
      print(object@V)
      cat("\n")
      cat("Weights W:\n")
      cat("(This is the loading matrix)\n")
      cat("\n")
      print(object@W)
      cat("\n")
      invisible(object)
    }else if(object@classname=="ur.ers"){
      title <- paste("#", object@test.name, "Unit Root Test #", sep=" ")
      row <- paste(rep("#", nchar(title)), collapse="")
      cat("\n")
      cat(row, "\n")
      cat(title, "\n")
      cat(row, "\n")
      cat("\n")
      cat("Test of type", object@type, "\ndetrending of series", object@model, "\n")
      cat("\n")
      if(!is.null(object@testreg)){
        print(object@testreg)
        cat('\n')
      }
      cat('Value of test-statistic is:', round(object@teststat, 4), '\n')
      cat('\n')
      cat('Critical values of', object@type, "are:\n")
      print(object@cval)
      cat('\n')
      invisible(object)
    }
})

setMethod("plot", signature(x="ur.ers", y="missing"), function(x){
  if(is.null(x@testreg)){
    stop("No plot method for P-test available")}
  oldpar <- par(no.readonly=TRUE)
  on.exit(par(oldpar))
  par(mfrow=c(1,1))
  layout(matrix(c(1, 2, 3, 1, 2, 4), 3 , 2))
  suppressWarnings(plot.ts(diff(x@yd)[-c(1:x@lag)], main="Diagram of fit for test regression", sub=paste("detrending ", x@model, " and ", x@lag, " lagged differences used in test regression",  sep=""), ylab="Actual and fitted values", xlab=""))
  lines(diff(x@yd)[-c(1:x@lag)] - resid(x@testreg), col="seagreen")
  plot.ts(resid(x@testreg), main="Residuals", ylab="", xlab="")
  abline(h=0, col="red")
  acf(resid(x@testreg), main="Autocorrelations of Residuals")
  pacf(resid(x@testreg), main="Partial Autocorrelations of Residuals")
})

setMethod("plot", signature(x="ca.jo", y="missing"), function(x){
  oldpar <- par(no.readonly=TRUE)
  on.exit(par(oldpar))
  par(mfrow=c(2,1))
  if(x@P==nrow(x@V)){
    ci <- x@x%*%x@V
  }else{
    ci <- x@x%*%x@V[-(x@P+1),]
  }
  for( i in 1:x@P){
    plot.ts(x@x[,i], main=paste("Time series plot of y", i, sep=""), ylab="")
    plot.ts(ci[,i], main=paste("Cointegration relation of ", i, ". variable", sep=""), ylab="")
    if(interactive()){
      cat("\nType <Return> to continue: ")
      readline()
    }
  }
})

setMethod("plot", signature(x="ur.kpss", y="missing"), function(x){
  oldpar <- par(no.readonly=TRUE)
  on.exit(par(oldpar))
  par(mfrow=c(1,1))
  layout(matrix(c(1, 2, 1, 3), 2 , 2))
  plot.ts(x@res, main=paste("Residuals from test regression of type:", x@type, " with", x@lag, "lags", sep=" "), ylab="residuals", xlab="")
  abline(h=0, col="red")
  acf(x@res, main="Autocorrelations of Residuals")
  pacf(x@res, main="Partial Autocorrelations of Residuals")
})

setMethod("plot", signature(x="ca.po", y="missing"), function(x){
  oldpar <- par(no.readonly=TRUE)
  on.exit(par(oldpar))
  par(mfrow=c(1,1))
  if(x@type=="Pu"){
    layout(matrix(c(1, 2, 1, 3), 2 , 2))
    suppressWarnings(plot.ts(x@res[,1], main="Residuals of CI-regression for y1", sub=paste("detrending:", x@model, sep=" "), ylab="", xlab=""))
    abline(h=0, col="red")
    acf(x@res[,1], main="Autocorrelations of Residuals")
    pacf(x@res[,1], main="Partial Autocorrelations of Residuals")
  }else if(x@type=="Pz"){
    m <- ncol(x@z)
    for( i in 1:m){
      layout(matrix(c(1, 2, 1, 3), 2 , 2))
      suppressWarnings(plot.ts(x@res[,i], main=paste("Residuals of CI-regression with y", i, " as lhs", sep=""), sub=paste("detrending:", x@model, sep=" "), ylab="", xlab=""))
      abline(h=0, col="red")
      acf(x@res[,i], main="Autocorrelations of Residuals")
      pacf(x@res[,i], main="Partial Autocorrelations of Residuals")
      if(interactive()){
        cat("\nType <Return> to continue: ")
        readline()
      }
    }
  }     
})

setMethod("plot", signature(x="ur.pp", y="missing"), function(x){
  oldpar <- par(no.readonly=TRUE)
  on.exit(par(oldpar))
  par(mfrow=c(1,1))
  layout(matrix(c(1, 2, 3, 1, 2, 4), 3 , 2))
  plot.ts(x@y[-1], main=paste("Diagram of fit for model", x@model, sep=" "), ylab="Actual and fitted values", xlab="")
  lines(x@y - x@res, col="seagreen")
  plot.ts(x@res, main="Residuals", ylab="", xlab="")
  abline(h=0, col="red")
  acf(x@res, main="Autocorrelations of Residuals")
  pacf(x@res, main="Partial Autocorrelations of Residuals")
})

setMethod("plot", signature(x="ur.df", y="missing"), function(x){
  oldpar <- par(no.readonly=TRUE)
  on.exit(par(oldpar))
  par(mfrow=c(1,1))
  layout(matrix(c(1, 2, 1, 3), 2 , 2))
  plot.ts(x@res, main="Residuals", ylab="", xlab="")
  abline(h=0, col="red")
  acf(x@res, main="Autocorrelations of Residuals")
  pacf(x@res, main="Partial Autocorrelations of Residuals")
})

setMethod("plot", signature(x="ur.sp", y="missing"), function(x){
  oldpar <- par(no.readonly=TRUE)
  on.exit(par(oldpar))
  par(mfrow=c(1,1))
  layout(matrix(c(1, 2, 3, 1, 2, 4), 3 , 2))
  plot.ts(x@y[-1], main=paste("Diagram of fit for model with polynomial degree of ", x@polynomial, sep="") , ylab="Actual and fitted values", xlab="")
  lines(x@y[-1] - x@res, col="seagreen")
  plot.ts(x@res, main="Residuals", ylab="", xlab="")
  abline(h=0, col="red")
  acf(x@res, main="Autocorrelations of Residuals")
  pacf(x@res, main="Partial Autocorrelations of Residuals")
})

setMethod("plot", signature(x="ur.za", y="missing"), function(x){
  oldpar <- par(no.readonly=TRUE)
  on.exit(par(oldpar))
  par(mfrow=c(1,1))
  yvals <- sort(c(x@cval, x@tstats))
  n <- length(x@y)
  xvals <- pretty(1:n)
  plot.ts(x@tstats, main="Zivot and Andrews Unit Root Test", ylab="t-statistics for lagged endogenous variable", ylim=c(min(yvals), max(yvals)))
  abline(h=x@cval, col=c("red", "blue", "seagreen"))
  if(x@teststat < x@cval[3]){
    abline(v=x@bpoint, col="red", lty=2)}
  mtext(paste("Model type:", x@model, sep=" "), side=1, line=4)
  legend(x=n, y=max(yvals), c("1% c.v.", "2.5% c.v.", "5% c.v."), col=c("red", "blue", "seagreen"), xjust=1, yjust=1, lty=1, horiz=TRUE, cex=0.66, bty="n")
})
  

################################################################################

#
# Examples from the forthcoming Monograph:
# 	Rmetrics - Financial Engineering and Computational Finance
#   A Practitioner's Guide for R and SPlus Programmers
#   written by Diethelm Wuertz
#   ISBN to be published
#
# Details:
#   Additonal Examples
#   Time Series Filters
#
# List of Examples, Exercises and Code Snippets:
#
#   3.6.1 Example: Filter available in R's "base" package
#   3.6.2 Example: Filter in R's contributed package "pastecs"
#   3.6.3 Example: Hodrick-Prescott Filter 
#
# Author:
#	(C) 1997-2005, Diethelm Wuertz, GPL
# 	  www.rmetrics.org
# 	  www.itp.phys.ethz.ch
# 	  www.finance.ch
#


################################################################################


### 3.6.1 Example: Filter available in R's "base" package

    # filter - 
    #	Applies linear filtering to a univariate time series or to 
    #	each series separately of a multivariate time series.
    if (FALSE) args(filter)
    ###
    
    
# ------------------------------------------------------------------------------


### 3.6.2 Example: Filter in R's contributed package "pastecs"

	# Discuss what kind of time series filter are availalbe under R. 
	###

    # Package: pastecs
    # Title: Package for Analysis of Space-Time Ecological Series
    # Version: 1.1-1
    # Date: 2002-11-12
    # Author: Frederic Ibanez <ibanez@obs-vlfr.fr>, Philippe Grosjean
    #        <phgrosjean@sciviews.org> & Michele Etienne
    #        <etienne@obs-vlfr.fr>
    # Description: Regulation, decomposition and analysis of space-time
    #        series. The pastecs library is a PNEC-Art4 and IFREMER (Benoit
    #        Beliaeff <Benoit.Beliaeff@ifremer.fr>) initiative to translate
    #        PASSTEC 2000
    #        (http://www.obs-vlfr.fr/~enseigne/anado/passtec/passtec.htm).
    # URL: http://www.sciviews.org/pastecs
    # Maintainer: Philippe Grosjean <phgrosjean@sciviews.org>
    # License: GNU Public Licence 2.0 or above at your convenience
    # Depends: boot, ctest, mva, ts
    # Built: R 1.9.0; ; 2004-03-28 14:51:33
    ###
    
    #   FILTER:
    #   decaverage    Decomposition using a moving average  
    #   deccensus     Decomposition using the CENSUS II method  
    #   decdiff       Decomposition using differences (trend elimination)  
    #   decevf        Decomposition using eigenvector filtering (EVF)  
    #   decloess      Decomposition by the LOESS method  
    #   decmedian     Decomposition using a running median  
    #   decreg        Decomposition using a regression model  
    ###
    
    
# ------------------------------------------------------------------------------


### 3.6.3 Example: Hodrick-Prescott Filter

	# Implement the Hodrick-Prescott filter which decomposes a macroeconomic 
	# time series into a smooth trend component and a cyclical component. 
	###

	# R function available in "funSeries.R"
	# Compute the cyclical component in the US CPI data for monthly data
    data(CPI.dat)
    logCPI = log(as.vector(CPI.dat[,2])) 
    cycCPI = logCPI - hpFilter(logCPI, 14400)
    par(mfrow = c(2, 1), cex = 0.5)
    ts.plot(logCPI, xlab = "Index", col = "steelblue")
    grid()
    ts.plot(cycCPI, xlab = "Index", col = "steelblue")
    grid()
	###
	

################################################################################

#
# Examples from the forthcoming Monograph:
# 	Rmetrics - Financial Engineering and Computational Finance
#   A Practitioner's Guide for R and SPlus Programmers
#   written by Diethelm Wuertz
#   ISBN to be published
#
# Details:
#   Examples from Chapter 3.3
#   Time Series with Long Range Dependence
#
# List of Examples, Exercises and Code Snippets:
#
#   3.3.1 Example: Simulate Gaussian FARIMA Model
#       * Code Snippet: fbmSim
#   3.3.2 Example: Simulate Fractal Brownian Motion
#   3.3.3 Example: Simulate Fractal Gaussian Noise
#   3.3.4 Example: Simulate FGN by Beran's, Durbin's, and Paxson's Methods
#   3.3.5 Example: True FARIMA Covariances and Fourier Transform
#       * Example: True FGN Covariances and Fourier Transform
#   3.3.6 Example: Aggregated Variance Method
#   3.3.7 Example: Differenced Aggregated Variance Method
#   3.3.8 Example: Absolute Values of the Aggregated Series
#   3.3.9 Example: Higuchi's or Fractal Dimension Method
#   3.3.10 Example: Peng's or Variance of Residuals Method
#   3.3.12 Example: The R/S Method
#   3.3.13 Example: The Periodogram Method
#   3.3.14 Example: The Boxed or Modified Periodogram Method
#   3.3.15 Example: The Whittle Estimator
#   3.3.16 Example: Averaged Hurst Exponent from 50 Samples
#   3.3.17 Example: The Wavelet Estimator
#
#
# Author:
#	(C) 1997-2005, Diethelm Wuertz, GPL
# 	  www.rmetrics.org
# 	  www.itp.phys.ethz.ch
# 	  www.finance.ch
#


################################################################################
# Time Series Simulation


### 3.3.1 Example: Simulate Gaussian FARIMA Model

	# Create Figure 3.3.1
	###
	
    # FARIMA(0, d, 0)
    x.ts = farimaSim(n = 100, model = list(d = 0.25))
    print(x.ts)
    par(mfrow = c(2, 2), cex = 0.7)
    plot(x.ts, main = "FARIMA(0, 0.25, 0)", col = "steelblue")
    grid()
    ###

    # Try also: FARIMA(2, d, 1)
    mode = model = list(ar = c(0.5, -0.5), d = 0.25, ma = 0.1)
    x.ts = farimaSim(n = 100, model = model)
    plot(x.ts, main = "FARIMA(2, 0.25, 1)", col = "steelblue")
    grid()
    ###
    
    
# ------------------------------------------------------------------------------


### Code Snippet: fbmSim

    # Show Argument List for 'fbmSim':
    > args(fbmSim)
    # function(n = 100, H = 0.7,
    #    method = c("mvn", "chol", "lev", "circ", "wave"),
    #    waveJ = 7, doplot = TRUE, fgn = FALSE)
    ###
    
    
# ------------------------------------------------------------------------------


### 3.3.2 Example: Simulate Fractal Brownian Motion

    # All 5 Methods:
    methods = c("mvn", "chol", "lev", "circ", "wave")
	###
	
    # Generate FBM Series and Plot it:
    par (mfrow = c(3, 2), cex = 0.7)
    for (method in methods) {
        set.seed(1953)
        fbmSim(1000, method = method, doplot = TRUE)
    }
    ###
    
    
# ------------------------------------------------------------------------------


### 3.3.3 Example: Simulate Fractal Gaussian Noise

    # Graph Frame:
	par (mfrow = c(3, 2), cex = 0.7)
	###
	
	# All 5 Methods:
    methods = c("mvn", "chol", "lev", "circ", "wave")
	###
	
    # Generate FGN Series and Plot it:
    for (method in methods) {
        set.seed(1953)
        fbmSim(1000, method = method, doplot = TRUE, fgn = TRUE)
    }
    ###
    
    
# ------------------------------------------------------------------------------


### 3.3.4 Example: Simulate FGN by Beran's, Durbin's and Paxson's Methods

   	# Graph Frame:
	par (mfrow = c(3, 1), cex = 0.7)
	###
	
	# Beran's Method: 
   	plot(fgnSim(n = 200, H = 0.75), type = "l", 
   		col = "steelblue", 
     	ylim = c(-3, 3), xlab = "time", ylab = "x(t)", 
     	main = "FGN Beran")
	grid()
	###
   
	# Durbin's Method:
	plot(fgnSim(n = 200, H = 0.75, method = "durbin"), type = "l",
		col = "steelblue",
	 	ylim = c(-3, 3), xlab = "time", ylab = "x(t)", 
	 	main = "FGN Durbin")
	grid()
	###
	
	# Paxson's Method:
	plot(fgnSim(n = 200, H = 0.75, method = "paxson"), 
		type = "l", col = "steelblue",
	 	ylim = c(-3, 3), xlab = "time", ylab = "x(t)", 
	 	main = "FGN Paxson")
    grid()
    ###
    
    
################################################################################
# True Model Statistics


### Example 3.3.5: True FARIMA Covariances and Fourier Transform
			
	# Graph Frame:
	par (mfrow = c(2,2), cex = 0.7)
	###
	
	# Parameters:
	n = 10000
	d = 0.2
	H = d + 0.5
	set.seed(1953)
	x = farimaSim(n, model = list(d = 0.2))
	###
	
	# Sample and True ACF:
	acf(x, main = "FARIMA: ACF")
	y = farimaTrueacf(41, H)
	points(0:40, y, col = "red")
	###
	
	# Simple - Fit Hurst Exponent from True ACF:
	coef = lsfit(x = log(1:40), y = log(y[-1]))$coef
	beta = coef[[2]]
	H.estimated = (beta+2)/2
	H.estimated
	###
	
	# Sample and True Spectrum:
	s = spectrum(x, plot = FALSE)$spec
	plot(s, type = "h", ylim = c(0, 60), main = "FARIMA: Spectrum")
	y = Re(farimaTruefft(n, H))
	lines(0:(n/2-1), y[1:(n/2)], col = "red")
	###
	
	# Double Logarithmic Plot:
	# plot(log(1:length(s)), log(s), type = "l", main = "log-log Spectrum")
	# lines(log(1:(n/2)), log(y[1:(n/2)]), col = "red")
	###
	
	# Simple Fit - Hurst Exponent from True Spectrum:
	coef = lsfit(x = log(1:length(s)), y = log(s))$coef
	beta = coef[[2]]
	H = (1-beta)/2
	H
	###
	
	
# ------------------------------------------------------------------------------
	

### Example: True FGN Covariances and Fourier Transform	
	
	# Parameters:
	n = 10000
	H = 0.7
	set.seed(1953)
	x = fgnSim(n, H)
	###
	
	# Sample and True ACF:
	acf(x, main = "FGN: ACF")
	y = fgnTrueacf(41, H)
	points(0:40, y, col = "red")
	###
	
	# Simple Fit - Hurst Exponent from True ACF:
	coef = lsfit(x = log(1:40), y = log(y[-1]))$coef
	beta = coef[[2]]
	H.estimated = (beta+2)/2
	H.estimated
	###
	
	# Sample and True Spectrum:
	s = spectrum(x, plot = FALSE)$spec
	plot(s, type = "h", ylim = c(0, 60), main = "FGN: Spectrum")
	y = Re(fgnTruefft(n, H))
	lines(0:(n/2-1), y[1:(n/2)], col = "red")
	###
	
	# Double Logarithmic Plot:
	# plot(log(1:length(s)), log(s), type = "l", main = "log-log Spectrum")
	# lines(log(1:(n/2)), log(y[1:(n/2)]), col = "red")
	###
	
	# Simple Fit - Hurst Exponent from True Spectrum:
	coef = lsfit(x = log(1:length(s)), y = log(s))$coef
	beta = coef[[2]]
	H = (1-beta)/2
	H
	###


# ------------------------------------------------------------------------------	
		
	
### Code Snippet: fHURST
	
	# Get Class:
	getClass("fHURST")
	###
	
	
################################################################################
# Estimation of the Hurst Exponent


### 3.3.6 Example: Aggregated Variance Method

    # Graphics Frame - Figure 3.3.6:
    par(mfrow = c(2, 2), cex = 0.7)
    ###
    
    # Fit - Method 1:
    set.seed(1953)
    x = fgnSim(n = 10000, H = 0.7)
    aggvarFit(x, cut.off = 10^c(0.7, 3.0), doplot = TRUE)
    ###
    
    
# ------------------------------------------------------------------------------	
   

### 3.3.7 Example: Differenced Aggregated Variance Method

    # Graphics Frame - continue ...
    ###
    
    # Fit - Method 2:
    set.seed(1953)
    x = fgnSim(n = 10000, H = 0.7)
    diffvarFit(x, cut.off = 10^c(0.7, 2.5), doplot = TRUE)
    ###
    
    
# ------------------------------------------------------------------------------	
   

### 3.3.8 Example: Absolute Values of the Aggregated Series

    # Graphics Frame - continue ...
    ###
    
    # Fit - Method 3:
    set.seed(1953)
    x = fgnSim(n = 10000, H = 0.7)
    absvalFit(x, cut.off = 10^c(0.7, 3), doplot = TRUE)
    ###
    
    
# ------------------------------------------------------------------------------	
   

### 3.3.9 Example: Higuchi's or Fractal Dimension Method

    # Graphics Frame - continue ...
    ###
    
    # Fit - Method 4:
    set.seed(1953)
    x = fgnSim(n = 10000, H = 0.7)
    higuchiFit(x, cut.off = 10^c(0.7, 3), doplot = TRUE)
    ###
    
    
# ------------------------------------------------------------------------------	
   

### 3.3.10 Example: Peng's or Variance of Residuals Method

    # Graphics Frame - Figure 3.3.6:
    par(mfrow = c(2, 2), cex = 0.7)
    ###
    
    # Fit - Method 5:
    set.seed(1953)
    x = fgnSim(n = 10000, H = 0.7)
    pengFit(x, cut.off = 10^c(0.7, 3.0), doplot = TRUE)
    ###
    
    
# ------------------------------------------------------------------------------


### 3.3.12 Example: The R/S Method

    # Graphics Frame - continue ...
    ###
    
    # Fit - Method 6:
    set.seed(1953)
    x = fgnSim(n = 10000, H = 0.7)
    rsFit(x, cut.off = 10^c(0.7, 2.5), doplot = TRUE)
    ###
    
    
# ------------------------------------------------------------------------------


### 3.3.13 Example: The Periodogram Method

    # Graphics Frame - continue ...
    ###
    
    # Fit - Method 7:
    set.seed(1953)
    x = fgnSim(n = 10000, H = 0.7)
    perFit(x, cut.off = 0.10, doplot = TRUE)
    ###
    
    
# ------------------------------------------------------------------------------


### 3.3.14 Example: The Boxed or Modified Periodogram Method

    # Graphics Frame - continue ...
    ###
    
    # Fit - Method 8:
    set.seed(1953)
    x = fgnSim(n = 10000, H = 0.7)
    boxperFit(x, cut.off = 0.10, doplot = TRUE)
    ###
    
    
# ------------------------------------------------------------------------------


### 3.3.15 Example: The Whittle Estimator

	# Fit - Method 9:
    set.seed(1953)
    x = fgnSim(n = 10000, H = 0.7)
    whittleFit(x)
    ###


# ------------------------------------------------------------------------------


### 3.3.16 Example: Averaged Hurst Exponent from 50 Samples

   	# Graphics Frame:
    par(mfrow = c(1, 1), cex = 0.7)
    ###
    
    # Be patient, this will take some time ...
    set.seed(1953)
    nominalH = 0.7
    H1 = H2 = H3 = H4 = H5 = H6 = H7 = H8 = H9 = NULL
    for (i in 1:50) {
        x = fgnSim(n = 10000, H = nominalH)
        NEXT.H1 = aggvarFit(x, cut.off = 10^c(0.7, 3.0))@hurst$H
          H1 = c(H1, NEXT.H1)
        NEXT.H2 = diffvarFit(x, cut.off = 10^c(0.7, 2.5))@hurst$H
          H2 = c(H2, NEXT.H2)
        NEXT.H3 = diffvarFit(x, cut.off = 10^c(0.7, 3.0))@hurst$H
          H3 = c(H3, NEXT.H3)
        NEXT.H4 = higuchiFit(x)@hurst$H
          H4 = c(H4, NEXT.H4)
        NEXT.H5 = pengFit(x)@hurst$H
          H5 = c(H5, NEXT.H5)
        NEXT.H6 = rsFit(x)@hurst$H
          H6 = c(H6, NEXT.H6)
        NEXT.H7 = perFit(x, cut.off = 0.10)@hurst$H
          H7 = c(H7, NEXT.H7)
        NEXT.H8 = boxperFit(x)@hurst$H
          H8 = c(H8, NEXT.H8)
        NEXT.H9 = whittleFit(x)@hurst$par
          H9 = c(H9, NEXT.H9)
        cat("\n", i, round(
            c(NEXT.H1, NEXT.H2, NEXT.H3, NEXT.H4, NEXT.H5,
              NEXT.H6, NEXT.H7, NEXT.H8, NEXT.H9), digits = 4))
    }
    # Combine Columnwise to a Matrix:
    H.mat = cbind(H1, H2, H3, H4, H5, H6, H7, H8, H9)
    ###
    
    # Mean Values:
    round(colMeans(H.mat), digits = 3)
    #    H1    H2    H3    H4    H5    H6    H7    H8    H9
    # 0.672 0.706 0.733 0.671 0.686 0.708 0.707 0.662 0.700
    ###
    
    # Standard Deviations:
    round(colStdevs(H.mat), digits = 3)
    #    H1    H2    H3    H4    H5    H6    H7    H8    H9
    # 0.034 0.061 0.043 0.026 0.015 0.075 0.021 0.021 0.007
    ###
    
    # Create a Box Plot:
    boxplot(data.frame(H.mat)-nominalH)
    ###
    
    
################################################################################
# Wavelet Estimator


### 3.3.17 Example: Wavelet Estimator Using Simulated Data

    # Fit:
    set.seed(1953)
    x = fgnSim(n = 1000, H = 0.7, method = "beran")
    waveletFit(x)
    ###

    # Have a Look on Changing the Octave Setting:
    H = NULL
    for (end in 3:8)
       H = c(H, waveletFit(x = x, octave = c(2, end))@hurst$H)
    data.frame(end = 3:8, H)
    #   end         H
    # 1   3 0.5662117
    # 2   4 0.5587855
    # 3   5 0.6892903
    # 4   6 0.8712615
    # 5   7 0.8712615
    # 6   8 0.8712615
    ###
  
    
# ------------------------------------------------------------------------------
  

### Example: Wavelet Estimator Using Market Data
    
	data(usdchf)
	USDCHF.TS = as.timeSeries(usdchf, format = "%Y%m%d%H%M")
	x = USDCHF.VOLATILITY = absSeries(returnSeries(USDCHF.TS))
	
	
# ##############################################################################

	

#
# Examples from the Paper
#   Parameter Estimation of ARMA Models with GARCH/APARCH Errors
#     An R and SPlus Software Implementation
#     written by Diethelm Wuertz, Yohan Chalabi, and Ladislav Luksan
#   submitted to Journal of Statistical Software
#
# Details:
#   1. Introduction
#   2. Mean and Variance Equation
#   3. The Standard GARCH(1,1) Model
#   4. Alternative Conditional Distributions
#   5. ARMA(m,n) Models with GARCH(p,q) Errors
#   6. APARCH(p,q) - Asymmetric Power Arch Models
#   7. An Unique GARCH Modelling Approach
#   8. Summary and Outlook
#
# List of Code Snippet and Figures:                
#   
#   CHAPTER 3:
#   Code Snippet  1: Implemting garch11Fit() frm Scratch
#   Code Snippet  2: Benchmarking the GARCH(1,1) for DEMGBP Exchange Rates
#   Figure 1: DEMGBP Series, Histogram, QQ, and ACF Plot
#
#   CHAPTER 4:
#   Figure 2: Student-t Density and Distribution
#   Figure 3: GED Density and Distribution
#   Figure 4: Skew Sudent-t and Skew GED Distributions
#   Code Snippet  3: Fitting Bollerslev's t-GARCH(1,1) Model
#   Code Snippet  4: Comparing "mci" and "uev" Recursion Initialization
#
#   CHAPTER 5:
#   Code Snippet  5: Comparing "mci" and "uev" Recursion Initialization
#   Code Snippet  6: APARCH - Computing Conditional Variances Effectively
#   Code Snippet  7: Using R's Filter Representation
#   Code Snippet  8: Tracing the "t-MA(1)-GARCH(1,2)" Model Fit
#
#   CHAPTER 6:
#   Code Snippet  9: Fitting the TS-GARCH(1,1) Model
#   Code Snippet 10: Fitting the GJR-GARCH(1,1) Model
#   Code Snippet 11: Fitting the DGE-GARCH(1,1) Model
#
#   CHAPTER 7:
#   Code Snippet 12: Specifying a t-MA(1)-GARCH(1,1) Model
#   Code Snippet 13: Simulating Bollerslev's GARCH(1,1) Model
#   Code Snippet 14: Simulating more complex ARMA-GARCH Models [Figure 5]
#   Code Snippet 15: Summarizing the Results from Parameter Estimates                                      
#   Code Snippet 16: Diagnostic Plots from Parameter Estimates [Figure 6]
#   Code Snippet 17: Forecasting Mean and Variance
#   Code Snippet   : Index, Returns, and Volatility Plots for SP500 [Figure 7]
#   Code Snippet 18: Estimating the Parameters for DGE's SP500 Model
#
# Author:
#   Rmetrics (C) 1997-2005, Diethelm Wuertz, GPL
#     www.rmetrics.org
#     www.itp.phys.ethz.ch
#     www.finance.ch
#
 

################################################################################
# CHAPTER 3: The Standard GARCH(1,1) Model

#   Code Snippet  1: Implemting garch11Fit() frm Scratch
#   Code Snippet  2: Benchmarking the GARCH(1,1) for DEMGBP Exchange Rates
#   Figure 1: DEMGBP Series, Histogram, QQ, and ACF Plot


# ------------------------------------------------------------------------------
# Code Snippet 1: garch11Fit()

    # Load Data:
    require(fSeries)
    data(dem2gbp)
    x = dem2gbp[,1]
    
    # Parameter Estimation:
    garch11Fit = function(x)
    {
        # Step 1: Initialize Time Series Globally:
          x <<- x
        # Step 2: Initialize Model Parameters and Bounds:
          Mean = mean(x); Var = var(x); S = 1e-6
          params = c(mu = Mean, omega = 0.1*Var, alpha = 0.1, beta = 0.8)
          lowerBounds = c(mu = -10*abs(Mean), omega = S^2, alpha = S, beta = S)
          upperBounds = c(mu =  10*abs(Mean), omega = 100*Var, alpha = 1-S, 
            beta = 1-S)
        # Step 3: Set Conditional Distribution Function:
          garchDist = function(z, hh) {
            dnorm(x = z/hh)/hh }
        # Step 4: Compose log-Likelihood Function:
          garchLLH = function(parm) {   
            mu = parm[1]; omega = parm[2]; alpha = parm[3]; beta = parm[4]
            z = (x-mu)
            Mean = mean(z^2)
            # Use Filter Representation:
            e = omega + alpha * c(Mean, z[-length(x)]^2)
            h = filter(e, beta, "r", init = Mean)
            hh = sqrt(abs(h))
            llh = -sum(log(garchDist(z, hh)))   
            llh } 
          print(garchLLH(params))    
        # Step 4: Estimate Parameters and Compute Numerically Hessian:
          fit = nlminb(start = params, objective = garchLLH,
              lower = lowerBounds, upper = upperBounds, control = list(trace=3))
          epsilon = 0.0001 * fit$par
          Hessian = matrix(0, ncol = 4, nrow = 4)
          for (i in 1:4) {
            for (j in 1:4) {
              x1 = x2 = x3 = x4 = fit$par
              x1[i] = x1[i] + epsilon[i]; x1[j] = x1[j] + epsilon[j]
              x2[i] = x2[i] + epsilon[i]; x2[j] = x2[j] - epsilon[j]
              x3[i] = x3[i] - epsilon[i]; x3[j] = x3[j] + epsilon[j]
              x4[i] = x4[i] - epsilon[i]; x4[j] = x4[j] - epsilon[j]
              Hessian[i, j] = 
                (garchLLH(x1)-garchLLH(x2)-garchLLH(x3)+garchLLH(x4)) /
                (4*epsilon[i]*epsilon[j]) } }
        # Step 5: Create and Print Summary Report: 
          se.coef = sqrt(diag(solve(Hessian)))
          tval = fit$par/se.coef
          matcoef = cbind(fit$par, se.coef, tval, 2*(1-pnorm(abs(tval))))
          dimnames(matcoef) = list(names(tval), c(" Estimate",
            " Std. Error", " t value", "Pr(>|t|)"))
          cat("\nCoefficient(s):\n")
          printCoefmat(matcoef, digits = 6, signif.stars = TRUE)
    }
    
    # Try it:
    garch11Fit(x)
    #   [1] 1133.253
    #   0      1133.25: -0.0164268 0.0221130 0.100000 0.800000
    #   3      1111.77: -0.0120583 0.0128702 0.120629 0.807733
    #   6      1107.36: -0.0122857 0.0102052 0.132150 0.825474
    #   9      1107.04: -0.00463769 0.0100908 0.133319 0.824104
    #  12      1106.88: -0.00497939 0.00998547 0.136549 0.821671
    #  15      1106.71: -0.00534939 0.00977796 0.146626 0.817967
    #  18      1106.64: -0.00586696 0.0101970 0.151814 0.810639
    #  21      1106.61: -0.00630191 0.0108863 0.155101 0.803834
    #  24      1106.61: -0.00621222 0.0107931 0.153469 0.805558
    #  27      1106.61: -0.00619040 0.0107614 0.153134 0.805974
    # 
    # Coefficient(s):
    #         Estimate  Std. Error  t value   Pr(>|t|)    
    # [1,] -0.00619040  0.00846211 -0.73154 0.46444724    
    # [2,]  0.01076140  0.00285270  3.77236 0.00016171 ***
    # [3,]  0.15313411  0.02652273  5.77369 7.7552e-09 ***
    # [4,]  0.80597365  0.03355251 24.02126 < 2.22e-16 ***
    # ---
    # Signif. codes:  0 '***' 0.001 '**' 0.01 '*' 0.05 '.' 0.1 ' ' 1 
    ###

    # An AddOn - The Minimalist's Bollerslev GARCH(1,1) Model:
    data(dem2gbp)
    x <<- dem2gbp[,1]
    # Log-Likelihood Function:
    LLH = function(p) {   
        X = (x-p[1])
        M = mean(X^2)
        h = rep(p[2] + p[3]*M + p[4]*M, length = length(X))
        for (i in 2:length(X)) h[i] = p[2] + p[3]*X[i-1]^2 + p[4]*h[i-1]
        s = sqrt(abs(h))
        -sum(log(dnorm(X/s)/s)) 
    }
    # Parameter Estimation:    
    nlminb(c(0, var(x)/10, 0.1, 0.8), LLH, control = list(trace = 1))$par
    # Result:
    # [1] -0.006190413  0.010761397  0.153134067  0.805973671
    ###
    
    
# ------------------------------------------------------------------------------
# Code Snippet 2: GARCH(1,1) Benchmark for the DEM/GBP Exchange Rates

    # Fitting Bollerslev's GARCH(1,1) with 'nlminb'
    data(dem2gbp)
    x = dem2gbp[, 1]
    garch11Fit(x = x)
    #           Estimate  Std. Error   t value   Pr(>|t|)    
    # mu     -0.00619040  0.00846211  -0.73154 0.46444724    
    # omega   0.01076140  0.00285270   3.77236 0.00016171 ***
    # alpha   0.15313411  0.02652273   5.77369 7.7552e-09 ***
    # beta    0.80597365  0.03355251  24.02126 < 2.22e-16 ***
    ###
    
    # R/Rmetrics:
    garchFit()
    #           Estimate  Std. Error   t value   Pr(>|t|)    
    # mu       -0.006190    0.008460    -0.732   0.464311    
    # omega     0.010761    0.002853     3.772   0.000162 ***
    # alpha1    0.153134    0.026522     5.774   7.75e-09 ***
    #beta1      0.805974    0.033552    24.022    < 2e-16 ***
    ###
    
    # Ox/G@RCH:
    garchOxFit()
    #            Coefficient  Std.Error  t-value  t-prob
    # Cst(M)       -0.006183  0.0084616  -0.7307  0.4650
    # Cst(V)        0.010761  0.0028506    3.775  0.0002
    # ARCH(Alpha1)  0.153406   0.026568    5.774  0.0000
    # GARCH(Beta1)  0.805876   0.033542    24.03  0.0000
    ###
    
    # SPlus/Finmetrics:
    if (FALSE) { 
        # For use under S-Plus, only
        module(finmetrics)
        x = read.table(file = "dem2gbp.csv", header = TRUE, sep = ";")[, 1]
        fit = garch(formula.var = ~garch(1,1), series = x, trace = TRUE,
          control = bhhh.control(tol=1e-6, delta=1e-6, n.iter=1000))
        summary(fit)
        coef = fit$coef
        se.coef = sqrt(diag(solve(-fit$cov$A)))
        t.value = coef/se.coef
        data.frame(Estimate = coef, StdError = se.coef, "t value" = t.value)    
    } 
    #               Estimate     StdError     t.value 
    #        C  -0.006053483  0.008470953  -0.7146165
    #        A   0.010896279  0.002910292   3.7440499
    #  ARCH(1)   0.154211478  0.026829521   5.7478282
    # GARCH(1)   0.804447554  0.034036971  23.6345221 
    ###
    
    
# ------------------------------------------------------------------------------
# Figure 1: DEM/GBP Exchange Rates
    
    # Load Data:
    data(dem2gbp)
    x = dem2gbp[, 1]
    ###
    
    # Basic Statistics:
    length(x)
    mean(x)
    var(x)
    sd(x)
    skewness(x)
    kurtosis(x)
    ###
    
    # Figure 1:
    par(mfrow = c(2, 2), cex = 0.7)
    plot(x, type = "l", col = "steelblue", ylab = "log Return",
        main = "DEMGBP FX Rates")
    abline(h = 0, lty = 3, col = "grey")
    grid()
    hist(x, n = 30, main = "Volatility Histogram", probability = TRUE,
        col = "steelblue", border = "white", xlim = c(-2, 2))
    s = seq(-2, 2, length = 401)
    lines(s, dnorm(s, mean(x), sd(x)))
    qqnorm(x, col = "steelblue", cex = 0.7)
    qqline(x)
    grid()
    acf(abs(x), main = "ACF |DEMGBP|")
    ###
    
    
################################################################################
# CHAPTER 4: Alternative Conditional Distributions

#   Figure 2: Student-t Density and Distribution
#   Figure 3: GED Density and Distribution
#   Figure 4: Skew Sudent-t and Skew GED Distributions
#   Code Snippet  3: Fitting Bollerslev's t-GARCH(1,1) Model
#   Code Snippet  4: Comparing "mci" and "uev" Recursion Initialization

    
# ------------------------------------------------------------------------------
# Figure 2: Standardized Symmetric Student-t Distribution  
 
    # Standardized Symmetric Student-t Distribution:
    #   nu =  2.5 Fat tailed Distribution
    #   nu =  5.0 Less fat tailed
    #   nu = 10.0 Almost Gaussian Distribution
    ###
    
    # Settings:
    mean = 0; sd = 1; dx = 0.1
    x = seq(-10+mean, 10+mean, by = dx)
    ###
    
    # 1st Graph - Density Function:
    par(mfrow = c(2, 2), cex = 0.7)
    d1 = dstd(x, mean = mean, sd = sd, nu = 2.5)
    d2 = dstd(x, mean = mean, sd = sd, nu = 5)
    d3 = dstd(x, mean = mean, sd = sd, nu = 10)
    plot(x, d1, type = "n", xlim = c(-5, 5), ylim = c(0, 0.85), 
        xlab = "z", ylab = "f(z)", main = "Student-t: Density")
    grid()
    lines(x, d1, col = "blue")
    lines(x, d2, col = "red")
    lines(x, d3, col = "green")
    text(3.6, 0.15, "nu=10", col = "green")
    text(2.4, 0.40, "nu=2",  col = "red")
    text(1.7, 0.64, "nu=1",  col = "blue")
    ###
    
    # 2nd Graph - Distribution Function:
    p1 = pstd(x, mean = mean, sd = sd, nu = 2.5)
    p2 = pstd(x, mean = mean, sd = sd, nu = 5)
    p3 = pstd(x, mean = mean, sd = sd, nu = 10)
    plot(x, p1, type = "n", xlim = c(-5, 5),
        xlab = "z", ylab = "F(z)", main = "Student-t: Distribution")
    grid()
    lines(x, p1, col = "blue")
    lines(x, p2, col = "red")
    lines(x, p3, col = "green")
    text(1.2, 0.20, "nu=1",  col = "blue")
    text(1.7, 0.50, "nu=2",  col = "red")
    text(2.6, 0.80, "nu=10", col = "green")
    ###
    
    
# ------------------------------------------------------------------------------
# Figure 3: Standardized Symmetric GED Distribution
    
    # Standardized Symmetric GED Distribution:
    #   nu =  1 Laplace Distribution
    #   nu =  2 Normal Distribution
    #   nu = 10 Almost Uniform Distribution
    ###
    
    # Settings:
    mean = 0; sd = 1; dx = 0.1
    x = seq(-10+mean, 10+mean, by = dx)
    ###
    
    # 1st Graph - Density Function:
    par(mfrow = c(2, 2), cex = 0.7)
    d1 = dged(x, mean = mean, sd = sd, nu = 1)
    d2 = dged(x, mean = mean, sd = sd, nu = 2)
    d3 = dged(x, mean = mean, sd = sd, nu = 10)
    plot(x, d1, type = "n", xlim = c(-5, 5), ylim = c(0, 0.7), 
        xlab = "z", ylab = "f(z)", main = "GED: Density")
    grid()
    lines(x, d1, col = "blue")
    lines(x, d2, col = "red")
    lines(x, d3, col = "green")
    text(3.6, 0.15, "nu=10", col = "green")
    text(2.4, 0.40, "nu=2",  col = "red")
    text(1.7, 0.64, "nu=1",  col = "blue")
    ###
    
    # 2nd Graph - Distribution Function:
    p1 = pged(x, mean = mean, sd = sd, nu = 1)
    p2 = pged(x, mean = mean, sd = sd, nu = 2)
    p3 = pged(x, mean = mean, sd = sd, nu = 10)
    plot(x, p1, type = "n", xlim = c(-5, 5),
        xlab = "z", ylab = "F(z)", main = "SGED: Distribution")
    grid()
    lines(x, p1, col = "blue")
    lines(x, p2, col = "red")
    lines(x, p3, col = "green")
    text(1.2, 0.20, "nu=1",  col = "blue")
    text(1.7, 0.50, "nu=2",  col = "red")
    text(2.6, 0.80, "nu=10", col = "green")
    ###
        
    
# ------------------------------------------------------------------------------
# Figure 4: Standardized Skew Student-t and GED Distributions
   
    # Skew Student-t and GED Distributions:
    ###
    
    # Settings:
    mean = 0; sd = 1; dx = 0.1
    x = seq(-10+mean, 10+mean, by = dx)
    ###
    
    # 1st Graph - Skew Student-t:
    par(mfrow = c(2, 2), cex = 0.7)
    d1 = dsstd(x, mean = mean, sd = sd, nu = 5, xi = 1.0)
    d2 = dsstd(x, mean = mean, sd = sd, nu = 5, xi = 0.8)
    d3 = dsstd(x, mean = mean, sd = sd, nu = 5, xi = 0.6)
    plot(x, d1, type = "n", xlim = c(-5, 5), ylim = c(0, 0.55), 
        xlab = "z", ylab = "f(z)", main = "Skew Student-t")
    grid()
    lines(x, d1, col = "blue")
    lines(x, d2, col = "red")
    lines(x, d3, col = "green")
    text(2.7, 0.15, "xi=1.0", col = "blue")
    text(3.0, 0.30, "xi=0.8", col = "red")
    text(3.3, 0.45, "xi=0.6", col = "green")
    ###
    
    # 2nd Graph - Skew GED:
    d1 = dsged(x, mean = mean, sd = sd, nu = 2, xi = 1.0)
    d2 = dsged(x, mean = mean, sd = sd, nu = 2, xi = 0.8)
    d3 = dsged(x, mean = mean, sd = sd, nu = 2, xi = 0.6)
    plot(x, d1, type = "n", xlim = c(-5, 5), ylim = c(0, 0.55), 
        xlab = "z", ylab = "f(z)", main = "Skew GED")
    grid()
    lines(x, d1, col = "blue")
    lines(x, d2, col = "red")
    lines(x, d3, col = "green")
    text(2.7, 0.15, "xi=1.0", col = "blue")
    text(3.0, 0.30, "xi=0.8", col = "red")
    text(3.3, 0.45, "xi=0.6", col = "green")
    ###


# ------------------------------------------------------------------------------
# Code Snippet 3: Fitting Bollerslev's t-GARCH Model

    # The relevant arguments of garchFit() are:
    # garchFit(cond.dist = c("dnorm", "dsnorm", "dstd", "dsstd", "dged", "dsged"),
    #   skew = 0.9, shape = 4, include.skew = NULL, include.shape = NULL, ...)
    ###
    
    # Fitting t-GARCH(1,1) Model (Student-t) with 'sqp'
    # Tailor Control List ...
    garchFit(series = "dem2gbp", cond.dist = "dstd", include.shape = TRUE)
    #         Estimate  Std. Error  t value Pr(>|t|)    
    # mu      0.002249    0.006954    0.323   0.7464    
    # omega   0.002319    0.001167    1.987   0.0469 *  
    # alpha1  0.124438    0.026958    4.616 3.91e-06 ***
    # beta1   0.884653    0.023517   37.617  < 2e-16 ***
    # shape   4.118427    0.401185   10.266  < 2e-16 ***
    ###                                     
    
    # Try all the other conditional distributions:
    data(dem2gbp)
    x = dem2gbp[, 1]
    garchFit()                      # Normal         ok  
    garchFit(cond.dist = "dstd")    # Student-t      ok
    garchFit(cond.dist = "dged")    # GED            ok
    garchFit(cond.dist = "dsnorm")  # Skew Norm      ok
    garchFit(cond.dist = "dsstd", algorithm = "nlminb")   # Skew Student  ok  
    garchFit(cond.dist = "dsged", algorithm = "lbfgsb")   # Skew GED      ok
    ###
    
    # Tailor Estimation:
    x = dem2gbp[, 1]
    garchFit(control = list(xscale = TRUE, fscale = TRUE))   
    garchFit(cond.dist = "dsged", skew = 0.8, shape = 1.2, 
        control =list(XMAX = 0.1, RPF = 1, xscale = TRUE, fscale = TRUE))
    ###
    
    
# ------------------------------------------------------------------------------
# Code Snippet 4: Fitting Laplace (1,1) with Different Solvers

    
    # Compare all three Optimization Methods:
            
    # NLMINB:
    garchFit(series = "dem2gbp", cond.dist = "dged", shape = 1, 
        include.shape = FALSE, algorithm = "nlminb")
    #         Estimate  Std. Error  t value  Pr(>|t|)      
    # mu     0.0030970   0.0002248   13.779  < 2e-16 ***
    # omega  0.0040773   0.0018142    2.247   0.0246 *  
    # alpha1 0.1360962   0.0321700    4.231 2.33e-05 ***
    # beta1  0.8661693   0.0304593   28.437  < 2e-16 ***
                                                ### Log Likelihood not printed !
    garchFit(series = "dem2gbp", cond.dist = "dged", shape = 1, 
        include.shape = FALSE, algorithm = "nlminb+nm")
    #         Estimate  Std. Error  t value Pr(>|t|)    
    # mu     0.0030970   0.0002159   14.346  < 2e-16 ***
    # omega  0.0040774   0.0018143    2.247   0.0246 *  
    # alpha1 0.1360974   0.0321703    4.231 2.33e-05 ***
    # beta1  0.8661677   0.0304597   28.436  < 2e-16 ***
    ###
    
    # BFGS:
    garchFit(series = "dem2gbp", cond.dist = "dged", shape = 1, 
        include.shape = FALSE, algorithm = "lbfgsb")
    #         Estimate  Std. Error  t value  Pr(>|t|)      
    # mu      0.003060    0.051727    0.059   0.9528    
    # omega   0.004098    0.001832    2.237   0.0253 *  
    # alpha1  0.136381    0.033219    4.106 4.03e-05 ***
    # beta1   0.865843    0.031366   27.604  < 2e-16 ***
    garchFit(series = "dem2gbp", cond.dist = "dged", shape = 1, 
        include.shape = FALSE, algorithm = "lbfgsb+nm")
    #         Estimate  Std. Error  t value  Pr(>|t|)    
    # mu     0.0030970   0.0002159   14.346  < 2e-16 ***
    # omega  0.0040774   0.0018143    2.247   0.0246 *  
    # alpha1 0.1360980   0.0321704    4.231 2.33e-05 ***
    # beta1  0.8661671   0.0304599   28.436  < 2e-16 ***
    ###
    
    # SQP:
    garchFit(series = "dem2gbp", cond.dist = "dged", shape = 1, 
        include.shape = FALSE)
    #         Estimate  Std. Error  t value Pr(>|t|)    
    # mu      0.003098    0.050169    0.062    0.951    
    # omega   0.004077    0.001831    2.226    0.026 *  
    # alpha1  0.136075    0.033163    4.103 4.07e-05 ***
    # beta1   0.866182    0.031381   27.602  < 2e-16 ***
    garchFit(series = "dem2gbp", cond.dist = "dged", shape = 1, 
        include.shape = FALSE, control = list(fscale = TRUE))
    #         Estimate  Std. Error  t value Pr(>|t|)    
    # mu      0.003099    0.049298    0.063   0.9499    
    # omega   0.004077    0.001831    2.227   0.0260 *  
    # alpha1  0.136089    0.033139    4.107 4.01e-05 ***
    # beta1   0.866176    0.031356   27.624  < 2e-16 ***
    ###

    
################################################################################
# CHAPTER 5: ARMA(m,n) with GARCH(p,q) Errors

#   Code Snippet  5: Comparing "mci" and "uev" Recursion Initialization
#   Code Snippet  6: APARCH - Computing Conditional Variances Effectively
#   Code Snippet  7: Using R's Filter Representation
#   Code Snippet  8: Tracing the "t-MA(1)-GARCH(1,2)" Model Fit


# ------------------------------------------------------------------------------
# Code Snippet  5: Comparing "mci" and "uev" Recursion Initialization

    # "mci"
    garchFit(series = "dem2gbp")@fit$coef
    #           mu        omega       alpha1        beta1 
    # -0.006190408  0.010761398  0.153134060  0.805973672
    ###
    
    # "uev"
    garchFit(series = "dem2gbp", init.rec = "uev")@fit$coef
    #           mu        omega       alpha1        beta1 
    # -0.006269318  0.010983393  0.148699664  0.805808563
    ###
    
    
# ------------------------------------------------------------------------------
# Code Snippet 6: APARCH - Computing Conditional Variances Effectively

    # APARCH - How to Compute Conditional Variances Effectively?
    N = 10000
    eps = round(rnorm(N), digits = 2) / 10
    omega = 0.1
    alpha = c(0.1, 0.05)
    gamma = c(0, 0)
    beta = c(0.4, 0.3)
    delta = 2
    u = length(alpha)
    v = length(beta)
    uv = max(u,v)
    h = rep(0.1, uv)
    ###
  
    # Case I: Conditional Variances as Double for-Loop:
    for (i in(uv+1):N ) {
      ed = 0
      for (j in 1:u) {
        ed = ed+alpha[j]*(abs(eps[i-j])-gamma[j]*eps[i-j])^delta
      }
      h[i] = omega + ed + sum(beta*h[i-(1:v)])
    }
    print(h[1:10])
    ###
    
    
# ------------------------------------------------------------------------------
# Code Snippet  7: Using R's Filter Representation

    # Case II: Conditional Variances in Filter Representation - Loopless:
    edelta = (abs(eps)-gamma*eps)^delta
    edeltat = filter(edelta, filter = c(0, alpha), sides = 1)
    c = omega/(1-sum(beta))
    h = c( h[1:uv], c + filter(edeltat[-(1:uv)], filter = beta,
      method = "recursive", init = h[uv:1]-c))
    print(h[1:10])
    ###
    
    
# ------------------------------------------------------------------------------
# Code Snippet 8: Tracing the Student-t MA(1)-GARCH(1,2) Model Fit

    # Fitting Student t-MA(1)-GARCH(1, 2) Model:
    require(fSeries)
    data(dem2gbp)
    x = dem2gbp[, 1]
    ###
    
    # Default SQP Solver:
    garchFit(~arma(0,1), ~garch(1,2), cond.dist = "dstd")
    #         Estimate  Std. Error  t value   Pr(>|t|)    
    # mu      0.003120    0.007177    0.435   0.663797    
    # ma1     0.033416    0.023945    1.396   0.162864    
    # omega   0.002848    0.001490    1.911   0.056046 .  
    # alpha1  0.172111    0.033789    5.094   3.51e-07 ***
    # beta1   0.299823    0.147459    2.033   0.042026 *  
    # beta2   0.540753    0.144052    3.754   0.000174 ***
    # shape   4.139274    0.404663   10.229   < 2e-16 ***
    ###



################################################################################
# CHAPTER 6: APARCH(p,q) - Assymmetric Power ARCH Model


#   Code Snippet  9: Fitting the TS-GARCH(1,1) Model
#   Code Snippet 10: Fitting the GJR-GARCH(1,1) Model
#   Code Snippet 11: Fitting the DGE-GARCH(1,1) Model
    
    
# ------------------------------------------------------------------------------
# Code Snippet 9: Fitting Taylor-Schwert GARCH Model

    # Fitting Taylor/Schwert TS-GARCH(1,1) Model:
    require(fSeries)
    data(dem2gbp)
    x = dem2gbp[, 1]
    ###
    
    # Default SQP Algorithm:
    garchFit(formula.var = ~aparch(1,1), delta = 1, leverage = FALSE, 
        include.delta = FALSE)
    # Error Analysis:
    #         Estimate  Std. Error  t value   Pr(>|t|)    
    # mu     -0.005210    0.008202   -0.635      0.525    
    # omega   0.030959    0.006135    5.046   4.51e-07 ***
    # alpha1  0.166849    0.021055    7.924   2.22e-15 ***
    # beta1   0.808431    0.026182   30.878    < 2e-16 ***
    ###
    
    # Use NLMINB+NM Algorithm:
    garchFit(formula.var = ~aparch(1,1), delta = 1, leverage = FALSE, 
        include.delta = FALSE, algorithm = "nlminb+nm")
    # Error Analysis:
    #         Estimate  Std. Error  t value   Pr(>|t|)    
    # mu     -0.005193    0.008202   -0.633      0.527    
    # omega   0.030967    0.006134    5.049   4.45e-07 ***
    # alpha1  0.166941    0.021058    7.928   2.22e-15 ***
    # beta1   0.808358    0.026177   30.881    < 2e-16 ***
    ###
                                                                
    
# ------------------------------------------------------------------------------
# Code Snippet 10: Fitting GJR GARCH Model

    # Fitting GJR-GARCH(1,1) Model:
    require(fSeries)
    data(dem2gbp)
    x = dem2gbp[, 1]
    ###
    
    # Use Default SQP Algorithm:
    garchFit(formula.var = ~aparch(1,1), delta = 2, include.delta = FALSE)
    #   Error Analysis:
    #         Estimate  Std. Error  t value   Pr(>|t|)    
    # mu     -0.007907    0.008625   -0.917   0.359253    
    # omega   0.011234    0.003019    3.721   0.000198 ***
    # alpha1  0.154348    0.026984    5.720   1.07e-08 ***
    # gamma1  0.046000    0.046075    0.998   0.318099    
    # beta1   0.801434    0.034860   22.990    < 2e-16 ***
    ###
    
    # Use NLMINB+NM Algorithm:
    garchFit(formula.var = ~aparch(1,1), delta = 2, include.delta = FALSE,
        algorithm = "nlminb+nm")    
    #   Error Analysis:
    #         Estimate  Std. Error  t value Pr(>|t|)    
    # mu     -0.007905    0.008625   -0.916 0.359450    
    # omega   0.011233    0.003019    3.721 0.000198 ***
    # alpha1  0.154346    0.026984    5.720 1.07e-08 ***
    # gamma1  0.045921    0.046035    0.998 0.318509    
    # beta1   0.801441    0.034858   22.991  < 2e-16 ***
    ###
    
    
# ------------------------------------------------------------------------------
# Code Snippet 11: Fitting the DGE-GARCH(1,1) Model

    # Fitting GJR-GARCH(1,1) Model:
    require(fSeries)
    data(dem2gbp)
    x = dem2gbp[, 1]
    ###
    
    # Use Default SQP Algorithm:
    garchFit(formula.var = ~aparch(1,1))
    #   Error Analysis:
    #         Estimate  Std. Error  t value   Pr(>|t|)    
    # mu     -0.007907    0.008625   -0.917   0.359253    
    # omega   0.011234    0.003019    3.721   0.000198 ***
    # alpha1  0.154348    0.026984    5.720   1.07e-08 ***
    # gamma1  0.046000    0.046075    0.998   0.318099    
    # beta1   0.801434    0.034860   22.990    < 2e-16 ***
    ###
    
                                                    # ERROR!
    
    # Use NLMINB+NM Algorithm:
    garchFit(formula.var = ~aparch(1,1), algorithm = "nlminb+nm")   
    #   Error Analysis:
    #         Estimate  Std. Error  t value   Pr(>|t|)    
    # mu     -0.009771    0.008641   -1.131    0.25813    
    # omega   0.025410    0.007738    3.284    0.00102 ** 
    # alpha1  0.170626    0.023182    7.360   1.84e-13 ***
    # gamma1  0.106758    0.060566    1.763    0.07796 .  
    # beta1   0.803157    0.028322   28.358    < 2e-16 ***
    # delta   1.231987    0.210132    5.863   4.55e-09 ***
    ###
    
    
################################################################################
# CHAPTER 7: An Unique GARCH Modelling Approach

#   Code Snippet 12: Specifying a t-MA(1)-GARCH(1,1) Model
#   Code Snippet 13: Simulating Bollerslev's GARCH(1,1) Model
#   Code Snippet 14: Simulating more complex ARMA-GARCH Models [Figure 5]
#   Code Snippet 15: Summarizing the Results from Parameter Estimates                                      
#   Code Snippet 16: Diagnostic Plots from Parameter Estimates [Figure 6]
#   Code Snippet 17: Forecasting Mean and Variance
#   Code Snippet   : Index, Returns, and Volatility Plots for SP500 [Figure 7]
#   Code Snippet 18: Estimating the Parameters for DGE's SP500 Model


# ------------------------------------------------------------------------------
# Code Snippet 12: Specifying a t-MA(1)-GARCH(1,1) Model

    # Argument List:
    args(garchSpec)
    # function (model = list(omega = 1.0e-6, alpha = 0.1, beta = 0.8), 
    #   presample = NULL, cond.dist = c("rnorm", "rged", "rstd", "rsnorm", 
    #   "rsged", "rsstd"), rseed = NULL)

    # Specify Model:
    garchSpec(model = list(mean = 0.1, ma = 0.3, omega = 2.0e-6, alpha = 0.12,
        beta = 0.84, skew = 1.1, shape = 4), cond.dist = "rsstd", rseed = 4711)
    ###
    
    
# ------------------------------------------------------------------------------
# Code Snippet 13: Simulating Bollerslev's GARCH(1,1) Model

    # Specify Model:
    model = list(omega = 1.0e-6, alpha = 0.13, beta = 0.81)
    x = garchSim(model, n = 100)
    x
    ###
    
    # Add Plot:
    par(mfrow = c(2, 1), cex = 0.7)
    plot(x, type = "b", col = "steelblue")
    title(main = "Bollerslev's GARCH(1,1) Model")
    grid()
    ###
    

# ------------------------------------------------------------------------------
# Code Snippet 14: Simulating More Complex ARMA-GARCH Models [Figure 5]


    # ARMA-APARCH Simulation - Show Argument List:
    args(garchSim)
    ###
    
    # Specify ARCH(2) Model:
    model = list(omega = 1e-6, alpha = c(0.1, 0.3), beta = 0)
    garchSim(model)
    ###

    # Graph Frame:
    par(mfrow = c(2, 2), cex = 0.7)
    ###
    
    # Specify Bollerslev t[4]-GARCH(1,1) Model:
    model = list(omega = 1e-6, alpha = 0.15, beta = 0.75, shape = 4)
    x = garchSim(model, n = 500, cond.dist = "rstd", rseed = 4711)
    x
    ts.plot(x, main = "t[4]-GARCH(1,1) Simulated Returns", col = "steelblue", 
        ylab = "Returns")
    grid()
    abline(h = 0, col = "grey")
    ts.plot(cumsum(x), main = "t[4]-GARCH(1,1) Prices", col = "steelblue", 
        ylab = "Prices")
    grid()
    ###

    # Specify Ding-Engle-Granger MA(1)-APARCH(1,1) Model:
    model = list(ma = 0.1, omega = 1e-6, alpha = 0.15, gamma = 0.3, 
        beta = 0.75, delta = 1.3))
    x = garchSim(model, n = 500, rseed = 4711)  
    x
    ts.plot(x, main = "MA(1)-APARCH(1,1) Simulated Returns", col = "steelblue", 
        ylab = "Returns")
    grid()
    abline(h = 0, col = "grey")
    ts.plot(cumsum(x), main = "MA(1)-APARCH(1,1) Prices", col = "steelblue", 
        ylab = "Prices")
    grid()
    ###


# ------------------------------------------------------------------------------
# Code Snippet 15: Summarizing the Results from Parameter Estimates

    # Estimate Parameters:
    fit = garchFit(series = "dem2gbp")
    ###
    
    # Summary Report:
    summary(fit)
    ###
    
    
# ------------------------------------------------------------------------------
# code Snippet 16: Conditional Variance and Quantile-Quantile Plots [Figure6]

    # Parameter Estimates:
    fit1 = garchFit(series = "dem2gbp")
    fit2 = garchFit(series = "dem2gbp", cond.dist = "dstd")
    ###
    
    # Plot:
    par(mfrow = c(2,2), cex = 0.7)
    plot(fit1, which = 3)
    title(main = "\n\nDEMGBP | GARCH(1,1)")
    plot(fit1, which = 13)
    title(main = "\n\nDEMGBP | GARCH(1,1)")
    plot(fit2, which = 3)
    title(main = "\n\nDEMGBP | t-GARCH(1,1)")
    plot(fit2, which = 13)
    title(main = "\n\nDEMGBP | t-GARCH(1,1)")
    ###
    
        
# ------------------------------------------------------------------------------
# Code Snippet 17: Forecasting Mean and Variance

    # Forecasting Mean and Variance
    ###
    
    # Fit:
    fit.norm = garchFit(series = "dem2gbp")
    fit.std = garchFit(series = "dem2gbp", cond.dist = "dstd")
    ###
    
    # Forecasting:
    predict(fit.norm, 10)
    ###

    # R/Rmetrics Forecasts:
    predict(garchFit(series = "dem2gbp"), 15)   
    #      meanForecast   meanError standardDeviation
    #   1  -0.006190408   0.4702368        0.3833 961
    #   2  -0.006190408   0.4702368        0.3895 422
    #   3  -0.006190408   0.4702368        0.3953 472
    #   4  -0.006190408   0.4702368        0.4008 358
    #   5  -0.006190408   0.4702368        0.4060 303
    #   6  -0.006190408   0.4702368        0.4109 507
    #   7  -0.006190408   0.4702368        0.4156 152
    #   8  -0.006190408   0.4702368        0.4200 402
    #   9  -0.006190408   0.4702368        0.4242 410
    #   10 -0.006190408   0.4702368        0.4282 313
    #   11 -0.006190408   0.4702368        0.4320 237
    #   12 -0.006190408   0.4702368        0.4356 301
    #   13 -0.006190408   0.4702368        0.4390 612
    #   14 -0.006190408   0.4702368        0.4423 269
    #   15 -0.006190408   0.4702368        0.4454 367
    ###
    
    # Ox/G@RCH Forecasts:
    data(dem2gbp)
    x = dem2gbp[,1]
    garchOxFit()
    # Horizon      Mean   Variance
    #      1  -0.006183     0.1470
    #      2  -0.006183     0.1517
    #      3  -0.006183     0.1563
    #      4  -0.006183     0.1606
    #      5  -0.006183     0.1648
    #      6  -0.006183     0.1688
    #      7  -0.006183     0.1727
    #      8  -0.006183     0.1764
    #      9  -0.006183     0.1799
    #     10  -0.006183     0.1833
    #     11  -0.006183     0.1866
    #     12  -0.006183     0.1897
    #     13  -0.006183     0.1927
    #     14  -0.006183     0.1956
    #     15  -0.006183     0.1983
    variance = c( 0.1470, 0.1517, 0.1563, 0.1606, 0.1648, 0.1688, 0.1727, 
          0.1764, 0.1799, 0.1833, 0.1866, 0.1897, 0.1927, 0.1956, 0.1983)
    round(data.frame(sd=sqrt(variance)), 4)
    #               sd
    #   1   0.3834 058
    #   2   0.3894 868
    #   3   0.3953 479
    #   4   0.4007 493
    #   5   0.4059 557
    #   6   0.4108 528
    #   7   0.4155 719
    #   8   0.4200 000
    #   9   0.4241 462
    #   10  0.4281 355
    #   11  0.4319 722
    #   12  0.4355 456
    #   13  0.4389 761
    #   14  0.4422 669
    #   15  0.4453 089
    ###
    
    # SPlus/Finmetrics Forecasts:
    if (FALSE) { 
        # For use under S-Plus, only
        module(finmetrics)
        x = read.table(file = "dem2gbp.csv", header = TRUE, sep = ";")[, 1]
        fit = garch(formula.var = ~garch(1,1), series = x, trace = TRUE,
          control = bhhh.control(tol = 1e-6, delta = 1e-6, n.iter = 1000))
        ans = predict(fit, 15)
        data.frame(pred = ans$series.pred, sigma = ans$sigma.pred)
    } 
    #              pred       sigma 
    #    1 -0.006053483  0.3838 101
    #    2 -0.006053483  0.3900 212
    #    3 -0.006053483  0.3958 840
    #    4 -0.006053483  0.4014 241
    #    5 -0.006053483  0.4066 643
    #    6 -0.006053483  0.4116 253
    #    7 -0.006053483  0.4163 256
    #    8 -0.006053483  0.4207 823
    #    9 -0.006053483  0.4250 110
    #   10 -0.006053483  0.4290 256
    #   11 -0.006053483  0.4328 394
    #   12 -0.006053483  0.4364 642
    #   13 -0.006053483  0.4399 111
    #   14 -0.006053483  0.4431 903
    #   15 -0.006053483  0.4463 114
    ###

    
# ------------------------------------------------------------------------------    
# Figure 7 - Price Index, Returns, and Absolute Returns Plots for SP500

    # Load Data:
    require(fSeries)
    data(sp500dge)
    x = sp500dge[, 1]
    ###
    
    # Plot:
    par(mfrow = c(3, 1), cex =0.7)
    # Returns:
    plot(x, type = "l", col = "steelblue", ylab = "Returns")
    title(main = "SP500 Daily Returns")
    grid()
    abline(h = 0, col = "grey")
    # Cumulated Returns:
    plot(x = exp(cumsum(x)), type = "l", col = "steelblue", 
        ylab = "exp(Cumulated Returns)")
    title(main = "SP500 Exponential Cumulated Returns")
    grid()
    abline(h = 0, col = "grey")
    # Abs Returns:
    plot(x = abs(x), type = "l", col = "steelblue", ylab = "abs(Returns)")
    title(main = "SP500 Volatilities")
    grid()
    abline(h = 0, col = "grey")
    ###
    

# ------------------------------------------------------------------------------
# Code Snippet 18: Estimating the Parameters for DGE's SP500 Model

    # Load Data:
    require(fSeries)
    data(sp500dge)
    x = 100 * sp500dge[, 1]
    ###
    
    # Results from DGE Paper:
    #         Estimate  t.value
    # mu      0.00021       3.2
    # ma      0.145        19
    # omega   0.000014      4.5
    # alpha   0.083        32.4
    # gamma   0.373        20.7
    # beta    0.920       474
    # delta   1.43         33.7
    #
    parm = c(0.00021, 0.145, 0.000014, 0.083, 0.373, 0.920, 1.43)                 
    tval = c(3.2, 19, 4.5, 32.4, 20.7, 474, 33.7)
    ###
           
    # R/Rmetrics - SQP Scaled: [41 sec]
    garchFit(~arma(0,1), ~aparch(1,1))     
    #         Estimate  Std. Error  t value Pr(>|t|)    
    # mu      0.020646    0.006346    3.253  0.00114 ** 
    # ma1     0.144745    0.008357   17.319  < 2e-16 ***
    # omega   0.009988    0.001085    9.203  < 2e-16 ***
    # alpha1  0.083803    0.004471   18.742  < 2e-16 ***
    # gamma1  0.373092    0.027995   13.327  < 2e-16 ***
    # beta1   0.919401    0.004093  224.622  < 2e-16 ***
    # delta   1.435124    0.067200   21.356  < 2e-16 ***
    #   Log Likelihood:   21563.34    normalized:  1.264341 
    # Rescale:
    scale = 1/100
    mu = 0.020646; mu*scale
    # [1] 0.00020646
    omega = 0.009988; delta = 1.435124; omega / (1/scale)^(2/delta)
    # [1] 1.630283e-05
    ###
    
    # Ox/G@RCH - Scaled: [47 sec]
    garchOxFit(~arma(0,1), ~aparch(1,1))
    #                   Coefficient  Std.Error  t-value  t-prob
    # Cst(M)               0.020375  0.0063657    3.201  0.0014
    # MA(1)                0.144631  0.0083808    17.26  0.0000
    # Cst(V)               0.009991  0.0010827    9.228  0.0000
    # ARCH(Alpha1)         0.083769  0.0044350    18.89  0.0000
    # APARCH(Gamma1)       0.376495   0.028137    13.38  0.0000
    # GARCH(Beta1)         0.919863  0.0040708    226.0  0.0000
    # APARCH(Delta)        1.416169   0.066176    21.40  0.0000
    # Rescale:
    mu = 0.020375; mu*scale
    # [1] 0.00020375
    omega = 0.009991; delta = 1.416169; omega / (1/scale)^(2/delta)
    # [1] 1.496536e-05
    ###
    
    # SPlus/Finmetrics - BHHH with Tailored Control Scaled:  
    if (FALSE) { 
        # For use under S-Plus, only
        module(finmetrics)
        x = 100*as.vector(sp500)
        date()
        fit = garch(~arma(0,1), ~pgarch(1,1), series = x, leverage = TRUE, 
          control = bhhh.control(tol=1e-6, delta=1e-6, n.iter=10000), 
          trace = TRUE)
        date()
        # Use Hessian Matrix ...
        coef = fit$coef
        se.coef = sqrt(diag(solve(-fit$cov$A)))
        t.value = coef/se.coef
        data.frame(Estimate = coef, StdError = se.coef, "t value" = t.value)   
    }   
    #             Estimate     StdError     t.value 
    #        C  0.02084031  0.006330720    3.291934
    #    MA(1)  0.14470177  0.008294756   17.444971
    #        A  0.01002876  0.001091768    9.185798
    #  ARCH(1)  0.08374599  0.004448664   18.824976
    #   LEV(1) -0.37098826  0.027775705  -13.356574
    # GARCH(1)  0.91954293  0.004078342  225.469798
    #    POWER  1.42901650  0.067071355   21.305914          
    # Rescale:
    mu = 0.02084; mu*scale
    # [1] 0.0002084
    omega = 0.01003; delta = 1.42902; omega / (1/scale)^(2/delta)
    # [1] 1.592868e-05
    ###

    
################################################################################
